<?php // -*- coding:utf-8 -*-
// Parameters:

// lang=xx    : only translates language 'xx',
//              if not given all languages are translated

// comments   : generate all comments (equal to close&module)

// close      : look for similar strings that are already translated and
//              generate a comment if a 'match' is made

// module     : generate comments that describe in which .php and/or .tpl
//              module(s) a certain string was found (useful for checking
//              translations in context)

// patch      : looks for the file 'language.patch' in the same directory
//              as the corresponding language.php and overrides any strings
//              in language.php - good if a user does not agree with
//              some translations or if only changes are sent to the maintainer

// spelling   : generates a file 'spellcheck_me.txt' that contains the
//              words used in the translation. It is then easy to check this
//              file for spelling errors (corrections must be done in
//              'language.php, however)

// groupwrite : Sets the generated files permissions to allow the generated
//              language.php also be group writable. This is good for
//              translators if they do not have root access to tiki but
//              are in the same group as the webserver. Please remember
//              to have write access removed when translation is finished
//              for security reasons. (Run script again without this
//              parameter)

// Examples:
// http://www.neonchart.com/get_strings.php?lang=sv
// Will translate language 'sv' and (almost) avoiding comment generation

// http://www.neonchart.com/get_strings.php?lang=sv&comments
// Will translate language 'sv' and generate all possible comments.
// This is the most usefull mode when working on a translation.

// http://www.neonchart.com/get_strings.php?lang=sv&nohelp&nosections
// These options will only provide the minimal amout of comments.
// Usefull mode when preparing a translation for distribution.

// http://www.neonchart.com/get_strings.php?nohelp&nosections
// Prepare all languages for release


// ### Note for translators about translation of text ending with punctuation
// ###
// ### The current list of concerned punctuation can be found in 'lib/init/tra.php'
// ### On 2009-03-02, it is: (':', '!', ';', '.', ',', '?')
// ### For clarity, we explain here only for colons: ':' but it is the same for the rest
// ###
// ### Short version: it is not a problem that string "Login:" has no translation. Only "Login" needs to be translated.
// ###
// ### Technical justification:
// ### If a string ending with colon needs translating (like "{tr}Login:{/tr}")
// ### then TikiWiki tries to translate 'Login' and ':' separately.
// ### This allows to have only one translation for "{tr}Login{/tr}" and "{tr}Login:{/tr}"
// ### and it still allows to translate ":" as "&nbsp;:" for languages that
// ### need it (like french)

$lang=Array(
// ### Start of unused words
// ### Please remove manually!
// ### N.B. Legitimate strings may be marked// ### as unused!
// ### Please see http://tikiwiki.org/tiki-index.php?page=UnusedWords for further info
"categorize" => "categorizar",
"Set prefs" => "Definir preferências",
"creation date" => "data de criação",
"last modification time" => "data da última modificação",
"Articles listing configuration" => "Configuração da listagem de artigos",
"PHPOpenTracker" => "Tráfego do Website",
"Set home forum" => "Definir o fórum inicial",
"enable/disable" => "habilitar/desabilitar",
"Set feeds" => "Definir fontes",
"Create TAR dump" => "Criar exportação TAR",
"Create HTML dump" => "Criar exportação HTML",
"Download last TAR dump" => "Baixar a última exportação TAR",
"Access HTML dump" => "Acessar a exportação HTML",
"Wiki Page Names" => "Nomes de páginas Wiki",
"strict" => "restrito",
"Cache wiki pages" => "Realizar cache de páginas Wiki",
"\n for rows" => "\n para linhas",
"Enable watch by default for author" => "Habilitar notificação padrão para o autor",
"Enable watches when I am the editor" => "Habilitar notificações quando eu for o editor",
"assign_perms" => "definir_perms",
"assign group" => "definir grupo",
"view info" => "ver informações",
"Users can vote only one item from this chart per period" => "Usuários só podem votar em um item deste gráfico por período",
"Prevent users from voting same item more than one time" => "Evitar que os usuários votem mais de uma vez no mesmo item",
"half a second" => "meio segundo",
"Forward messages to this forum to this email" => "Enviar as mensagens destinadas a este fórum para o seguinte e-mail",
"Admin HTML page dynamic zones" => "Administrar zonas dinâmicas da página HTML",
"use dynamic content" => "usar conteúdo dinâmico",
"Users can subscribe any email addresss" => "Usuários podem assinar de qualquer endereço de email",
"create new empty structure" => "Criar uma nova estrutura vazia",
"Create structure from tree" => "Criar estrutura da cidade",
"Options (separated by commas used in dropdowns only)" => "Opções (separadas por vírgula, apenas em caixas de seleção)",
"Click here to create a new backup" => "Clique aqui para criar um novo backup",
"Click to enlarge" => "Clique para aumentar",
"Navigation Panel" => "Painel de Navegação",
"Hide Panels" => "Esconder Painéis",
"hide from display" => "esconder",
"Tiki Calendars" => "Calendários Tiki",
"browse by" => "visualizar por",
"If you change the calendar selection, please refresh to get the appropriated list in Category, Location and people (if applicable to the calendar you choose)." => "Se você alterar a seleção de calendário, por favor atualize a página para obter a lista apropriada de categorias, locais e pessoas (se for o caso para o calendário selecionado).",
"from the list" => "da lista",
"choose" => "escolher",
"with role" => "com perfil",
"You should first ask that a calendar is created, so you can create events attached to it." => "Você deve antes criar um calendário, para poder criar ventos anexados a ele.",
"Use (:name:) for smileys" => "Utilize (:nome:) para emoticons",
"Type help to get list of available commands" => "Digite ajuda para obter uma lista de comandos",
"Publish/Event Date" => "Data de Publicação/Evento",
"Displays preformated text/code; no Wiki processing is done inside these sections" => "Exibe texto/código-fonte pré-formatado; nenhum processamento wiki é efetuado dentro destas seções",
"wiki link" => "link Wiki",
"heading" => "cabeçalho",
"horizontal ruler" => "linha horizontal",
"center" => "centralizar",
"img nc" => "img nc",
"In parent page" => "Na página-pai",
"Newss from" => "Notícia de",
"Assign permissions to this page" => "Definir permissões para esta página",
"You can include the image in an HTML/Tiki page using" => "Você pode incluir a imagem em uma página HTML/Tiki usando",
"Tiki forums" => "Fóruns do Tiki",
"Show Post Form" => "Exibir Formulário de Envio",
"Hide Post Form" => "Esconder Formulário de Envio",
"smileys" => "emoticons",
"mot" => "mot",
"Mark as Flagged" => "Marcar como Selecionada",
"Wiki Import dump" => "Importar arq. exp. Wiki",
"Top Files" => "Arquivos mais populares",
"xx" => "xx",
"xxx" => "xxx",
"No such forum" => "Fórum inexistente",
"No image uploaded" => "Nenhuma imagem foi carregada",
"Permission denied you cannot browse this gallery" => "Permissão negada: você não pode visualizar esta galeria",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory" => "Endereço não pode ser acessado e adicionado ao diretório: URL incorreta ou site off-line",
"Anonymous users cannot edit pages" => "Usuários anônimos não podem editar páginas",
"Invalid password. You current password is required to change your email address." => "Senha inválida. Sua senha atual é necessária para alterar seu endereço de e-mail.",
"Current page:" => "Página atual:",
"version %s" => "versão %s",
"last modified on %s" => "última modificação em %s",
"by %s" => "por %s",
"Archived page:" => "Página arquivada:",
"Diff of %s." => "Diferenças de %s.",
"Displays a snippet of code.\nSet optional paramater -+ln+- to 1 if you need line numbering feature." => "Exibe um trecho de código-fonte.\nDefina o parâmetro opcional -+ln+- com o valor 1 se desejar numeração de linhas.",
"Split a page into columns" => "Dividir a página em colunas",
"column" => "coluna",
"Renders a graph" => "Desenha um gráfico",
"There is an error in the plugin data" => "Há um erro nos dados do plug-in",
"Insert articles into a wikipage" => "Incluir artigos numa página wiki",
"the space beetween nodes\n" => "o espaço entre nós\n",
"Quiz time limit excedeed quiz cannot be computed" => "Tempo do teste excedeu o limite e não pode ser computado",
"Unexistant link" => "Link Inexistente",
"Unexistant gallery" => "Galeria inexistente",
"Unexistant version" => "Versão inexistente",
"Unexistant user" => "Usuário inexistente",
"The user has choosen to make his information private" => "O usuário escolheu deixar suas informações privadas",
"Are you sure you want to delete this directory?" => "Você tem certeza que deseja remover este diretório?",
"Are you sure you want to delete this file?" => "Você tem certeza que deseja apagar este arquivo?",
"You can view the page following this link:" => "Você pode ver a página pelo seguinte link:",
"Are you sure you want to delete this repository?" => "Você tem certeza que deseja apagar este repositório?",
"Click here to delete this repository" => "Clique aqui para remover este repositório",
"Are you sure you want to delete this forum?" => "Você tem certeza que deseja apagar este fórum?",
"Reduce area width" => "Reduzir a largura de área",
"Enlarge area width" => "Ampliar a largura de área",
"Delete item from category?" => "Apagar o item da categoria?",
"Are you sure you want to delete this category?" => "Você tem certeza que deseja remover esta categoria?",
"Are you sure you want to delete this tracker?" => "Você tem certeza que deseja remover este acompanhamento?",
"Click here to delete this tracker" => "Clique aqui para remover este acompanhamento",
"Are you sure you want to delete this contact?" => "Você tem certeza que deseja apagar este contato?",
"Click here to delete this contact" => "Clique aqui para apagar este contato",
"Are you sure you want to delete this attachment?" => "Você tem certeza que deseja apagar este anexo?",
"Click here to delete this attachment" => "Clique aqui para remover este anexo",
"Click here to unassign this module" => "Clique aqui para desabilitar este módulo",
"Click here to edit this menu" => "Clique aqui para editar este menu",
"Click here to edit this comment" => "Clique aqui para editar este comentário",
"Are you sure you want to delete this comment?" => "Você tem certeza que deseja apagar este comentário?",
"Click here to delete this comment" => "Clique aqui para apagar este comentário",
"Are you sure you want to delete this rule?" => "Você tem certeza que deseja apagar esta regra?",
"Click here to delete this rule" => "Clique aqui para apagar esta regra",
"(Dropdown options : list of items separated with commas)" => "(Opções de dropdown : lista de itens separada por vírgulas)",
"(Image options : xSize,ySize indicated in pixels)" => "(Opções de imagens : xTamanho,yTamanho indicados em pixels)",
"Are you sure you want to delete this drawing?" => "Você tem certeza que deseja remover este desenho?",
"Click here to delete this drawing" => "Clique aqui para apagar este desenho",
"Are you sure you want to delete this HTML page?" => "Você tem certeza que deseja apagar esta página HTML?",
"Are you sure you want to delete this copyright?" => "Você tem certeza que deseja apagar este copyright?",
"Click here to delete this copyright" => "Clique aqui para remover este copyright",
"Are you sure you want to delete this template?" => "Você tem certeza que deseja remover este modelo?",
"Click here to delete this template" => "Clique aqui para apagar este modelo",
"Are you sure you want to delete this menu?" => "Você tem certeza que deseja remover este menu?",
"Click here to delete this menu" => "Clique aqui para remover este menu",
"Are you sure you want to delete this group?" => "Você tem certeza que deseja remover este grupo?",
"Are you sure you want to delete this external wiki?" => "Você tem certeza que deseja remover este wiki externo?",
"Thankyou for installing Tikiwiki" => "Obrigado por instalar o Tikiwiki",
"Click here to configure this menu" => "Clique aqui para configurar este menu",
"Are you sure you want to delete this dsn?" => "Você tem certeza que deseja apagar este dsn?",
"Are you sure you want to delete this cookie?" => "Você tem certeza que deseja apagar este cookie?",
"Click here to delete this cookie" => "Clique aqui para apagar este cookie",
"Events Panel" => "Painel de Eventos",
"Klick to enlarge" => "Clique para ampliar",
"Are you sure you want to delete this hotword?" => "Você tem certeza que deseja remover esta palavra-chave?",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appeareance of the page, no versions are stored for this page." => "A bancada de testes é a página onde você pode praticar suas edições. Use a funcionalidade de preview para ver a aparência da página editada. Nenhuma versão da página é armazenada.",
"Are you sure you want to delete this channel?" => "Você tem certeza que deseja remover este canal?",
"Click here to delete this channel" => "Clique aqui para apagar este canal",
"LDAP Group Atribute" => "Atributo de Grupo LDAP",
"Email Encoding" => "Codificação do E-mail",
"Are you sure you want to delete this calendar?" => "Você tem certeza que deseja remover este calendário?",
"New message arrived from " => "Chegou uma nova mensagem de ",
"Welcome to " => "Bem-vindo(a) a ",
" at " => " em ",
"Bye bye from " => "Saudações de ",
"New article submitted at " => "Novo artigo enviado em ",
"Your Tiki account information for" => "Informações da sua conta Tiki para",
" new topic:" => " novo tópico:",
"topic:" => "tópico:",
"You can edit the page following this link:" => "Você pode editar a página seguindo este link:",
"Diff:" => "Difer:",
"The new page content is:" => "O conteúdo da nova página é:",
"Threads can be voted" => "Seqüências podem ser votadas",
"Directory (include trailing slash)" => "Diretório (incluir barra invertida final)",
"checked" => "marcado",
"unchecked" => "desmarcado",
"Show status when listing tracker items?" => "Exibir estado na lista de itens de acompanhamento?",
"remove bookmark" => "remover bookmark",
"Control by Object" => "Controlar por objeto",
"use square brackets for an" => "utilize colchetes para um",
"link_description" => "descricao_do_link",
"Prevents parsing data" => "Evita a interpretação de dados",
"In blog listing show user as" => "Na listagem de Blog mostrar o usuário como",
"Add New Group" => "Adicionar Novo Grupo",
"Edit this group:" => "Editar este grupo:",
"Return to messages" => "Voltar às mensagens",
"Unflagg" => "Desmarcar",
"Calendars Panel" => "Painel de Calendários",
"parent" => "pai",
"reply to this" => "responder",
"Control by category" => "Controlar por categoria",
"Select available themes:" => "Escolha os temas disponíveis:",
"Admin structures" => "Administrar estruturas",
"FAQ Questions" => "Perguntas da FAQ",
"FAQ Answers" => "Respostas da FAQ",
"Show suggested questions/suggest a question" => "Exibir perguntas sugeridas/sugerir uma pergunta",
"Hide suggested questions" => "Esconder perguntas sugeridas",
"save a custom copy" => "salvar uma cópia personalizada",
"Add users" => "Adicionar usuários",
"Reuse question" => "Reutilizar a pergunta",
"WebMail accounts" => "Contas de WebMail",
"Create New Survey:" => "Criar uma Nova Pesquisa:",
"Ranking" => "Ranking",
"The cord" => "The cord",
"Comm" => "Comm",
"Cms" => "Sistema de Gerenciamento de Conteúdo (SGC)",
"AdminDSN" => "AdminDSN",
"ChatAdmin" => "ChatAdmin",
"op" => "operador do sistema",
"ver" => "versão",
"note: those parameters are exclusive" => "nota: estes parâmetros são exclusivos",
"Renders a graph, with linked pages navigation visually figured.\n" => "Renderizar um gráfico, com links de navegação de páginas figurados.\n",
"the number of hops the graph follows\n" => "o número de degraus no gráfico seguem\n",
"the title of the map\n" => "o título do mapa\n",
"Left to Right, the direction of graph\n" => "Esquerda para a Direita, a direção do gráfico\n",
"the background color, use #rrvvbb color types.\n" => "a cor de fundo, use tipos de cor RGB.\n",
"nothing there, unlimited size. use 5,3 type sizes in inches\n" => "nada aqui, tamanho ilimitado. usar tipo 5,3 em polegadas\n",
"the font size in pts presumably\n" => "o tamanho da fonte presumível em pontos\n",
"the name of the font used for labels\n" => "o nome da fonte usada para rótulos\n",
"the shape of a node. can be " => "o formato de um nó pode ser ",
"plaintext ellipse circle egg triangle box diamond trapezium parallelogram house hexagon octagon\n" => "texto plano elipse circular ovo triângulo caixa diamante trapézio paralelogramo casa hexagonal octagonal\n",
"style for drawing nodes.\n" => "estilo para desenhar nós.\n",
"color of the border\n" => "cor da borda\n",
"background color of the node\n" => "cor de fundo do nó\n",
"sortof relative width ??\n" => "ordenar largura relativa ??\n",
"same mystery as above\n" => "mesmo mistério como acima\n",
"color for links (called edges here)\n" => "cor para links (chamar bordas aqui)\n",
"shape of the arrow that come with the link\n" => "formato da seta que vem com o link\n",
"Upload was not successful (maybe a duplicate file)" => "O envio do arquivo não foi efetuado (possivelmente arquivo duplicado)",
"Security check failed!" => "Verificação de segurança falhou!",
"Warn on edit" => "Avisar na edição",
"Wiki page" => "Página Wiki",
"A password reminder email has been sent " => "Um lembrete da senha foi enviado",
"A new password has been sent " => "Uma nova senha foi enviada ",
"pageviews" => "visitas",
"Only an admin can remove a thread." => "Somente um administrador pode remover uma sequência.",
"forum topic" => "tópico do fórum",
"updated by the phpwiki import process" => "atualizada pelo processo de importação do phpwiki",
"created from phpwiki import" => "criada pela importação phpwiki",
"someone from" => "alguém de",
"You can include the image in an HTML or Tiki page using" => "Você pode incluir a imagem em uma página HTML ou Tiki usando",
"For more information, please see WikiSyntax\non Tikiwiki.org." => "Para maiores informações, por favor veja WikiSyntax\nno Tikiwiki.org.",
"File gals" => "Gal. Arquivos",
"Image gals" => "Gal. Imagens",
"ExtWikis" => "WikisExternos",
"assgn" => "definir",
"CMS settings" => "Configuração de CMS",
"admin HtmlPages" => "administrar PáginasHtml",
"All tasks" => "Todas as tarefas",
"mark as done" => "marcar como realizada",
"open tasks" => "tarefas em aberto",
"Add or edit a task" => "Adicionar ou editar uma tarefa",
"Start date" => "Data de início",
"admin ExternalWiki" => "administrar WikiExterno",
"MyTiki (click!)" => "MeuTiki (clique!)",
"Admin (click!)" => "Administração (clique!)",
"More info about" => "Mais informação sobre",
"idle" => "ocioso",
"MyTikiDoc" => "MeuTikiDoc",
"Posted comments" => "Comentários enviados",
"Reply to parent comment" => "Responder ao comentário pai",
"use filename" => "use o nome do arquivo",
"Go \r\n back" => "Ir \r\n voltar",
"Return to home \r\n page" => "Retornar para home \r\n página",
"Confirmation required" => "Confirmação requerida",
"Add scaled images size X x Y" => "Adicionar imagens em escala X por Y",
"Show chart for the last " => "Exibir o gráfico para os últimos ",
"days (0=all)" => "dias (0=todos)",
"Time Zone" => "Fuso horário",
"Server time zone" => "Fuso horário do servidor",
"Time Zone Map" => "Mapa de fuso horário",
"this post was reported" => "esta mensagem foi enviada",
"report this post" => "enviar esta mensagem",
"Import pages from a PHPWiki Dump" => "Importar páginas de uma exportação PHPWiki",
"Path to where the dumped files are (relative to tiki basedir with trailing slash ex: dump/)" => "Caminho para os arquivos de dados (relativo ao diretório-base Tiki, com barra terminadora; ex: dump/)",
"Use dbl click to edit pages" => "Usar duplo clique para editar páginas",
"Change your email" => "Alterar seu endereço de email",
"change email" => "alterar endereço de email",
"Configure this page" => "Configurar esta página",
"Send Objects" => "Enviar Objetos",
"stat" => "status",
"You can view the page by following this link:\n {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}" => "Você pode ver a página pelo seguinte link:\n {\$mail_machine}/tiki-index.php?page={\$mail_page|escape:\"url\"}",
"You can edit the page by following this link:\n {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}" => "Você pode editar a página pelo seguinte link:\n {\$mail_machine}/tiki-editpage.php?page={\$mail_page|escape:\"url\"}",
"You can view a diff back to the previous version by following\nthis link:\n {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}" => "Você pode ver as diferenças de uma versão anterior pelo link\n:\n {\$mail_machine}/tiki-pagehistory.php?page={\$mail_page|escape:\"url\"}&diff2={\$mail_last_version}",
"Create a group for each user\n(with the same\nname as the user)" => "Criar um grupo para cada usuário\n(com o mesmo \nnome do usuário)",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax ((page name))." => "Controlar reconhecimento de links Wiki usando dois parênteses como sintaxe Wiki ((nome da página)).",
"\nNote 1: if you allow your users to configure modules then assigned\nmodules won't be reflected in the screen until you configure them\nfrom MyTiki->modules.\n\nNote 2: If you assign modules to groups make sure that you\nhave turned off the option 'display modules to all groups always'\nfrom Admin->General\n" => "\nNota 1: Se você permitir aos usuários configurar módulos, os módulos configurados não serão\natualizados na tela até que você os configure\nem MeuTiki->módulos.\n\nNota 2: Se você atribuir módulos a grupos certifique-se de ter desligado\na opção 'Módulos acessíveis por todos grupos'\nem Admin->Geral.\n",
"For more information, please see <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\non <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>." => "Para maiores informações, por favor veja <a\nhref=\"http://www.tikiwiki.org/tiki-index.php?page=WikiSyntax\">WikiSyntax</a>\nno <a href=\"http://www.tikiwiki.org\">Tikiwiki.org</a>.",
"no attachment on this page." => "sem anexos nessa página.",
"Displays the output of a tracker content" => "Mostra a saída do conteúdo de um acompanhamento",
"the space between nodes\n" => "O espaço entre os nós\n",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be display before the field append wil be display just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opções de texto: 1,tamanho,anexar no início,anexar,max com o tamanho em caracteres, anexar no início será mostrado antes do campo anexar será mostrado imediatamente após, max é o número máximo de caracteres que podem ser salvos, e 1 inicial para fazer com que o próximo campo de texto ou <i>checkbox</i> sejam na mesma linha. Se você indicar somente 1 isto significa que o próximo campo está na mesma linha também.",
"E-Mail address options: MakeLink (0,1 or 2), 0 shows the address as a normal text field. 1 Does an obfuscated mailto: link when viewing item. 2 Does a normal href mailto: when viewing items." => "Opções de endereço de e-mail: MakeLink (0,1 ou 2), 0 mostra o endereço como um campo de texto normal. 1 Gera um email ofuscado. 2 Faz um href de envio normal.",
"Remove selected packages" => "Remove os pacotes selecionados",
"Manage attachement preferences" => "Manipular preferências dos anexos",
"permission." => "permissão.",
"To the event:" => "Para o evento:",
"Event:" => "Evento:",
"Welcome to our event!" => "Bem vindo ao nosso evento!",
"Projects Menu" => "Menu de projetos",
"Register New Project" => "Registrar novo projeto",
"Site Calendar" => "Calendário do site",
"Friendship network" => "Rede de amigos",
"Tiki Projects" => "Projetos do Tiki",
"Create New Group" => "Criar novo grupo",
"<b>Title</b>" => "<b>Título</b>",
"<b>Description</b>" => "<b>Descrição</b>",
"you can see users rank by score in the module users_rank, for that go to" => "você pode ver o rank de usuários por pontos no módulo users_rank, para isso vá para",
"list events" => "listar eventos",
"admin events" => "eventos do administrador",
"send events" => "enviar eventos",
"Add all users" => "Adicionar todos os usuários",
"Create/edit events" => "Criar/editar eventos",
"send event" => "enviar evento",
"Field is hidden? (visible by admin only)" => "O campo é secreto? (visível apenas para o administrador)",
"Project Name:" => "Nome do projeto:",
"Project Description:" => "Descrição do projeto:",
"Project Active" => "Projeto ativo",
"Add a File Gallery" => "Adicionar arquivo na galeria",
"Project Admin" => "Administrador do projeto",
"Project Members" => "Membros do projeto",
"First Name:" => "Nome:",
"Last Name:" => "Sobrenome:",
"Company:" => "Empresa:",
"create new user" => "criar novo usuário",
"Project Created:" => "Projeto criado:",
"Project Info" => "Informações do projeto",
"Project Admins:" => "Administradores do projeto:",
"Project Members:" => "Membros do projeto:",
"Edit Project" => "Editar projeto",
"Publisher" => "Publisher",
"-1m" => "-1m",
"-7d" => "-7d",
"-1d" => "-1d",
"+1d" => "+1d",
"+7d" => "+7d",
"+1m" => "+1m",
"perm" => "perm",
"You do not have permission to use this feature." => "Você não possui permissão para usar este recurso.",
" line " => " linha ",
"Error: No" => "Erro: Nro",
"Error: Invalid" => "Erro: Inválido",
"Error: Call to hw_page_fetch_by_id failed!" => "Erro: Chamada para hw_page_fetch_by_id falhou!",
"no description" => "sem descrição",
"Updated" => "Atualizado",
"Textarea options: options,width,height,max with option is 1 or 0, rest is size indicated in chars and lines, max is the maximum number of characters that can be saved." => "Opções da área do texto: opções,largura,altura,max com opções 1 ou 0, tamanho indicado em caracteres e linhas, max é o número máximo de caracteres que podem ser salvos.",
"~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} Insert articles into a wikipage" => "~np~{~/np~ARTICLES(max=>3,topic=>topicName)}{ARTICLES} Insere artigos na página wiki",
"You need to supply information for : " => "Você precisa fornecer informação para: ",
"missing tracker ID for plugin TRACKER" => "Faltando o ID do acompanhamento para o plugin ACOMPANHAMENTO",
"User \$a_user can not receive messages" => "User usuário \$a_user não pode receber mensagens",
"Invalid user: \$a_user" => "Usuário Inválido: \$a_user",
"requested a reminder of the password for the" => "requisitar um lembrete da senha para a",
"since this is your registered email address we inform that the" => "uma vez que este é o seu endereço de email registrado informamos que a",
"password for this account is" => "senha para esta conta é",
"Information:" => "Informações:",
"New blog post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova mensagem de blog: {\$mail_title} por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at\n{\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi alterada por {\$mail_user} em\n{\$mail_date|tiki_short_datetime}",
"Click the :: option on the menu for more options." => "Clique na opção :: no menu para mais opções.",
"Please also see" => "Por favor, veja também",
"Admin->Modules" => "Admin->Módulos",
"Please" => "Por favor",
"log in" => "efetue o logon",
"to access full functionalities" => "para acessar todos os recursos",
"Blog settings" => "Configurações do Blog",
"FAQs settings" => "Configurações de FAQs",
"FAQ comments" => "Comentários de FAQ",
"Create a group for each user <br />(with the same\nname as the user)" => "Criar um grupo para cada usuário <br />(com o mesmo \nnome do usuário)",
"Remind passwords by email" => "Lembrar de senhas por e-mail",
"Poll settings" => "Configurações de enquetes",
"Append CSS file to feed urls" => "Adicionar arquivo CSS para o campo de urls",
"Create a tag for the current wiki" => "Criar uma tag para o Wiki atual",
"Restore the wiki" => "Restaurar o Wiki",
"Wiki comments settings" => "Configurações de comentários Wiki",
"Wiki page list configuration" => "Configuração de lista de páginas Wiki",
"Wiki 3D browser configuration" => "Configurações do navegador wiki 3D",
"Like pages" => "Páginas similares",
"List Calendars" => "Listar Calendários",
"admin Drawings" => "administrar Desenhos",
"Use {literal}{{/literal}ed id=name} or {literal}{{/literal}ted id=name} to insert dynamic zones" => "Utilize {literal}{{/literal}ed id=nome} ou literal}{{/literal}ted id=nome} para inserir zonas dinâmicas",
"Add all your site users to this newsletter (broadcast)" => "Adicionar todos usuários do seu site a este comunicado (comunicado geral)",
"Added users" => "Usuários adicionados",
"search category" => "buscar categoria",
"deep" => "profundo",
"today" => "hoje",
"Add Calendar Item" => "Adicionar Item ao Calendário",
"Textheight" => "Altura do texto",
"Height of top Heading" => "Altura do cabeçalho superior",
"Height of mid Heading" => "Altura do cabeçalho intermediário",
"Height of inner Heading" => "Altura do cabeçalho interno",
"tbheight" => "tbaltura",
"Automatic Page Breaks" => "Quebra de Páginas Automática",
"Emphasis" => "Ênfase",
"italics" => "itálico",
"both" => "ambos",
"use ...page... to separate pages" => "utilize ...page... para separar páginas",
"make_headings" => "criar_cabecalhos",
"underlines text" => "sublinhar texto",
"Simple box" => "Caixa simples",
"Will display using the indicated HTML color" => "Será exibido com a cor HTML indicada",
"Will display the text centered" => "Exibirá o texto centralizado",
"Edit Submissions" => "Editar Submissões",
"act status" => "status da ação",
"running" => "em execução",
"Activs" => "Atividades",
"Ins" => "Inst",
"time" => "hora",
"Wiki quick help" => "Auxílio rápido Wiki",
"Quicklinks" => "Links Rápidos",
"Comparing versions" => "Comparando versões",
"Actual_version" => "Versão_real",
"Diff to version" => "Diferença para a versão",
"admin DynamicContent" => "administrar DynamicContent",
"topics in this forum" => "tópicos neste fórum",
"Editing tracker item" => "Editando item de acompanhamento",
"The passwords dont match" => "As senhas não coincidem",
"You do not have permission to write the template" => "Você não tem permissão de escrita para modificar o template",
"You must be a student to edit homework pages." => "Você precisa ser um estudante para editar as páginas de Tarefa de casa.",
"Error: Invalid id for hw_pages table." => "Erro: Id inválido para tabela hw_pages.",
"Error: This page is being edited by another user." => "Erro: Esta página está sendo editada por outro usuário.",
"Permission denied: Students may only view or edit their own work." => "Permissão negada: Estudantes só podem ver ou editar suas próprias tarefas.",
"Permission denied: Students may NOT edit their work after the due date." => "Permissão negada: Estudantes NÃO podem editar seus próprios trabalhos depois da data da entrega.",
"Permission denied: The teacher must wait until the due date to edit students' work." => "Permissão negada: O professor deve aguardar até a data de entrega para editar a tarefa dos estudantes.",
"Permission denied: you must be a teacher to access this page." => "Permissão Negada: você deve ser um professor para para acessar essa página.",
"Error: Could not fetch page" => "Erro: Página não realizada",
"This function is deprecated in favor of the improved quizzes outside of the Homework feature." => "Essa função está obsoleta em favor da melhora dos testes fora do recurso Tarefa de Casa.",
"Permission denied: You cannot rollback this page." => "Acesso Proibido: Você não pode desfazer a alteração dessa página.",
"Error: nonexistant version specified." => "Erro: a versão especificada não existe.",
"You must be a teacher or grader to access this page." => "Você precisa ser professor ou graduando para ver essa página.",
"Permission denied: You must be a teacher to edit assignments." => "Permissão negada: Você deve ser um professor para poder editar as tarefas.",
" error: Can not find assignment " => " erro: não foi possível achar a tarefa",
"You have to type a searchword" => "Você deve digitar uma palavra de busca",
"Invalid variable value : " => "Valor inválido para variável : ",
"You have to provide a name to the image" => "Você deve fornecer um nome para a imagem",
"%H:%M:%S %Z" => "%H:%M:%S %Z",
"uploaded by" => "carregado por",
"not specified" => "não especificado",
"There was a problem with your upload." => "Ocorreu um problema com seu upload.",
"The file you are trying to upload is too big." => "O arquivo que você quer subir é muito grande.",
"The file you are trying to upload was only partially uploaded." => "O aquivo que você está tentando subir está apenas parcialmente atualizado.",
"You must select a file for upload." => "Você deve escolher um arquivo para subir.",
"%s is an empty archive file" => "%s é um arquivo vazio",
"Project Group for " => "Grupo de Projeto para ",
"Project Admin Group for " => "Administrador do Projeto para ",
"%A %d of %B, %Y" => "%A %d de %B, %Y",
"%A %d of %B, %Y[%H:%M:%S %Z]" => "%A %d de %B, %Y[%H:%M:%S %Z]",
"%a %d of %b, %Y" => "%a %d de %b, %Y",
"%a %d of %b, %Y[%H:%M %Z]" => "%a %d de %b, %Y[%H:%M %Z]",
"attachments" => "anexos",
"No attachments for this page" => "Nenhum anexo para esta página",
"Skip to navigation" => "Pular para a navegação",
"Server name (for absolute URIs)" => "Nome do servidor (para URIs absolutas)",
"HTTPS Server" => "Servidor HTTPS",
"Wiki_Tiki_Title" => "Titulo_Wiki_Tiki",
"Validate email address (may not work)" => "Validar endereço de e-mail (pode não funcionar)",
"Require HTTP Basic authentication" => "Exigir autenticação básica HTTP",
"HTTP server name" => "Nome do servidor HTTP",
"HTTP URL prefix" => "Prefixo do endereço HTTP",
"HTTPS server name" => "Nome do servidor HTTPS",
"HTTPS URL prefix" => "Prefixo do endereço HTTPS",
"Only for users" => "Apenas para usuários",
"Users and admins" => "Usuários e administradores",
"full" => "completo",
"Enable Feature" => "Habilitar Recursos",
"Edit existing forums" => "Editar fóruns",
"Click here to delete this forum" => "Clique aqui para remover este fórum",
"label" => "rótulo",
"admin backups" => "administrar backups",
"List of available backups" => "Lista de backups disponíveis",
"Restoring a backup" => "Restaurando um backup",
"Warning!" => "Atenção!",
"Restoring a backup destoys all the data in your Tiki database. All your tables will be replaced with the information in the backup." => "Restaurar um backup destrói todos os dados no seu banco de dados Tiki. Todas suas tabelas serão sobrescritas com os dados do backup.",
"Click here to confirm restoring" => "Clique aqui para confirmar a restauração",
"Create new backup" => "Criar um novo backup",
"Creating backups may take a long time. If the process is not completed you will see a blank screen. If so you need to increment the maximum script execution time from your php.ini file" => "A criação de backups pode levar muito tempo. Se o processo não for concluído, você verá uma tela em branco. Se isto acontecer, você precisa aumentar o tempo máximo de execução de scripts em seu arquivo php.ini",
"Upload a backup" => "Carregar um backup",
"Upload backup" => "Carregar backup",
"add item" => "adicionar item",
"or create a new category" => "ou crie uma nova categoria",
"or create a new location" => "ou crie uma novo local",
"comma separated usernames" => "usuários separados por vírgula",
"comma separated username:role" => "usuário:perfil, separados por vírgula",
"with roles" => "com perfis",
"Chair" => "Cadeira",
"Optional" => "Opcional",
"Admin ephemerides" => "Administrar curiosidades",
"All ephemerides" => "Todas curiosidades",
"configure listing" => "configurar a listagem",
"Edit a file using this form" => "Editar um arquivo usando esta forma",
"delete selected files" => "apagar os arquivos selecionados",
"Flash binary (.sqf or .dcr)" => "Arquivo Flash binário (.sqf ou .dcr)",
"Assign permissions to page" => "Definir permissões para a página",
"Current permissions for this page" => "Permissões atuais para esta página",
"remove from this page" => "remover desta página",
"remove from this structure" => "remover desta estrutura",
"this page" => "esta página",
"Send email notifications when this page changes to" => "Enviar notificações por email sobre alterações nesta página para",
"add email" => "adicionar endereço de email",
"Notifications" => "Notificações",
"no comments" => "sem comentários",
"DATE-of" => "de",
"You do not have permission to edit messages" => "Você não possui permissão para editar mensagens",
"Permission denied you cannot upload files" => "Permissão negada: você não pode carregar arquivos",
"cannot process upload" => "impossível processar a carga",
"Your email address has been removed from the list of addresses monitoring this tracker" => "Seu endereço de email foi removido da lista de monitoramento deste acompanhamento",
"Your email address has been added to the list of addresses monitoring this tracker" => "Seu endereço de email foi adicionado à lista de monitoramento deste acompanhamento",
"Cancel monitoring" => "Não monitorar mais",
"Your email address has been removed from the list of addresses monitoring this item" => "Seu endereço de email foi removido da lista de monitoramento deste tem",
"Your email address has been added to the list of addresses monitoring this item" => "Seu endereço de email foi adicionado à lista de monitoramento deste tem",
"Posted messages" => "Mensagens postadas",
"To log on this site, your email must be confirmed." => "Para entrar nesse site seu e-mail precisa ser confirmado.",
"Please visit this link to confirm:" => "Por favor visite esse link para confirmar:",
"Last visitors" => "Últimos visitantes",
"logout" => "sair",
"last modification:" => "última modificação:",
"list view" => "ver em forma de lista",
"admin groups template" => "administrar template dos grupos",
"admin banning tpl" => "administrar banir tpl",
"participants" => "participantes",
"subscription" => "inscrições",
"admin categories tpl" => "admin categorias tpl",
"admin content templates template" => "administrar conteúdo do modelo dos templates",
"use in events" => "usar em eventos",
"admin Drawings tpl" => "administrar desenhos tpl",
"admin External Wikis" => "admin Wikis externos",
"admin forums template" => "administrar template dos fóruns",
"admin hotwords template" => "administar palavras-chave template",
"admin Html Pages" => "admin páginas Html",
"admin Html Pages template" => "admin template das páginas Html",
"admin featured links template" => "admin template dos recursos de link",
"admin mailin template" => "admin template de mailin",
"admin menus template" => "admin template dos menus",
"admin modules template" => "admin templates do módulos",
"admin newsletters template" => "admin template de newsletters",
"drafts" => "rascunhos",
"send newsletter" => "enviar newsletter",
"admin notifications template" => "admin template de notificações",
"admin polls template" => "administrar enquetes template",
"admin RSSmodules template" => "admin template RSSmodules",
"admin shoutbox words" => "administrar palavras do quadro negro",
"admin shoutbox words template" => "administrar palavras do quadro negro template",
"admin structures template" => "administrar estruturas template",
"admin topics template" => "administrar tópicos template",
"admin Trackers tpl" => "administrar Acompanhamentos tpl",
"Import file" => "Importar arquivo",
"remove from group" => "remover do grupo",
"admin users template" => "administrar templates de usuários",
"edit account settings" => "editar configurações da conta",
"edit included group" => "editar grupo incluído",
"remove users and their userpages" => "remover usuários e suas páginas de usuário",
"edit article tpl" => "editar artigo tpl",
"Available groups" => "Grupos disponíveis",
"remove file extension from image name" => "remover a extensão quando mostrar o nome da imagem",
"admin the category system" => "administrar as categorias do sistema",
"list galleries" => "listar galerias",
"stop monitoring this gallery" => "parar de monitorar essa galeria",
"remove from this category &amp; all its children" => "remover dessa categoria &amp; todas os seus filhos",
"remove from this category only" => "remover apenas dessa categoria",
"admin directory tpl" => "administrar diretório tpl",
"edit tpl" => "editar tpl",
"admin directory categories tpl" => "administrar categorias de diretório tpl",
"add a category" => "adicionar categoria",
"edit blog tpl" => "editar blog tpl",
"admin quicktags" => "administrar tags rápidos",
"save and go next" => "salvar e ir para a próxima",
"admin quizzes tpl" => "administrar quiz tpl",
"edit quiz questions" => "editar questões do quiz",
"edit quiz questions tpl" => "editar questões do quiz tpl",
"edit submissions tpl" => "editar artigos enviados tpl",
"save only in the theme:" => "salvar apenas no tema:",
"edit translations" => "editar traduções",
"edit translations template" => "editar traduções template",
"add to the set" => "adicionar ao espaço de traduções",
"Search " => "Busca ",
"save draft" => "salvar rascunho",
"create new file gallery" => "criar uma nova galeria de arquivos",
"duplicate file gallery" => "duplicar galeria de arquivos",
"reload" => "recarregar",
"list articles tpl" => "listar artigos tpl",
"admin Banners tpl" => "administrar banners tpl",
"admin cache tpl" => "administrar cache tpl",
"admin DynamicContent tpl" => "administrar conteúdo dinâmico tpl",
"list faqs tpl" => "listar faqs tpl",
"list posts tpl" => "listar mensagens tpl",
"list quizzes tpl" => "listar quiz tpl",
"edit quiz stats tpl" => "editar status quiz tpl",
"take survey" => "pegar pesquisa",
"list trackers tpl" => "listar acompanhamentos tpl",
"admin live support tpl" => "administrar live support tpl",
"wiki pages" => "páginas wiki",
"admin send objects tpl" => "administrar objetos enviados tpl",
"create new sheet" => "criar nova planilha",
"admin Tiki Shoutbox tpl" => "administar quadro negro do tiki tpl",
"first" => "primeiro",
"admin mode" => "modo de administração",
"trash" => "lixeira",
"empty trash" => "limpar lixeira",
"remove from trash" => "remover da lixeira",
"use start date and time" => "data e hora do início",
"use end date and time" => "data e hora do término",
"edit user files" => "editar arquivos do usuário",
"view faq tpl" => "ver faq tpl",
"admin menus tpl" => "administrar menus tpl",
"add suggestion" => "adicionar sugestão",
"list attachments" => "listar anexos",
"remove image" => "remover imagem",
"perms" => "permissões",
"ok" => "ok",
"loc" => "loc",
"cat" => "cat",
"lang" => "lang",
"prio" => "prio",
"dsn" => "dsn",
"coms" => "coms",
"ppd" => "ppd",
"admin" => "admin",
"adm" => "adm",
"site" => "site",
"delete" => "apagar",
"post" => "enviar",
"stop monitoring this blog" => "não monitorar mais este blog",
"posts" => "mensagens",
"visits" => "visitas",
"show categories" => "exibir categorias",
"author" => "autor",
"send email to user" => "enviar email ao usuário",
"delete selected" => "apagar selecionados",
"new reply" => "nova resposta",
"upload" => "carregar",
"stop monitoring this map" => "parar de monitorar este mapa",
"save" => "salvar",
"send" => "enviar",
"new messages" => "mensagens novas",
"new message" => "mensagem nova",
"go" => "buscar",
"refresh" => "atualizar",
"print" => "imprimir",
"create pdf" => "criar pdf",
"monitor this page" => "monitorar esta página",
"stop monitoring this page" => "não monitorar mais esta página",
"rename" => "renomear",
"unlock" => "destravar",
"lock" => "travar",
"history" => "histórico",
"undo" => "desfazer",
"export" => "exportar",
"discuss" => "discutir",
"add comment" => "comentário",
"attach file" => "anexar",
"translation" => "traduzir",
"last modification" => "última modificação em",
"stats" => "estats",
"last changes" => "últimas alterações",
"list pages" => "listar páginas",
"back to homepage" => "voltar à página inicial",
"cancel edit" => "cancelar edição",
"view blog" => "ver o blog",
"list blogs" => "listar os blogs",
"save and exit" => "salvar e sair",
"view comments" => "ver comentários",
"wiki help" => "auxílio wiki",
"images" => "imagens",
"path" => "caminho",
"groups" => "grupos",
"url" => "endereço",
"permissions" => "permissões",
"admin categories" => "administrar categorias",
"create new" => "criar nova",
"edit chart" => "editar gráfico",
"admin content templates" => "administrar padrões de conteúdo",
"use in cms" => "usar no CMS",
"use in wiki" => "usar no Wiki",
"use in newsletters" => "Usar em comunicados",
"use in HTML pages" => "usar em páginas HTML",
"last modif" => "última modificação",
"sections" => "seções",
"admin FortuneCookie" => "administrar FortuneCookie",
"extwiki" => "wikiext",
"topics" => "assuntos",
"age" => "idade",
"last post" => "última mensagem",
"admin hotwords" => "administrar palavras-chaves",
"admin HTML page dynamic zones" => "administrar páginas HTML com zonas dinâmicas",
"list repositories" => "listar repositórios",
"new repository" => "novo repositório",
"view repository" => "ver repositório",
"view this repository" => "ver este repositório",
"new rule" => "nova regra",
"admin featured links" => "administrar links oferecidos",
"position" => "posição",
"admin Webmail" => "administrar Webmail",
"admin menu builder" => "administrar construtor de menus",
"options" => "opções",
"admin modules" => "administrar módulos",
"assign module" => "atribuir novo módulo",
"left modules" => "módulos da esquerda",
"right modules" => "módulos da direita",
"edit/create" => "editar/criar",
"clear cache" => "limpar o cache",
"assign" => "atribuir",
"use poll" => "usar a enquete",
"use gallery" => "usar a galeria",
"use rss module" => "utilizar módulo rss",
"use menu" => "utilizar o menu",
"use phplayermenu" => "usar phplayermenu",
"use banner zone" => "Utilizar zona de banner",
"list newsletters" => "listar comunicados",
"admin newsletters" => "administrar comunicados",
"send newsletters" => "enviar comunicados",
"editions" => "edições",
"last sent" => "última enviada",
"admin Email Notifications" => "administrar notificações e-mail",
"use admin email" => "usar o endereço do admin",
"event" => "evento",
"admin polls" => "administrar enquetes",
"admin QuickTags" => "administrar QuickTags",
"admin RSS Modules" => "administrar módulos RSS",
"export pages" => "exportar páginas",
"dump tree" => "exportar árvore",
"create webhelp" => "criar webhelp",
"view webhelp" => "ver webhelp",
"tree" => "árvore",
"create new structure" => "criar nova estrutura",
"survey stats" => "estatísticas das pesquisas",
"edit this survey" => "editar esta pesquisa",
"admin surveys" => "administrar pesquisas",
"list surveys" => "listar pesquisas",
"questions" => "perguntas",
"files" => "arquivos",
"items" => "itens",
"version" => "versão",
"admin groups" => "administrar grupos",
"assign permissions" => "Associar permissões",
"admin users" => "administrar usuários",
"assign to groups" => "associar aos grupos",
"all" => "todos",
"Assign user" => "Atribuir usuário",
"assign perms to this group" => "associar permissões para esse grupo",
"admin category" => "administrar categoria",
"edit gallery" => "editar galeria",
"list gallery" => "listar a galeria",
"edit image" => "editar imagem",
"permission" => "permissão",
"remove page" => "remover página",
"browse" => "navegar",
"related" => "relacionados",
"validate" => "validar",
"add a site" => "adicionar um site",
"edit template" => "editar modelo",
"list articles" => "listar artigos",
"view articles" => "ver artigos",
"create zone" => "criar zona",
"save the banner" => "salvar o banner",
"create new block" => "criar um novo bloco",
"list quizzes" => "listar testes",
"quiz stats" => "estats. teste",
"edit this quiz" => "editar este teste",
"admin quizzes" => "administrar testes",
"results" => "resultados",
"create page" => "criar página",
"list submissions" => "listar submissões",
"new question" => "nova pergunta",
"upload file" => "carregar um arquivo",
"topic" => "assunto",
"save and approve" => "salvar e aprovar",
"new topic" => "novo assunto",
"add new" => "adicionar novo",
"add role" => "adicionar perfil",
"new minor" => "novo secundário",
"new major" => "novo principal",
"admin processes" => "administrar processos",
"admin activities" => "administrar atividades",
"admin roles" => "administrar perfis",
"edit this process" => "editar este processo",
"monitor" => "monitorar",
"send instance" => "enviar instância",
"create new gallery" => "criar uma nova galeria",
"result" => "resultado",
"edit repository" => "editar repositório",
"edit new article" => "editar um novo artigo",
"admin Banners" => "administrar Banners",
"create new blog" => "criar um novo blog",
"admin cache" => "administrar cache",
"edit blog" => "editar blog",
"edit new submission" => "editar nova mensagem",
"set as operator" => "definir como operador",
"add topic" => "adicionar assunto",
"install" => "instalar",
"wiki create" => "criar wiki",
"wiki overwrite" => "sobrescrever wiki",
"clear stats" => "limpar estatísticas",
"admin Referer stats" => "administrar Estats de Referência",
"last" => "último",
"send me my password" => "envie minha senha",
"searched" => "buscadas",
"galleries" => "galerias",
"blog posts" => "mensagens de blogs",
"articles" => "artigos",
"add article" => "adicionar um artigo",
"admin Tiki Shoutbox" => "administrar Mural",
"send answers" => "enviar as respostas",
"section" => "seção",
"remove folder" => "remover pasta",
"refresh cache" => "atualizar cache",
"HomePage" => "Página inicial",
"edit items" => "editar itens",
"list charts" => "listar gráficos",
"last chart" => "último gráfico",
"item" => "item",
"view faq" => "ver faq",
"monitor this forum" => "monitorar este fórum",
"stop monitoring this forum" => "não monitorar mais este fórum",
"delete selected topics" => "apagar os tópicos selecionados",
"stop monitoring this topic" => "não monitorar mais este tópico",
"Comments below your current threshold" => "Comentários abaixo do seu limite atual",
"add contacts" => "adicionar contatos",
"Permission denied you cannot assign permissions for this page" => "Permissão negada: você não pode definir permissões para esta página",
"slides" => "slides",
"move" => "mover",
"parameters" => "parâmetros",
"switch" => "alternar",
"similar" => "similares",
"Full Text Search" => "Busca completa",
"left" => "esquerda",
"right" => "direita",
"order" => "ordem",
"move to right column" => "mover para a coluna direita",
"unassign" => "não atribuir mais",
"move to left column" => "mover para a coluna esquerda",
"create/edit" => "criar/editar",
"rebuild thumbnails" => "Recriar miniaturas",
"upload image" => "carregar uma imagem",
"monitor this gallery" => "monitorar essa galeria",
"original size" => "tamanho original",
"return to gallery" => "retornar à galeria",
"smaller" => "menor",
"bigger" => "maior",
"prev image" => "imagem anterior",
"popup window" => "janela de popup",
"next image" => "próxima imagem",
"slideshow forward" => "avançar slide",
"stop" => "parar",
"imagescale" => "escaladeimagem",
"replace" => "substituir",
"approve" => "aprovar",
"reject" => "rejeitar",
"accept" => "aceitar",
"refuse" => "recusar",
"source" => "fonte",
"browse gallery" => "navegar pela galeria",
"To validate your account and login to the site, please click on the following link" => "Para ativar sua conta e entrar no site clique no link",
"User Selector: use options for automatic field feeding : you can use 1 for author login or 2 for modificator login." => "Seleção do usuário: use opções para preenchimento automático dos campos: você pode usar 1 para login do autor ou 2 para o login do modificador.",
"user level" => "nível de usuário",
"score" => "pontuação",
"reads" => "leituras",
"replies" => "respostas",
"cancel" => "cancelar",
"create" => "criar",
"use" => "usar",
"cached" => "em cache",
"backlinks" => "referências",
"click here" => "clique aqui",
"change" => "alterar",
"update" => "atualizar",
"flag" => "marca",
"online" => "on-line",
"structure" => "estrutura",
"try" => "experimentar",
"display" => "exibir",
"For more information, please see <a href=\"{\$helpurl}Wiki Page Editor\">Wiki Page Editor</a>" => "Para mais informações, veja <a href=\"{\$helpurl}Wiki Page Editor\">Wiki Page Editor</a> (em inglês)",
"Forums search" => "Busca nos fóruns",
"back" => "voltar",
"Edit received page" => "Editar uma página recebida",
"General preferences" => "Preferências gerais",
"Other preferences" => "Outras preferências",
"Change information" => "Atualizar informações",
"You cannot edit this page because it is a user personal page" => "Você não pode editar esta página porque ela é a página pessoal de alguém",
"Cannot read file" => "Impossível ler o arquivo",
"download" => "download",
"emot" => "emot",
"show" => "mostrar",
"hide" => "esconder",
"reply" => "responder",
"Thank you for you registration. You may log in now." => "Obrigado por registrar-se. Você pode se logar a partir de agora.",
"Storing files in a directory" => "Guardando arquivos em um diretório",
"please read" => "por favor, leia",
"Click here for more details." => "Clique aqui para mais detalhes.",
"Users &amp; groups" => "Usuários &amp; grupos",
"<b>Item</b>" => "<b>Item</b>",
"<b>Value</b>" => "<b>Valor</b>",
"<b>Feed</b>" => "<b>Campo</b>",
"<b>enable/disable</b>" => "<b>habilita/desabilita</b>",
"<b>Max number of items</b>" => "<b>Número máximo de itens</b>",
"WARNING : Old and New trackers cannot coexist. Trackers created with new library\nwill not work with old library and conversely" => "ATENÇÃO: Acompanhamentos Velhos e Novos não podem coexistir. Acompanhamentos criados com a nova biblioteca\nnão funcionarão com a biblioteca nova e vice-versa",
"configure repositories" => "configurar repositórios",
"configure this repository" => "configurar este repositório",
"copy rules" => "copiar regras",
"List all members" => "Listar todos os membros",
"quater" => "trimestre",
"Use ...page... to separate pages in a multi-page article" => "Utilize ...page... para separar páginas em artigos multi-páginas",
"Print Wiki Pages" => "Imprimir Páginas Wiki",
"Total threads" => "Número total de seqüências",
"Average threads per topic" => "Média de seqüências por tópico",
"You can include the file in an HTML/Tiki page using" => "Você pode incluir este arquivo em uma página HTML/Tiki usando",
"post new comment" => "enviar novo comentário",
"moderator actions" => "ações de moderador",
"move selected topics" => "mover os tópicos selecionados",
"unlock selected topics" => "destravar os tópicos selecionados",
"lock selected topics" => "travar os tópicos selecionados",
"merge" => "unir",
"merge selected topics" => "unir os tópicos selecionados",
"reported messages:" => "mensagens enviadas:",
"queued messages:" => "mensagens pendentes:",
"Please create a directory named \$map_path to hold your map files." => "Por favor, crie um diretório chamado \$map_path para guardar seus arquivo de mapa.",
"Permision denied" => "Permissão negada",
"downloads" => "downloads",
"Dls" => "Dls",
"pdf" => "pdf",
"UTC" => "UTC",
"Local" => "Local",
"proc" => "proc",
"Com" => "Com",
"Vers" => "Vers",
"pos" => "pos",
"pop" => "pop",
"new image uploaded by" => "nova imagem carregada por",
"new subscriptions" => "nova assinatura",
"new item in tracker" => "novo item no acompanhamento",
"tikiwiki logo" => "logo do tikiwiki",
"field is not numeric" => "campo não é numérico",
"message" => "mensagem",
"Include an article" => "Incluir um artigo",
"no such attachment on this page" => "nenhum anexo nessa página",
"select all" => "selecionar todos",
"All fields must be from the same tracker" => "Todos os campos precisam ser do mesmo acompanhamento",
"filter" => "filtro",
"missing fields list" => "Faltando lista de campos",
"move %s in %s" => "mover %s para %s",
"no such file" => "arquivo inexistente",
"hide categories" => "esconder categorias",
"Admin categories" => "Administrar categorias",
"monitor this topic" => "monitorar este tópico",
"active perms" => "permissões ativas",
"edit/unlock" => "editar/destravar",
"move selected files" => "mover os arquivos selecionados",
"from\nthe mapfile:" => "de\no arquivo de mapa:",
"compare" => "comparar",
"diff" => "difer",
"older version" => "versão antiga",
"Click the :: options in the Menu for more options." => "Clique em :: opções no menu para mais opções.",
"Please, also see" => "Por favor, veja também",
"for more setup details." => "para mais detalhes de configuração.",
"Note 1:" => "Nota 1:",
"You can remove this module in" => "Você pode remover este módulo em",
"as well as assign or edit many others." => "como associar ou editar muitos outros.",
"Note 2:" => "Nota 2:",
"The menu module installed by default is named" => "O módulo do menu instalado por padrão se chama",
"it is a \"custom module\" which includes menu ID " => "é um \"custom module\" o que inclui um ID do menu ",
"That menu is stored in database and it can be edited from " => "Ess menu está na banco de dados e pode ser editado no ",
"Do not mix this with the original <em>application_menu</em> module" => "Não misture esse com o módulo original <em>application_menu</em>",
"That one can be heavily customized to match style used but it can be currently done only by editing mod-application_menu.tpl file \"manually\"" => "Esse pode ser totalmente customizado para se parecer com o estilo usado mas isso só ser feito editando o arquivo mod-application_menu.tpl \"manually\"",
"My friends" => "Meus amigos",
"Create pdf" => "Criar pdf",
"categories" => "categorias",
"List pages where I am a creator" => "Listar páginas onde eu sou um autor",
"by creator" => "por autor",
"List pages where I am a modificator" => "Listar páginas onde eu sou um modificador",
"by modificator" => "por modificador",
"at tracker" => "no acompanhamento",
"calendar view" => "ver em forma de calendário",
"check / uncheck all" => "marcar / desmarcar todos",
"Tiki sections and features" => "Seções e recursos do Tiki",
"tikiwiki.org help" => "Ajuda em tikiwiki.org",
"Site Logo and Identity" => "Logo do site e identidade",
"yes" => "sim",
"Tiki preferences value field in db is set to be max. 250 characters long by default until now. That applies for the custom code content too. Check this field if you want to update your preferences database table to support more than 250 chars (although it was tested and works fine with mysql, it's recommended to backup your data manually before any database update)" => "As preferências do Tiki na banco de dados (db) estão configuradas para no máximo 250 caracteres por padrão. Isso se aplica para o código personalizado também. Selecione esse campo se você quer atualizar suas preferências na tabela do banco de dados para suportar mais do que 250 caracteres (apesar desse recurso ter sido bastante testado e funciona bem com o mysql é recomendado fazer manualmente um backup dos seus dados antes de qualquer atualização na db)",
"private" => "privada",
"This page is to configure settings of RSS feeds generated/exported by Tiki. To read/import RSS feeds, look for \"RSS Modules\" on the application menu, or" => "Essa página é para configurar os fontes RSS gerados/exportados pelo tiki. Para ler/importar fontes RSS, procure por \"RSS Modules\" no menu de aplicações, ou",
"Feed" => "Campo",
"Max number of items" => "Número máximo de itens",
"Feed for Articles" => "Fonte para Artigos",
"Feed for Weblogs" => "Fonte para Weblogs",
"Feed for Image Galleries" => "Fonte para Galerias de Imagens",
"Feed for File Galleries" => "Fonte para Galerias de Arquivos",
"Feed for the Wiki" => "Fonte para Wiki",
"Feed for individual Image Galleries" => "Fonte para Galerias individuais de Imagens",
"Feed for individual File Galleries" => "Fonte para Galerias individuais de Arquivos",
"Feed for individual weblogs" => "Fonte para Weblogs individuais",
"Feed for individual forums" => "Fonte para fóruns individuais",
"Feed for mapfiles" => "Campo para arquivos de mapas",
"Feed for directories" => "Fonte para os diretórios",
"Feed for tracker items" => "Fonte para os itens dos acompanhamentos",
"Site Search" => "Busca do site",
"Change style only" => "Mudar apenas o estilo",
"PDF generation" => "Geração de PDF",
"Use in CMS" => "Usar no CMS",
"Use in Wiki" => "Usar no Wiki",
"Use in newsletters" => "Usar em comunicados",
"Use in events" => "Usar em eventos",
"Use in HTML pages" => "Usar em páginas HTML",
"Edit Existing Forums" => "Editar fóruns",
"Refresh rate (if dynamic) [secs]" => "Taxa de atualização (se dinâmica) [em segundos]",
"Allow customized text message" => "Permitir mensagem de texto customizada",
"archives" => "arquivos",
"configure polls" => "configurar enquetes",
"Tip: hold down CTRL to select multiple" => "Dica: segure a tecla CTRL para selecionar vários",
"activate" => "ativar",
"fields" => "campos",
"active permissions" => "ativar permissões",
"filename" => "nome do arquivo",
"filesize" => "tamanho do arquivo",
"filetype" => "tipo do arquivo",
"longdesc" => "descrição longa",
"Import/Export CSV Data" => "Importar/Exportar dados CSV",
"Add a new group" => "Adicionar novo grupo",
"Add a new user" => "Adicionar um novo usuário",
"manage group assignments" => "alterar associações do grupo",
"set default groups" => "definir grupos padrão",
"clear" => "limpar",
"Popup Window" => "Janela de popup",
"details" => "detalhes",
"change focus" => "mudar focochange focus",
"quarter" => "trimestre",
"semester" => "semestre",
"Welcome to the Tiki Chat Rooms" => "Bem-vindo(a) às salas de chat",
"Please select a chat channel" => "Por favor, selecione uma sala ",
"enter chat room" => "entrar na sala de chat",
"There are no channels setup, please contact a site admin" => "Não existem canais configurados. Por favor contate um administrador do site",
"Chatroom" => "Sala de chat",
"Active Channels" => "Canais ativos",
"Users in this channel" => "Usuários neste canal",
"Channel Information" => "Informações sobre o canal",
"Channel" => "Canal",
"Ratio" => "Taxa",
"Use :nickname:message for private messages" => "Utilize :apelido:mensagem para mensagens particulares",
"Use [URL|description] or [URL] for links" => "Utilize [URL|descrição] ou [URL] para links",
"Use (:smileyname:) for smileys" => "Usar (:emoticons:) for emoticons",
"Create PDF" => "Criar PDF",
"PDF Settings" => "Configurações PDF",
"Select Wiki Pages" => "Selecionar Páginas Wiki",
"Remove Page" => "Remover página",
"Create Zone" => "Criar zona",
"use square brackets for an external link: [URL] or [URL|link_description] or [URL|description|nocache] (that last form prevents the local Wiki from caching the page; please use that form for large pages!)." => "use colchetes para links externos: [URL] ou [URL|link_description] or [URL|description|nocache] (essa última forma impede que o wiki coloque essa página no cache; use essa função para páginas grandes!)!).",
"answer" => "resposta",
"Edit Translation:" => "Editar tradução:",
"Use this section to set the language of the version you are currently working on." => "Use essa sessão para definir o idioma da versão que você está trabalhando atualmente.",
"Set of Translations" => "Espaço das traduções",
"Select the article for which the current article is the translation." => "Selecione o artigo para o qual o artigo atual é a tradução.",
"Translation of:" => "Tradução de:",
"Enter the name of the page for which the current page is the translation." => "Coloque o nome para o qual a página atual é a tradução.",
"Add to the Set" => "Adicionar ao espaço de traduções",
"or create a new page" => "ou crie uma nova página",
"graph" => "gráfico",
"icon" => "ícone",
"creator" => "criador",
"Sub-galleries listing configuration" => "Configuração de listagem das sub-galerias",
"Available File Galleries" => "Galerias de Arquivos Disponíveis",
"configure forum" => "configurar fórum",
"start" => "início",
"end" => "fim",
"roles" => "perfis",
"Add role" => "Adicionar perfil",
"active process" => "processo ativo",
"invalid" => "inválido",
"invalid process" => "processo inválido",
"valid process" => "processo válido",
"activities" => "atividades",
"aborted" => "abortado",
"value" => "valor",
"exceptions" => "exceções",
"Please enter your database connection info" => "Coloque as informações da conexão com a banco de dados",
"The type of database you intend to use" => "O tipo de banco de dados que você pretende usar",
"Database password" => "Senha do banco de dados",
"The name of the database where tiki will create tables. You can create the database using mysqladmin, or PHPMyAdmin or ask your\nhosting service to create a MySQL database. Normally Tiki tables won't conflict with other product names" => "O nome da base de dados onde o Tiki criará as tabelas. Você pode criar a base de dados usando mysqladmin ou PHPMyAdmin, ou ainda pedir para o responsável pelo seu servidor criar. Normalmente as tabelas do Tiki não conflitam com tabelas de outros softwares na mesma base de dados.",
"Welcome to the installation &amp; upgrade script!" => "Bem-vindo ao script de atualização da instalação!",
"Descriptions of the available profiles" => "Descrições dos perfis disponíveis",
"backup your database" => "faça um backup do seu banco de dados",
"with mysqldump or phpmyadmin before you proceed" => "com mysqldump ou phpmyadmin antes de continuar",
"Please enter your admin password to continue" => "Coloque a senha de admin para continuar",
"Print operations executed successfully" => "Saída das operações executadas com sucesso",
"Print operations failed" => "Saída das operações que falharam",
"READ THE FOLLOWING NOTES BEFORE ENTERING TIKI USING THE LINKS BELOW!" => "LEIA AS SEGUINTES NOTAS ANTES DE ENTRAR NO TIKI USANDO OS LINKS ABAIXO!",
"If this is a first time installation, go to tiki-admin.php after login to start configuring your new Tiki installation" => "Se essa é a sua primeira instalação, vá para tiki-admin.php depois de logar para começar a configurar a aplicação",
"rollback" => "restaurar",
"Listing Gallery" => "Listando a galeria",
"Gallery Files" => "Arquivos da Galeria",
"Last ver" => "Última versão",
"rollback to this version" => "restaurar para essa versão",
"add page" => "adicionar página",
"click to navigate" => "clique para navegar",
"Now enter the file URL" => "Agora digite o endereço para o arquivo",
" or upload a local file from your disk" => " ou carregue um arquivo local do seu disco",
"You have to \ncreate a gallery first!" => "Você precisa \ncriar uma galeria primeiro!",
"received" => "recebido",
"submitted" => "enviado",
"shared" => "compartilhado",
"accepted by task user and creator" => "aceito pelo usuário e criador da tarefa",
"accepted user and creator" => "aceito usuário e criador",
"not accepted by one user" => "não aceito por um usuário",
"not accepted user" => "usuário não aceito",
"waiting for me" => "esperando por mim",
"waiting for other user" => "esperando por outro usuário",
"red" => "vermelho",
"move into trash" => "mover para a lixeira",
"waiting / not started" => "esperando para começar",
"waiting" => "esperando",
"shared for group" => "compartilhado para o grupo",
"accepted by user" => "aceito pelo usuário",
"no / rejected" => "não / rejeitado",
"accepted by creator" => "aceito pelo proprietário",
"priority" => "prioridade",
"select one" => "selecionar um",
"undo trash" => "limpar lixeira",
"show:" => "mostrar:",
"all shared tasks" => "todas as tarefas compartilhadas",
"previous chart" => "gráfico anterior",
"next chart" => "próximo gráfico",
"pre" => "ant",
"permanency" => "permanência",
"avg" => "méd",
"Post New Comment" => "Enviar novo comentário",
"HTML tags are not allowed inside comments" => "Tags HTML não são permitidos em comentários",
"subscriptions" => "assinaturas",
"account" => "conta",
"actions" => "ações",
"Projects" => "Projetos",
"Projects configuration" => "Configurar projetos",
"Site Identity features" => "Recursos da identidade do site",
"Click here to delete this category" => "Clique aqui para deletar essa categoria",
"User doesnt exist" => "O usuário não existe",
"Group doesnt exist" => "O grupo não existe",
"Event without Name" => "Evento sem nome",
"Invalid old password" => "Senha antiga inválida",
"No channel indicated" => "Nenhum canal indicado",
"No nickname indicated" => "Nenhum apelido indicado",
"No permission to view the page" => "Sem permissões para visualizar a página",
"cache" => "cache",
"del" => "del",
"Include all post in a blog" => "Incluir tudo o que foi postado em um blog",
"attach" => "anexar",
"monitor this blog" => "monitorar este blog",
"browse category" => "navegar na categoria",
"Edit this file gallery:" => "Editar esta galeria de arquivos:",
"Other users can upload files to this gallery" => "Outros usuários podem carregar arquivos nesta galeria",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Clique no link a seguir para confirmar que você deseja uma nova senha e vá para a página onde você deve escolher uma nova senha. Escolha uma senha que apenas você saiba e não compartilhe com ninguém.\n{\$mail_machine}/tiki-remind_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nPronto! Você já deve estar logado.",
"usernames separated with ," => "usuários separados com ,",
"1 file attached" => "1 arquivo anexado",
"Language :" => "Idioma :",
"add" => "adicionar",
"IP not displayed in history" => "IP não aparece no histórico",
"Edit or add poll options" => "Editar ou adicionar opções de enquetes",
"Create/edit Polls" => "Criar/editar enquetes",
"Rss channels" => "Canais RSS",
"show pubdate" => "mostrar data da publicação",
"Edit tracker fields" => "Editar campos",
"visible by admin only" => "visível apenas para o administrador",
"The group will have all the permissions of the included groups" => "O novo grupo terá todas as permissões do grupo incluído",
"browse image" => "alterar imagem",
"translate" => "traduzir",
"Create or edit content" => "Criar ou editar conteúdo",
"Create or edit content block" => "Criar ou editar um bloco de conteúdo dinâmico",
"Add or edit a news server" => "Adicionar ou editar um servidor de notícias",
"Add or edit folder" => "Adicionar ou editar pasta",
"Add or edit a URL" => "Adicionar ou editar um endereço",
"A new (and temporary) password and your IP address has been sent " => "Uma nova senha temporária foi enviada, junto com seu endereço IP ",
"Country Selector options: 1|2 where 1 show only country name and 2 show only country flag. By default show both country name and flag" => "Opções ao selecionar o país: 1|2 onde 1 mostra apenas o nome do país e 2 mostra apenas a bandeira do país. Por padrão mostra os dois.",
"The SNARF plugin replaces itself with the HTML body of a URL. Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace." => "O plugin SNARF repõe a si mesmo com o corpo HTML de uma URL. Recolocamentos arbitrários regex podem ser feitos nesse contexto usando regex e regexres, o segundo sendo usado como o secundo argumento para preg_replace.",
"Zoom out x4" => "Menos zoom x4",
"Zoom out x3" => "Menos zoom x3",
"Zoom in x3" => "Mais zoom x3",
"Zoom in x4" => "Mais zoom x4",
"error" => "erro",
"Use Quote plugin rather than &ldquo;>&rdquo; for quoting" => "Use o plugin QUOTE em vez de &ldquo;>&rdquo; para citar",
"Create/edit newsletters" => "Criar/editar comunicados",
"Use Admin Email" => "Usar o endereço do admin",
"Admin tracker" => "Administrar",
"Edit this tracker" => "Editar",
"View this tracker items" => "Ver itens",
"Import/export trackers fields" => "Importar/exportar campos dos acompanhamentos",
"Edit tracker" => "Editar acompanhamento",
"Create trackers" => "Criar acompanhamentos",
"Import/export" => "Importar/exportar",
"Create/edit trackers" => "Criar/editar acompanhamentos",
"No individual permissions global permissions apply" => "Nenhuma permissão individual, permissões globais em efeito",
"Edit item" => "Editar item",
"Add or edit a site" => "Adicionar ou editar um site",
"Delete selected" => "Deletar selecionado(s)",
"Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs. Lines can be of any length, and will be wrapped together with the next line. Paragraphs are separated by blank lines." => "Como o recurso \"Formatação wiki de parágrafos\" está habilitado, todos os grupos de linhas não vazias serão apresentadas juntas num mesmo parágrafo. Parágrafos são definidos por uma linha em branco.",
"Because the Wiki paragraph formatting feature is off, each line will be presented as you write it. This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line." => "Como o recurso \"Formatação wiki de parágrafos\" está desabilitada, casa linha aparecerá na visualização da página do jeito que você escrever.",
"Creates a link to the named file. If page is not given, the file must be attached to the current page. If desc is not given, the file name is used for the link text, unless showdesc is used, which makes the file description be used for the link text. If image=1 is given, the attachment is treated as an image and is displayed directly on the page; no link is generated." => "Cria um link para o arquivo indicado. Se o parâmetro página não for utilizado, o arquivo precisa estar anexado a página atual. Se houver uma descrição (parâmetro desc) e o parâmetro showdesc for igual a 1, a descrição é usada como texto do link, se não o nome do arquivo é usado como texto do link. Se for usado o parâmetro image=1, o anexo é tratado como uma imagem e ela é mostrada diretamente na página sem link.",
"\"~pp~ data ~/pp~\" Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done). \"~pre~ data ~/pre~\" also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text." => "\"~pp~ texto ~/pp~\" Mostra um texto ou código pré-formatado; o interpretador wiki não é aplicado ao código e o espaçamento é fixo. \"~pre~ texto ~/pre~\" também mostra um texto pré-formatado com espaçamento fixo, mas nesse caso é aplicado o interpretador wiki.",
"\"~tc~ Tiki Comment ~/tc~\" makes a Tiki comment. It will be completely removed from the display, but saved in the file for future reference. \"~hc~ HTML Comment ~/hc~\" makes an HTML comment. It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar." => "\"~tc~ comentário do ~/tc~\" cria um comentário dentro do wiki. O texto entre essa tag não aparece na visualização da página mas pode ser visto na interface de edição. \"~hc~ comentário ~/hc~\" cria um comentário HTML. É inserido na saída da visualização da página como um comentário HTML, não aparece na visualização mas pode ser visto usando o \"Ver código da página\" do navegador.",
"Instructions: Type, or paste, your multiple choice questions below. One line for the question, then start answer choices on subsequent lines. Separate additional questions with a blank line. Indicate correct answers by starting them with a \"*\" (without the quotes) character." => "Instruções: digite, ou cole, as suas questões de múltipla escolha aqui, então defina a resposta correta na linha subsequente. Separe questões adicionais com uma linha branca. Indique as respostas corretas começando com \"*\" (sem as aspas).",
"Edit FAQ questions" => "Editar perguntas do FAQ",
"subscribe" => "inscrever",
"Sent edition" => "Enviar edição",
"Subscribe to newsletter" => "Assine o comunicado",
"lowercase only" => "apenas minúsculas",
"Edit fields" => "Editar campos",
"View item" => "Visualizar item",
"Add a comment" => "Adicionar um comentário",
"I have refused your friendship request!" => "Eu recusei o seu convite para entrar na sua rede de amigos!",
"sites" => "sites",
"click here to send us an email" => "clique aqui para nos enviar um e-mail",
"cool sites" => "sites legais",
"this quiz stats" => "estatísticas deste teste",
"with checked" => "com marcação",
"Old vers" => "Versão ant.",
"Tag name" => "Nome da Tag",
"Category for approved pages" => "Categoria para páginas aprovadas",
"Enable wiki 3D browser" => "Habilitar navegador wiki 3D",
"Existing page node color" => "Cor das páginas existentes",
"Missing page node color" => "Cor das páginas inexistentes",
"Anonymous editors must input anti-bot code" => "Editores anônimos precisam preencher código anti-rôbo",
"Edit idle timeout" => "Tempo limite de espera para edição",
"Use page description" => "Usar descrição de página",
"Show page title" => "Exibir título da página",
"Show page ID" => "Mostrar ID da página",
"Cache wiki pages (global)" => "Armazenamento de páginas wiki (global)",
"Users can lock pages (if perm)" => "Usuários podem travar páginas (se perm)",
"Use WikiWords" => "Usar WikiWords",
"Use Wiki paragraph formatting" => "Usar formatação Wiki de parágrafos",
"Use external link icons" => "Usar links de ícones externos",
"User's Page" => "Página do Usuário",
"UserPage prefix" => "Prefixo da página do usuário (UserPage)",
"List authors" => "Lista de autores",
"Print Page" => "Imprimir página",
"Show page version" => "Exibir versão da página",
"Maximum number of versions for history" => "Número máximo de versões para histórico",
"Never delete versions younger than days" => "Nunca apagar versões mais novas que (dias)",
"Diff style" => "Estilo de comparação entre versões",
"clip" => "clip",
"cc" => "cc",
"Phillippines" => "Filipinas",
"sender" => "remetente",
"subject" => "assunto",
"date" => "data",
"flagged" => "selecionada",
"find replied message" => "encontrar mensagens respondidas",
"mark" => "marca",
"replied" => "respondida",
"Click" => "Clique",
"posted by" => "enviada por",
"email this post" => "enviar por email",
"Add or edit event" => "Adicionar ou editar evento",
"merge selected notes into" => "combinar notas selecionadas em",
"Faq Stats" => "Estatísticas de FAQ",
"Edit User Files" => "Editar arquivos do usuário",
"Your message has been queued for approval, the message will be posted after\na moderator approves it." => "Sua mensagem está aguardando aprovação, a mensagem pode ser postada depois\nque um moderador aprová-la.",
"Webmail Doc" => "Documento Webmail",
"settings" => "configurações",
"mailbox" => "correio",
"compose" => "escrever",
"contacts" => "contatos",
"back to mailbox" => "retornar à lista de mensagens",
"full headers" => "cabeçalhos completos",
"normal headers" => "cabeçalhos comuns",
"reply all" => "responder a todos",
"forward" => "remeter",
"select from address book" => "selecionar da agenda de endereços",
"item found" => "item encontrado",
"items found" => "items encontrados",
"You are not the owner of this page" => "Você não é o dono dessa página",
"Name is empty" => "O nome está vazio",
"You do not have permission to view this part of content" => "Você não tem permissão para ver essa parte do conteúdo",
"Permission assigned to the group" => "Permissões associadas ao grupo",
"Permission assigned to the group through a category" => "Permissões associadas ao grupo através de uma categoria",
"Current permissions" => "Permissões atuais",
"Read &amp; write" => "Leitura e escrita",
"No specific permission" => "Nenhuma permissão específica",
"Apply permissions" => "Aplicar permissões",
"Additional permissions" => "Permissões adicionais",
"Add Groups" => "Adicionar grupos",
"Add Users" => "Adicionar usuários",
"Add to List" => "Adicionar a lista",
"Share Page" => "Compartilhar página",
"Extra Stuff &amp; Fun" => "Recursos extras",
"Paramaters" => "Parâmetros",
"Prevent automatic/robot registration" => "Evitar cadastro automático/robôs",
"IRC log" => "Log de IRC",
"Technology" => "Tecnologia",
"Content Related" => "Recursos de conteúdo",
"Technical Features" => "Recursos técnicos",
"Content Features" => "Recursos de Conteúdo",
"Contact Us (Anonymous)" => "Contate-nos (Anônimo)",
"entire site" => "site inteiro",
"search" => "buscar",
"up" => "subir",
"down" => "descer",
"set" => "definir",
"register" => "registrar-se",
"standard" => "padrão",
"secure" => "seguro",
"stay in ssl mode" => "permanecer no modo seguro",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc)}{ARTICLES}~/np~",
"Freetags rock!" => "Freetags rock!",
"8" => "8",
"9" => "9",
"ImportingPagesPhpWikiPageAdmin" => "ImportingPagesPhpWikiPageAdmin",
"hist" => "hist",
"Text options: 1,size,prepend,append,max with size in chars, prepend will be displayed before the field append will be displayed just after, max is the maximum number of characters that can be saved, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opções do texto: 1,tamanho,concatenar no começo,agregar,tamanho máximo em caracteres, concatenar no começo será mostrado depois do campo agregar, max é o número máximo de caracteres que podem ser salvos, e o 1 inicial é para garantir que o próximo campo de texto ou checkbox esteja na mesma linha. Se você indicar apenas 1 significa que o próximo campo também estará na mesma linha.",
"Checkbox options: put 1 if you need that next field is on the same row." => "Opções <i>Checkbox</i>: coloque 1 se você precisa que o próximo campo seja na mesma linha.",
"Numeric options: 1,size,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too." => "Opções Numéricas: 1,tamanho,prepend,append with size in chars, prepend will be displayed before the field append will be displayed just after, and initial 1 to make that next text field or checkbox is in same row. If you indicate only 1 it means next field is in same row too.",
"Dropdown options: list of items separated with commas." => "Opções da Caixa de Seleção: lista de Itens separados por vírgulas.",
"Radio buttons options: list of items separated with commas." => "Opções de botões circulares <i>(radio buttons)</i>: lista de items separados com vírgulas.",
"Group Selector: use options for automatic field feeding : you can use 1 for group of creation and 2 for group where modification come from. The default group has to be set, or the first group that come is chosen for a user, or the default group is Registered." => "Seletor de Grupo: para preenchimento automático dos campos use as opções: você pode usar 1 para criar grupos e 2 para modificar grupos. O grupo padrão deve ser especificado, ou o primeiro grupo que vier será escolhido pelo usuário, ou o grupo padrçao será Registrado.",
"Action options: Label,post,tiki-index.php,page:fieldname,highlight=test" => "Opções de ação: rótulo,mensagem,tiki-index.php,página:nome do campo,destaque=teste",
"Email address options: 0|1|2 where 0 puts the address as plain text, 1 does a hex encoded mailto link (more difficult for web spiders to pick it up and spam) and 2 does the normal href mailto." => "Opções do endereço de e-mail: 0|1|2 sendo que 0 coloca o endereço como texto puro, 1 cria um link hexadecimal para o endereço (mais difícil para enviar spams)e 2 cria um href normal para o endereço.",
"Impossible to render the graphic." => "Não foi possível renderizar o gráfico.",
"View graphic" => "Ver gráfico",
"blogId is mandatory" => "blogId é obrigatório",
"new submissions" => "novos artigos enviados",
"new sites" => "novos sites",
"new calendar events" => "novos eventos",
"Message Broadcast" => "Mensagem Global",
"click to show/hide" => "clique para mostrar/esconder",
"Are you sure you want to remove this module?" => "Você tem certeza que deseja remover esse módulo?",
"database queries used" => "consultas usadas no banco de dados",
"Created by:" => "Criado por:",
"Last Modification:" => "última modificação:",
"{\$atts_cnt} files attached" => "{\$atts_cnt} arquivos anexados",
"pass" => "senha",
"Page generated in" => "Página gerada em",
"sent" => "enviada",
"Homework" => "Tarefa de casa",
"Assignments" => "Associações",
"Favorites" => "Favoritos",
"Member list" => "Lista de membros",
"Back to Homepage" => "Voltar à página inicial",
"Edit Summary" => "Comentário da edição",
"Minor" => "Menor",
"Admin Forums Template" => "Administrar template dos fóruns",
"Edit Article" => "Editar Artigo",
"Edit Article Tpl" => "Editar artigo tpl",
"No articles." => "Nenhum artigo.",
"Show/Hide Left Modules" => "Mostrar/esconder módulos da esquerda",
"Show/Hide Right Modules" => "Mostrar/esconder módulos da direita",
"Last update from CVS" => "Última atualização do CVS",
"Translate in" => "Traduzir em",
"babelfish it" => "traduzir",
"Welcome to" => "Bem vindo a",
"6" => "Put tags separated by spaces. For tags with more than one word, use no spaces and put words together.",
"7" => "Coloque as tags separadas por espaços. Para tags com mais de uma palavra, junte as palavras sem espaço.",
"Site Logo" => "Logo do site",
"Flash Lenght" => "Largura do flash",
"Video Lenght" => "Largura do vídeo",
"Admin Groups Template" => "Administrar template dos grupos",
"Help on Banning System" => "Ajuda para banir o sistema",
"Admin banning tpl" => "Administrar banir tpl",
"Create/edit Calendars" => "Criar/editar Calendários",
"Admin Categories tpl" => "Admin categorias tpl",
"charts" => "gráficos",
"Chat Administration" => "Administração do chat",
"Chat Admin" => "Administrar Chat",
"Chat Admin tpl" => "Administrar chat tpl",
"Create/edit channel" => "Criar/editar canal",
"Half a second" => "Meio segundo",
"second" => "segundo",
"Chat channels" => "Canais de chat",
"Admin Content Templates Template" => "Administrar conteúdo do modelo dos templates",
"Help on Drawings" => "Ajuda nos desenhos",
"Admin DSN" => "Administrar DSN",
"Admin Hotwords Template" => "Administar palavras-chave template",
"Admin Featured Links" => "Administrar links oferecidos",
"Admin Featured Links Template" => "Admin template dos recursos de link",
"Admin Webmail" => "Administrar Webmail",
"Admin Mailing Template" => "Admin template de mailin",
"Admin Menu Builder" => "Administrar construtor de menus",
"Admin Menus Template" => "Admin template dos menus",
"Path to the folder icon for close sections" => "Caminho para icone de pasta usado em seções fechadas",
"Provide also a folder icon for open sections with the same name with the letter 'o' before in the same directory (ex: folder.png and ofolder.png)" => "Coloque no mesmo diretório também um icone de pasta para seções abertas com o mesmo nome e com a letra 'o' antes (ex: pasta.png e opasta.png)",
"Admin Modules Template" => "Admin templates do módulos",
"Assign Module" => "Atribuir novo módulo",
"Edit/Create" => "Editar/Criar",
"subscribed" => "inscrita",
"Admin Newsletters Template" => "Admin template de newsletters",
"Admin Notifications Template" => "Admin template de notificações",
"Admin Polls Template" => "Administrar enquetes template",
"Configure Polls" => "Configurar enquetes",
"Score System" => "Sistema de pontuação",
"security admin" => "admin segurança",
"security admin tpl" => "administrar segurança tpl",
"Admin Shoutbox Words Template" => "Administrar palavras do quadro negro template",
"Edit survey questions" => "Editar as perguntas da pesquisa",
"administer surveys template" => "administrar pesquisa template",
"system admin" => "administração do sistema",
"system admin tpl" => "administrar sistema tpl",
"Admin Topics Template" => "Administrar tópicos template",
"Admin Tracker" => "Administrar",
"Admin Users Template" => "Administrar templates de usuários",
"Warning: changing the username will require the user to change his password and will mess with slave intertiki sites that use this one as master" => "Atenção: ao mudar o nome do usuário será necessário que ele crie uma nova senha. Além disso, se você usar o recurso intertiki, alterar o nome do usuário pode atrapalhar sites que usam este tiki como mestre",
"Warning: changing the username will require the user to change his password" => "Alerta: alterar o nome do usuário forçara o mesmo a alterar sua senha",
"Again" => "Confirmar",
"User must change his password at first login" => "Usuário precisa alterar senha no primeiro login",
"Article Types tpl" => "Tipos de artigos tpl",
"Assign permissions to group" => "Definir permissões para o grupo",
"Browsing Gallery" => "Navegando pela Galeria",
"Config Calendars" => "Configurar calendário",
"Admin Directory tpl" => "Administrar diretório tpl",
"Admin Directory Categories tpl" => "Administrar categorias de diretório tpl",
"Admin Directory Related" => "Administrar Diretórios Relacionados",
"Admin Directory Sites" => "Administrar Sites do Diretório",
"Admin Directory Sites tpl" => "Administrar diretório dos sites tpl",
"Validate Sites" => "Validar Sites",
"directory validate sites tpl" => "diretório para validar sites tpl",
"Edit Blog Tpl" => "Editar blog tpl",
"Show Plugins Help" => "Exibir Auxílio para Plugins",
"Will display using the indicated HTML color or color name" => "Mostra o texto usando o código HTML ou nome da cor especificado",
"Show Text Formatting Rules" => "Exibir Regras de Formatação de Texto",
"Program dynamic content for block" => "Programar conteúdo dinâmico para o bloco",
"Admin quizzes" => "Administrar testes",
"Admin Quizzes tpl" => "Administrar quiz tpl",
"Edit Quiz Questions" => "Editar questões do quiz",
"Edit Quiz Questions Tpl" => "Editar questões do quiz tpl",
"Help on Articles" => "Ajuda com os artigos",
"Edit Submissions Tpl" => "Editar artigos enviados tpl",
"EditTemplates" => "EditarPadroes",
"EditTemplates tpl" => "Editar templates tpl",
"Edit Translations" => "Editar traduções",
"Edit Translations Template" => "Editar traduções template",
"Message queue for" => "Mensagem na fila para",
"back to forum" => "retornar ao fórum",
"Reported messages for" => "Mensagens enviadas para",
"friends tpl" => "amigos tpl",
"Update database using script" => "Atualize o banco de dados usando script",
"List Articles Tpl" => "Listar artigos tpl",
"Admin Banners" => "Administrar banners",
"Admin Cache" => "Administrar cache",
"Admin Cache tpl" => "Administrar cache tpl",
"Help on Dynamic Content" => "Ajuda no conteúdo dinâmico",
"List FAQs Tpl" => "Listar faqs tpl",
"games tpl" => "jogos tpl",
"List Posts Tpl" => "Listar mensagens tpl",
"List Quizzes Tpl" => "Listar quiz tpl",
"Edit Quiz Stats Tpl" => "Editar status quiz tpl",
"List Trackers Tpl" => "Listar acompanhamentos tpl",
"Admin Live Support tpl" => "Administrar live support tpl",
"back to admin" => "voltar à administração",
"User Calendar" => "Calendário do usuário",
"User Calendar Doc tpl" => "documento do calendário do usuário tpl",
"User Calendar Doc" => "Documento do calendário do usuário",
"User Calendar Preferences Doc tpl" => "Preferências do documento do calendário do usuário tpl",
"my tiki tpl" => "área pessoal tpl",
"Stats for quiz" => "Estats para a pesquisa",
"Received Articles" => "Artigos Recebidos",
"received articles tpl" => "artigos recebidos tpl",
"Help on Communication Center" => "Ajuda no centro de comunicações",
"received pages tpl" => "páginas recebidas tpl",
"Rename page" => "Renomear a página",
"to_version" => "versão_desejada",
"Admin Send Objects tpl" => "Administrar objetos enviados tpl",
"sheets tpl" => "planilhas tpl",
"Stats for survey" => "Estatísticas para a pesquisa",
"system logs" => "logs do sistema",
"system logs tpl" => "logs do sistema tpl",
"Theme Control Center: categories" => "Centro de Controle de Temas: categorias",
"ThemeControl" => "ControleDeTemas",
"ThemeControl tpl" => "Controle do tema tpl",
"ThemeControl Objects" => "ControleDeTemas Objetos",
"Theme Control Center: sections" => "Centro de Controle de Temas: seções",
"File Title" => "Título do Arquivo",
"Unzip all zip files" => "Descompacte todos os arquivos zip",
"Image Gallery tpl" => "Galeria de imagens tpl",
"User Assigned Modules" => "Módulos Atribuídos pelo Usuário",
"User Assigned Modules tpl" => "módulos associados pelo usuário tpl",
"User Bookmarks tpl" => "Favoritos do usuário tpl",
"UserPreferences tpl" => "Preferências do usuário tpl",
"User Tasks tpl" => "Tarefas do usuário tpl",
"User Watches tpl" => "Notificações do usuário tpl",
"View FAQ Tpl" => "Ver faq tpl",
"Admin Menus tpl" => "Administrar menus tpl",
"Edit mail account" => "Editar conta de e-mail",
"Add new mail account" => "Adicionar nova conta de email",
"User accounts" => "Contas de usuários",
"View All" => "Ver Todas",
"Msg" => "Mnsg",
"Can't parse remote HTML page" => "Não posso analisar a página HTML remota",
"%s - Version %d of this page has been saved by %s." => "%s - Versão %d desta página foi salva por %s.",
"Permission denied you cannot remove pages" => "Permissão negada: você não pode remover páginas",
"Zoom" => "Zoom",
"Plugin" => "Plugin",
"Cannot write to this file" => "Não foi possível escrever neste arquivo",
"Your post has not been posted" => "Seu post NÃO foi enviado",
"Missing title or body when trying to post a comment" => "Tentativa de envio de comentário sem título ou corpo",
"Antarctica" => "Antárctica",
"\\n for rows" => "\\n para linhas",
"Use this thread to discuss the %s page." => "Use esse assunto para discutir a página %s ",
"Newsletter subscription information at " => "Assinatura de comunicado em ",
"Changes" => "Mudanças",
"Hold down CTRL to select multiple categories" => "Segure a tecla CTRL para selecionar mais de uma categoria",
"categorize this object" => "categorizar este objeto",
"Uncheck the above checkbox to uncategorize this page/object" => "Deslecione o checkbox abaixo para remover a categoria dessa página/objeto",
"Your account request have been stored and will be activated by the admin as soon as possible." => "Seu pedido de conta foi registrado e será ativado pelo administrador o mais rápido possível.",
"New article post: {\$mail_title} by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "Nova artigo: {\$mail_title} por {\$mail_user} as {\$mail_date|tiki_short_datetime}",
"New article post at %s" => "Novo artigo em %s",
"Syntax highlighting" => "Colorização de sintaxe",
"MyTiki Home" => "Área pessoal",
"My Files" => "Meus arquivos",
"Mini calendar" => "Mini calendário",
"FriendsMenu" => "Menu dos amigos",
"User list" => "Lista de usuários",
"Dump" => "Exportação",
"Send Pages" => "Enviar páginas",
"Received pages" => "Páginas recebidas",
"New Article" => "Novo artigo",
"Admin Posts" => "Administrar mensagens",
"Submit a New Link" => "Enviar um novo link",
"Browse directory" => "Listar links",
"Admin Directory" => "Administrar diretórios",
"Layer Management" => "Gerenciamento de camadas",
"List quizzes" => "Listar testes",
"ShtMenu" => "MuralMenu",
"List trackers" => "Listar todos",
"Ephemerides Admin" => "Administrar curiosidades",
"Charts Admin" => "Administrar gráficos",
"Debugger console" => "Console de debug",
"To learn more, visit: <a href=\"http://www.tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>" => "Para aprender mais, visite: <a href=\"http://www.tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://www.tikiwiki.org</a>",
"I forgot my pass" => "Esqueci minha senha",
"Click to see the ratings" => "Clique para ver as classificações",
"Note: if you want to use images please save the post first and you\n\twill be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor\n\tor use the image URL to include images using the WYSIWYG editor" => "Nota: se você quiser usar imagens salve primeiro o post e\n\tentão será possível adicionar imagens",
"Send trackback pings to:" => "Enviar pings de retorno para:",
"(comma separated list of URIs)" => "(lista de URIs separadas por vírgula)",
"This is" => "Este é o",
"The TikiWiki community" => "A comunidade do TikiWiki",
"by the" => "criado pela",
"Tiki community" => "comunidade Tiki",
"User identity features" => "Recursos da identidade do usuário",
"Tikiwiki version" => "Versão do Tikiwiki",
"Use URI as Home Page" => "Utilizar URI como página inicial",
"OS" => "Sistema Operacional",
"Enable Smarty Security (e.g. do not allow php code in smarty templates)" => "Habilitar Smarty seguro (não permite código PHP dentro dos templates do Smarty)",
"Default charset for sending mail:" => "Codificação de caracteres padrão para enviar e-mail:",
"Mail end of line:" => "Final de linha do e-mail:",
"Disallow access to the site (except for those with permission)" => "Desabilitar o acesso ao site (exceto para quem tem permissão)",
"Message to display when site is closed" => "Mostrar mensagem quando o site estiver fechado",
"Disallow access when load is above the threshold (except for those with permission)" => "Desabilitar o acesso quando a carga do servidor está acima do seu limiar (exceto para quem possui permissão)",
"Max average server load threshold in the last minute" => "Média máxima carregada no último minuto",
"Message to display when server is too busy" => "Mostrar mensagem quando o servidor estiver sobrecarregado",
"Use cache for external images" => "Cache para imagens externas",
"Use gzipped output" => "Saída comprimida (gzip)",
"output compression is active." => "saída compactada ativa.",
"compression is handled by" => "compactação é feita por",
"Sender Email" => "Remetente (e-mail)",
"Allow anonymous users to \"Contact Us\"" => "Permitir que usuários anônimos \"Contact Us\"",
"contact feature disabled" => "contato desabilitado",
"Session lifetime in minutes" => "Tempo de vida das sessões em minutos",
"Proxy Host" => "Host do Proxy",
"Proxy port" => "Porta do Proxy",
"Any help with the documentation is welcome." => "Qualquer ajuda com a documentação é bem-vinda.",
"Release check" => "Verificar novas versões",
"Release checks are made when you browse admin main page only" => "A verificação por novas versões é feita apenas quando você acessa o painel de administração",
"Force immediate check" => "Forçar checagem imediata",
"When possible, show the real user name instead of login:" => "Quando possível, exibir o nome completo ao invés do nome de usuário:",
"Locations separator" => "Separador de localizações",
"User registration and login" => "Cadastro e login de usuário",
"Use WebServer authentication for Tiki" => "Utilizar autenticação do servidor Web para o Tiki",
"... but need admin validation" => "... mas precisa de autorização do administrador",
"Create a group for each user <br />(with the same name as the user)" => "Criar um grupo para cada usuário <br />(grupo terá o mesmo nome do usuário)",
"Use tracker for more user information" => "Usar acompanhamentos para mais informações do usuário",
"Use tracker for more group information" => "Usar acompanhamento para mais informações do grupo",
"Request passcode to register" => "Exigir código secreto para cadastro",
"Php GD library required" => "Biblioteca Php GD necessária",
"Validate users by email" => "Validar usuários por e-mail",
"Remind passwords by email (if \"Store plaintext passwords\" is activated.) Else, Reset passwords by email" => "Lembrar senhas por e-mail (se \"Guardar senhas em texto puro\" esta ativado) ou gerar nova senha por e-mail",
"Store plaintext passwords" => "Armazenar senhas sem criptografia",
"Reg users can change password" => "Usuários registrados podem alterar sua senha",
"Reg users can change language" => "Usuários comuns podem alterar idioma",
"Restrict available languages" => "Restringir línguas disponíveis",
"Available languages:" => "Línguas disponíveis:",
"Minimum username length" => "Mínimo de caracteres para o nome do usuário",
"Maximum username length" => "Máximo de caracteres para o nome do usuário",
"Force lowercase username" => "Nome do usuário apenas com minúsculas",
"Force to use chars and nums in passwords" => "Exigir uso de letras e números em senhas",
"Minimum password length" => "Comprimento mínimo para senhas",
"Password invalid after days" => "Invalidar senhas após (dias)",
"Re-validate user by email after days" => "Revalidar usuários por e-mail depois de X dias",
"Re-validate user by email after unsuccessful logins" => "Revalidar usuários por e-mail depois de X tentativas de login inválidas",
"Remember me feature" => "Lembre-me os recursos",
"Duration:" => "Duração:",
"Remember me name" => "Lembre-se do meu nome",
"Remember me domain" => "Lembre-me o domínio",
"Remember me path" => "Lembre-me o caminho",
"Protect against CSRF with a confirmation step" => "Proteger contra CSRF com uma etapa de confirmação",
"Highlight Group" => "Destacar grupo",
"User can choose beyond these groups at registration time" => "Usuário pode escolher entre esses grupos no registro",
"Displays user's contribution in the user information page" => "Mostrar as contribuições do usuário em sua página",
"Create user if not in Tiki?" => "Criar usuário se não estiver no Tiki?",
"Create user if not in Auth?" => "Criar usuários se não estiver no PEAR::Auth?",
"Just use Tiki auth for admin?" => "Utilizar apenas autenticação do Tiki para admin?",
"LDAP URL<br />(if set, this will override the Host and Port below)" => "LDAP URL<br />(se ativo, irá sobrescrever o host e a porta abaixo)",
"LDAP Host" => "Host LDAP",
"LDAP Port" => "Porta LDAP",
"LDAP Scope" => "Escopo LDAP",
"LDAP Base DN" => "Base DN do LDAP",
"LDAP User DN" => "Usuário DN do LDAP",
"LDAP User Attribute" => "Atributo do usuário do LDAP",
"LDAP User OC" => "OC do usuário do LDAP",
"LDAP Group DN" => "DN do Grupo do LDAP",
"LDAP Group Attribute" => "Atributo do Grupo do LDAP",
"LDAP Group OC" => "OC do grupo do LDAP",
"LDAP Member Attribute" => "Atributo do Membro do LDAP",
"LDAP Member Is DN" => "Membro do LDAP é DN",
"LDAP Admin User" => "Usuário de Administração LDAP",
"LDAP Admin Pwd" => "Senha de Administração LDAP",
"CAS server hostname" => "Nome do servidor CAS",
"CAS server port" => "Porta do servidor CAS",
"CAS server path" => "Path do servidor CAS",
"Change CAS preferences" => "Alterar preferências do CAS",
"Default group: " => "Grupo padrão: ",
"Note: This feature also requires PHPLayers to be turned on in " => "Nota: esse recurso depende do recurso PHPLayers que deve ser habilitado em ",
"Meta Keywords" => "Meta palavras-chaves",
"Meta Description" => "Meta descrição",
"Meta Author" => "Meta autor",
"meta robots" => "meta robôs",
"revisit after" => "retorne depois",
"Allow Smileys" => "Permitir Emoticons",
"Use File Galleries for images inclusion" => "Usar galeria de arquivos para inclusão de imagens",
"Hotwords in New Windows" => "Palavras-chaves em novas janelas",
"Trackers attachments preferences" => "Preferências dos anexos dos acompanhamentos",
"Trackers attachments" => "Anexos dos acompanhamentos",
"To add/edit wiki pages easily, add the module quick_edit via \"Modules\" on the application menu, or" => "Para adicionar/editar páginas wiki facilmente, adicione o módulo quick_edit em \"Modules\" no menu de aplicações, ou",
"Create a Tag for the Current Wiki" => "Criar Tag para o wiki atual",
"Restore the Wiki" => "Restaurar o Wiki",
"restore" => "restaurar",
"Remove a Tag" => "Remover Tag",
"Wiki Comments Settings" => "Configurações dos comentários Wiki",
"Default number of comments per page:" => "Número padrão de comentários por página:",
"Wiki Administration" => "Administração do Wiki",
"Wiki Home Page" => "Página inicial do Wiki",
"Wiki Discussion" => "Discussão Wiki",
"Wiki Link Format" => "Formato de Link Wiki",
"Controls recognition of Wiki links using the two parenthesis Wiki link syntax <i>((page name))</i>." => "Controlar reconhecimento de links Wiki usando dois parênteses como sintaxe Wiki <i>((nome da página))</i>.",
"Wiki Page List Configuration" => "Configuração da lista de páginas Wiki",
"Wiki 3D Browser Configuration" => "Configuração do Wiki 3D Browser",
"Wiki Features" => "Recursos Wiki",
"Last changes:" => "Últimas alterações:",
"Export:" => "Exportar:",
"View source:" => "Ver código fonte:",
"List pages:" => "Listar páginas:",
"Undo:" => "Desfazer:",
"Save Draft:" => "Salvar rascunho:",
"Comments:" => "Comentários:",
"Pictures:" => "Imagens:",
"Show page title:" => "Mostrar título da página:",
"Show page ID:" => "Mostrar ID da página:",
"Footnotes:" => "Nota de rodapé:",
"Users can lock pages (if perm):" => "Usuários podem travar páginas (se tiverem permissão):",
"Use WikiWords:" => "Usar PalavrasWiki:",
"Tables syntax:" => "Sintaxe de tabelas:",
"Use external link icons:" => "Usar ícone para links externos:",
"User's Page:" => "Página do usuário:",
"Page creators are admin of their pages:" => "Criador é administrador da página:",
"Import HTML:" => "Importar HTML:",
"Import Page:" => "Importar página:",
"Protect email against spam:" => "Proteger e-mail contra spam:",
"Print Page:" => "Imprimir página:",
"Allow HTML:" => "Permitir HTML:",
"Show page version:" => "Mostra versão da página:",
"Wiki History" => "Histórico Wiki",
"Wiki Watch" => "Notificação Wiki",
"More Links" => "Mais links",
"browse the category system" => "mudar para o sistema de categorias",
"Admin Charts" => "Administrar gráficos",
"Add new rule" => "Adicionar nova regra",
"Separate multiple sections with a comma ( , )." => "Separe multiplas seções com vírgula ( , ).",
"Separate multiple permissions with a comma ( , )." => "Separe multiplas permissões com vírgula ( , ).",
"To use a menu in a tiki format" => "Para usar o menu em um formato tiki",
"To use menu in a css/suckerfish format" => "Para usar o menu no formato css/suckerfish",
"EMail notifications" => "Notificações por email",
"Edit this RSS module:" => "Editar este módulo RSS:",
"Create new RSS module" => "Criar um novo módulo RSS",
"Tikiwiki settings" => "Configurar Tikiwiki",
"Create/edit questions for survey" => "Criar/editar perguntas para a pesquisa",
"Active?" => "Ativo?",
"Create Trackers" => "Criar acompanhamentos",
"Create/Edit Trackers" => "Criar/editar acompanhamentos",
"tracker name must be unique, field names must be unique \nfor a tracker and they must be valid in SQL" => "o nome do acompanhamento precisa ser único, assim como o nome dos campos \ne eles precisam ser válidos no SQL",
"Create item" => "Criar item",
"Assign to Groups" => "Associar aos grupos",
"show help" => "mostrar ajuda",
"Delete this type" => "Deletar esse tipo",
"level configuration" => "configurar os níveis",
"Browse gallery" => "Visualizar galeria",
"Upload from disk" => "Carregar do disco",
"width" => "largura",
"height" => "altura",
"Browse file gallery" => "Navegar na galeria de arquivos",
"Directory batch" => "Diretório em lote",
"Browsing Image" => "Visualizando Imagem",
"Duplicate to" => "Duplicar para",
"Again please" => "Confirmar",
"Admin category relationships" => "Administrar relacionamentos de categorias",
"Validate links" => "Validar links",
"File with names appended by -{\$user} are modifiable, others are only duplicable and be used as model." => "Arquivos com nomes terminados em -{\$user} são modificáveis, os demais são apenas duplicáveis e podem ser utilizados como modelos.",
"Im- Export Languages" => "Importar/Exportar Línguas",
"disable" => "desabilitar",
"MultiTiki setup" => "Configurar MultiTiki",
"Host:" => "Servidor:",
"Database name" => "Nome do banco de dados",
"Do nothing and enter Tiki" => "Não faça nada e entre no Tiki",
"Reset database connection settings" => "Reinicie as configurações de conexão com o banco de dados",
"Important Information" => "Informações importantes",
"Please read the following notes before entering Tikiwiki." => "Por favor leia as seguintes notas antes de entrar no Tikiwiki.",
"Create a file gallery" => "Criar uma galeria de arquivos",
"Support tickets" => "Bilhete de suporte",
"Return to HomePage" => "Retornar à página inicial",
"Stats for this survey Questions " => "Estatísticas para as perguntas desta pesquisa ",
"SysLog" => "Logs do sistema",
"Batch upload" => "Carga em lote",
"1 suggestion" => "1 sugestão",
"suggestions" => "sugestões",
"fields marked with a * are mandatory" => "campos marcados com * são obrigatórios",
"Minor Edit" => "Menor",
"The \"Snarf Wikiplugin\" is installed. It can be used by wiki editors to include pages from the local network and via regex replacement create any html." => "O \"Wikiplugin Snarf\" esta instalado. Ele pode ser utilizado pelos editores wiki para incluir páginas localmente e criar html por substituição de expressões regulares.",
"The \"Regex Wikiplugin\" is installed. It can be used by wiki editors to create any html via regex replacement." => "O \"Wikiplugin Regex\" esta instalado. Ele pode ser utilizado pelos editores wiki para criar html por substituição de expressões regulares.",
"The \"Lsdir Wikiplugin\" is installed. It can be used by wiki editors to view the contents of any directory." => "O \"Wikiplugin Lsdir\" está instalado. Ele pode ser utilizado pelos editores para visualizar o conteúdo de diretórios.",
"The \"Bloglist Wikiplugin\" is installed. It can be used by wiki editors to disclose private blog posts." => "O \"Wikiplugin Bloglist\" esta instalado. Ele pode ser usado por editores wiki para mostrar blogs restritos.",
"You can not download files" => "Você não pode baixar arquivos",
"cannot be found" => "não pode ser achado",
"Please wait 2 minutes between posts" => "Por favor, aguarde dois minutos entre mensagens",
"The text in RED is" => "O texto em VERMELHO é",
"Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nDone! You should be logged in." => "Por favor clique no link para confirmar que você deseja reiniciar sua senha e ir para a tela onde você poderá escolher uma nova senha. Escolha uma senha que apenas você conheça e não comportilhe com outras pessoas.\n{\$mail_machine}/tiki-change_password.php?user={\$mail_user|escape:'url'}&actpass={\$mail_apass}\n\nPronto! Você já deve estar logado.",
"Wiki page %s changed" => "Página wiki %s alterada",
"Blog features" => "Recursos de Blog",
"Blog level comments" => "Comentários no blog",
"Post level comments" => "Comentários nas mensagens do blog",
"Spellchecking" => "Correção ortográfica",
"Blogs have a custom heading" => "Blogs tem cabeçalho customizável",
"Default ordering for blog listing" => "Ordem padrão para listagem de Blog",
"Blog listing configuration (when listing available blogs)" => "Configuração de listagem de Blog (listando Blogs disponíveis)",
"Last modification time" => "Última hora de modificação",
"Blog comments settings" => "Configurações de comentários de Blog",
"Group calendar sticky popup" => "Popup pegajoso do calendário do grupo",
"Group calendar item view tab" => "Tab para ver item do calendário do grupo",
"Calendar manual selection of time/date" => "Seleção manual de hora e data do calendário",
"Show Category Path" => "Exibir o Caminho de Categorias",
"Show Category Objects" => "Exibir Objetos de Categorias",
"Search may show forbidden results. Much better performance though." => "Busca pode mostrar resultados proibidos, mas isso garante uma performace melhor.",
"The feature must be activated" => "O recurso precisa ser ativado",
"CMS features" => "Recursos de CMS",
"Use templates" => "Usar padrões",
"Print article" => "Imprimir artigo",
"Can specify notification emails when creating an article" => "Pode definir e-mails a serem notificados quando criar um artigo",
"Settings for page articles home" => "Configurações para a página inicial de artigos",
"Maximum number of articles in home" => "Número máximo de artigos na página inicial",
"Article comments settings" => "Configurações de comentários de artigos",
"Fields to display on page" => "Campos para mostrar na página",
"Expire Date" => "Data de Expiração",
"Copyright Management" => "Gerenciamento de Copyright",
"License Page" => "Página de Licença",
"Submit Notice" => "Nota de Submissão",
"Enable Feature for Wiki" => "Habilitar recurso para wiki",
"Enable Feature for Articles" => "Habilitar recurso para artigos",
"Enable Feature for Blogues" => "Habilitar recurso para blogs",
"Enable Feature for Faqs" => "Habilitar recurso para FAQs",
"To add/remove file galleries, go to \"File Galleries\" on the application menu, or" => "Para adicionar/remover galerias de arquivos, vá para \"Acervo de arquivos\" no menu de aplicações, ou",
"File author" => "Autor do arquivo",
"PodCast directory (must be web accessible):" => "Diretório para Podcast (o servidor web precisa ter acesso):",
"Uploaded filenames must match regex" => "Arquivos carregados devem seguir a expressão regular",
"Uploaded filenames cannot match regex" => "Arquivos carregados não podem seguir a expressão regular",
"File galleries comments settings" => "Configurações de comentários de galerias de arquivos",
"File galleries search indexing" => "Galeria de arquivos indexada para busca",
"Leave command blank to delete handler" => "Deixe o comando em branco para deletar a indexação",
"Use %1 for where internal file name should be substituted (example: \"strings %1\" to convert the document to text using the unix strings command)" => "Use %1 onde o nome do arquivo deve ser substituído (exemplo: \"strings %1\" para converter o documento para texto usando o comando de strings do unix)",
"Enable auto indexing on file upload or change" => "Habilitar indexamento automático quando fizer upload ou alteração de arquivo",
"System command" => "Comando do sistema",
"Home Forum" => "Página inicial do fórum",
"Forums features" => "Recursos do fórum",
"Forum quick jumps" => "Navegação rápida pelo fórum",
"Ordering for forums in the forum listing" => "Ordenação dos fóruns na listagem",
"Forum listing configuration" => "Configuração da listagem de fóruns",
"Threads default preferences" => "Configurações padrão dos Threads",
"Allow to manage thread defaults in each forum configuration" => "Permitir administração de padrões de thread em cada configuração de fórum",
"Display thread configuration bar to override defaults" => "Mostrar barra de configurações de thread sobrescrevendo os padrões",
"Configuration bar settings are kept for all forums during the user session:" => "A barra de configurações é mantida em todos os fóruns Durante a sessão do usuário :",
"Default thread style" => "Estilo padrão de thread",
"Default thread sort mode" => "Ordenação padrão de thread",
"Freetag Browsing" => "Navegador de tags",
"Show Tag Cloud" => "Mostrar nuvem de tags",
"Random tag cloud colors (separated by comma)" => "Cores aleatórias para Núvem de Tag (separado por vírgulas)",
"Number of Tags to show in Cloud" => "Número de tags para mostrar na nuvem de tags",
"Accept all" => "Aceitar tudo",
"Only accept lowercase freetags" => "Tags apenas com letras minúsculas",
"Camera settings" => "Configurações da câmera",
"Default Language" => "Idioma padrão",
"Available languages (Ctrl+Click to select multiple languages):" => "Idiomas disponíveis (Ctrl+Clique para selecionar mais de um idioma):",
"Show Babelfish Translation URLs" => "Mostrar URLs de Tradução do Babelfish",
"Show Babelfish Translation Logo" => "Mostrar Logo de Tradução Babelfish",
"Required for many of the general layout features" => "Obrigatório para a maioria das opções de layout do site",
"Allow Anonymous Poll Voting" => "Permitir que anônimos votem na enquete",
"Performance issues" => "Questões de desempenho",
"Search features" => "Recursos da busca",
"SearchStats" => "EstatsBusca",
"Settings for searching content" => "Configurações para busca de conteúdo",
"Search refresh rate" => "Taxa de atualização de busca",
"Number of lines" => "Número de linhas",
"this survey stats" => "estatísticas desta pesquisa",
"theme" => "tema",
"You have {\$unread} unread private messages" => "Você tem {\$unread} mensagens particulares não lidas",
"unread private messages" => "mensagens particulares não lidas",
"Welcome to the TikiWiki installation and upgrade script" => "Bem-vindo à interface de instalação e atualização do TikiWiki",
"Select your language" => "Selecione seu idioma",
"Please read the following license agreement" => "Por favor leia os termos da licença",
"Tiki was able to send a test message to info@tikiwiki.org" => "Foi possível enviar uma mensagem de teste para info@tikiwiki.org",
"Review the mail settings in your <strong>php.ini</strong> file (for example: confirm that the <strong>sendmail_path</strong> is correct)" => "Verifique as configurações de e-mail no arquivo <strong>php.ini</strong> (por exemplo: confirme que o <strong>sendmail_path</strong> está correto)",
"Only databases supported by your PHP installation are listed here. If your database is not in the list, try to install the appropriate PHP extension" => "Apenas os servidores suportados pela instalação do PHP são listados aqui. Se o seu servidor não está na lista, instale primeira a extensão PHP correspondente",
"Host name" => "Nome do host",
"Enter the host name or IP for your database" => "Coloque o nome ou então o IP do banco de dados",
"Enter the name of the database that Tiki will use" => "Coloque o nome da base de dados que o Tiki utilizará",
"User name" => "Nome do usuário",
"See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"{tr}Description of available profiles" => "Veja a documentação para uma <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"{tr}descrição dos perfis disponíveis",
"No Internet Connection has been found" => "Não foi possível conectar à internet",
"The default installation profile will be used" => "O perfil padrão de instalação será utilizado",
"Your database has been configured and Tikiwiki is ready to run" => "Sua base de dados foi configurada e o Tiki está pronto para ser utilizado",
"If this is your first install, your admin password is <strong>admin</strong>" => "Se essa é a primeira vez que você entra no site, a senha do usuário admin é <strong>admin</strong>",
"You can now log in into Tikiwiki as user <strong>admin</strong> and start configuring the application" => "Agora você pode entrar no Tikiwiki com o usuário <strong>admin</strong> e iniciar a configuração da aplicação",
"Database was left unchanged" => "A base de dados não foi alterada",
"hr" => "hr",
"Old:" => "Antigo:",
"New:" => "Novo:",
"Show Categories" => "Exibir categorias",
"Hide Categories" => "Esconder categorias",
"Administer modules" => "Administrar módulos",
"Show Module Controls" => "Mostrar Controle de Módulos",
"Users can Configure Modules" => "Usuários podem configurar módulos",
"Users can Shade Modules" => "Usuários podem colapsar módulos",
"module decides" => "módulo decide",
"Enable now." => "Habilitar agora.",
"bold" => "negrito",
"italic" => "itálico",
"underline" => "sublinhado",
"chat" => "chat",
"WfMenu" => "WfMenu",
"rankings" => "rankings",
"Backups" => "Backups",
"Review the" => "Review the",
"TikiWiki" => "TikiWiki",
"TikiWiki Web Site" => "TikiWiki Web Site",
"Status:" => "Estado:",
"(unchanged)" => "(sem alterações)",
"Remaining:" => "Restando:",
"This module requires parameters trackerId and name set" => "Esse módulo requer os parâmetros trackerId e nome definidos",
"you or someone registered this email address at" => "alguém (possivelmente você) registrou este endereço de email em",
"Your Tiki information registration" => "Instruções para cadastramento no Tiki",
"left/right" => "esquerdo/direito",
"Unassign module" => "Módulo não associado",
"home" => "Página Inicial",
"contact us" => "entre em contato",
"debugger console" => "console de depuração",
"MyMenu" => "MeuMenu",
"User menu" => "Menu do usuário",
"WikiMenu" => "MenuWiki",
"dump" => "exportação",
"orphan pages" => "páginas-órfãs",
"sandbox" => "bancada de testes",
"received pages" => "páginas recebidas",
"structures" => "estruturas",
"GalMenu" => "MenuGal",
"Articles Home" => "Página principal de Artigos",
"Send articles" => "Enviar artigos",
"Create/Edit Blog" => "Criar/Editar Blog",
"ForMenu" => "MenuFor",
"DirMenu" => "MenuDir",
"Browse Directory" => "Listar links",
"FileGalMenu" => "MenuGalArq",
"Admin FAQs" => "Administrar FAQs",
"Edit mapfiles" => "Editar arquivos de mapas",
"QuizMenu" => "MenuTeste",
"Admin quiz" => "Administrar teste",
"TrkMenu" => "MenuAcomp",
"Admin trackers" => "Administrar",
"SrvMenu" => "MenuPesq",
"Send newsletters" => "Enviar comunicados",
"Send events" => "Enviar eventos",
"Admin events" => "Administrar eventos",
"EphMenu" => "MenuCurios",
"Ephemerides" => "Curiosidades",
"ChartMenu" => "MenuGraf",
"AdmMenu" => "MenuAdm",
"Admin home" => "Página do administrador",
"Edit languages" => "Editar línguas",
"External wikis" => "Wikis externos",
"Mods Admin" => "Admin Mods",
"UsrMenu" => "MenuUsuário",
"Click here to manage your personal menu" => "Clique aqui para editar seu menu pessoal",
"Quick edit a Wiki page" => "Edição rápida de página Wiki",
"Language: " => "Idioma: ",
"Sort posts by:" => "Ordenar mensagens por:",
"read more" => "ler mais",
"Use this script to install a new TikiWiki database or upgrade your existing database to release" => "Você pode tanto fazer uma nova instalação do TikiWiki, quanto atualizar a sua instalação atual para uma nova versão",
"For more information about TikiWiki, please visit" => "Para mais informações sobre o TikiWiki visite",
"TikiWiki is software distributed under the LGPL license" => "O TikiWiki é distribuído sob a licença LGPL",
"Before installing TikiWiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Antes de instalar o TikiWiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">verifique a documentação</a> e confirme que o seu sistema é compatível com os requisitos mínimos",
"This installer will perform some basic checks automatically" => "O instalador verifica automaticamente alguns requisitos básicos",
"Tiki has not detected your PHP memory_limit" => "Não foi possível detectar o valor do memory_limit do PHP",
"This probably means you have no set limit (all is well)" => "Isso provavelmente significa que não há um limite configurado (não há problemas em não ter um limite)",
"alert" => "alerta",
"Tiki has detected your PHP memory limit at" => "Tiki detectou que seu memory limit do PHP é",
"TikiWiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "TikiWiki necessita <strong>de pelo menos</strong> 32MB para o memory do PHP para a execução dos scripts",
"Allocating too little memory will cause TikiWiki to display blank pages" => "Com um valor abaixo do mínimo necessário algumas páginas do TikiWiki poderão aparecer em branco",
"To change the memory limit, use the <strong>memory_limit</strong> key in your <strong>php.ini </strong> file (for example: memory_limit = 32M) and restart your webserver" => "Para alterar o limite de memória, altere o valor do <strong>memory_limit</strong> no arquivo <strong>php.ini </strong> (por exemplo: memory_limit = 32M) e reinicie o seu servidor web",
"Tiki has detected your PHP memory_limit at" => "Tiki detectou que seu memory limit do PHP é",
"TikiWiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "O TikiWiki usa a função <strong>mail</strong> do PHP para enviar notificações e mensagens",
"To test your system configuration, TikiWiki will attempt to send a test message to info@tikiwiki.org" => "Para testar as configurações do seu sistema, o TikiWiki tentará enviar uma mensagem para info@tikiwiki.org",
"Tiki was not able to send a test message" => "Não foi possível enviar a mensagem de teste",
"Review your mail log for details" => "Verifique o arquivo de log do servidor de e-mail para mais detalhes",
"If your host requires SMTP authentication, additional configuration may be necessary" => "Se o seu servidor utiliza autenticação SMTP, é necessário realizar algumas configurações extras",
"Tiki detected" => "O Tiki detectou",
"Tiki was not able to detect the GD library" => "Não foi possível encontrar a biblioteca GD",
"TikiWiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "O TikiWiki usa a biblioteca GD para processar imagens para a galeria de imagens entre outros",
"TikiWiki requires an active database connection" => "É necessário uma conexão ativa com um banco de dados",
"You must create the database and user <em>before</em> completing this page" => "Você deve criar a base de dados e o usuário <em>antes</em> de preencher as informações abaixo",
"Tiki cannot find a database connection" => "Tiki não conseguiu conectar à banco de dados",
"This is normal for a new installation" => "Isso é normal para uma instalação nova",
"Tiki found an existing database connection in your local.php file" => "O Tiki encontrou uma conexão com o banco de dados no arquivo db/local.php",
"Use this page to create a new database connection" => "Utilize está página para criar uma nova conexão com o banco de dados",
"Enter your database connection information" => "Digite as informações da conexão com o banco de dados",
"Database type" => "Tipo do banco de dados",
"Select the type of database to use with Tiki" => "Selecione o tipo do servidor de banco de dados que será usado",
"Use <strong>localhost</strong> if the database is running on the same machine as Tiki" => "Utilize <strong>localhost</strong> se o banco de dados está na mesma máquina que o Tiki",
"For SQLite, enter the path and filename to your database file" => "Para SQLite, coloque o caminho e o nome do arquivo",
"The database must already exist. You can create the database using mysqladmin, PHPMyAdmin, cPanel, or ask your hosting provider.  Normally Tiki tables won't conflict with other product names" => "A base de dados precisa existir. Você pode criar uma base de dados usando mysqladmin, PHPMyAdmin, cPanel, ou então pedir ajuda ao suporte do seu servidor. Em geral o nome das tabelas do Tiki não conflitam com tabelas de outros softwares",
"For Oracle" => "Para Oracle",
"Enter a database user with administrator permission for the Database" => "Informe o nome de um usuário com permissões de administrador na base de dados",
"Select the installation" => "Selecione o script de instalação",
"(or upgrade)" => "(ou atualização)",
"script to use" => "para usar",
"This script will populate {if \$tikidb_created}(or upgrade){/if} the database" => "Esse script irá popular {if \$tikidb_created}(ou atualizar){/if} a base de dados",
"Profiles can be used to pre-configure your site with specific features and settings" => "Perfis podem ser utilizados para habilitar em seu site um grupo específico de configurações e recursos",
"Visit <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> for more information" => "Visite <a href=\"http://profiles.tikiwiki.org\" target=\"_blank\">http://profiles.tikiwiki.org</a> para mais informações",
"This will destroy your current database" => "Essa ação irá destruir todos os dados antigos da base",
"Create a new database (clean install) with profile" => "Criar a nova base de dados (nova instação) com o perfil",
"This site has an admin account configured" => "Esse site tem uma conta de administrador configurada",
"Please login with your admin password to continue" => "Por favor entre com a sua senha de administrador para continuar",
"Pass" => "Senha",
"operations executed successfully" => "operações executadas com sucesso",
"SQL queries" => "queries SQL",
"Operations failed" => "Operações falharam",
"Display details" => "Exibir detalhes",
"Admin email" => "E-mail do administrador",
"This is the email address for your administrator account" => "Endereço de e-mail para a conta do usuário administrador do site",
"Enter Your TikiWiki" => "Entrar no TikiWiki",
"The installation is complete" => "A instalação foi completado com sucesso!",
"Enter TikiWiki and Lock Installer" => "Travar o script de instalação e entrar no TikiWiki",
"Enter TikiWiki Without Locking Installer" => "Entrar no TikiWiki sem travar o script de instalação",
"Restart the installer" => "Reiniciar o instalador",
"Reset the" => "Reiniciar a",
"Install/Upgrade Profile" => "Instalar/atualizar perfil",
"System Admin" => "Administração do sistema",
"Misc" => "Misc",
"Displays an miniquiz" => "Mostra um mini-teste",
"underscores" => "sublinhados",
"colons" => "dois pontos",
"some text" => "algum texto",
"equals" => "igual",
"One carat" => "Um acento circunflexo",
"Creates a box with the data" => "Cria uma caixa com os dados",
"creates a title bar" => "Cria uma barra de título",
"make headings" => "cria cabeçalhos",
"creates a table" => "cria uma tabela",
"makes a horizontal rule" => "criar uma linha horizontal",
"page|desc" => "página|desc",
"displays an image" => "exibe uma imagem",
"Non cacheable images" => "Imagens não armazenáveis em cache",
"height width desc link and align are optional" => "height, width, desc, link e align são opcionais",
"Wiki File Attachments" => "Anexos do arquivo wiki",
"displays rss feed with id=n maximum=m items" => "exibe fonte rss com itens id=n maximum=m",
"Will be replaced by the actual value of the dynamic content block with id=n" => "Será substituído pelo valor real do bloco de conteúdo dinâmico com id=n",
"\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "\"{literal}{toc}{/literal}\", \"{literal}{maketoc}{/literal}\" mostrar uma tabela de conteúdo para a página atual baseada em estruturas (toc) ou ! cabeçalhos (maketoc)",
"weeks" => "semanas",
"If not in the group, edit is always redirected to the staging page edit" => "Se não estiver no gruop, editar sempre redireciona a edição de página em regime de teste",
"Unique page name prefix to indicate staging copy" => "Prefixo único do nome da página para indicar cópia em regime de teste",
"Freetags are disabled" => "Tag-Livre (Freetags) estão desabilitadas",
"Tiki is unable to connect to the database " => "Tiki não pode se conectar ao banco de dados ",
"Tiki was unable to retrieve login data from the database " => "Tiki não conseguiu recuperar os dados de login no banco de dados ",
"The following error message was returned" => "A seguinte mensagem de erro retornou",
"Things to check" => "Pontos para verificar",
"Is your database up and running" => "Seu banco de dados está rodando",
"Are your database login credentials correct" => "Os dados de login do banco de dados está correto",
"Did you complete the <a href='tiki-install.php' >Tiki Installer" => "Você completou o <a href='tiki-install.php' >Instalador do Tiki",
"Please see <a href=\"http://doc.tikiwiki.org/\">the documentation</a> for more information" => "Por favor, veja <a href=\"http://doc.tikiwiki.org/\">a documentação</a> para mais informação",
"PHP version" => "Versão do PHP",
"Server" => "Servidor",
"Sample plugin" => "Plugin de exemplo",
"Font family to use" => "Fonte a ser usada",
"As defined by CSS" => "Como definido no CSS",
"Select a Wiki page to link to" => "Selecione uma página Wiki para linkar com",
"This is an approximation based on your server memory limit" => "Essa é uma aproximaximação baseada no limite de memória do seu servidor",
"Your database requires an update to match the current TikiWiki version. Please proceed to <a href=\"tiki-install.php\">the installer</a>. Using Tiki with an incorrect database version usually provoke errors" => "Seu banco de dados requer uma atualização para ser a mesma versão do TikiWiki. Por favor, execute o <a href=\"tiki-install.php\">instalador</a>. Usar o Tiki com uma versão do banco de dados incorreta frequentemente provoca erros",
"The file you are trying upload was only partially uploaded" => "O arquivo que você está tentando carregar foi carregados apenas parcialmente",
"Flash player not available" => "O \"Flash player\" não está disponível",
"__WARNING__: Plugin disabled \$plugin" => "__ATENÇÃO__: Plugin \$plugin desabilitado",
"Upload was not successful. Duplicate file content " => "Arquivo carregado sem sucesso. Conteúdo de arquivo duplicado ",
"Displays various information about the client" => "Exibe várias informações sobre o cliente",
"Creates a link to an anchor within a page. Anchors can be created using the ANAME plugin" => "Cria uma link para uma âncora em uma página. Âncoras pode ser criadas usando o plugin ANAME",
"Anchor link label" => "Rótulo do link para âncora",
"The anchor name as defined in the ANAME plugin" => "O nome da âncora como definido no plugin ANAME",
"The name of the wiki page containing the anchor" => "O nome da página wiki que contém a âncora",
"Inserts an anchor in the wiki page. Anchors can be linked to using the ALINK plugin" => "Insere uma âncora na página wiki. É possível criar links para as âncoras usando o plugin ALINK",
"The name of the anchor" => "O nome da âncora",
"Autogenerated content. Leave blank initially" => "Auto-gerar conteúdo. Deixar em branco inicialmente",
"Absolute URL to the image or relative path from tikiwiki root" => "URL absoluta para a imagem ou caminho relativo a partir da raiz do tikiwiki",
"Image alignment. Possible values: left, right, center" => "Alihamento da imagem. Valores possíveis: left, right, center (esquera, direita, centro)",
"Image annotations changed" => "Anotações de Imagem modificadas",
"Creates an annotation block for an image" => "Criar um bloco de anotações para uma imagem",
"Displays an image and allow the users to define zones to highlight information on the image" => "Exibir uma imagem e permitir usuários definirem zonas para exibir informações em uma imagem",
"Includes an article\\'s content within the page" => "Inclui o conteúdo de um artigo na página",
"The article field to display. Default field is Heading" => "O campo do artigo a ser exibido. O campo padrão é o Cabeçalho",
"The article to display. If no value is provided, most recent article will be used" => "O artigo a ser exibido. Se não for informado nada, o artigo mais recente será usado",
"Includes a list of articles within the page" => "Insere uma lista de artigos em uma página",
"The amount of articles to display in the list" => "Quantos artigos serão exibidos na lista",
"The ID of the category to list from" => "O ID do assunto dos artigos que serão listados",
"The article language to list" => "O idioma dos artigos que serão listados",
"The column and order of the sort in columnName_asc or columnName_desc format" => "O nome da coluna e a ordem pela qual será organizada no formato nomeDaColuna_asc ou nomeDaColuna_desc",
"Whether to not report when there are no articles" => "Não relatar quando não houver artigos",
"Whether to only show the title of the articles" => "Mostrar apenas o título dos artigos",
"Set your preferred languages" => "Defina seus idiomas preferenciais",
"Changes that need to be reproduced are highlighted below" => "Mudanças que precisam ser reproduzidas estão marcadas abaixo.",
"Please see the <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>evaluation of each feature</a> on Tiki's developer site" => "Por favor, veja a <a class='rbox-link' target='tikihelp' href='http://doc.tikiwiki.org/Features'>explicação de cada recurso</a> no site de Desenvolvimento do Tiki",
"Used to embed Flash content in wiki pages, banners etc" => "Usado para inserir conteúdos Flash em páginas wiki, banners, etc...",
"Store passwords in plain text is activated. You should never set this unless you know what you are doing" => "Armazenar senha como texto simples está habilitado. Você não deve fazer isso a menos que saiba o que está fazendo",
"A new version of Tikiwiki, <b>{\$tiki_release}</b>, is available. You are currently running <b>{\$tiki_version}</b>. Please visit <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>" => "Uma nova versão do TikiWIki, <b>{\$tiki_release}</b>, está disponível. Você está rodando a versão <b>{\$tiki_version}</b>. Por favor, acesse <a href=\"http://tikiwiki.org/Download\">http://tikiwiki.org/Download</a>",
"The following list of changes has been applied" => "As seguintes configurações foram feitas",
"Please select some actions to view" => "Por favor, seleciona algumas ações para visualizar",
" The connection failed, so check the server names" => " A conexão falhou, então verifique o nome do servidor",
" But the login failed, so check the Username and Password" => " Mas o login falhou, então verifique seu Nome de Usuário e Senha",
"Plugin modified by editor" => "Plugin modificado pelo editor",
"You are about to delete a TikiTest file, do you want to continue " => "Você está prestes a deletar um arquivo TikiTest, deseja continuar  ",
"Click to Navigate" => "Clique para navegar",
"Focus:" => "Foco:",
// ### end of unused words

// ### start of untranslated words
// ### uncomment value pairs as you translate
// "Explorer" => "Explorer",
// "Slideshow" => "Slideshow",
// "Aland Islands" => "Aland Islands",
// "Andorra" => "Andorra",
// "Anguilla" => "Anguilla",
// "Aruba" => "Aruba",
// "Azerbaijan" => "Azerbaijan",
// "Belize" => "Belize",
// "Benin" => "Benin",
// "Bhutan" => "Bhutan",
// "Bosnia and Herzegovina" => "Bosnia and Herzegovina",
// "Botswana" => "Botswana",
// "Bouvet Island" => "Bouvet Island",
// "British Indian Ocean Territory" => "British Indian Ocean Territory",
// "British Virgin Islands" => "British Virgin Islands",
// "Bulgaria" => "Bulgaria",
// "Burkina Faso" => "Burkina Faso",
// "Burundi" => "Burundi",
// "Cambodia" => "Cambodia",
// "Cape Verde" => "Cape Verde",
// "Catalan Countries" => "Catalan Countries",
// "Central African Republic" => "Central African Republic",
// "Chad" => "Chad",
// "Christmas Island" => "Christmas Island",
// "Cocos Islands" => "Cocos Islands",
// "Comoros" => "Comoros",
// "Congo" => "Congo",
// "Congo Democratic" => "Congo Democratic",
// "Djibouti" => "Djibouti",
// "Dominica" => "Dominica",
// "Equatorial Guinea" => "Equatorial Guinea",
// "Eritrea" => "Eritrea",
// "Falkland Islands" => "Falkland Islands",
// "Faroe Islands" => "Faroe Islands",
// "French Southern Territories" => "French Southern Territories",
// "Gabon" => "Gabon",
// "Gambia" => "Gambia",
// "Georgia" => "Georgia",
// "Ghana" => "Ghana",
// "Gibraltar" => "Gibraltar",
// "Greenland" => "Greenland",
// "Grenada" => "Grenada",
// "Guadeloupe" => "Guadeloupe",
// "Guernsey" => "Guernsey",
// "Guinea" => "Guinea",
// "Heard Island and McDonald Islands" => "Heard Island and McDonald Islands",
// "Hong Kong" => "Hong Kong",
// "Isle of Man" => "Isle of Man",
// "Jersey" => "Jersey",
// "Kiribati" => "Kiribati",
// "Kyrgyzstan" => "Kyrgyzstan",
// "Laos" => "Laos",
// "Lesotho" => "Lesotho",
// "Liberia" => "Liberia",
// "Libya" => "Libya",
// "Liechtenstein" => "Liechtenstein",
// "Macao" => "Macao",
// "Madagascar" => "Madagascar",
// "Malawi" => "Malawi",
// "Maldives" => "Maldives",
// "Mali" => "Mali",
// "Martinique" => "Martinique",
// "Mauritania" => "Mauritania",
// "Mayotte" => "Mayotte",
// "Moldova" => "Moldova",
// "Montenegro" => "Montenegro",
// "Montserrat" => "Montserrat",
// "Myanmar" => "Myanmar",
// "Namibia" => "Namibia",
// "Nauru" => "Nauru",
// "Netherlands Antilles" => "Netherlands Antilles",
// "Niue" => "Niue",
// "Norfolk Island" => "Norfolk Island",
// "Northern Mariana Islands" => "Northern Mariana Islands",
// "Oman" => "Oman",
// "Palau" => "Palau",
// "Philippines" => "Philippines",
// "Pitcairn" => "Pitcairn",
// "Republic of Macedonia" => "Republic of Macedonia",
// "Reunion" => "Reunion",
// "Rwanda" => "Rwanda",
// "Saint Helena" => "Saint Helena",
// "Saint Kitts and Nevis" => "Saint Kitts and Nevis",
// "Saint Lucia" => "Saint Lucia",
// "Saint Pierre and Miquelon" => "Saint Pierre and Miquelon",
// "San Marino" => "San Marino",
// "Sao Tome and Principe" => "Sao Tome and Principe",
// "Senegal" => "Senegal",
// "Serbia" => "Serbia",
// "Seychelles" => "Seychelles",
// "Sierra Leone" => "Sierra Leone",
// "South Georgia and South Sandwich Islands" => "South Georgia and South Sandwich Islands",
// "Svalbard and Jan Mayen" => "Svalbard and Jan Mayen",
// "Swaziland" => "Swaziland",
// "Syria" => "Syria",
// "Tajikistan" => "Tajikistan",
// "Tanzania" => "Tanzania",
// "Tokelau" => "Tokelau",
// "Turkmenistan" => "Turkmenistan",
// "Turks and Caicos Islands" => "Turks and Caicos Islands",
// "Tuvalu" => "Tuvalu",
// "Uganda" => "Uganda",
// "United Nations Organization" => "United Nations Organization",
// "United States Minor Outlying Islands" => "United States Minor Outlying Islands",
// "US Virgin Islands" => "US Virgin Islands",
// "Uzbekistan" => "Uzbekistan",
// "Vanuatu" => "Vanuatu",
// "Viet Nam" => "Viet Nam",
// "Wallis and Futuna" => "Wallis and Futuna",
// "Western Sahara" => "Western Sahara",
// "Yemen" => "Yemen",
// "MySQL Improved (mysqli). Requires MySQL 4.1+" => "MySQL Improved (mysqli). Requires MySQL 4.1+",
// "PostgeSQL 7.2+" => "PostgeSQL 7.2+",
// "Oracle" => "Oracle",
// "Sybase" => "Sybase",
// "SQLLite" => "SQLLite",
// "MSSQL" => "MSSQL",
// "Farsi" => "Farsi",
// "Finnish" => "Finnish",
// "Fijian" => "Fijian",
// "Galician" => "Galician",
// "Q and A" => "Q and A",
// "Question ID" => "Question ID",
// "utf-8" => "utf-8",
// "iso-8859-1" => "iso-8859-1",
// "CRLF (standard)" => "CRLF (standard)",
// "LF (some Unix MTA)" => "LF (some Unix MTA)",
// "Encourage secure (https) login" => "Encourage secure (https) login",
// "crypt-md5" => "crypt-md5",
// "crypt-des" => "crypt-des",
// "tikihash (old)" => "tikihash (old)",
// "Shibboleth" => "Shibboleth",
// "OpenID and Tiki" => "OpenID and Tiki",
// "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing" => "\$feature set to \" . \$featureStr));\n\t\t\t\t} else {\n\t\t\t\t\t\$tikilib->set_preference(\$feature, \$_POST[\$feature]);\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to \" . \$featureStr));\n\t\t\t\t}\n\t\t\t} else if( \$isMultiple ) {\n\n\n\t\t\t\tif ( \$pref != '' ) {\n\t\t\t\t\t\$tikilib->set_preference(\$pref, array());\n\t\t\t\t\t\$prefs[\$feature] = \$_POST[\$feature];\n\t\t\t\t\t\$logslib->add_log('Configuration', tra(\"\$feature set to nothing",
// "Foo" => "Foo",
// "Face" => "Face",
// "You are alerted by the server " => "You are alerted by the server ",
// "You are alerted of a changement on " => "You are alerted of a changement on ",
// "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>" => "unknown destination directory. Please set it up in <a href='tiki-admin.php?page=galleries'>tiki-admin.php?page=galleries</a>",
// "unlink failed" => "unlink failed",
// "Query point" => "Query point",
// "layer" => "layer",
// "Record" => "Record",
// "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it" => "You can only use optionId = 0 to create a new option or optionId equal an id that already belongs to the menu to update it",
// "menu" => "menu",
// "The content retrieved at %s is not a list of mods" => "The content retrieved at %s is not a list of mods",
// "Can't chdir to '%s'" => "Can't chdir to '%s'",
// "%s impossible to remove" => "%s impossible to remove",
// "section edit" => "section edit",
// "Created by profile installer" => "Created by profile installer",
// "Page updated by profile installer" => "Page updated by profile installer",
// "Feed provided by %s. Click to visit" => "Feed provided by %s. Click to visit",
// "_HOMEPAGE_CONTENT_" => "_HOMEPAGE_CONTENT_",
// "<!-- jq smarty plugin inactive: feature_jquery off -->" => "<!-- jq smarty plugin inactive: feature_jquery off -->",
// "Fast Next" => "Fast Next",
// "Fast Prev" => "Fast Prev",
// "You need either JQuery or MooTools enabled for this feature" => "You need either JQuery or MooTools enabled for this feature",
// "Invert Sort" => "Invert Sort",
// "sec" => "sec",
// "km" => "km",
// "img-g" => "img-g",
// "file-g" => "file-g",
// "arts" => "arts",
// "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a one-line field for numeric input only.  Prepend or append values may be alphanumeric.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append</strong>\n\t\t\t\t<dt>Example: 0,60,,hours\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible size of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select only from a specified set of options in a drop-down bar.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "drop down with other textfield" => "drop down with other textfield",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to select from a specified set of options in a drop-down bar, or provide an alternate selection in a one-line text field.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list_of_items]</strong> is the list of all values you want in the drop-down, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear once in the list as the default selection.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a multiple-choice-style set of options from which a user may only choose one.\n\t\t\t\t<dt>Usage: <strong>list_of_items</strong>\n\t\t\t\t<dt>Example: yes,no\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[list of items]</strong> is the list of all values you want in the set, separated by commas;\n\t\t\t\t<dd>if you wish to specify a default value other than the first item, enter the value twice, consecutively, and it will appear as the one selected.\n\t\t\t\t<dd>If first option is &lt;br&gt;, options will be separated with a carriaage return\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usernames.\n\t\t\t\t<dt>Usage: <strong>auto-assign,email_notify</strong>\n\t\t\t\t<dt>Example: 1,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1, or will set the selection to the user who last modified the item if set to 2, or will give the choice between all the users for other values;\n\t\t\t\t<dd><strong>[email_notify]</strong> will send an email to the assigned user when the item is saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of usergroups.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the field to the usergroup of the creator if set to 1, or will set the selection to the group of the user who last modified the item if set to 2, or will give the choice between all the groups for other values;\n\t\t\t\t<dd>if the user does not have a default group set, the first group the user belongs to will be chosen, otherwise Registered group will be used.\n\t\t\t\t</dl>",
// "ip selector" => "ip selector",
// "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a field for entering an IP address.\n\t\t\t\t<dt>Usage: <strong>auto-assign</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-populate the field with the IP address of the user who created the item if set to 1, or will set the field to the IP of the user who last modified the item if set to 2, or will be a free IP for other values.\n\t\t\t\t</dl>",
// "page selector" => "page selector",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from the list of pages.\n\t\t\t\t<dt>Usage: <strong>auto-assign, size, create</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[auto-assign]</strong> will auto-assign the creator of the item if set to 1\n\t\t\t\t<dd><strong>[size]</strong> is the visible input length of the field in characters (<=0 not limited);\n\t\t\t\t<dd><strong>[create]</strong>: will create the page if not exits copy of the page with name value of this param.which pagename is the value of this param\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a selection from a specified list of countries.\n\t\t\t\t<dt>Usage: <strong>name_flag,sort</strong>\n\t\t\t\t<dt>Example: 1,0\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[name_flag]</strong> default is 0 and will display both the country name and its flag, 1 will display only the country name, while 2 will show only the country flag;\n\t\t\t\t<dd><strong>[sortorder]</strong> specifies the order the country list should be displayed in, where 0 is the default and sorts according to the translated name, and 1 sorts according to the english name;\n\t\t\t\t<dd>if the country names are translated and option 1 is selected for the sort order, the countries will still appear translated, but will merely be in english order.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides drop-down options to accurately select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime,startyear,endyear,blankdate</strong>\n\t\t\t\t<dt>Example: d,2000,,blank\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\";\n\t\t\t\t<dd><strong>[startyear]</strong> allows you to specify a custom first year in the date range (eg. 1987), default is current year;\n\t\t\t\t<dd><strong>[endyear]</strong> allows you to specify a custom end year in the date range (eg. 2020), default is 4 years from now;\n\t\t\t\t<dd><strong>[blankdate]</strong> when set to \"blank\" will default the initial date field to an empty date, and allow selection of empty dates;\n\t\t\t\t<dd>blankdate is overridden if the field isMandatory;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dt>Example: \"d,2000,2009,blank\"\n\t\t\t\t<dd>sets a date only field from 2000 through 2009, allowing blank dates.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a javascript graphical date selector to select a date and/or time.\n\t\t\t\t<dt>Usage: <strong>datetime</strong>\n\t\t\t\t<dt>Example: dt\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[datetime]</strong> will only allow a date to be selected if set to \"d\", and allows a full date and time selection if set to \"dt\", defaulting to \"dt\".\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user to upload an image into the tracker item.\n\t\t\t\t<dt>Usage: <strong>xListSize,yListSize,xDetailsSize,yDetailsSize,uploadLimitScale,shadowBox</strong>\n\t\t\t\t<dt>Example: 30,30,100,100,1000,item\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[xListSize]</strong> sets the pixel width of the image in the list view;\n\t\t\t\t<dd><strong>[yListSize]</strong> sets the pixel height of the image in the list view;\n\t\t\t\t<dd><strong>[xDetailSize]</strong> sets the pixel width of the image in the item view;\n\t\t\t\t<dd><strong>[yDetailSize]</strong> sets the pixel height of the image in the item view;\n\t\t\t\t<dd><strong>[uploadLimitScale]</strong> sets the maximum total size of the image, in pixels (width or height);\n\t\t\t\t<dd><strong>[shadowbox]</strong> actives a shadowbox(if feature on) = \\'item\\': to use the same shadowbox for an item, =\\'individual\\': to use a shadowbox only for this image, other value= to set the group of images of the shadowbox ;\n\t\t\t\t<dd>images are stored in img/trackers;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: ?\n\t\t\t\t<dt>Usage: <strong>label,post,tiki-index.php,page:fieldname,highlight=test</strong>\n\t\t\t\t<dt>Example: \n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[label]</strong> needs explanation;\n\t\t\t\t<dd><strong>[post]</strong> needs explanation;\n\t\t\t\t<dd><strong>[tiki-index.php]</strong> needs explanation;\n\t\t\t\t<dd><strong>[page:fieldname]</strong> needs explanation;\n\t\t\t\t<dd><strong>[highlight=test]</strong> needs explanation;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: will display trhe field name as a html header h2;\n\t\t\t\t</dl>",
// "static text" => "static text",
// "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows insertion of a static block of text into a tracker to augment input fields. (non-editable)\n\t\t\t\t<dt>Usage: <strong>wikiparse,max</strong>\n\t\t\t\t<dt>Example: 1,20\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[wikiparse]</strong> will allow wiki syntax to be parsed if set to 1, otherwise default is 0 to only support line-breaks;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows one or more categories under a main category to be assigned to the tracker item.\n\t\t\t\t<dt>Usage: <strong>parentId,inputtype,selectall</strong>\n\t\t\t\t<dt>Example: 12,radio,1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[parentId]</strong> is the ID of the main category, categories in the list will be children of this;\n\t\t\t\t<dd><strong>[inputtype]</strong> is one of [d|m|radio|checkbox], where d is a drop-down list, m is a multiple-selection drop-down list, radio and checkbox are self-explanatory;\n\t\t\t\t<dd><strong>[selectall]</strong> will provide a checkbox to automatically select all categories in the list if set to 1, default is 0;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a way to choose a value from another tracker (eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldId,linkToItem,displayedFieldsList</strong>\n\t\t\t\t<dt>Example: 3,5,1,6|8\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldId]</strong> is the field in [trackerId] from which you can select a value among all the field values of the items of [trackerId];\n\t\t\t\t<dd><strong>[linkToItem]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to the item in the other tracker;\n\t\t\t\t<dd><strong>[displayedFieldsList]</strong> is a list of fields in [trackerId] to display instead of [fieldId], multiple fields can be separated with a |;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Displays a list of field values from another tracker that has a relation with this tracker(eventually with a link).\n\t\t\t\t<dt>Usage: <strong>trackerId,fieldIdThere,fieldIdHere,displayFieldIdThere,linkToItems</strong>\n\t\t\t\t<dt>Example: 5,3,4,10|11\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the tracker ID of the fields you want to display;\n\t\t\t\t<dd><strong>[fieldIdThere]</strong> is the field (multiple fields can be separated with a \":\") you want to link with;\n\t\t\t\t<dd><strong>[fieldIdHere]</strong> is the field in this tracker you want to link with;\n\t\t\t\t<dd><strong>[displayFieldIdThere]</strong> the field(s) in [trackerId] you want to display, multiple fields can be separated by \"|\";\n\t\t\t\t<dd><strong>[linkToItems]</strong> if set to 0 will simply display the value, but if set to 1 will provide a link directly to that values item in the other tracker;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "dynamic items list" => "dynamic items list",
// "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Dynamically updates a selection list based on linked data from another tracker.\n\t\t\t\t<dt>Usage: <strong>trackerId,filterFieldIdThere,filterFieldIdHere,listFieldIdThere,statusThere</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[trackerId]</strong> is the ID of the tracker to link with;\n\t\t\t\t<dd><strong>[filterFieldIdThere]</strong> is the field you want to link with in that tracker;\n\t\t\t\t<dd><strong>[filterFieldIdHere]</strong> is the field you want to link with in the current tracker;\n\t\t\t\t<dd><strong>[listFieldIdThere]</strong> is the field ID you wish to pull the selection list from, based on the value selected in fiterFieldIdHere matching field(s) in filterFieldIdThere;\n\t\t\t\t<dd><strong>[statusThere]</strong> restricts values appearing in the list to those coming from records in the other tracker that meet specified statuses of [o|p|c] or in combination (op, opc);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows users to enter an email address with option of making it active.\n\t\t\t\t<dt>Usage: <strong>link,watchopen,watchpending,watchclosed</strong>\n\t\t\t\t<dt>Example: 0,o\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[link]</strong> may be one of [0|1|2] and specifies how to display the email address, defaulting to 0 as plain text, 1 as an encoded hex mailto link, or 2 as a standard mailto link;\n\t\t\t\t<dd><strong>[watchopen]</strong> if set to \"o\" will email the address every time the status of the item changes to open;\n\t\t\t\t<dd><strong>[watchpending]</strong> if set to \"p\" will email the address every time the status of the item changes to pending;\n\t\t\t\t<dd><strong>[watchclosed]</strong> if set to \"c\" will email the address every time the status of the item changes to closed;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Will play MP3 or FLV files, as specified, in a player.\n\t\t\t\t<dt>Usage: <strong>source,xSize,ySize</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[source]</strong> is one of [0|1|2|3|4|5] where 0 is default and will support a URL in the file gallery for MP3, 1 for URL in file gallery for FLV, 2 for URL in file gallery of either MP3 or FLV, 3 to upload an MP3 file to be played, 4 to upload an FLV file to be played, 5 to upload either an MP3 or FLV file;\n\t\t\t\t<dd><strong>[xSize]</strong> is the width in pixels of the player applet (default 200);\n\t\t\t\t<dd><strong>[ySize]</strong> is the height in pixels of the player applet (default 100);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t<dd>this is best-used as a tracker item that is not generally editable and you want a specific file played;\n\t\t\t\t\tedit the tracker item and provide the URL for the file you wish to play.\n\t\t\t\t</dl>",
// "auto-increment" => "auto-increment",
// "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows an incrementing value field, or itemId field. (non-editable)\n\t\t\t\t<dt>Usage: <strong>start,prepend,append,itemId</strong>\n\t\t\t\t<dt>Example: 1,,,itemId\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[start]</strong> is the starting value for the field, defaults to 1;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed after the field;\n\t\t\t\t<dd><strong>[itemId]</strong> if set to \"itemId\" will set this field to match the value of the actual database itemId field value;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>",
// "user subscription" => "user subscription",
// "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allow registered users to subscribe themselves to a tracker item (think Evite.com).\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Use this field as you would to have people sign up for an event. It is best if the tracker is only editable by its creator or the admin.  To set the max number of subscribers, edit the tracker item and put the number at the beginning of the field.\n\t\t\t\t<dt>Example:\n\t\t\t\t<dd>Old field may have \"#\" or \"#2[0]\" in it.  Making it \"20#2[0]\" will set the max number to 20.\n\t\t\t\t</dl>",
// "Google Maps" => "Google Maps",
// "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Use Google Maps.\n\t\t\t\t<dt>Will display a Google Maps around a point.\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: System only.\n\t\t\t\t<dt>Usage: None\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd>Needs a description.\n\t\t\t\t</dl>",
// "computed field" => "computed field",
// "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Provides a computed value based on numeric field values.\n\t\t\t\t<dt>Usage: <strong>formula</strong>\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[formula]</strong> is the formula you wish to compute, using numeric values, operators \"+ - * / ( )\", and tracker fields identified with a leading #;\n\t\t\t\t<dt>Example: \"#3*(#4+5)\"\n\t\t\t\t<dd>adds the numeric value in item 4 by 5, and multiplies it by the numeric value in item 3.\n\t\t\t\t</dl>",
// "user preference" => "user preference",
// "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows user preference changes from a tracker.\n\t\t\t\t<dt>Usage: <strong>type</strong>\n\t\t\t\t<dt>Example: password\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[type]</strong> if value is password, will allow to change the user password, if value is email, will display/allow to change the user email;\n\t\t\t\t</dl>",
// "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Function: Allows a file to be attached to the tracker item.\n\t\t\t\t<dt>Usage: <strong>listview</strong>\n\t\t\t\t<dt>Example: nu\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[listview]</strong> may be one of [n|t|s|u] on their own or in any combination (n, t, ns, nts), allowing you to see the attachment in the item list view as its name (n), its type (t), its name (n), or display the username of the uploader (u);\n\t\t\t\tnote that this option will cost an extra query to the database for each attachment and can severely impact performance with several attachments.\n\t\t\t\t<dd>\n\t\t\t\t</dl>",
// "Same as name" => "Same as name",
// "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages" => "Gives the name of another page the attached file is on. The file on that page is linked to instead. Only works with wiki pages",
// "Shows the description as the link text instead of the file name" => "Shows the description as the link text instead of the file name",
// "Makes the list of attachments a bulleted list" => "Makes the list of attachments a bulleted list",
// "Says that this file is an image, and should be displayed inline using the img tag" => "Says that this file is an image, and should be displayed inline using the img tag",
// "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description" => "Puts the stuff between {ATTACH} tags as the link text instead of the file name or description",
// "Shows all attachments from the whole wiki" => "Shows all attachments from the whole wiki",
// "Gives the number, in the list of attachments, of the attachment to link to" => "Gives the number, in the list of attachments, of the attachment to link to",
// "Gives the actual id of the attachment to link in. You probably should never use this" => "Gives the actual id of the attachment to link in. You probably should never use this",
// "Puts the number of downloads in the alt comment" => "Puts the number of downloads in the alt comment",
// "Shows a file icon" => "Shows a file icon",
// "The wiki page the avatar will link to" => "The wiki page the avatar will link to",
// "Float" => "Float",
// "left|right" => "left|right",
// "Displays a link that allows to go back in the browser history" => "Displays a link that allows to go back in the browser history",
// "Insert back link on wiki page" => "Insert back link on wiki page",
// "List all pages linking to the specified page" => "List all pages linking to the specified page",
// "The page links will point to. Default value is the current page" => "The page links will point to. Default value is the current page",
// "Displayed information" => "Displayed information",
// "Pipe separated list of fields to display. ex: hits|user" => "Pipe separated list of fields to display. ex: hits|user",
// "Excluded pages" => "Excluded pages",
// "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox" => "Pipe separated list of pages to be excluded from the listing. ex: HomePage|Sandbox",
// "Include Self" => "Include Self",
// "1|0" => "1|0",
// "No Header" => "No Header",
// "Banner" => "Banner",
// "Insert a banner" => "Insert a banner",
// "Target" => "Target",
// "missing parameter" => "missing parameter",
// "Blog List" => "Blog List",
// "Use BLOGLIST to include posts from a blog" => "Use BLOGLIST to include posts from a blog",
// "Blog ID" => "Blog ID",
// "Numeric value" => "Numeric value",
// "Maximum amount of entries to list" => "Maximum amount of entries to list",
// "Use BLOGLIST to include posts from a blog. Syntax is" => "Use BLOGLIST to include posts from a blog. Syntax is",
// "where Id is the blog Id and Items is the max number of posts to display" => "where Id is the blog Id and Items is the max number of posts to display",
// "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~" => "Ex: ~np~{BLOGLIST(Id=2, Items=15)}{BLOGLIST}~/np~",
// "Box" => "Box",
// "Box title" => "Box title",
// "Displayed above the content" => "Displayed above the content",
// "Background color" => "Background color",
// "As defined by CSS, name or Hex code" => "As defined by CSS, name or Hex code",
// "Box width" => "Box width",
// "In pixels or percentage. Default value is 100%" => "In pixels or percentage. Default value is 100%",
// "Text Alignment" => "Text Alignment",
// "Float Position" => "Float Position",
// "for box with width lesser than 100%, make text wrap around the box" => "for box with width lesser than 100%, make text wrap around the box",
// "CSS Class" => "CSS Class",
// "Apply custom CSS class to the box" => "Apply custom CSS class to the box",
// "Category IDs" => "Category IDs",
// "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page" => "List of category IDs separated by + signs. ex: 1+2+3. Default will use category of the current page",
// "Types" => "Types",
// "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img" => "List of object types to include in the list separated by plus signs. ex: article+blog+faq+fgal+forum+igal+newsletter+event+poll+quiz+survey+tracker+wiki+img",
// "Sort Order" => "Sort Order",
// "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle" => "fieldName_asc|fieldName_desc, valid fields: type, created, name, hits, shuffle",
// "Split" => "Split",
// "And" => "And",
// "Category Orphans" => "Category Orphans",
// "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker" => "wiki|article|blog|faq|fgal|forum|igal|newsletter|poll|quizz|survey|tracker",
// "Category Path" => "Category Path",
// "Separator" => "Separator",
// "String used to separate the categories in the path. Default character is >" => "String used to separate the categories in the path. Default character is >",
// "Display top category" => "Display top category",
// "yes|no, default to no" => "yes|no, default to no",
// "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool" => "Displays a chart from TikiSheet. This plugin can be generated by the TikiSheet chart tool",
// "Chart caption" => "Chart caption",
// "Sheet ID" => "Sheet ID",
// "Data sheet ID" => "Data sheet ID",
// "Chart Type" => "Chart Type",
// "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic" => "BarStackGraphic|MultibarGraphic|MultilineGraphic|PieChartGraphic",
// "Chart Width" => "Chart Width",
// "Width in pixels" => "Width in pixels",
// "Chart Height" => "Chart Height",
// "Height in pixels" => "Height in pixels",
// "Value series" => "Value series",
// "Required for pie charts" => "Required for pie charts",
// "Independant series" => "Independant series",
// "Required for types other than pie chart" => "Required for types other than pie chart",
// "Dependant series" => "Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y2' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y3' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series" => "'),\n\t\t\t),\n\t\t\t'y4' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Dependant series",
// "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors" => "'),\n\t\t\t),\n\t\t\t'color' => array(\n\t\t\t\t'required' => false,\n\t\t\t\t'name' => tra('Colors",
// "List of colors to use" => "List of colors to use",
// "Styles" => "Styles",
// "List of styles to use" => "List of styles to use",
// "Labels" => "Labels",
// "Labels for the series or values in the legend" => "Labels for the series or values in the legend",
// "Chart as PDF" => "Chart as PDF",
// "Chart as PostScript" => "Chart as PostScript",
// "Caption" => "Caption",
// "Code snippet label" => "Code snippet label",
// "Word Wrap" => "Word Wrap",
// "0|1, Enable word wrapping on the code to avoid breaking the layout" => "0|1, Enable word wrapping on the code to avoid breaking the layout",
// "Colors" => "Colors",
// "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, .." => "Syntax highlighting to use. May not be used with line numbers. Available: php, html, sql, javascript, css, java, c, doxygen, delphi, ..",
// "Line numbers" => "Line numbers",
// "0|1, may not be used with colors" => "0|1, may not be used with colors",
// "Wiki syntax" => "Wiki syntax",
// "0|1, parse wiki syntax within the code snippet" => "0|1, parse wiki syntax within the code snippet",
// "Right to left" => "Right to left",
// "0|1, switch the text display from left to right to right to left" => "0|1, switch the text display from left to right to right to left",
// "Content is HTML" => "Content is HTML",
// "0|1, display the content as is instead of escaping HTML special chars" => "0|1, display the content as is instead of escaping HTML special chars",
// "Includes content from the dynamic content system" => "Includes content from the dynamic content system",
// "Content ID" => "Content ID",
// "Also known as Fortune cookies or Taglines" => "Also known as Fortune cookies or Taglines",
// "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~" => "Pattern to display the copyright in. May contain ~title~, ~year~ and ~authors~",
// "Countdown" => "Countdown",
// "Displays a countdown from now until the specified date" => "Displays a countdown from now until the specified date",
// "Text to append to the countdown" => "Text to append to the countdown",
// "End date" => "End date",
// "Target date. Multiple formats accepted" => "Target date. Multiple formats accepted",
// "Locate Time" => "Locate Time",
// "on|off" => "on|off",
// "DBReport" => "DBReport",
// "Run a database report" => "Run a database report",
// "report definition" => "report definition",
// "Full DSN" => "Full DSN",
// "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database" => "A full DSN (Data Source Name) connection string. eg: mysql://user:pass@server/database",
// "Wiki DSN name" => "Wiki DSN name",
// "The name of a DSN connection defined by the Wiki administrator" => "The name of a DSN connection defined by the Wiki administrator",
// "0|1, parse wiki syntax within the report" => "0|1, parse wiki syntax within the report",
// "Debug" => "Debug",
// "0|1, display the parsed report definition" => "0|1, display the parsed report definition",
// "Missing db or dsn parameter" => "Missing db or dsn parameter",
// "You do not have permission to use this DSN" => "You do not have permission to use this DSN",
// "No DSN connection string found" => "No DSN connection string found",
// "Div" => "Div",
// "left|right|center|justify" => "left|right|center|justify",
// "left|right, for box with width lesser than 100%, make text wrap around the box" => "left|right, for box with width lesser than 100%, make text wrap around the box",
// "Definition List" => "Definition List",
// "One entry per line. Each line is in \"Term: Definition\" format" => "One entry per line. Each line is in \"Term: Definition\" format",
// "Draw" => "Draw",
// "Displays drawings in the wiki page" => "Displays drawings in the wiki page",
// "Name of the drawing to display" => "Name of the drawing to display",
// "Name parameter missing" => "Name parameter missing",
// "Equation" => "Equation",
// "Renders an equation written in LaTeX syntax as an image" => "Renders an equation written in LaTeX syntax as an image",
// "equation" => "equation",
// "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large" => "Percentage of increase from normal size. 100 produces the default size. 200 produces an image twice as large",
// "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size" => "Renders an equation written in LaTeX syntax as a png.  Optional parameter size defaults to 100 and is the percentage of the normal size, i.e., size=200 indicates an equation 2x the normal size",
// "Includes the list of events from a calendar in the page" => "Includes the list of events from a calendar in the page",
// "Calendar ID" => "Calendar ID",
// "Numeric" => "Numeric",
// "Maximum days" => "Maximum days",
// "Maximum Rows" => "Maximum Rows",
// "Datetime" => "Datetime",
// "0|1" => "0|1",
// "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage" => "~np~{~/np~EVENTS(calendarid=1|2,maxdays=365,max=-1,datetime=1,desc=1)}{EVENTS} Insert rss feed output into a wikipage",
// "Fade" => "Fade",
// "Displays a label. On click, the block of content will fade in and fade out" => "Displays a label. On click, the block of content will fade in and fade out",
// "Wiki syntax containing the text to display" => "Wiki syntax containing the text to display",
// "Label to display on first display" => "Label to display on first display",
// "Unspecified label" => "Unspecified label",
// "Fancy List" => "Fancy List",
// "One item per line starting with anything followed by \")\"" => "One item per line starting with anything followed by \")\"",
// "Use div" => "Use div",
// "Use div instead of ol" => "Use div instead of ol",
// "Class" => "Class",
// "CSS class of the fancylist" => "CSS class of the fancylist",
// "Creates a fancy looking list" => "Creates a fancy looking list",
// "num" => "num",
// "item text" => "item text",
// "one item per line" => "one item per line",
// "Fancy Table" => "Fancy Table",
// "One row per line, cells separated by ~|~" => "One row per line, cells separated by ~|~",
// "Heading row" => "Heading row",
// "Heading row of the table, same format as the body section" => "Heading row of the table, same format as the body section",
// "Heading CSS Class" => "Heading CSS Class",
// "CSS Class to apply on the heading row" => "CSS Class to apply on the heading row",
// "Displays a link to an attachment to a wiki page and can display an image attachment. " => "Displays a link to an attachment to a wiki page and can display an image attachment. ",
// "Gallery ID" => "Gallery ID",
// "name_asc" => "name_asc",
// "Shows ID" => "Shows ID",
// "Shows Icon" => "Shows Icon",
// "Shows Name" => "Shows Name",
// "Shows Filename" => "Shows Filename",
// "Shows Size" => "Shows Size",
// "Shows Description" => "Shows Description",
// "Shows Creation Date" => "Shows Creation Date",
// "Shows Hits" => "Shows Hits",
// "Shows Locked by" => "Shows Locked by",
// "Shows Modification Date" => "Shows Modification Date",
// "Shows Author" => "Shows Author",
// "Shows Creator" => "Shows Creator",
// "Shows Parent Gallery Name" => "Shows Parent Gallery Name",
// "Shows Number of Files" => "Shows Number of Files",
// "Shows the slideshow of a gallery" => "Shows the slideshow of a gallery",
// "List files in a file gallery (with a category) or in a category or a file gallery od this category" => "List files in a file gallery (with a category) or in a category or a file gallery od this category",
// "Displays a list of files from the File Gallery" => "Displays a list of files from the File Gallery",
// "Flash video" => "Flash video",
// "Complete URL to the movie to include" => "Complete URL to the movie to include",
// "Default width: 425" => "Default width: 425",
// "Default height: 350" => "Default height: 350",
// "Quality" => "Quality",
// "Flash video quality. Default value: high" => "Flash video quality. Default value: high",
// "Footnote" => "Footnote",
// "Inserts a superscripted footnote number next to text and takes in footnote as parameter" => "Inserts a superscripted footnote number next to text and takes in footnote as parameter",
// "The footnote" => "The footnote",
// "Footnotearea" => "Footnotearea",
// "Inserts a section for collected footnotes within the wiki page" => "Inserts a section for collected footnotes within the wiki page",
// "Download box for a file on ftp server" => "Download box for a file on ftp server",
// "ftp" => "ftp",
// "file name" => "file name",
// "Ftp Server Name" => "Ftp Server Name",
// "Ftp User name" => "Ftp User name",
// "Ftp password" => "Ftp password",
// "Download button label" => "Download button label",
// "Connection failed" => "Connection failed",
// "Gauge" => "Gauge",
// "Displays a graphical gauge" => "Displays a graphical gauge",
// "current value (REQUIRED)" => "current value (REQUIRED)",
// "Maximum Value" => "Maximum Value",
// "Maximum possible value. Default: 100" => "Maximum possible value. Default: 100",
// "Label displayed on the left side of the gauge" => "Label displayed on the left side of the gauge",
// "Color" => "Color",
// "Background Color" => "Background Color",
// "Bar width in pixels" => "Bar width in pixels",
// "Label Width" => "Label Width",
// "Width in pixels allocated to the label" => "Width in pixels allocated to the label",
// "Display Percentage" => "Display Percentage",
// "true|false, if true then a percentage of the maximum is displayed" => "true|false, if true then a percentage of the maximum is displayed",
// "Display Value" => "Display Value",
// "true|false, if the numeric value is displayed" => "true|false, if the numeric value is displayed",
// "Bar height in pixels" => "Bar height in pixels",
// "Google Analytics" => "Google Analytics",
// "Add the tracking code for Google Analytics" => "Add the tracking code for Google Analytics",
// "Account number" => "Account number",
// "The account number for the site" => "The account number for the site",
// "googledoc" => "googledoc",
// "Leave this empty" => "Leave this empty",
// "Type of Google document" => "Type of Google document",
// "key" => "key",
// "Google doc key - for example pXsHENf1bGGY92X1iEeJJI" => "Google doc key - for example pXsHENf1bGGY92X1iEeJJI",
// "Name of iframe" => "Name of iframe",
// "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large" => "Size of frame, use instead of width and height, they will fit the Google presentations sizes exactly. It can be small|medium|large",
// "Pixels or %" => "Pixels or %",
// "Margin Height" => "Margin Height",
// "Pixels" => "Pixels",
// "Margin Width" => "Margin Width",
// "Scrolling" => "Scrolling",
// "editLink" => "editLink",
// "Required parameter \"type\" missing" => "Required parameter \"type\" missing",
// "Required parameter \"key\" missing" => "Required parameter \"key\" missing",
// "Displays a Google document" => "Displays a Google document",
// "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition" => "Wiki text to display if conditions are met. The body may contain {ELSE}. Text after the marker will be displayed to users not matching the condition",
// "Allowed Groups" => "Allowed Groups",
// "Pipe separated list of groups allowed to view the block. ex: Admins|Developers" => "Pipe separated list of groups allowed to view the block. ex: Admins|Developers",
// "Denied Groups" => "Denied Groups",
// "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers" => "Pipe separated list of groups denied from viewing the block. ex: Anonymous|Managers",
// "HTML" => "HTML",
// "Include literal HTML in a Wiki page" => "Include literal HTML in a Wiki page",
// "0|1, parse wiki syntax within the html code" => "0|1, parse wiki syntax within the html code",
// "Include literal HTML" => "Include literal HTML",
// "Iframe" => "Iframe",
// "iframe" => "iframe",
// "Displays an iframe" => "Displays an iframe",
// " (experimental - possible successor to img in 4.0)" => " (experimental - possible successor to img in 4.0)",
// "File ID" => "File ID",
// "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in a File Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required" => "Numeric ID of an image in an Image Gallery (or comma-separated list). \"fileId\", \"id\" or \"src\" required",
// "Image Source" => "Image Source",
// "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required" => "Full URL to the image to display. \"fileId\", \"id\" or \"src\" required",
// "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded" => "Maximum height or width in pixels (largest dimension is scaled).\tIf no scalesize is given one will be attempted from default or given height or width.  If scale does not match a defined scale for the gallery the full sized image is downloaded",
// "Alias: lnk. Location the image should point to" => "Alias: lnk. Location the image should point to",
// "Link Relation" => "Link Relation",
// "\"rel\" attribute to add to the link" => "\"rel\" attribute to add to the link",
// "Link title" => "Link title",
// "Title text" => "Title text",
// "Image alt text" => "Image alt text",
// "Alternate text to display if impossible to load the image" => "Alternate text to display if impossible to load the image",
// "Alias:imalign. Image alignment in the page. (left, right)" => "Alias:imalign. Image alignment in the page. (left, right)",
// "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)" => "Whether to block items from flowing next to image from the top or bottom. (top,bottom,both,none)",
// "Image description to display on the page" => "Image description to display on the page",
// "Image Map" => "Image Map",
// "Name of the image map to use for the image" => "Name of the image map to use for the image",
// "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)" => "CSS class to apply to the image'.\"'\".'s img tag. (Usually used in configuration rather than on individual images.)",
// "CSS Style" => "CSS Style",
// "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)" => "CSS styling to apply to the plugin. (Usually used in configuration rather than on individual images.)",
// "Border options" => "Border options",
// "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options" => "Border configuration.  Values \"on\" and \"off\" control visibility, or else specify CSS styling options",
// "Description options" => "Description options",
// "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)" => "Description configuration.\tValues \"on\" and \"off\" control visibility, or else specify CSS styling options. (Usually used in configuration rather than on individual images.)",
// "Default configuration" => "Default configuration",
// "Default configuration definitions. (Usually used in configuration rather than on individual images.)" => "Default configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Mandatory configuration" => "Mandatory configuration",
// "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)" => "Mandatory configuration definitions. (Usually used in configuration rather than on individual images.)",
// "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content" => "Display an image using configured format. Allows presentation of all images to be changed without having to alter existing content",
// "Display an image" => "Display an image",
// "Displays an image" => "Displays an image",
// "Full URL to the image to display" => "Full URL to the image to display",
// "Alternate Text" => "Alternate Text",
// "Height of the image to display" => "Height of the image to display",
// "Width of the image to display" => "Width of the image to display",
// "Link Title" => "Link Title",
// "Image alignment in the page. (left, right, center) Uses HTML IMG tag" => "Image alignment in the page. (left, right, center) Uses HTML IMG tag",
// "Float Alignment" => "Float Alignment",
// "Image alignment in the flow of the document. (left, right, none) Uses CSS float property" => "Image alignment in the flow of the document. (left, right, none) Uses CSS float property",
// "Style to apply to the image" => "Style to apply to the image",
// "Include a page\\'s content" => "Include a page\\'s content",
// "Page Name" => "Page Name",
// "Wiki page name to include" => "Wiki page name to include",
// "When only a portion of the page should be included, specify the marker from which inclusion should start" => "When only a portion of the page should be included, specify the marker from which inclusion should start",
// "When only a portion of the page should be included, specify the marker at which inclusion should end" => "When only a portion of the page should be included, specify the marker at which inclusion should end",
// "Jabber" => "Jabber",
// "Applet height in pixels" => "Applet height in pixels",
// "'),\n\t\t\t\t'description' => tra('Applet width in pixels" => "'),\n\t\t\t\t'description' => tra('Applet width in pixels",
// "'),\n\t\t\t\t'description' => tra('jabber.org" => "'),\n\t\t\t\t'description' => tra('jabber.org",
// "Default Color" => "Default Color",
// "255,255,255" => "255,255,255",
// "JQuery" => "JQuery",
// "Insert JQuery javascript code. Requires feature_jquery" => "Insert JQuery javascript code. Requires feature_jquery",
// " (experimental - may change in future versions)" => " (experimental - may change in future versions)",
// "JQuery Code" => "JQuery Code",
// "NotOnReady" => "NotOnReady",
// "NoJQuery" => "NoJQuery",
// "Optional markup for when feature_jquery is off" => "Optional markup for when feature_jquery is off",
// "Insert JQuery javascript code" => "Insert JQuery javascript code",
// "jquery code e.g. \$jq(\"img\\" => "jquery code e.g. \$jq(\"img\\",
// "Do not execute on document ready (execute inline)" => "Do not execute on document ready (execute inline)",
// "Javascript" => "Javascript",
// "Insert a javascript file or/and some javascript code" => "Insert a javascript file or/and some javascript code",
// "javascript code" => "javascript code",
// "Javascript filename" => "Javascript filename",
// "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Not Language" => "Not Language",
// "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs" => "List of languages for which the block is not displayed. Languages use the two letter language codes (ex: en, fr, es, ...). Multiple languages can be specified by separating codes by + signs",
// "Page name to display information of. Default value is current page" => "Page name to display information of. Default value is current page",
// "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given" => "The last_mod plugin replaces itself with last modification time of the named wiki page, or the current page if no name given",
// "Result Offset" => "Result Offset",
// "Result number at which the listing should start" => "Result number at which the listing should start",
// "Result Count" => "Result Count",
// "Amount of results displayed in the list" => "Amount of results displayed in the list",
// "Initial" => "Initial",
// "txt" => "txt",
// "Show Name Only" => "Show Name Only",
// "Structure Head" => "Structure Head",
// "Show Page Alias" => "Show Page Alias",
// "Two letter language code to filter pages listed" => "Two letter language code to filter pages listed",
// "Orphan Language" => "Orphan Language",
// "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed" => "Two letter language code to filter pages listed. Only pages not available in the provided language will be listed",
// "Load Translations" => "Load Translations",
// "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter" => "user or pipe separated list of two letter language codes for additional languages to display. If the language parameter is not defined, the first element of this list will be used as the primary filter",
// "Exact Match" => "Exact Match",
// "Related to Find" => "Related to Find",
// "Only Orphan Pages" => "Only Orphan Pages",
// "For List Pages" => "For List Pages",
// "List Directory" => "List Directory",
// "Full path to the server-local directory" => "Full path to the server-local directory",
// "URL Prefix" => "URL Prefix",
// ".ext" => ".ext",
// "Limit" => "Limit",
// "Maximum amount of files to display" => "Maximum amount of files to display",
// "Map File" => "Map File",
// "Extents" => "Extents",
// "Inline Flash mp3 and flv Player" => "Inline Flash mp3 and flv Player",
// "Mediaplayer" => "Mediaplayer",
// "MP3 URL" => "MP3 URL",
// "Complete URL to the mp3 to include" => "Complete URL to the mp3 to include",
// "FLV URL" => "FLV URL",
// "Complete URL to the flv to include" => "Complete URL to the flv to include",
// "One of" => "One of",
// "Mini Quiz" => "Mini Quiz",
// "Displays a miniquiz" => "Displays a miniquiz",
// "Instructions::Feedback" => "Instructions::Feedback",
// "Tracker ID" => "Tracker ID",
// "Insert Module" => "Insert Module",
// "Module name as known in Tikiwiki" => "Module name as known in Tikiwiki",
// "Decoration" => "Decoration",
// "Flip" => "Flip",
// "Max" => "Max",
// "np" => "np",
// "notitle" => "notitle",
// "Displays a module inlined in page. More parameters can be added, not supported by UI" => "Displays a module inlined in page. More parameters can be added, not supported by UI",
// "Monospace" => "Monospace",
// "Font name as known in browsers" => "Font name as known in browsers",
// "Mouse Over" => "Mouse Over",
// "Create a mouseover feature on some text" => "Create a mouseover feature on some text",
// "Mouseover text if param label exists. Page text if text param exists" => "Mouseover text if param label exists. Page text if text param exists",
// "Text displayed on the page. The body is the mouseover content" => "Text displayed on the page. The body is the mouseover content",
// "Destination link when moused-over text is clicked. Use http:// for external links" => "Destination link when moused-over text is clicked. Use http:// for external links",
// "DEPRECATED" => "DEPRECATED",
// "Text displayed on the mouseover. The body contains the text of the page" => "Text displayed on the mouseover. The body contains the text of the page",
// "Mouse over box width. Default: 400px" => "Mouse over box width. Default: 400px",
// "Mouse over box height. Default: 200px" => "Mouse over box height. Default: 200px",
// "Offset X" => "Offset X",
// "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px" => "Shifts the overlay to the right by the specified amount of pixels in relation to the cursor. Default: 5px",
// "Offset Y" => "Offset Y",
// "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px" => "Shifts the overlay to the bottom by the specified amount of pixels in relation to the cursor. Default: 0px",
// "Parse Body" => "Parse Body",
// "y|n, parse the body of the plugin as wiki content. (Default to y)" => "y|n, parse the body of the plugin as wiki content. (Default to y)",
// "Color of the inside popup" => "Color of the inside popup",
// "Default: #F5F5F5" => "Default: #F5F5F5",
// "Text popup color" => "Text popup color",
// "#FFFFFF" => "#FFFFFF",
// "Padding" => "Padding",
// "No label specified" => "No label specified",
// "MWTable" => "MWTable",
// "fancy" => "fancy",
// "true|false" => "true|false",
// "wiki_classes" => "wiki_classes",
// "Displays the data using (sort of) MediaWiki syntax" => "Displays the data using (sort of) MediaWiki syntax",
// "Displays a table using MediaWiki syntax" => "Displays a table using MediaWiki syntax",
// "MySpace" => "MySpace",
// "MySpace Page" => "MySpace Page",
// "Displays a SWF myspace mp3 playlist on the wiki page" => "Displays a SWF myspace mp3 playlist on the wiki page",
// "Object Hits" => "Object Hits",
// "Object ID" => "Object ID",
// "Object Type" => "Object Type",
// "Search for images uploaded by users" => "Search for images uploaded by users",
// " (deprecated - scheduled to be removed or changed significantly)" => " (deprecated - scheduled to be removed or changed significantly)",
// "Filename or full path to file" => "Filename or full path to file",
// "Plugin Manager" => "Plugin Manager",
// "Multiple values separated with | can be used" => "Multiple values separated with | can be used",
// "Poll" => "Poll",
// "Poll ID" => "Poll ID",
// "Profile Installer" => "Profile Installer",
// "Adds controls required to install a profile" => "Adds controls required to install a profile",
// "Domain" => "Domain",
// "Profile repository domain. Default value is profiles.tikiwiki.org" => "Profile repository domain. Default value is profiles.tikiwiki.org",
// "Profile Name" => "Profile Name",
// "Name of the profile" => "Name of the profile",
// "Profile plugin only available to administrators" => "Profile plugin only available to administrators",
// "Profile %0/%1 not found" => "Profile %0/%1 not found",
// "Proposal" => "Proposal",
// "Provides a widget for users to vote on a proposal and view the current decision" => "Provides a widget for users to vote on a proposal and view the current decision",
// "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username" => "The list of votes casted. One vote per line. Either 0, +1 or -1 followed by a username",
// "Accept proposal" => "Accept proposal",
// "Still undecided" => "Still undecided",
// "Reject proposal" => "Reject proposal",
// "Displays a proposal acceptance widget" => "Displays a proposal acceptance widget",
// "Short description of the proposal to vote on. Will be displayed above the result table" => "Short description of the proposal to vote on. Will be displayed above the result table",
// "Quote" => "Quote",
// "Quoted text" => "Quoted text",
// "Reply to" => "Reply to",
// "Name of the quoted person" => "Name of the quoted person",
// "Random Dynamic Content" => "Random Dynamic Content",
// "Includes random content from the dynamic content system" => "Includes random content from the dynamic content system",
// "Redirect" => "Redirect",
// "Redirect the user to a wiki page or generic URL" => "Redirect the user to a wiki page or generic URL",
// "Wiki page name to redirect to" => "Wiki page name to redirect to",
// "Complete URL, internal or external" => "Complete URL, internal or external",
// "Redirects you to another wiki page" => "Redirects you to another wiki page",
// "Regular Expression" => "Regular Expression",
// "Takes regex expressions and parses the content between REGEX tags and replaces the text" => "Takes regex expressions and parses the content between REGEX tags and replaces the text",
// "Page name containing the regular expression" => "Page name containing the regular expression",
// "Displays a comment, tip, note or warning box" => "Displays a comment, tip, note or warning box",
// "remarks text" => "remarks text",
// "Remarks Box" => "Remarks Box",
// "Label displayed above the remark" => "Label displayed above the remark",
// "Highlight" => "Highlight",
// "Icon ID" => "Icon ID",
// "RSS Feed" => "RSS Feed",
// "Inserts an RSS feed output" => "Inserts an RSS feed output",
// "IDs" => "IDs",
// "List of feed IDs separated by colons. ex: feedId:feedId2" => "List of feed IDs separated by colons. ex: feedId:feedId2",
// "Amount of results displayed" => "Amount of results displayed",
// "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage" => "~np~{~/np~RSS(id=>feedId:feedId2,max=>3,date=>1,desc=>1,author=>1)}{RSS} Insert rss feed output into a wikipage",
// "SourceForge" => "SourceForge",
// "aid?" => "aid?",
// "adit?" => "adit?",
// "groupid?" => "groupid?",
// "sharethis" => "sharethis",
// "Insert a ShareThis Button from www.sharethis.com" => "Insert a ShareThis Button from www.sharethis.com",
// "Display a social networking tool" => "Display a social networking tool",
// "Sheet" => "Sheet",
// "Displays the content of a spreadsheet in the page" => "Displays the content of a spreadsheet in the page",
// "Internal ID of the TikiSheet" => "Internal ID of the TikiSheet",
// "New sheet in page: " => "New sheet in page: ",
// "Incomplete call to plugin: No target sheet" => "Incomplete call to plugin: No target sheet",
// "Create new sheet" => "Create new sheet",
// "Show Pages" => "Show Pages",
// "Search criteria" => "Search criteria",
// "Maximum amount of results displayed" => "Maximum amount of results displayed",
// "name|desc" => "name|desc",
// "Skype" => "Skype",
// "Clickable Skype link" => "Clickable Skype link",
// "Name or number to call or chat with" => "Name or number to call or chat with",
// "Snarf" => "Snarf",
// "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified" => "Include the content of a remote HTTP page. Regular expression selecting the content portion to include must be specified",
// "Full URL to the page to include" => "Full URL to the page to include",
// "PCRE compliant regular expression" => "PCRE compliant regular expression",
// "Regular Expression Part" => "Regular Expression Part",
// "ex: \$1" => "ex: \$1",
// "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace" => "The SNARF plugin replaces itself with the HTML body of a URL.  Arbitrary regex replacement can be done on this content using regex and regexres, the latter being used as the second argument to preg_replace",
// "Data to sort, one entry per line" => "Data to sort, one entry per line",
// "asc|desc|shuffle" => "asc|desc|shuffle",
// "Join Columns" => "Join Columns",
// "Generate the colspan attribute if columns are missing" => "Generate the colspan attribute if columns are missing",
// "Fixed Size" => "Fixed Size",
// "Generate the width attribute on the columns" => "Generate the width attribute on the columns",
// "Column Size" => "Column Size",
// "Editable" => "Editable",
// "Display edit icon for each section" => "Display edit icon for each section",
// "Custom class" => "Custom class",
// "add a class to customize the design" => "add a class to customize the design",
// "SQL" => "SQL",
// "DNS Name" => "DNS Name",
// "ADODB DNS" => "ADODB DNS",
// "Subscript" => "Subscript",
// "Subscribe or unsubscribe to a group" => "Subscribe or unsubscribe to a group",
// "Subscribe Group" => "Subscribe Group",
// "Group Name" => "Group Name",
// "As known in Tikiwiki" => "As known in Tikiwiki",
// "Subscribe Text" => "Subscribe Text",
// "Subscribe text, containing %s as the placeholder for the group name" => "Subscribe text, containing %s as the placeholder for the group name",
// "Unsubscribe Text" => "Unsubscribe Text",
// "Unsubscribe text, containing %s as the placeholder for the group name" => "Unsubscribe text, containing %s as the placeholder for the group name",
// "Subscribe Action" => "Subscribe Action",
// "Subscribe button label, containing %s as the placeholder for the group name" => "Subscribe button label, containing %s as the placeholder for the group name",
// "Unsubscribe Action" => "Unsubscribe Action",
// "Unsubscribe button label, containing %s as the placeholder for the group name" => "Unsubscribe button label, containing %s as the placeholder for the group name",
// "Subscribe Groups" => "Subscribe Groups",
// "Colon separated list of groups" => "Colon separated list of groups",
// "Superscript" => "Superscript",
// "Displays text in superscript (exponent)" => "Displays text in superscript (exponent)",
// "Displays text in superscript" => "Displays text in superscript",
// "Wiki Page to redirect the user after his vote" => "Wiki Page to redirect the user after his vote",
// "Displays a survey" => "Displays a survey",
// "Tag" => "Tag",
// "Displays the text between an html tag" => "Displays the text between an html tag",
// "Any valid HTML tag, span by default" => "Any valid HTML tag, span by default",
// "Equivalent of the style attribute on the HTML tag" => "Equivalent of the style attribute on the HTML tag",
// "File ID from the file gallery" => "File ID from the file gallery",
// "Image ID from the image gallery" => "Image ID from the image gallery",
// "URL to the image" => "URL to the image",
// "Maximum Size" => "Maximum Size",
// "Maximum width or height for the image" => "Maximum width or height for the image",
// "Floating" => "Floating",
// "Link target of the image" => "Link target of the image",
// "File is not an image" => "File is not an image",
// "Server does not support image manipulation" => "Server does not support image manipulation",
// "No image specified" => "No image specified",
// "Title Search" => "Title Search",
// "Search wiki page titles" => "Search wiki page titles",
// "Search Criteria" => "Search Criteria",
// "Portion of a page name" => "Portion of a page name",
// "hits|user" => "hits|user",
// "Exclude" => "Exclude",
// "Pipe separated list of page names to exclude from results" => "Pipe separated list of page names to exclude from results",
// "Table of Contents (Structure)" => "Table of Contents (Structure)",
// "Displays the table of contents for the current structure\\'s subtree as part of the page content" => "Displays the table of contents for the current structure\\'s subtree as part of the page content",
// "Maximum Depth" => "Maximum Depth",
// "Maximum amount of levels to display. On very large structures, this should be limited" => "Maximum amount of levels to display. On very large structures, this should be limited",
// "By default, structure for the current page will be displayed. Alternate structure may be provided" => "By default, structure for the current page will be displayed. Alternate structure may be provided",
// "asc|desc" => "asc|desc",
// "Show Description" => "Show Description",
// "0|1, show the page description instead of the page name" => "0|1, show the page description instead of the page name",
// "Show Numbering" => "Show Numbering",
// "0|1, display the section numbers or not" => "0|1, display the section numbers or not",
// "plain|fancy" => "plain|fancy",
// "Top Friends" => "Top Friends",
// "Maximum result count" => "Maximum result count",
// "Translate a string using Tikiwiki translation table" => "Translate a string using Tikiwiki translation table",
// "string" => "string",
// "Confirmation message after posting form" => "Confirmation message after posting form",
// "Colon-separated list of field IDs to be displayed. Example: 2:4:5" => "Colon-separated list of field IDs to be displayed. Example: 2:4:5",
// "Label on the submit button" => "Label on the submit button",
// "Show Title" => "Show Title",
// "Show Mandatory" => "Show Mandatory",
// "Embedded" => "Embedded",
// "Url used for the field links" => "Url used for the field links",
// "Values" => "Values",
// "Colon-separated list of values" => "Colon-separated list of values",
// "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or " => "Note that plugin arguments can be enclosed with double quotes \"; this allows them to contain , or ",
// "user|page" => "user|page",
// "itemId" => "itemId",
// "itemId if you want to edit an item" => "itemId if you want to edit an item",
// "Template File" => "Template File",
// "Name of the template used to display the tracker items" => "Name of the template used to display the tracker items",
// "Name of the wiki page containing the template to display the tracker items" => "Name of the wiki page containing the template to display the tracker items",
// "New Status" => "New Status",
// "Default status applied to newly created items" => "Default status applied to newly created items",
// "Width of first column " => "Width of first column ",
// "Specify the width in pixels or percentage of the first column in the tracker form" => "Specify the width in pixels or percentage of the first column in the tracker form",
// "Incorrect fieldId" => "Incorrect fieldId",
// "Display List" => "Display List",
// "Line" => "Line",
// "Tracker Filter" => "Tracker Filter",
// "notice" => "notice",
// "tracker field type not processed yet" => "tracker field type not processed yet",
// "Wiki text" => "Wiki text",
// "Tracker Item Field" => "Tracker Item Field",
// "Wiki text containing an {ELSE} marker" => "Wiki text containing an {ELSE} marker",
// "Item ID" => "Item ID",
// "Field ID" => "Field ID",
// "Colon separated list of field IDs" => "Colon separated list of field IDs",
// "o|p|c|op|oc|pc|opc" => "o|p|c|op|oc|pc|opc",
// "Test" => "Test",
// "Value to compare against" => "Value to compare against",
// "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)" => "Displays the value of a tracker item field or the wiki text if the value of the field is set or has a value(if itemId not specified, use the itemId of the url or the user tracker)",
// "Tracker List" => "Tracker List",
// "Notice" => "Notice",
// "Popup" => "Popup",
// "Colon-separated list of fields to display on click. Example: 6:7" => "Colon-separated list of fields to display on click. Example: 6:7",
// "Sticky Popup" => "Sticky Popup",
// "Show Links" => "Show Links",
// "shownbitems" => "shownbitems",
// "Show Initials" => "Show Initials",
// "Show Status" => "Show Status",
// "Show Creation Date" => "Show Creation Date",
// "Show Last Modification" => "Show Last Modification",
// "Show Field Name" => "Show Field Name",
// "Status Filter" => "Status Filter",
// "Which item status to list. o = open, p = pending, c = closed" => "Which item status to list. o = open, p = pending, c = closed",
// "Sort Mode" => "Sort Mode",
// "Filter Field" => "Filter Field",
// "Colon separated list of fields to allow filtering on" => "Colon separated list of fields to allow filtering on",
// "Filter Value" => "Filter Value",
// "Exact Value" => "Exact Value",
// "Checkbox" => "Checkbox",
// "goIfOne" => "goIfOne",
// "More URL" => "More URL",
// "Select automatically the item of the current user or the page" => "Select automatically the item of the current user or the page",
// "View User" => "View User",
// "Item ID separated with " => "Item ID separated with ",
// "List of items Ids" => "List of items Ids",
// "link url" => "link url",
// "Left Deliminator" => "Left Deliminator",
// "Right Deliminator" => "Right Deliminator",
// "If y, value will be truncated" => "If y, value will be truncated",
// "Export Button" => "Export Button",
// "Compute" => "Compute",
// "Sum or average all the values of a field  and displays it at the bottom of the table" => "Sum or average all the values of a field  and displays it at the bottom of the table",
// "fieldId" => "fieldId",
// "incorrect filterfield" => "incorrect filterfield",
// "Displays a button to link to a page with a tracker plugin with prefilled tracker fields" => "Displays a button to link to a page with a tracker plugin with prefilled tracker fields",
// "Tracker Prefill" => "Tracker Prefill",
// "Tracker page name" => "Tracker page name",
// "Button label" => "Button label",
// "Field 1" => "Field 1",
// "Value 1" => "Value 1",
// "Content of the field" => "Content of the field",
// "Field 2" => "Field 2",
// "Value 2" => "Value 2",
// "Field 3" => "Field 3",
// "Value 3" => "Value 3",
// "Field 4" => "Field 4",
// "Value 4" => "Value 4",
// "Field 5" => "Field 5",
// "Value 5" => "Value 5",
// "Tracker Stats" => "Tracker Stats",
// "Show Percentage" => "Show Percentage",
// "Show Bar" => "Show Bar",
// "Show link to tiki-view_tracker" => "Show link to tiki-view_tracker",
// "Displays some stat of a tracker content, fields are indicated with numeric ids" => "Displays some stat of a tracker content, fields are indicated with numeric ids",
// "incorrect fieldId" => "incorrect fieldId",
// "Tracker Timeline" => "Tracker Timeline",
// "Timeline view of a tracker, can be used to display event schedules or gantt charts" => "Timeline view of a tracker, can be used to display event schedules or gantt charts",
// "Title Field" => "Title Field",
// "Tracker Field ID containing the item title" => "Tracker Field ID containing the item title",
// "Summary Field" => "Summary Field",
// "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused" => "Tracker Field ID containing the summary of the item. The summary will be displayed on the timeline when the item is focused",
// "Start Date" => "Start Date",
// "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element start date. The field must be a datetime/jscalendar field",
// "End Date" => "End Date",
// "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field" => "Tracker Field ID containing the element end date. The field must be a datetime/jscalendar field",
// "Element Group" => "Element Group",
// "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row" => "Tracker Field ID containing the element\\'s group. Elements of a same group are displayed on the same row",
// "Lower Bound" => "Lower Bound",
// "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date from which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Upper Bound" => "Upper Bound",
// "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format" => "Date until which element should be displayed. Date must be provided in YYYY-MM-DD HH:mm:ss format",
// "Primary Scale Unit" => "Primary Scale Unit",
// "hour, day, week, month or year (default to hour)" => "hour, day, week, month or year (default to hour)",
// "Secondary Scale Unit" => "Secondary Scale Unit",
// "hour, day, week, month, year or empty (default to empty)" => "hour, day, week, month, year or empty (default to empty)",
// "Link Group Name" => "Link Group Name",
// "Convert the group name to a link. (y|n)" => "Convert the group name to a link. (y|n)",
// "Page Link Field" => "Page Link Field",
// "Tracker Field ID containing the page name for item details" => "Tracker Field ID containing the page name for item details",
// "Missing parameter: %0" => "Missing parameter: %0",
// "Start date after end date" => "Start date after end date",
// "Translated" => "Translated",
// "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)" => "[url] or ((wikiname)) or ((inter:interwiki)) (use wiki syntax)",
// "Two letter language code of the language, ex: fr" => "Two letter language code of the language, ex: fr",
// "Country name, ex: France" => "Country name, ex: France",
// "User Count" => "User Count",
// "Login Filter" => "Login Filter",
// "String to use between elements of the list" => "String to use between elements of the list",
// "Maximum" => "Maximum",
// "Result limit" => "Result limit",
// "Layout" => "Layout",
// "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default" => "Block of text separated by ---(version x)--- markers. Text before the first marker is used by default",
// "Navigation" => "Navigation",
// "Displays a navigation box that allows users to select a specific version to display" => "Displays a navigation box that allows users to select a specific version to display",
// "Display the current version name as the title. Note: Do not work when nav=>y" => "Display the current version name as the title. Note: Do not work when nav=>y",
// "Default" => "Default",
// "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'" => "Specifies version label to show when displaying the page for the first time. e.g. \\'Default\\'",
// "This is the default text" => "This is the default text",
// "(version 3)" => "(version 3)",
// "This is version 3 info" => "This is version 3 info",
// "(version 2)" => "(version 2)",
// "This is version 2 info" => "This is version 2 info",
// "(version 1)" => "(version 1)",
// "This is version 1 info" => "This is version 1 info",
// "Show Stats" => "Show Stats",
// "Show Stats After" => "Show Stats After",
// "Show Creator" => "Show Creator",
// "Wanted Pages" => "Wanted Pages",
// "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)" => "Custom level regex. A custom filter for wanted pages to be listed (only used when level=>custom).\n\t\tpossible values: a valid regex-expression (PCRE)",
// "Ignore" => "Ignore",
// "Split By" => "Split By",
// "Skip Extension" => "Skip Extension",
// "Collect" => "Collect",
// "Level" => "Level",
// "Page-Pattern" => "Page-Pattern",
// "Custom-Level-Regex" => "Custom-Level-Regex",
// "A wildcard pattern of originating pages to be ignored" => "A wildcard pattern of originating pages to be ignored",
// "(refer to PHP function fnmatch() for details)\n" => "(refer to PHP function fnmatch() for details)\n",
// "The character, by which ignored patterns are separated" => "The character, by which ignored patterns are separated",
// "possible values: characters\n" => "possible values: characters\n",
// "Whether to include external wikis in the list" => "Whether to include external wikis in the list",
// "Collect either originating or wanted pages in a cell and display them in the second column" => "Collect either originating or wanted pages in a cell and display them in the second column",
// "Switch-on debug output with details about the items" => "Switch-on debug output with details about the items",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell",
// "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex" => "Filter the list of wanted pages according to page_regex or custom filter. The default value is the site's __current__ page_regex",
// "A custom filter for wanted pages to be listed (only used when level=>custom)" => "A custom filter for wanted pages to be listed (only used when level=>custom)",
// "a valid regex-expression (PCRE)" => "a valid regex-expression (PCRE)",
// "Lists ''wanted'' wiki pages" => "Lists ''wanted'' wiki pages",
// "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)" => "A wildcard pattern of originating pages to be ignored. (refer to PHP fuction fnmatch() for details)",
// "The character, by which ignored patterns are separated. possible values: characters" => "The character, by which ignored patterns are separated. possible values: characters",
// "Whether to include external wikis in the list. possible values" => "Whether to include external wikis in the list. possible values",
// "Collect either originating or wanted pages in a cell and display them in the second column. possible values" => "Collect either originating or wanted pages in a cell and display them in the second column. possible values",
// "Switch-on debug output with details about the items. possible values" => "Switch-on debug output with details about the items. possible values",
// "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values" => "Multiple collected items are separated in distinct table rows, or by comma or line break in one cell. possible values",
// "non-valid custom regex" => "non-valid custom regex",
// ", " => ", ",
// "dash-WikiWord" => "dash-WikiWord",
// "WikiWord" => "WikiWord",
// "not in level" => "not in level",
// "Referenced By Page" => "Referenced By Page",
// "Web Service" => "Web Service",
// "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface" => "Obtains and display remote information exposed in JSON or YAML. The plugin can be used to display registered or unregistered services. Registered services may use more parameters not defined in this interface",
// "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter" => "Template to apply to the data provided. Template format uses smarty templating engine using double brackets as delimiter. Output must provide wiki syntax. Body can be sent to a parameter instead by using the bodyname parameter",
// "Complete service URL" => "Complete service URL",
// "Service Name" => "Service Name",
// "Registered service name" => "Registered service name",
// "Template Name" => "Template Name",
// "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided" => "For use with registered services, name of the template to be used to display the service output. This parameter will be ignored if a body is provided",
// "Body as Parameter" => "Body as Parameter",
// "Name of the argument to send the body as for services with complex input. Named service required for this to be useful" => "Name of the argument to send the body as for services with complex input. Named service required for this to be useful",
// "Unknown Template" => "Unknown Template",
// "Unknown Service" => "Unknown Service",
// "Missing parameters" => "Missing parameters",
// "Youtube" => "Youtube",
// "URL to the Youtube video" => "URL to the Youtube video",
// "Plugin " => "Plugin ",
// "Semantic token already exists" => "Semantic token already exists",
// "Invalid semantic token name" => "Invalid semantic token name",
// "Semantic token not found" => "Semantic token not found",
// "Categorize %s in %s" => "Categorize %s in %s",
// "List by month" => "List by month",
// "Please wait.." => "Please wait..",
// "Since your last visit.." => "Since your last visit..",
// "updated tracker items" => "updated tracker items",
// "Invalid server key" => "Invalid server key",
// "Cookie not found" => "Cookie not found",
// "Can create/admin calendars" => "Can create/admin calendars",
// "Can add events in the calendar" => "Can add events in the calendar",
// "Can change events in the calendar" => "Can change events in the calendar",
// "Can browse the calendar" => "Can browse the calendar",
// "Can view events details" => "Can view events details",
// "Can view Tikiwiki tools calendar" => "Can view Tikiwiki tools calendar",
// "Can admin categories" => "Can admin categories",
// "Can edit items in categories" => "Can edit items in categories",
// "Can view categories" => "Can view categories",
// "Can view categorized items" => "Can view categorized items",
// "Can search on objects of this category" => "Can search on objects of this category",
// "Can admin charts" => "Can admin charts",
// "Autovalidate suggestions" => "Autovalidate suggestions",
// "Can suggest items" => "Can suggest items",
// "Can view charts" => "Can view charts",
// "Can vote" => "Can vote",
// "Administrator, can create channels remove channels etc" => "Administrator, can create channels remove channels etc",
// "Can use the chat system" => "Can use the chat system",
// "Can admin the cms" => "Can admin the cms",
// "Can approve submissions" => "Can approve submissions",
// "Can admin article topics" => "Can admin article topics",
// "Can admin article types" => "Can admin article types",
// "Can read article headings" => "Can read article headings",
// "Submited articles automatically approved" => "Submited articles automatically approved",
// "Can edit articles" => "Can edit articles",
// "Can edit submissions" => "Can edit submissions",
// "Can read articles" => "Can read articles",
// "Can remove articles" => "Can remove articles",
// "Can remove submissions" => "Can remove submissions",
// "Can submit articles" => "Can submit articles",
// "Can read a topic (Applies only to individual topic perms)" => "Can read a topic (Applies only to individual topic perms)",
// "Can admin contributions" => "Can admin contributions",
// "Can admin the directory" => "Can admin the directory",
// "Can admin directory categories" => "Can admin directory categories",
// "Can admin directory sites" => "Can admin directory sites",
// "Submited links are valid" => "Submited links are valid",
// "Can submit sites to the directory" => "Can submit sites to the directory",
// "Can validate submited links" => "Can validate submited links",
// "Can use the directory" => "Can use the directory",
// "Can admin drawings" => "Can admin drawings",
// "Can edit drawings" => "Can edit drawings",
// "Can admin faqs" => "Can admin faqs",
// "Can suggest faq questions" => "Can suggest faq questions",
// "Can view faqs" => "Can view faqs",
// "Administrator, can manage users groups and permissions, Hotwords and all the weblog features" => "Administrator, can manage users groups and permissions, Hotwords and all the weblog features",
// "Can admin users" => "Can admin users",
// "Can access site when closed" => "Can access site when closed",
// "Administrator, can admin banners" => "Administrator, can admin banners",
// "Can ban users or ips" => "Can ban users or ips",
// "Can admin the dynamic content system" => "Can admin the dynamic content system",
// "Can admin integrator repositories and rules" => "Can admin integrator repositories and rules",
// "Can admin mail-in accounts" => "Can admin mail-in accounts",
// "Can edit object permissions" => "Can edit object permissions",
// "Can admin rss modules" => "Can admin rss modules",
// "Can clean cache" => "Can clean cache",
// "Can create new css suffixed with -user" => "Can create new css suffixed with -user",
// "Can remove association between two pages in a translation set" => "Can remove association between two pages in a translation set",
// "Can admin cookies" => "Can admin cookies",
// "Can edit translations and create new languages" => "Can edit translations and create new languages",
// "Can edit menu" => "Can edit menu",
// "Can edit menu option" => "Can edit menu option",
// "Can edit site templates" => "Can edit site templates",
// "Can search" => "Can search",
// "Can report a link to the webmaster" => "Can report a link to the webmaster",
// "Can subscribe to groups" => "Can subscribe to groups",
// "Can send a link to a friend" => "Can send a link to a friend",
// "Can use HTML in pages" => "Can use HTML in pages",
// "Can view action log" => "Can view action log",
// "Can view action log for users of his own groups" => "Can view action log for users of his own groups",
// "Can view integrated repositories" => "Can view integrated repositories",
// "Can view referer stats" => "Can view referer stats",
// "Can view site stats" => "Can view site stats",
// "Can view site templates" => "Can view site templates",
// "Can admin blogs" => "Can admin blogs",
// "Can assign perms to blog" => "Can assign perms to blog",
// "Can post to a blog" => "Can post to a blog",
// "Can create a blog" => "Can create a blog",
// "Can read blogs" => "Can read blogs",
// "Can admin file galleries" => "Can admin file galleries",
// "Can assign perms to file gallery" => "Can assign perms to file gallery",
// "Can use Directory Batch Load" => "Can use Directory Batch Load",
// "Can upload zip files with files" => "Can upload zip files with files",
// "Can create file galleries" => "Can create file galleries",
// "Can download files" => "Can download files",
// "Can edit a gallery file" => "Can edit a gallery file",
// "Can list file galleries" => "Can list file galleries",
// "Can upload files" => "Can upload files",
// "Can view file galleries explorer" => "Can view file galleries explorer",
// "Can view file galleries path" => "Can view file galleries path",
// "Can view file galleries" => "Can view file galleries",
// "Can admin forums" => "Can admin forums",
// "Can attach to forum posts" => "Can attach to forum posts",
// "Can edit own forum posts" => "Can edit own forum posts",
// "Can post in forums" => "Can post in forums",
// "Can start threads in forums" => "Can start threads in forums",
// "Can read forums" => "Can read forums",
// "Can report msgs to moderator" => "Can report msgs to moderator",
// "Can vote comments in forums" => "Can vote comments in forums",
// "Can admin freetags" => "Can admin freetags",
// "Can admin Image Galleries" => "Can admin Image Galleries",
// "Can assign perms to image gallery" => "Can assign perms to image gallery",
// "Can upload zip files with images" => "Can upload zip files with images",
// "Can create image galleries" => "Can create image galleries",
// "Can tag objects" => "Can tag objects",
// "Can list image galleries" => "Can list image galleries",
// "Can unassign tags from an object" => "Can unassign tags from an object",
// "Can upload images" => "Can upload images",
// "Can browse freetags" => "Can browse freetags",
// "Can view image galleries" => "Can view image galleries",
// "Can admin games" => "Can admin games",
// "Can play games" => "Can play games",
// "Can admin newsletters" => "Can admin newsletters",
// "Can subscribe many e-mails at once (requires tiki_p_subscribe email)" => "Can subscribe many e-mails at once (requires tiki_p_subscribe email)",
// "Can send newsletters" => "Can send newsletters",
// "Can subscribe any email to newsletters" => "Can subscribe any email to newsletters",
// "Can subscribe to newsletters" => "Can subscribe to newsletters",
// "Can admin polls" => "Can admin polls",
// "Can view poll results" => "Can view poll results",
// "Can vote polls" => "Can vote polls",
// "Can view poll voters" => "Can view poll voters",
// "Can admin quicktags" => "Can admin quicktags",
// "Can admin quizzes" => "Can admin quizzes",
// "Can take quizzes" => "Can take quizzes",
// "Can view quiz stats" => "Can view quiz stats",
// "Can view user quiz results" => "Can view user quiz results",
// "Can admin sheet" => "Can admin sheet",
// "Can create and edit sheets" => "Can create and edit sheets",
// "Can view sheet" => "Can view sheet",
// "Can view sheet history" => "Can view sheet history",
// "Can admin shoutbox (Edit/remove msgs)" => "Can admin shoutbox (Edit/remove msgs)",
// "Can post messages in shoutbox" => "Can post messages in shoutbox",
// "Can view shoutbox" => "Can view shoutbox",
// "Can admin surveys" => "Can admin surveys",
// "Can take surveys" => "Can take surveys",
// "Can view survey stats" => "Can view survey stats",
// "Can admin trackers" => "Can admin trackers",
// "Can attach files to tracker items" => "Can attach files to tracker items",
// "Can insert comments for tracker items" => "Can insert comments for tracker items",
// "Can view tracker items comments" => "Can view tracker items comments",
// "Can create new items for trackers" => "Can create new items for trackers",
// "Can list trackers" => "Can list trackers",
// "Can change tracker items" => "Can change tracker items",
// "Can view rating result for tracker items" => "Can view rating result for tracker items",
// "Can vote a rating for tracker items" => "Can vote a rating for tracker items",
// "Can view trackers" => "Can view trackers",
// "Can view trackers closed items" => "Can view trackers closed items",
// "Can view trackers pending items" => "Can view trackers pending items",
// "Can watch tracker" => "Can watch tracker",
// "Can export tracker items" => "Can export tracker items",
// "Can admin the wiki" => "Can admin the wiki",
// "Can assign perms to wiki pages" => "Can assign perms to wiki pages",
// "Can edit pages" => "Can edit pages",
// "Can edit copyright notices" => "Can edit copyright notices",
// "Can edit dynamic variables" => "Can edit dynamic variables",
// "Can create and edit structures" => "Can create and edit structures",
// "Can export wiki pages using the export feature" => "Can export wiki pages using the export feature",
// "Can lock pages" => "Can lock pages",
// "Can save as minor edit" => "Can save as minor edit",
// "Can remove" => "Can remove",
// "Can rename pages" => "Can rename pages",
// "Can rollback pages" => "Can rollback pages",
// "Can upload pictures to wiki pages" => "Can upload pictures to wiki pages",
// "Can use the page as a tracker template" => "Can use the page as a tracker template",
// "Can view page/pages" => "Can view page/pages",
// "Can watch structure" => "Can watch structure",
// "Can admin attachments to wiki pages" => "Can admin attachments to wiki pages",
// "Can add and change ratings on wiki pages" => "Can add and change ratings on wiki pages",
// "Can attach files to wiki pages" => "Can attach files to wiki pages",
// "Can view wiki attachments and download" => "Can view wiki attachments and download",
// "Can view wiki comments" => "Can view wiki comments",
// "Can view wiki history" => "Can view wiki history",
// "Can view rating of wiki pages" => "Can view rating of wiki pages",
// "Can view source of wiki pages" => "Can view source of wiki pages",
// "Can participate to rating of wiki pages" => "Can participate to rating of wiki pages",
// "Can view similar wiki pages" => "Can view similar wiki pages",
// "Can admin workflow processes" => "Can admin workflow processes",
// "Can abort a process instance" => "Can abort a process instance",
// "Can declare an instance as exception" => "Can declare an instance as exception",
// "Can send instances after completion" => "Can send instances after completion",
// "Can execute workflow activities" => "Can execute workflow activities",
// "Can admin received articles" => "Can admin received articles",
// "Can admin received pages" => "Can admin received pages",
// "Can send articles to other sites" => "Can send articles to other sites",
// "Can send articles to this site" => "Can send articles to this site",
// "Can send pages to this site" => "Can send pages to this site",
// "Can send pages to other sites" => "Can send pages to other sites",
// "Can admin the TikiTests" => "Can admin the TikiTests",
// "Can edit TikiTests" => "Can edit TikiTests",
// "Can replay the TikiTests" => "Can replay the TikiTests",
// "Can cache user bookmarks" => "Can cache user bookmarks",
// "Can configure modules" => "Can configure modules",
// "Can create user bookmarks" => "Can create user bookmarks",
// "Can use the mini event calendar" => "Can use the mini event calendar",
// "Can use the newsreader" => "Can use the newsreader",
// "Can use the notepad" => "Can use the notepad",
// "Can admin public tasks" => "Can admin public tasks",
// "Can use tasks" => "Can use tasks",
// "Can receive tasks from other users" => "Can receive tasks from other users",
// "Can send tasks to other users" => "Can send tasks to other users",
// "Can upload personal files" => "Can upload personal files",
// "Can create items in personal menu" => "Can create items in personal menu",
// "Can broadcast messages to all user" => "Can broadcast messages to all user",
// "Can broadcast messages to groups" => "Can broadcast messages to groups",
// "Can use the messaging system" => "Can use the messaging system",
// "Can admin comments" => "Can admin comments",
// "Can edit all comments" => "Can edit all comments",
// "Can post new comments" => "Can post new comments",
// "Can read comments" => "Can read comments",
// "Can delete comments" => "Can delete comments",
// "Can vote comments" => "Can vote comments",
// "Can admin content templates" => "Can admin content templates",
// "Can edit content templates" => "Can edit content templates",
// "Can use content templates" => "Can use content templates",
// "Can edit HTML pages" => "Can edit HTML pages",
// "Can view HTML pages" => "Can view HTML pages",
// "Can list registered users" => "Can list registered users",
// "Admin live support system" => "Admin live support system",
// "Can use live support system" => "Can use live support system",
// "Can create new mapfile" => "Can create new mapfile",
// "Can delete mapfiles" => "Can delete mapfiles",
// "Can edit mapfiles" => "Can edit mapfiles",
// "Can view mapfiles" => "Can view mapfiles",
// "Can view contents of mapfiles" => "Can view contents of mapfiles",
// "Can use webmail" => "Can use webmail",
// "Can use group webmail" => "Can use group webmail",
// "Can administrate group webmail accounts" => "Can administrate group webmail accounts",
// "Can use personal webmail accounts" => "Can use personal webmail accounts",
// "Can administrate personal webmail accounts" => "Can administrate personal webmail accounts",
// "Can view unapproved plugin details" => "Can view unapproved plugin details",
// "Can execute unapproved plugin" => "Can execute unapproved plugin",
// "Can approve plugin execution" => "Can approve plugin execution",
// "Trust all user inputs (no security checks)" => "Trust all user inputs (no security checks)",
// "View page backlinks" => "View page backlinks",
// "Can admin mail notifications" => "Can admin mail notifications",
// "tiki release" => "tiki release",
// "feature version checks" => "feature version checks",
// "tiki needs upgrade" => "tiki needs upgrade",
// "tiki version last check" => "tiki version last check",
// "tiki version check frequency" => "tiki version check frequency",
// "lastUpdatePrefs" => "lastUpdatePrefs",
// "feature print indexed" => "feature print indexed",
// "feature wiki" => "feature wiki",
// "default wiki diff style" => "default wiki diff style",
// "feature backlinks" => "feature backlinks",
// "feature dump" => "feature dump",
// "feature history" => "feature history",
// "feature lastChanges" => "feature lastChanges",
// "feature likePages" => "feature likePages",
// "feature listPages" => "feature listPages",
// "feature listorphanPages" => "feature listorphanPages",
// "feature page title" => "feature page title",
// "feature sandbox" => "feature sandbox",
// "feature warn on edit" => "feature warn on edit",
// "feature wiki 1like redirection" => "feature wiki 1like redirection",
// "feature wiki allowhtml" => "feature wiki allowhtml",
// "feature wiki argvariable" => "feature wiki argvariable",
// "feature wiki attachments" => "feature wiki attachments",
// "feature wiki comments" => "feature wiki comments",
// "feature wiki description" => "feature wiki description",
// "feature wiki discuss" => "feature wiki discuss",
// "feature wiki export" => "feature wiki export",
// "feature wiki structure" => "feature wiki structure",
// "feature wiki import page" => "feature wiki import page",
// "feature wiki footnotes" => "feature wiki footnotes",
// "feature wiki icache" => "feature wiki icache",
// "feature wiki import html" => "feature wiki import html",
// "feature wiki mindmap" => "feature wiki mindmap",
// "feature wiki monosp" => "feature wiki monosp",
// "feature wiki multiprint" => "feature wiki multiprint",
// "feature wiki notepad" => "feature wiki notepad",
// "feature wiki make structure" => "feature wiki make structure",
// "feature wiki open as structure" => "feature wiki open as structure",
// "feature wiki pageid" => "feature wiki pageid",
// "feature wiki paragraph formatting" => "feature wiki paragraph formatting",
// "feature wiki paragraph formatting add br" => "feature wiki paragraph formatting add br",
// "feature wiki pictures" => "feature wiki pictures",
// "feature wiki plurals" => "feature wiki plurals",
// "feature wiki print" => "feature wiki print",
// "feature wiki protect email" => "feature wiki protect email",
// "feature wiki rankings" => "feature wiki rankings",
// "feature wiki ratings" => "feature wiki ratings",
// "feature wiki replace" => "feature wiki replace",
// "feature wiki show hide before" => "feature wiki show hide before",
// "feature wiki tables" => "feature wiki tables",
// "feature wiki templates" => "feature wiki templates",
// "feature wiki undo" => "feature wiki undo",
// "feature wiki userpage" => "feature wiki userpage",
// "feature wiki userpage prefix" => "feature wiki userpage prefix",
// "feature wiki usrlock" => "feature wiki usrlock",
// "feature wiki feedback polls" => "feature wiki feedback polls",
// "feature wiki save draft" => "feature wiki save draft",
// "feature wikiwords" => "feature wikiwords",
// "feature wikiwords usedash" => "feature wikiwords usedash",
// "feature wiki pagealias" => "feature wiki pagealias",
// "mailin autocheck" => "mailin autocheck",
// "mailin autocheckFreq" => "mailin autocheckFreq",
// "mailin autocheckLast" => "mailin autocheckLast",
// "page bar position" => "page bar position",
// "warn on edit time" => "warn on edit time",
// "wikiHomePage" => "wikiHomePage",
// "wikiLicensePage" => "wikiLicensePage",
// "wikiSubmitNotice" => "wikiSubmitNotice",
// "wiki authors style" => "wiki authors style",
// "wiki authors style by page" => "wiki authors style by page",
// "wiki show version" => "wiki show version",
// "wiki bot bar" => "wiki bot bar",
// "wiki cache" => "wiki cache",
// "wiki comments default ordering" => "wiki comments default ordering",
// "wiki comments displayed default" => "wiki comments displayed default",
// "wiki comments per page" => "wiki comments per page",
// "wiki creator admin" => "wiki creator admin",
// "wiki feature copyrights" => "wiki feature copyrights",
// "wiki forum id" => "wiki forum id",
// "wiki left column" => "wiki left column",
// "wiki list backlinks" => "wiki list backlinks",
// "wiki list comment" => "wiki list comment",
// "wiki list comment len" => "wiki list comment len",
// "wiki list description" => "wiki list description",
// "wiki list description len" => "wiki list description len",
// "wiki list creator" => "wiki list creator",
// "wiki list hits" => "wiki list hits",
// "wiki list lastmodif" => "wiki list lastmodif",
// "wiki list lastver" => "wiki list lastver",
// "wiki list links" => "wiki list links",
// "wiki list name" => "wiki list name",
// "wiki list name len" => "wiki list name len",
// "wiki list size" => "wiki list size",
// "wiki list status" => "wiki list status",
// "wiki list user" => "wiki list user",
// "wiki list versions" => "wiki list versions",
// "wiki list language" => "wiki list language",
// "wiki list categories" => "wiki list categories",
// "wiki list categories path" => "wiki list categories path",
// "wiki list id" => "wiki list id",
// "wiki list sortorder" => "wiki list sortorder",
// "wiki list sortdirection" => "wiki list sortdirection",
// "wiki pagealias tokens" => "wiki pagealias tokens",
// "wiki page regex" => "wiki page regex",
// "wiki page separator" => "wiki page separator",
// "wiki page navigation bar" => "wiki page navigation bar",
// "wiki actions bar" => "wiki actions bar",
// "wiki pagename strip" => "wiki pagename strip",
// "wiki right column" => "wiki right column",
// "wiki top bar" => "wiki top bar",
// "wiki topline position" => "wiki topline position",
// "wiki uses slides" => "wiki uses slides",
// "wiki watch author" => "wiki watch author",
// "wiki watch comments" => "wiki watch comments",
// "wiki watch editor" => "wiki watch editor",
// "wiki watch minor" => "wiki watch minor",
// "feature wiki history full" => "feature wiki history full",
// "feature wiki categorize structure" => "feature wiki categorize structure",
// "feature wiki watch structure" => "feature wiki watch structure",
// "feature wikiapproval" => "feature wikiapproval",
// "wikiapproval prefix" => "wikiapproval prefix",
// "wikiapproval hideprefix" => "wikiapproval hideprefix",
// "wikiapproval delete staging" => "wikiapproval delete staging",
// "wikiapproval master group" => "wikiapproval master group",
// "wikiapproval staging category" => "wikiapproval staging category",
// "wikiapproval approved category" => "wikiapproval approved category",
// "wikiapproval outofsync category" => "wikiapproval outofsync category",
// "wikiapproval block editapproved" => "wikiapproval block editapproved",
// "wikiapproval sync categories" => "wikiapproval sync categories",
// "wikiapproval update freetags" => "wikiapproval update freetags",
// "wikiapproval combine freetags" => "wikiapproval combine freetags",
// "wiki edit section" => "wiki edit section",
// "wiki edit section level" => "wiki edit section level",
// "wiki edit plugin" => "wiki edit plugin",
// "wiki validate plugin" => "wiki validate plugin",
// "wiki edit minor" => "wiki edit minor",
// "wikiplugin agentinfo" => "wikiplugin agentinfo",
// "wikiplugin alink" => "wikiplugin alink",
// "wikiplugin aname" => "wikiplugin aname",
// "wikiplugin annotation" => "wikiplugin annotation",
// "wikiplugin article" => "wikiplugin article",
// "wikiplugin articles" => "wikiplugin articles",
// "wikiplugin attach" => "wikiplugin attach",
// "wikiplugin avatar" => "wikiplugin avatar",
// "wikiplugin back" => "wikiplugin back",
// "wikiplugin backlinks" => "wikiplugin backlinks",
// "wikiplugin banner" => "wikiplugin banner",
// "wikiplugin bloglist" => "wikiplugin bloglist",
// "wikiplugin box" => "wikiplugin box",
// "wikiplugin category" => "wikiplugin category",
// "wikiplugin catorphans" => "wikiplugin catorphans",
// "wikiplugin catpath" => "wikiplugin catpath",
// "wikiplugin center" => "wikiplugin center",
// "wikiplugin chart" => "wikiplugin chart",
// "wikiplugin code" => "wikiplugin code",
// "wikiplugin content" => "wikiplugin content",
// "wikiplugin cookie" => "wikiplugin cookie",
// "wikiplugin copyright" => "wikiplugin copyright",
// "wikiplugin countdown" => "wikiplugin countdown",
// "wikiplugin dbreport" => "wikiplugin dbreport",
// "wikiplugin div" => "wikiplugin div",
// "wikiplugin dl" => "wikiplugin dl",
// "wikiplugin draw" => "wikiplugin draw",
// "wikiplugin equation" => "wikiplugin equation",
// "wikiplugin events" => "wikiplugin events",
// "wikiplugin fade" => "wikiplugin fade",
// "wikiplugin fancylist" => "wikiplugin fancylist",
// "wikiplugin fancytable" => "wikiplugin fancytable",
// "wikiplugin file" => "wikiplugin file",
// "wikiplugin files" => "wikiplugin files",
// "wikiplugin flash" => "wikiplugin flash",
// "wikiplugin footnote" => "wikiplugin footnote",
// "wikiplugin footnotearea" => "wikiplugin footnotearea",
// "wikiplugin ftp" => "wikiplugin ftp",
// "wikiplugin gauge" => "wikiplugin gauge",
// "wikiplugin googleanalytics" => "wikiplugin googleanalytics",
// "wikiplugin googledoc" => "wikiplugin googledoc",
// "wikiplugin group" => "wikiplugin group",
// "wikiplugin html" => "wikiplugin html",
// "wikiplugin iframe" => "wikiplugin iframe",
// "wikiplugin img" => "wikiplugin img",
// "wikiplugin image" => "wikiplugin image",
// "wikiplugin include" => "wikiplugin include",
// "wikiplugin jabber" => "wikiplugin jabber",
// "wikiplugin js" => "wikiplugin js",
// "wikiplugin jq" => "wikiplugin jq",
// "wikiplugin lang" => "wikiplugin lang",
// "wikiplugin lastmod" => "wikiplugin lastmod",
// "wikiplugin listpages" => "wikiplugin listpages",
// "wikiplugin lsdir" => "wikiplugin lsdir",
// "wikiplugin map" => "wikiplugin map",
// "wikiplugin mediaplayer" => "wikiplugin mediaplayer",
// "wikiplugin miniquiz" => "wikiplugin miniquiz",
// "wikiplugin module" => "wikiplugin module",
// "wikiplugin mono" => "wikiplugin mono",
// "wikiplugin mouseover" => "wikiplugin mouseover",
// "wikiplugin mwtable" => "wikiplugin mwtable",
// "wikiplugin myspace" => "wikiplugin myspace",
// "wikiplugin objecthits" => "wikiplugin objecthits",
// "wikiplugin picture" => "wikiplugin picture",
// "wikiplugin pluginmanager" => "wikiplugin pluginmanager",
// "wikiplugin poll" => "wikiplugin poll",
// "wikiplugin profile" => "wikiplugin profile",
// "wikiplugin proposal" => "wikiplugin proposal",
// "wikiplugin quote" => "wikiplugin quote",
// "wikiplugin rcontent" => "wikiplugin rcontent",
// "wikiplugin redirect" => "wikiplugin redirect",
// "wikiplugin regex" => "wikiplugin regex",
// "wikiplugin remarksbox" => "wikiplugin remarksbox",
// "wikiplugin rss" => "wikiplugin rss",
// "wikiplugin sf" => "wikiplugin sf",
// "wikiplugin share" => "wikiplugin share",
// "wikiplugin sharethis" => "wikiplugin sharethis",
// "wikiplugin sheet" => "wikiplugin sheet",
// "wikiplugin showpages" => "wikiplugin showpages",
// "wikiplugin skype" => "wikiplugin skype",
// "wikiplugin snarf" => "wikiplugin snarf",
// "wikiplugin sort" => "wikiplugin sort",
// "wikiplugin split" => "wikiplugin split",
// "wikiplugin sql" => "wikiplugin sql",
// "wikiplugin sub" => "wikiplugin sub",
// "wikiplugin subscribegroup" => "wikiplugin subscribegroup",
// "wikiplugin subscribegroups" => "wikiplugin subscribegroups",
// "wikiplugin sup" => "wikiplugin sup",
// "wikiplugin survey" => "wikiplugin survey",
// "wikiplugin tag" => "wikiplugin tag",
// "wikiplugin thumb" => "wikiplugin thumb",
// "wikiplugin titlesearch" => "wikiplugin titlesearch",
// "wikiplugin toc" => "wikiplugin toc",
// "wikiplugin topfriends" => "wikiplugin topfriends",
// "wikiplugin trackerfilter" => "wikiplugin trackerfilter",
// "wikiplugin trackeritemfield" => "wikiplugin trackeritemfield",
// "wikiplugin trackerlist" => "wikiplugin trackerlist",
// "wikiplugin trackertimeline" => "wikiplugin trackertimeline",
// "wikiplugin tracker" => "wikiplugin tracker",
// "wikiplugin trackerprefill" => "wikiplugin trackerprefill",
// "wikiplugin trackerstat" => "wikiplugin trackerstat",
// "wikiplugin translated" => "wikiplugin translated",
// "wikiplugin tr" => "wikiplugin tr",
// "wikiplugin usercount" => "wikiplugin usercount",
// "wikiplugin userlist" => "wikiplugin userlist",
// "wikiplugin versions" => "wikiplugin versions",
// "wikiplugin vote" => "wikiplugin vote",
// "wikiplugin wantedpages" => "wikiplugin wantedpages",
// "wikiplugin webservice" => "wikiplugin webservice",
// "wikiplugin youtube" => "wikiplugin youtube",
// "wikiplugininline agentinfo" => "wikiplugininline agentinfo",
// "wikiplugininline alink" => "wikiplugininline alink",
// "wikiplugininline aname" => "wikiplugininline aname",
// "wikiplugininline annotation" => "wikiplugininline annotation",
// "wikiplugininline article" => "wikiplugininline article",
// "wikiplugininline articles" => "wikiplugininline articles",
// "wikiplugininline attach" => "wikiplugininline attach",
// "wikiplugininline avatar" => "wikiplugininline avatar",
// "wikiplugininline back" => "wikiplugininline back",
// "wikiplugininline backlinks" => "wikiplugininline backlinks",
// "wikiplugininline banner" => "wikiplugininline banner",
// "wikiplugininline bloglist" => "wikiplugininline bloglist",
// "wikiplugininline box" => "wikiplugininline box",
// "wikiplugininline category" => "wikiplugininline category",
// "wikiplugininline catorphans" => "wikiplugininline catorphans",
// "wikiplugininline catpath" => "wikiplugininline catpath",
// "wikiplugininline center" => "wikiplugininline center",
// "wikiplugininline chart" => "wikiplugininline chart",
// "wikiplugininline code" => "wikiplugininline code",
// "wikiplugininline content" => "wikiplugininline content",
// "wikiplugininline cookie" => "wikiplugininline cookie",
// "wikiplugininline copyright" => "wikiplugininline copyright",
// "wikiplugininline countdown" => "wikiplugininline countdown",
// "wikiplugininline dbreport" => "wikiplugininline dbreport",
// "wikiplugininline div" => "wikiplugininline div",
// "wikiplugininline dl" => "wikiplugininline dl",
// "wikiplugininline draw" => "wikiplugininline draw",
// "wikiplugininline equation" => "wikiplugininline equation",
// "wikiplugininline events" => "wikiplugininline events",
// "wikiplugininline fade" => "wikiplugininline fade",
// "wikiplugininline fancylist" => "wikiplugininline fancylist",
// "wikiplugininline fancytable" => "wikiplugininline fancytable",
// "wikiplugininline file" => "wikiplugininline file",
// "wikiplugininline files" => "wikiplugininline files",
// "wikiplugininline flash" => "wikiplugininline flash",
// "wikiplugininline footnote" => "wikiplugininline footnote",
// "wikiplugininline footnotearea" => "wikiplugininline footnotearea",
// "wikiplugininline ftp" => "wikiplugininline ftp",
// "wikiplugininline gauge" => "wikiplugininline gauge",
// "wikiplugininline googleanalytics" => "wikiplugininline googleanalytics",
// "wikiplugininline googledoc" => "wikiplugininline googledoc",
// "wikiplugininline group" => "wikiplugininline group",
// "wikiplugininline html" => "wikiplugininline html",
// "wikiplugininline iframe" => "wikiplugininline iframe",
// "wikiplugininline img" => "wikiplugininline img",
// "wikiplugininline image" => "wikiplugininline image",
// "wikiplugininline include" => "wikiplugininline include",
// "wikiplugininline jabber" => "wikiplugininline jabber",
// "wikiplugininline js" => "wikiplugininline js",
// "wikiplugininline jq" => "wikiplugininline jq",
// "wikiplugininline lang" => "wikiplugininline lang",
// "wikiplugininline lastmod" => "wikiplugininline lastmod",
// "wikiplugininline listpages" => "wikiplugininline listpages",
// "wikiplugininline lsdir" => "wikiplugininline lsdir",
// "wikiplugininline map" => "wikiplugininline map",
// "wikiplugininline mediaplayer" => "wikiplugininline mediaplayer",
// "wikiplugininline miniquiz" => "wikiplugininline miniquiz",
// "wikiplugininline module" => "wikiplugininline module",
// "wikiplugininline mono" => "wikiplugininline mono",
// "wikiplugininline mouseover" => "wikiplugininline mouseover",
// "wikiplugininline mwtable" => "wikiplugininline mwtable",
// "wikiplugininline myspace" => "wikiplugininline myspace",
// "wikiplugininline objecthits" => "wikiplugininline objecthits",
// "wikiplugininline picture" => "wikiplugininline picture",
// "wikiplugininline pluginmanager" => "wikiplugininline pluginmanager",
// "wikiplugininline poll" => "wikiplugininline poll",
// "wikiplugininline profile" => "wikiplugininline profile",
// "wikiplugininline proposal" => "wikiplugininline proposal",
// "wikiplugininline quote" => "wikiplugininline quote",
// "wikiplugininline rcontent" => "wikiplugininline rcontent",
// "wikiplugininline redirect" => "wikiplugininline redirect",
// "wikiplugininline regex" => "wikiplugininline regex",
// "wikiplugininline remarksbox" => "wikiplugininline remarksbox",
// "wikiplugininline rss" => "wikiplugininline rss",
// "wikiplugininline sf" => "wikiplugininline sf",
// "wikiplugininline share" => "wikiplugininline share",
// "wikiplugininline sharethis" => "wikiplugininline sharethis",
// "wikiplugininline sheet" => "wikiplugininline sheet",
// "wikiplugininline showpages" => "wikiplugininline showpages",
// "wikiplugininline skype" => "wikiplugininline skype",
// "wikiplugininline snarf" => "wikiplugininline snarf",
// "wikiplugininline sort" => "wikiplugininline sort",
// "wikiplugininline split" => "wikiplugininline split",
// "wikiplugininline sql" => "wikiplugininline sql",
// "wikiplugininline sub" => "wikiplugininline sub",
// "wikiplugininline subscribegroup" => "wikiplugininline subscribegroup",
// "wikiplugininline subscribegroups" => "wikiplugininline subscribegroups",
// "wikiplugininline sup" => "wikiplugininline sup",
// "wikiplugininline survey" => "wikiplugininline survey",
// "wikiplugininline tag" => "wikiplugininline tag",
// "wikiplugininline thumb" => "wikiplugininline thumb",
// "wikiplugininline titlesearch" => "wikiplugininline titlesearch",
// "wikiplugininline toc" => "wikiplugininline toc",
// "wikiplugininline topfriends" => "wikiplugininline topfriends",
// "wikiplugininline trackerfilter" => "wikiplugininline trackerfilter",
// "wikiplugininline trackeritemfield" => "wikiplugininline trackeritemfield",
// "wikiplugininline trackerlist" => "wikiplugininline trackerlist",
// "wikiplugininline trackertimeline" => "wikiplugininline trackertimeline",
// "wikiplugininline tracker" => "wikiplugininline tracker",
// "wikiplugininline trackerprefill" => "wikiplugininline trackerprefill",
// "wikiplugininline trackerstat" => "wikiplugininline trackerstat",
// "wikiplugininline translated" => "wikiplugininline translated",
// "wikiplugininline tr" => "wikiplugininline tr",
// "wikiplugininline usercount" => "wikiplugininline usercount",
// "wikiplugininline userlist" => "wikiplugininline userlist",
// "wikiplugininline versions" => "wikiplugininline versions",
// "wikiplugininline vote" => "wikiplugininline vote",
// "wikiplugininline wantedpages" => "wikiplugininline wantedpages",
// "wikiplugininline webservice" => "wikiplugininline webservice",
// "wikiplugininline youtube" => "wikiplugininline youtube",
// "webservice consume defaultcache" => "webservice consume defaultcache",
// "feature wysiwyg" => "feature wysiwyg",
// "wysiwyg optional" => "wysiwyg optional",
// "wysiwyg default" => "wysiwyg default",
// "wysiwyg memo" => "wysiwyg memo",
// "wysiwyg wiki parsed" => "wysiwyg wiki parsed",
// "wysiwyg wiki semi parsed" => "wysiwyg wiki semi parsed",
// "wysiwyg toolbar skin" => "wysiwyg toolbar skin",
// "wysiwyg toolbar" => "wysiwyg toolbar",
// "wiki feature 3d" => "wiki feature 3d",
// "wiki 3d width" => "wiki 3d width",
// "wiki 3d height" => "wiki 3d height",
// "wiki 3d navigation depth" => "wiki 3d navigation depth",
// "wiki 3d feed animation interval" => "wiki 3d feed animation interval",
// "wiki 3d existing page color" => "wiki 3d existing page color",
// "wiki 3d missing page color" => "wiki 3d missing page color",
// "feature blogs" => "feature blogs",
// "blog list order" => "blog list order",
// "home blog" => "home blog",
// "feature blog rankings" => "feature blog rankings",
// "feature blog comments" => "feature blog comments",
// "blog comments default ordering" => "blog comments default ordering",
// "blog comments per page" => "blog comments per page",
// "feature blogposts comments" => "feature blogposts comments",
// "blog list user" => "blog list user",
// "blog list title" => "blog list title",
// "blog list title len" => "blog list title len",
// "blog list description" => "blog list description",
// "blog list created" => "blog list created",
// "blog list lastmodif" => "blog list lastmodif",
// "blog list posts" => "blog list posts",
// "blog list visits" => "blog list visits",
// "blog list activity" => "blog list activity",
// "feature blog mandatory category" => "feature blog mandatory category",
// "feature blog heading" => "feature blog heading",
// "feature file galleries" => "feature file galleries",
// "home file gallery" => "home file gallery",
// "fgal use db" => "fgal use db",
// "fgal batch dir" => "fgal batch dir",
// "fgal match regex" => "fgal match regex",
// "fgal nmatch regex" => "fgal nmatch regex",
// "fgal use dir" => "fgal use dir",
// "fgal podcast dir" => "fgal podcast dir",
// "feature file galleries comments" => "feature file galleries comments",
// "file galleries comments default ordering" => "file galleries comments default ordering",
// "file galleries comments per page" => "file galleries comments per page",
// "feature file galleries batch" => "feature file galleries batch",
// "feature file galleries rankings" => "feature file galleries rankings",
// "fgal enable auto indexing" => "fgal enable auto indexing",
// "fgal asynchronous indexing" => "fgal asynchronous indexing",
// "fgal allow duplicates" => "fgal allow duplicates",
// "fgal sort mode" => "fgal sort mode",
// "feature file galleries author" => "feature file galleries author",
// "fgal list id" => "fgal list id",
// "fgal list type" => "fgal list type",
// "fgal list name" => "fgal list name",
// "fgal list description" => "fgal list description",
// "fgal list size" => "fgal list size",
// "fgal list created" => "fgal list created",
// "fgal list lastmodif" => "fgal list lastmodif",
// "fgal list creator" => "fgal list creator",
// "fgal list author" => "fgal list author",
// "fgal list last user" => "fgal list last user",
// "fgal list comment" => "fgal list comment",
// "fgal list files" => "fgal list files",
// "fgal list hits" => "fgal list hits",
// "fgal list lockedby" => "fgal list lockedby",
// "fgal show path" => "fgal show path",
// "fgal show explorer" => "fgal show explorer",
// "fgal show slideshow" => "fgal show slideshow",
// "fgal default view" => "fgal default view",
// "fgal limit hits per file" => "fgal limit hits per file",
// "fgal prevent negative score" => "fgal prevent negative score",
// "feature galleries" => "feature galleries",
// "feature gal batch" => "feature gal batch",
// "feature gal slideshow" => "feature gal slideshow",
// "home gallery" => "home gallery",
// "gal use db" => "gal use db",
// "gal use lib" => "gal use lib",
// "gal match regex" => "gal match regex",
// "gal nmatch regex" => "gal nmatch regex",
// "gal use dir" => "gal use dir",
// "gal batch dir" => "gal batch dir",
// "feature gal rankings" => "feature gal rankings",
// "feature image galleries comments" => "feature image galleries comments",
// "image galleries comments default order" => "image galleries comments default order",
// "image galleries comments per page" => "image galleries comments per page",
// "gal list name" => "gal list name",
// "gal list parent" => "gal list parent",
// "gal list description" => "gal list description",
// "gal list created" => "gal list created",
// "gal list lastmodif" => "gal list lastmodif",
// "gal list user" => "gal list user",
// "gal list imgs" => "gal list imgs",
// "gal list visits" => "gal list visits",
// "feature image gallery mandatory category" => "feature image gallery mandatory category",
// "preset galleries info" => "preset galleries info",
// "gal image mouseover" => "gal image mouseover",
// "ProgressBarPlay" => "ProgressBarPlay",
// "ProgressBarLoad" => "ProgressBarLoad",
// "ProgressBarButton" => "ProgressBarButton",
// "ProgressBar" => "ProgressBar",
// "VolumeOn" => "VolumeOn",
// "VolumeOff" => "VolumeOff",
// "VolumeButton" => "VolumeButton",
// "Button" => "Button",
// "ButtonPressed" => "ButtonPressed",
// "ButtonOver" => "ButtonOver",
// "ButtonInfo" => "ButtonInfo",
// "ButtonInfoPressed" => "ButtonInfoPressed",
// "ButtonInfoOver" => "ButtonInfoOver",
// "ButtonInfoText" => "ButtonInfoText",
// "ID3" => "ID3",
// "PlayTime" => "PlayTime",
// "TotalTime" => "TotalTime",
// "PanelDisplay" => "PanelDisplay",
// "AlertMesg" => "AlertMesg",
// "PreloadDelay" => "PreloadDelay",
// "VideoHeight" => "VideoHeight",
// "VideoLength" => "VideoLength",
// "URLAppend" => "URLAppend",
// "LimitedMsg" => "LimitedMsg",
// "MaxPlay" => "MaxPlay",
// "MultimediaGalerie" => "MultimediaGalerie",
// "MultimediaDefaultLength" => "MultimediaDefaultLength",
// "MultimediaDefaultHeight" => "MultimediaDefaultHeight",
// "feature forums" => "feature forums",
// "home forum" => "home forum",
// "feature forum rankings" => "feature forum rankings",
// "feature forum parse" => "feature forum parse",
// "feature forum topics archiving" => "feature forum topics archiving",
// "feature forum replyempty" => "feature forum replyempty",
// "feature forum quickjump" => "feature forum quickjump",
// "feature forums allow thread titles" => "feature forums allow thread titles",
// "feature forum content search" => "feature forum content search",
// "feature forums name search" => "feature forums name search",
// "forums ordering" => "forums ordering",
// "forum list topics" => "forum list topics",
// "forum list posts" => "forum list posts",
// "forum list ppd" => "forum list ppd",
// "forum list lastpost" => "forum list lastpost",
// "forum list visits" => "forum list visits",
// "forum list desc" => "forum list desc",
// "forum list description len" => "forum list description len",
// "feature forum local search" => "feature forum local search",
// "feature forum local tiki search" => "feature forum local tiki search",
// "forum thread defaults by forum" => "forum thread defaults by forum",
// "forum thread user settings" => "forum thread user settings",
// "forum thread user settings keep" => "forum thread user settings keep",
// "forum comments per page" => "forum comments per page",
// "forum comments no title prefix" => "forum comments no title prefix",
// "forum thread style" => "forum thread style",
// "forum thread sort mode" => "forum thread sort mode",
// "forum match regex" => "forum match regex",
// "feature articles" => "feature articles",
// "feature submissions" => "feature submissions",
// "feature cms rankings" => "feature cms rankings",
// "feature cms print" => "feature cms print",
// "feature cms emails" => "feature cms emails",
// "art list title" => "art list title",
// "art list title len" => "art list title len",
// "art list topic" => "art list topic",
// "art list date" => "art list date",
// "art list author" => "art list author",
// "art list reads" => "art list reads",
// "art list size" => "art list size",
// "art list expire" => "art list expire",
// "art list img" => "art list img",
// "art list type" => "art list type",
// "art list visible" => "art list visible",
// "art view type" => "art view type",
// "art view title" => "art view title",
// "art view topic" => "art view topic",
// "art view date" => "art view date",
// "art view author" => "art view author",
// "art view reads" => "art view reads",
// "art view size" => "art view size",
// "art view img" => "art view img",
// "art list lang" => "art list lang",
// "feature article comments" => "feature article comments",
// "article comments default ordering" => "article comments default ordering",
// "article comments per page" => "article comments per page",
// "feature cms templates" => "feature cms templates",
// "cms bot bar" => "cms bot bar",
// "cms left column" => "cms left column",
// "cms right column" => "cms right column",
// "cms top bar" => "cms top bar",
// "cms spellcheck" => "cms spellcheck",
// "art home title" => "art home title",
// "feature trackers" => "feature trackers",
// "t use db" => "t use db",
// "t use dir" => "t use dir",
// "groupTracker" => "groupTracker",
// "userTracker" => "userTracker",
// "trk with mirror tables" => "trk with mirror tables",
// "feature userlevels" => "feature userlevels",
// "userlevels" => "userlevels",
// "userbreadCrumb" => "userbreadCrumb",
// "user assigned modules" => "user assigned modules",
// "user flip modules" => "user flip modules",
// "user show realnames" => "user show realnames",
// "feature mytiki" => "feature mytiki",
// "feature userPreferences" => "feature userPreferences",
// "feature user bookmarks" => "feature user bookmarks",
// "feature tasks" => "feature tasks",
// "w use db" => "w use db",
// "w use dir" => "w use dir",
// "w displayed default" => "w displayed default",
// "uf use db" => "uf use db",
// "uf use dir" => "uf use dir",
// "userfiles quota" => "userfiles quota",
// "feature usermenu" => "feature usermenu",
// "feature minical" => "feature minical",
// "feature notepad" => "feature notepad",
// "feature userfiles" => "feature userfiles",
// "feature community gender" => "feature community gender",
// "feature community mouseover" => "feature community mouseover",
// "feature community mouseover name" => "feature community mouseover name",
// "feature community mouseover gender" => "feature community mouseover gender",
// "feature community mouseover picture" => "feature community mouseover picture",
// "feature community mouseover friends" => "feature community mouseover friends",
// "feature community mouseover score" => "feature community mouseover score",
// "feature community mouseover country" => "feature community mouseover country",
// "feature community mouseover email" => "feature community mouseover email",
// "feature community mouseover lastlogin" => "feature community mouseover lastlogin",
// "feature community mouseover distance" => "feature community mouseover distance",
// "feature community list name" => "feature community list name",
// "feature community list score" => "feature community list score",
// "feature community list country" => "feature community list country",
// "feature community list distance" => "feature community list distance",
// "feature community friends permission" => "feature community friends permission",
// "feature community friends permission dep" => "feature community friends permission dep",
// "change language" => "change language",
// "change theme" => "change theme",
// "login is email" => "login is email",
// "validateUsers" => "validateUsers",
// "validateEmail" => "validateEmail",
// "forgotPass" => "forgotPass",
// "available languages" => "available languages",
// "available styles" => "available styles",
// "lowercase username" => "lowercase username",
// "username pattern" => "username pattern",
// "max username length" => "max username length",
// "min username length" => "min username length",
// "users prefs allowMsgs" => "users prefs allowMsgs",
// "users prefs country" => "users prefs country",
// "users prefs diff versions" => "users prefs diff versions",
// "users prefs display timezone" => "users prefs display timezone",
// "users prefs email is public" => "users prefs email is public",
// "users prefs homePage" => "users prefs homePage",
// "users prefs lat" => "users prefs lat",
// "users prefs lon" => "users prefs lon",
// "users prefs mess archiveAfter" => "users prefs mess archiveAfter",
// "users prefs mess maxRecords" => "users prefs mess maxRecords",
// "users prefs mess sendReadStatus" => "users prefs mess sendReadStatus",
// "users prefs minPrio" => "users prefs minPrio",
// "users prefs mytiki blogs" => "users prefs mytiki blogs",
// "users prefs mytiki articles" => "users prefs mytiki articles",
// "users prefs mytiki gals" => "users prefs mytiki gals",
// "users prefs mytiki items" => "users prefs mytiki items",
// "users prefs mytiki msgs" => "users prefs mytiki msgs",
// "users prefs mytiki pages" => "users prefs mytiki pages",
// "users prefs mytiki tasks" => "users prefs mytiki tasks",
// "users prefs mytiki workflow" => "users prefs mytiki workflow",
// "users prefs mytiki forum topics" => "users prefs mytiki forum topics",
// "users prefs mytiki forum replies" => "users prefs mytiki forum replies",
// "users prefs realName" => "users prefs realName",
// "users prefs gender" => "users prefs gender",
// "users prefs show mouseover user info" => "users prefs show mouseover user info",
// "users prefs tasks maxRecords" => "users prefs tasks maxRecords",
// "users prefs user dbl" => "users prefs user dbl",
// "users prefs user information" => "users prefs user information",
// "users prefs userbreadCrumb" => "users prefs userbreadCrumb",
// "users prefs mailCharset" => "users prefs mailCharset",
// "validateRegistration" => "validateRegistration",
// "feature messages" => "feature messages",
// "messu mailbox size" => "messu mailbox size",
// "messu archive size" => "messu archive size",
// "messu sent size" => "messu sent size",
// "allowmsg by default" => "allowmsg by default",
// "allowmsg is optional" => "allowmsg is optional",
// "feature newsreader" => "feature newsreader",
// "feature freetags" => "feature freetags",
// "freetags browse show cloud" => "freetags browse show cloud",
// "freetags cloud colors" => "freetags cloud colors",
// "freetags preload random search" => "freetags preload random search",
// "freetags browse amount tags in cloud" => "freetags browse amount tags in cloud",
// "freetags browse amount tags suggestion" => "freetags browse amount tags suggestion",
// "freetags normalized valid chars" => "freetags normalized valid chars",
// "freetags lowercase only" => "freetags lowercase only",
// "freetags feature 3d" => "freetags feature 3d",
// "freetags 3d width" => "freetags 3d width",
// "freetags 3d height" => "freetags 3d height",
// "freetags 3d navigation depth" => "freetags 3d navigation depth",
// "freetags 3d feed animation interval" => "freetags 3d feed animation interval",
// "freetags 3d existing page color" => "freetags 3d existing page color",
// "freetags 3d missing page color" => "freetags 3d missing page color",
// "freetags 3d autoload" => "freetags 3d autoload",
// "freetags 3d camera distance" => "freetags 3d camera distance",
// "freetags 3d elastic constant" => "freetags 3d elastic constant",
// "freetags 3d eletrostatic constant" => "freetags 3d eletrostatic constant",
// "freetags 3d fov" => "freetags 3d fov",
// "freetags 3d friction constant" => "freetags 3d friction constant",
// "freetags 3d node charge" => "freetags 3d node charge",
// "freetags 3d node mass" => "freetags 3d node mass",
// "freetags 3d node size" => "freetags 3d node size",
// "freetags 3d spring size" => "freetags 3d spring size",
// "freetags 3d text size" => "freetags 3d text size",
// "freetags 3d adjust camera" => "freetags 3d adjust camera",
// "freetags multilingual" => "freetags multilingual",
// "morelikethis algorithm" => "morelikethis algorithm",
// "morelikethis basic mincommon" => "morelikethis basic mincommon",
// "freetags show middle" => "freetags show middle",
// "feature search stats" => "feature search stats",
// "feature search" => "feature search",
// "feature search fulltext" => "feature search fulltext",
// "feature search show forbidden obj" => "feature search show forbidden obj",
// "feature search show forbidden cat" => "feature search show forbidden cat",
// "feature search show object filter" => "feature search show object filter",
// "feature search show search box" => "feature search show search box",
// "feature search show visit count" => "feature search show visit count",
// "feature search show pertinence" => "feature search show pertinence",
// "feature search show object type" => "feature search show object type",
// "feature search show last modification" => "feature search show last modification",
// "search refresh index mode" => "search refresh index mode",
// "search parsed snippet" => "search parsed snippet",
// "feature webmail" => "feature webmail",
// "webmail max attachment" => "webmail max attachment",
// "webmail view html" => "webmail view html",
// "feature contacts" => "feature contacts",
// "feature faqs" => "feature faqs",
// "feature faq comments" => "feature faq comments",
// "faq comments per page" => "faq comments per page",
// "faq comments default ordering" => "faq comments default ordering",
// "faq prefix" => "faq prefix",
// "feature quizzes" => "feature quizzes",
// "feature polls" => "feature polls",
// "feature poll comments" => "feature poll comments",
// "feature poll anonymous" => "feature poll anonymous",
// "poll comments default ordering" => "poll comments default ordering",
// "poll comments per page" => "poll comments per page",
// "poll list categories" => "poll list categories",
// "poll list objects" => "poll list objects",
// "feature poll revote" => "feature poll revote",
// "feature surveys" => "feature surveys",
// "feature featuredLinks" => "feature featuredLinks",
// "feature directory" => "feature directory",
// "directory columns" => "directory columns",
// "directory links per page" => "directory links per page",
// "directory open links" => "directory open links",
// "directory validate urls" => "directory validate urls",
// "directory cool sites" => "directory cool sites",
// "directory country flag" => "directory country flag",
// "feature calendar" => "feature calendar",
// "feature default calendars" => "feature default calendars",
// "calendar sticky popup" => "calendar sticky popup",
// "default calendars" => "default calendars",
// "calendar view mode" => "calendar view mode",
// "calendar view tab" => "calendar view tab",
// "calendar firstDayofWeek" => "calendar firstDayofWeek",
// "calendar timespan" => "calendar timespan",
// "feature jscalendar" => "feature jscalendar",
// "feature action calendar" => "feature action calendar",
// "calendar start year" => "calendar start year",
// "calendar end year" => "calendar end year",
// "calendar list begins focus" => "calendar list begins focus",
// "server timezone" => "server timezone",
// "long date format" => "long date format",
// "long time format" => "long time format",
// "short date format" => "short date format",
// "short time format" => "short time format",
// "display field order" => "display field order",
// "feature charts" => "feature charts",
// "rss forums" => "rss forums",
// "rss forum" => "rss forum",
// "rss directories" => "rss directories",
// "rss articles" => "rss articles",
// "rss blogs" => "rss blogs",
// "rss image galleries" => "rss image galleries",
// "rss file galleries" => "rss file galleries",
// "rss wiki" => "rss wiki",
// "rss image gallery" => "rss image gallery",
// "rss file gallery" => "rss file gallery",
// "rss blog" => "rss blog",
// "rss tracker" => "rss tracker",
// "rss trackers" => "rss trackers",
// "rss calendar" => "rss calendar",
// "rss mapfiles" => "rss mapfiles",
// "rss cache time" => "rss cache time",
// "max rss forums" => "max rss forums",
// "max rss forum" => "max rss forum",
// "max rss directories" => "max rss directories",
// "max rss articles" => "max rss articles",
// "max rss blogs" => "max rss blogs",
// "max rss image galleries" => "max rss image galleries",
// "max rss file galleries" => "max rss file galleries",
// "max rss wiki" => "max rss wiki",
// "max rss image gallery" => "max rss image gallery",
// "max rss file gallery" => "max rss file gallery",
// "max rss blog" => "max rss blog",
// "max rss mapfiles" => "max rss mapfiles",
// "max rss tracker" => "max rss tracker",
// "max rss trackers" => "max rss trackers",
// "max rss calendar" => "max rss calendar",
// "summary rss blogs" => "summary rss blogs",
// "rssfeed default version" => "rssfeed default version",
// "rssfeed language" => "rssfeed language",
// "rssfeed editor" => "rssfeed editor",
// "rssfeed webmaster" => "rssfeed webmaster",
// "rssfeed creator" => "rssfeed creator",
// "rssfeed css" => "rssfeed css",
// "rssfeed publisher" => "rssfeed publisher",
// "rssfeed img" => "rssfeed img",
// "rss basic auth" => "rss basic auth",
// "feature maps" => "feature maps",
// "map path" => "map path",
// "default map" => "default map",
// "map help" => "map help",
// "map comments" => "map comments",
// "gdaltindex" => "gdaltindex",
// "ogr2ogr" => "ogr2ogr",
// "mapzone" => "mapzone",
// "feature gmap" => "feature gmap",
// "gmap defaultx" => "gmap defaultx",
// "gmap defaulty" => "gmap defaulty",
// "gmap defaultz" => "gmap defaultz",
// "gmap key" => "gmap key",
// "allowRegister" => "allowRegister",
// "eponymousGroups" => "eponymousGroups",
// "useRegisterPasscode" => "useRegisterPasscode",
// "registerPasscode" => "registerPasscode",
// "rememberme" => "rememberme",
// "remembertime" => "remembertime",
// "remembermethod" => "remembermethod",
// "feature clear passwords" => "feature clear passwords",
// "feature crypt passwords" => "feature crypt passwords",
// "feature challenge" => "feature challenge",
// "min user length" => "min user length",
// "min pass length" => "min pass length",
// "pass chr num" => "pass chr num",
// "pass due" => "pass due",
// "email due" => "email due",
// "unsuccessful logins" => "unsuccessful logins",
// "rnd num reg" => "rnd num reg",
// "generate password" => "generate password",
// "auth method" => "auth method",
// "auth pear" => "auth pear",
// "auth create user tiki" => "auth create user tiki",
// "auth create user auth" => "auth create user auth",
// "auth skip admin" => "auth skip admin",
// "auth ldap url" => "auth ldap url",
// "auth pear host" => "auth pear host",
// "auth pear port" => "auth pear port",
// "auth ldap scope" => "auth ldap scope",
// "auth ldap basedn" => "auth ldap basedn",
// "auth ldap userdn" => "auth ldap userdn",
// "auth ldap userattr" => "auth ldap userattr",
// "auth ldap useroc" => "auth ldap useroc",
// "auth ldap groupdn" => "auth ldap groupdn",
// "auth ldap groupattr" => "auth ldap groupattr",
// "auth ldap groupoc" => "auth ldap groupoc",
// "auth ldap memberattr" => "auth ldap memberattr",
// "auth ldap memberisdn" => "auth ldap memberisdn",
// "auth ldap adminuser" => "auth ldap adminuser",
// "auth ldap adminpass" => "auth ldap adminpass",
// "auth ldap version" => "auth ldap version",
// "auth ldap nameattr" => "auth ldap nameattr",
// "auth ldap countryattr" => "auth ldap countryattr",
// "auth ldap emailattr" => "auth ldap emailattr",
// "https login" => "https login",
// "feature show stay in ssl mode" => "feature show stay in ssl mode",
// "feature switch ssl mode" => "feature switch ssl mode",
// "https port" => "https port",
// "http port" => "http port",
// "login url" => "login url",
// "login scr" => "login scr",
// "register url" => "register url",
// "error url" => "error url",
// "highlight group" => "highlight group",
// "cookie path" => "cookie path",
// "cookie domain" => "cookie domain",
// "cookie name" => "cookie name",
// "user tracker infos" => "user tracker infos",
// "desactive login autocomplete" => "desactive login autocomplete",
// "permission denied login box" => "permission denied login box",
// "permission denied url" => "permission denied url",
// "feature intertiki" => "feature intertiki",
// "feature intertiki server" => "feature intertiki server",
// "feature intertiki slavemode" => "feature intertiki slavemode",
// "interlist" => "interlist",
// "feature intertiki mymaster" => "feature intertiki mymaster",
// "feature intertiki import preferences" => "feature intertiki import preferences",
// "feature intertiki import groups" => "feature intertiki import groups",
// "known hosts" => "known hosts",
// "tiki key" => "tiki key",
// "intertiki logfile" => "intertiki logfile",
// "intertiki errfile" => "intertiki errfile",
// "feature intertiki sharedcookie" => "feature intertiki sharedcookie",
// "search lru length" => "search lru length",
// "search lru purge rate" => "search lru purge rate",
// "search max syllwords" => "search max syllwords",
// "search min wordlength" => "search min wordlength",
// "search refresh rate" => "search refresh rate",
// "search syll age" => "search syll age",
// "feature categories" => "feature categories",
// "feature categoryobjects" => "feature categoryobjects",
// "feature categorypath" => "feature categorypath",
// "feature category reinforce" => "feature category reinforce",
// "feature category use phplayers" => "feature category use phplayers",
// "categorypath excluded" => "categorypath excluded",
// "categories used in tpl" => "categories used in tpl",
// "feature games" => "feature games",
// "feature html pages" => "feature html pages",
// "feature filegals manager" => "feature filegals manager",
// "feature contact" => "feature contact",
// "contact user" => "contact user",
// "contact anon" => "contact anon",
// "mail crlf" => "mail crlf",
// "feature detect language" => "feature detect language",
// "feature homePage if bl missing" => "feature homePage if bl missing",
// "record untranslated" => "record untranslated",
// "feature best language" => "feature best language",
// "feature translation" => "feature translation",
// "feature urgent translation" => "feature urgent translation",
// "lang use db" => "lang use db",
// "language" => "language",
// "feature babelfish" => "feature babelfish",
// "feature babelfish logo" => "feature babelfish logo",
// "quantify changes" => "quantify changes",
// "feature sync language" => "feature sync language",
// "show available translations" => "show available translations",
// "metatag keywords" => "metatag keywords",
// "metatag threadtitle" => "metatag threadtitle",
// "metatag imagetitle" => "metatag imagetitle",
// "metatag freetags" => "metatag freetags",
// "metatag description" => "metatag description",
// "metatag author" => "metatag author",
// "metatag geoposition" => "metatag geoposition",
// "metatag georegion" => "metatag georegion",
// "metatag geoplacename" => "metatag geoplacename",
// "metatag robots" => "metatag robots",
// "metatag revisitafter" => "metatag revisitafter",
// "head extra js" => "head extra js",
// "keep versions" => "keep versions",
// "feature custom home" => "feature custom home",
// "site crumb seper" => "site crumb seper",
// "site nav seper" => "site nav seper",
// "feature sitemycode" => "feature sitemycode",
// "sitemycode" => "sitemycode",
// "sitemycode publish" => "sitemycode publish",
// "feature sitelogo" => "feature sitelogo",
// "sitelogo bgcolor" => "sitelogo bgcolor",
// "sitelogo bgstyle" => "sitelogo bgstyle",
// "sitelogo align" => "sitelogo align",
// "sitelogo title" => "sitelogo title",
// "sitelogo src" => "sitelogo src",
// "sitelogo alt" => "sitelogo alt",
// "feature siteloc" => "feature siteloc",
// "feature sitenav" => "feature sitenav",
// "sitenav" => "sitenav",
// "feature sitead" => "feature sitead",
// "sitead" => "sitead",
// "sitead publish" => "sitead publish",
// "feature breadcrumbs" => "feature breadcrumbs",
// "feature siteloclabel" => "feature siteloclabel",
// "feature sitesearch" => "feature sitesearch",
// "feature site login" => "feature site login",
// "feature sitemenu" => "feature sitemenu",
// "feature topbar version" => "feature topbar version",
// "feature topbar debug" => "feature topbar debug",
// "feature topbar id menu" => "feature topbar id menu",
// "feature topbar custom code" => "feature topbar custom code",
// "feature sitetitle" => "feature sitetitle",
// "feature sitedesc" => "feature sitedesc",
// "feature bot logo" => "feature bot logo",
// "feature endbody code" => "feature endbody code",
// "feature left column" => "feature left column",
// "feature right column" => "feature right column",
// "feature top bar" => "feature top bar",
// "feature bot bar" => "feature bot bar",
// "feature bot bar icons" => "feature bot bar icons",
// "feature bot bar debug" => "feature bot bar debug",
// "feature bot bar rss" => "feature bot bar rss",
// "feature bot bar power by tw" => "feature bot bar power by tw",
// "maxRecords" => "maxRecords",
// "maxArticles" => "maxArticles",
// "maxVersions" => "maxVersions",
// "feature view tpl" => "feature view tpl",
// "slide style" => "slide style",
// "site favicon" => "site favicon",
// "site favicon type" => "site favicon type",
// "style" => "style",
// "style option" => "style option",
// "site style" => "site style",
// "site style option" => "site style option",
// "use context menu icon" => "use context menu icon",
// "use context menu text" => "use context menu text",
// "feature site report" => "feature site report",
// "feature site send link" => "feature site send link",
// "feature layoutshadows" => "feature layoutshadows",
// "feature mods provider" => "feature mods provider",
// "mods dir" => "mods dir",
// "mods server" => "mods server",
// "feature experimental" => "feature experimental",
// "feature actionlog" => "feature actionlog",
// "feature actionlog bytes" => "feature actionlog bytes",
// "browsertitle" => "browsertitle",
// "tmpDir" => "tmpDir",
// "feature tell a friend" => "feature tell a friend",
// "feature copyright" => "feature copyright",
// "feature multimedia" => "feature multimedia",
// "feature swfobj" => "feature swfobj",
// "feature smileys" => "feature smileys",
// "popupLinks" => "popupLinks",
// "feature autolinks" => "feature autolinks",
// "quicktags over textarea" => "quicktags over textarea",
// "default rows textarea wiki" => "default rows textarea wiki",
// "default rows textarea comment" => "default rows textarea comment",
// "default rows textarea forum" => "default rows textarea forum",
// "default rows textarea forumthread" => "default rows textarea forumthread",
// "feature floating help" => "feature floating help",
// "direct pagination" => "direct pagination",
// "nextprev pagination" => "nextprev pagination",
// "pagination firstlast" => "pagination firstlast",
// "pagination hide if one page" => "pagination hide if one page",
// "pagination icons" => "pagination icons",
// "pagination fastmove links" => "pagination fastmove links",
// "direct pagination max middle links" => "direct pagination max middle links",
// "direct pagination max ending links" => "direct pagination max ending links",
// "anonCanEdit" => "anonCanEdit",
// "cacheimages" => "cacheimages",
// "cachepages" => "cachepages",
// "count admin pvs" => "count admin pvs",
// "default mail charset" => "default mail charset",
// "error reporting adminonly" => "error reporting adminonly",
// "error reporting level" => "error reporting level",
// "smarty security" => "smarty security",
// "feature ajax" => "feature ajax",
// "feature ajax autosave" => "feature ajax autosave",
// "feature antibot" => "feature antibot",
// "feature banners" => "feature banners",
// "feature banning" => "feature banning",
// "feature comm" => "feature comm",
// "feature contribution" => "feature contribution",
// "feature contribution display in comment" => "feature contribution display in comment",
// "feature contribution mandatory" => "feature contribution mandatory",
// "feature contribution mandatory blog" => "feature contribution mandatory blog",
// "feature contribution mandatory comment" => "feature contribution mandatory comment",
// "feature contribution mandatory forum" => "feature contribution mandatory forum",
// "feature debug console" => "feature debug console",
// "feature debugger console" => "feature debugger console",
// "feature display my to others" => "feature display my to others",
// "feature drawings" => "feature drawings",
// "feature dynamic content" => "feature dynamic content",
// "feature edit templates" => "feature edit templates",
// "feature editcss" => "feature editcss",
// "feature events" => "feature events",
// "feature friends" => "feature friends",
// "feature fullscreen" => "feature fullscreen",
// "feature help" => "feature help",
// "feature hotwords" => "feature hotwords",
// "feature hotwords nw" => "feature hotwords nw",
// "feature integrator" => "feature integrator",
// "feature live support" => "feature live support",
// "feature mailin" => "feature mailin",
// "feature menusfolderstyle" => "feature menusfolderstyle",
// "feature mobile" => "feature mobile",
// "feature modulecontrols" => "feature modulecontrols",
// "feature morcego" => "feature morcego",
// "feature multilingual" => "feature multilingual",
// "feature multilingual one page" => "feature multilingual one page",
// "feature multilingual structures" => "feature multilingual structures",
// "feature newsletters" => "feature newsletters",
// "feature obzip" => "feature obzip",
// "feature phplayers" => "feature phplayers",
// "feature cssmenus" => "feature cssmenus",
// "feature projects" => "feature projects",
// "feature ranking" => "feature ranking",
// "feature redirect on error" => "feature redirect on error",
// "feature referer highlight" => "feature referer highlight",
// "feature referer stats" => "feature referer stats",
// "feature score" => "feature score",
// "feature sheet" => "feature sheet",
// "feature shoutbox" => "feature shoutbox",
// "feature source" => "feature source",
// "feature stats" => "feature stats",
// "feature tabs" => "feature tabs",
// "feature theme control" => "feature theme control",
// "feature ticketlib" => "feature ticketlib",
// "feature ticketlib2" => "feature ticketlib2",
// "feature top banner" => "feature top banner",
// "feature usability" => "feature usability",
// "feature use quoteplugin" => "feature use quoteplugin",
// "feature user watches" => "feature user watches",
// "feature group watches" => "feature group watches",
// "feature user watches translations" => "feature user watches translations",
// "feature workflow" => "feature workflow",
// "feature xmlrpc" => "feature xmlrpc",
// "helpurl" => "helpurl",
// "layout section" => "layout section",
// "limitedGoGroupHome" => "limitedGoGroupHome",
// "minical reminders" => "minical reminders",
// "modallgroups" => "modallgroups",
// "modseparateanon" => "modseparateanon",
// "php docroot" => "php docroot",
// "proxy host" => "proxy host",
// "proxy port" => "proxy port",
// "ip can be checked" => "ip can be checked",
// "sender email" => "sender email",
// "feature site report email" => "feature site report email",
// "session db" => "session db",
// "session lifetime" => "session lifetime",
// "shoutbox autolink" => "shoutbox autolink",
// "show comzone" => "show comzone",
// "system os" => "system os",
// "tikiIndex" => "tikiIndex",
// "urlIndex" => "urlIndex",
// "useGroupHome" => "useGroupHome",
// "useGroupTheme" => "useGroupTheme",
// "useUrlIndex" => "useUrlIndex",
// "use proxy" => "use proxy",
// "user list order" => "user list order",
// "webserverauth" => "webserverauth",
// "feature purifier" => "feature purifier",
// "feature shadowbox" => "feature shadowbox",
// "log sql" => "log sql",
// "log sql perf min" => "log sql perf min",
// "log mail" => "log mail",
// "log tpl" => "log tpl",
// "case patched" => "case patched",
// "site closed" => "site closed",
// "site closed msg" => "site closed msg",
// "use load threshold" => "use load threshold",
// "load threshold" => "load threshold",
// "site busy msg" => "site busy msg",
// "bot logo code" => "bot logo code",
// "feature blogposts pings" => "feature blogposts pings",
// "feature create webhelp" => "feature create webhelp",
// "feature forums search" => "feature forums search",
// "feature trackbackpings" => "feature trackbackpings",
// "feature wiki ext icon" => "feature wiki ext icon",
// "feature wiki mandatory category" => "feature wiki mandatory category",
// "feature intertiki imported groups" => "feature intertiki imported groups",
// "feature wiki history ip" => "feature wiki history ip",
// "pam create user tiki" => "pam create user tiki",
// "pam service" => "pam service",
// "pam skip admin" => "pam skip admin",
// "shib affiliation" => "shib affiliation",
// "shib create user tiki" => "shib create user tiki",
// "shib group" => "shib group",
// "shib skip admin" => "shib skip admin",
// "shib usegroup" => "shib usegroup",
// "wiki 3d camera distance" => "wiki 3d camera distance",
// "wiki 3d elastic constant" => "wiki 3d elastic constant",
// "wiki 3d eletrostatic constant" => "wiki 3d eletrostatic constant",
// "wiki 3d fov" => "wiki 3d fov",
// "wiki 3d friction constant" => "wiki 3d friction constant",
// "wiki 3d node charge" => "wiki 3d node charge",
// "wiki 3d node mass" => "wiki 3d node mass",
// "wiki 3d node size" => "wiki 3d node size",
// "wiki 3d spring size" => "wiki 3d spring size",
// "wiki 3d text size" => "wiki 3d text size",
// "articles feature copyrights" => "articles feature copyrights",
// "blogues feature copyrights" => "blogues feature copyrights",
// "faqs feature copyrights" => "faqs feature copyrights",
// "feature contributor wiki" => "feature contributor wiki",
// "https login required" => "https login required",
// "maxRowsGalleries" => "maxRowsGalleries",
// "replimaster" => "replimaster",
// "rowImagesGalleries" => "rowImagesGalleries",
// "scaleSizeGalleries" => "scaleSizeGalleries",
// "thumbSizeXGalleries" => "thumbSizeXGalleries",
// "thumbSizeYGalleries" => "thumbSizeYGalleries",
// "wiki 3d adjust camera" => "wiki 3d adjust camera",
// "wiki 3d autoload" => "wiki 3d autoload",
// "feature mootools" => "feature mootools",
// "javascript enabled" => "javascript enabled",
// "feature comments post as anonymous" => "feature comments post as anonymous",
// "feature comments moderation" => "feature comments moderation",
// "feature comments locking" => "feature comments locking",
// "feature template zoom" => "feature template zoom",
// "feature iepngfix" => "feature iepngfix",
// "iepngfix selectors" => "iepngfix selectors",
// "iepngfix elements" => "iepngfix elements",
// "use minified scripts" => "use minified scripts",
// "valid email regex" => "valid email regex",
// "feature jquery" => "feature jquery",
// "jquery effect" => "jquery effect",
// "jquery effect direction" => "jquery effect direction",
// "jquery effect speed" => "jquery effect speed",
// "jquery effect tabs" => "jquery effect tabs",
// "jquery effect tabs direction" => "jquery effect tabs direction",
// "jquery effect tabs speed" => "jquery effect tabs speed",
// "feature jquery ui" => "feature jquery ui",
// "feature jquery tooltips" => "feature jquery tooltips",
// "feature jquery autocomplete" => "feature jquery autocomplete",
// "feature jquery superfish" => "feature jquery superfish",
// "feature jquery reflection" => "feature jquery reflection",
// "feature jquery sheet" => "feature jquery sheet",
// "feature jquery tablesorter" => "feature jquery tablesorter",
// "feature jquery cycle" => "feature jquery cycle",
// "feature sefurl" => "feature sefurl",
// "feature sefurl filter" => "feature sefurl filter",
// "feature sefurl paths" => "feature sefurl paths",
// "feature sefurl title article" => "feature sefurl title article",
// "feature sefurl title blog" => "feature sefurl title blog",
// "feature tikitests" => "feature tikitests",
// "feature magic" => "feature magic",
// "profile sources" => "profile sources",
// "profile channels" => "profile channels",
// "feature minichat" => "feature minichat",
// "feature pear date" => "feature pear date",
// "feature bidi" => "feature bidi",
// "feature lastup" => "feature lastup",
// "transition style ver" => "transition style ver",
// "magic last load" => "magic last load",
// "feature groupalert" => "feature groupalert",
// "lib spellcheck" => "lib spellcheck",
// "wiki spellcheck" => "wiki spellcheck",
// "blog spellcheck" => "blog spellcheck",
// "allowMsgs" => "allowMsgs",
// "diff versions" => "diff versions",
// "display timezone" => "display timezone",
// "email is public" => "email is public",
// "homePage" => "homePage",
// "lat" => "lat",
// "lon" => "lon",
// "mess archiveAfter" => "mess archiveAfter",
// "mess maxRecords" => "mess maxRecords",
// "mess sendReadStatus" => "mess sendReadStatus",
// "minPrio" => "minPrio",
// "mytiki blogs" => "mytiki blogs",
// "mytiki articles" => "mytiki articles",
// "mytiki gals" => "mytiki gals",
// "mytiki items" => "mytiki items",
// "mytiki msgs" => "mytiki msgs",
// "mytiki pages" => "mytiki pages",
// "mytiki tasks" => "mytiki tasks",
// "mytiki workflow" => "mytiki workflow",
// "mytiki forum topics" => "mytiki forum topics",
// "mytiki forum replies" => "mytiki forum replies",
// "realName" => "realName",
// "gender" => "gender",
// "show mouseover user info" => "show mouseover user info",
// "tasks maxRecords" => "tasks maxRecords",
// "user dbl" => "user dbl",
// "user information" => "user information",
// "mailCharset" => "mailCharset",
// "Group Monitor" => "Group Monitor",
// "Watched by categories" => "Watched by categories",
// "Select Categories" => "Select Categories",
// "Select/deselect all categories" => "Select/deselect all categories",
// "Comments Locked" => "Comments Locked",
// "Threaded" => "Threaded",
// "below your current threshold" => "below your current threshold",
// "Comments are locked" => "Comments are locked",
// "Maximum size" => "Maximum size",
// "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address" => "If you would like to be notified when someone replies to this topic<br />please tell us your e-mail address",
// "Please note that the preview does not keep the attached file which you will have to choose before posting" => "Please note that the preview does not keep the attached file which you will have to choose before posting",
// "Your comment will have to be approved by the moderator before it is displayed" => "Your comment will have to be approved by the moderator before it is displayed",
// "Contributors" => "Contributors",
// "Duplicate categories" => "Duplicate categories",
// "Duplicate perms" => "Duplicate perms",
// "Users with perms and not only the owner of the gallery can upload in it" => "Users with perms and not only the owner of the gallery can upload in it",
// "The files can be locked at download" => "The files can be locked at download",
// "Maximum number of archives for each file" => "Maximum number of archives for each file",
// "Group of users alerted when file gallery is modified" => "Group of users alerted when file gallery is modified",
// "Allows to select each user for small groups" => "Allows to select each user for small groups",
// "Upload New Version" => "Upload New Version",
// "Download and lock" => "Download and lock",
// "Both" => "Both",
// "Show an icon in a column" => "Show an icon in a column",
// "not in" => "not in",
// "Clear Filter" => "Clear Filter",
// "Translate tags" => "Translate tags",
// "You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page" => "You are about to leave this page. If you have made any changes without Saving, your changes will be lost.  Are you sure you want to exit this page",
// "\\074span class=\"shortcut\"\\076C\\074/span\\076lose" => "\\074span class=\"shortcut\"\\076C\\074/span\\076lose",
// "\\074span class=\"shortcut\"\\076N\\074/span\\076ext" => "\\074span class=\"shortcut\"\\076N\\074/span\\076ext",
// "\\074span class=\"shortcut\"\\076P\\074/span\\076revious" => "\\074span class=\"shortcut\"\\076P\\074/span\\076revious",
// "Show Tree" => "Show Tree",
// "Hide Tree" => "Hide Tree",
// "Download the zip" => "Download the zip",
// "Other Sorts" => "Other Sorts",
// "No Additionnal Sort" => "No Additionnal Sort",
// "Contribution" => "Contribution",
// "GET:WikiName to get a wiki page" => "GET:WikiName to get a wiki page",
// "PUT:WikiName to update/create a wiki page (use the body for the page data)" => "PUT:WikiName to update/create a wiki page (use the body for the page data)",
// "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)" => "APPEND:WikiName to append data to a Wiki page (use the body for the data to add)",
// "PREPEND:WikiName to append the data at the top" => "PREPEND:WikiName to append the data at the top",
// "Tiki mail-in auto-reply" => "Tiki mail-in auto-reply",
// "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first" => "{\$mail_user} <{\$mail_email}> has requested a new password on {\$mail_site}, but you need to validate his account first",
// "User Tracker" => "User Tracker",
// "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else" => "Please click on the following link to confirm you wish to reset your password and go to the screen where you must enter a new \"permanent\" password. Please pick a password only you will know, and don't share it with anyone else",
// "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}" => "ItemID {\$mail_itemId} was deleted in the tracker {\$mail_trackerName}",
// "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}" => "New status ItemID {\$mail_itemId} for the tracker {\$mail_trackerName}",
// "Download the file at" => "Download the file at",
// "Please visit this link before login again" => "Please visit this link before login again",
// "Confirm your account at %s" => "Confirm your account at %s",
// "An administrator of the site below has added you as a new user" => "An administrator of the site below has added you as a new user",
// "If you want to confirm your membership in this site, click on the following link to login for the first time" => "If you want to confirm your membership in this site, click on the following link to login for the first time",
// "Your authentication credentials are" => "Your authentication credentials are",
// "Welcome on the site" => "Welcome on the site",
// "Your personal access to" => "Your personal access to",
// "{\$mail_action} article post" => "{\$mail_action} article post",
// "{\$mail_title} by {\$mail_user} at" => "{\$mail_title} by {\$mail_user} at",
// "New article post" => "New article post",
// "Edited article post" => "Edited article post",
// "Deleted article post" => "Deleted article post",
// "{\$mail_action} article post at" => "{\$mail_action} article post at",
// "View item calendar at" => "View item calendar at",
// "A new category was created in" => "A new category was created in",
// "A category was removed in" => "A category was removed in",
// "A category was updated" => "A category was updated",
// "Updated by" => "Updated by",
// "Old" => "Old",
// "updated" => "updated",
// "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}" => "New forum post in <{\$mail_forum|truncate:20:\"...\"}> by {\$mail_author}",
// "An object was added to category" => "An object was added to category",
// "Added by" => "Added by",
// "Object type" => "Object type",
// "An object was removed from category" => "An object was removed from category",
// "A page has been added to your watched sub-structure" => "A page has been added to your watched sub-structure",
// "A page has been removed from your watched sub-structure" => "A page has been removed from your watched sub-structure",
// "A page has been promoted out your watched sub-structure" => "A page has been promoted out your watched sub-structure",
// "A page has been demoted to your watched structure" => "A page has been demoted to your watched structure",
// "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "The page {\$mail_page} was deleted by {\$mail_user} at {\$mail_date|tiki_short_datetime}",
// "The page {\$mail_page} was deleted but used to be here" => "The page {\$mail_page} was deleted but used to be here",
// "The old page content follows below" => "The old page content follows below",
// "Wiki page %s created by {\$mail_user}" => "Wiki page %s created by {\$mail_user}",
// "Wiki page %s deleted by {\$mail_user}" => "Wiki page %s deleted by {\$mail_user}",
// "Wiki page %s changed by {\$mail_user}" => "Wiki page %s changed by {\$mail_user}",
// "Wiki page %s was commented on by" => "Wiki page %s was commented on by",
// "Query Results" => "Query Results",
// "Querying" => "Querying",
// "Scroll Up" => "Scroll Up",
// "Scroll Down" => "Scroll Down",
// "from the mapfile" => "from the mapfile",
// "is reply to" => "is reply to",
// "Toggle module contents" => "Toggle module contents",
// "toggle" => "toggle",
// "\$tpl_module_title" => "\$tpl_module_title",
// "Admin Drawings" => "Admin Drawings",
// "External Wikis" => "External Wikis",
// "Tiki Cache/Sys Admin" => "Tiki Cache/Sys Admin",
// "Syntax Highlighting" => "Syntax Highlighting",
// "\$module_title" => "\$module_title",
// "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>" => "To learn more, visit: <a href=\"http://tikiwiki.org\" title=\"The Tikiwiki Community\" target=\"_blank\">http://tikiwiki.org</a>",
// "on blogpost" => "on blogpost",
// "\$modcattitle" => "\$modcattitle",
// "Folksonomy" => "Folksonomy",
// "Tags This Page Has" => "Tags This Page Has",
// "Add tags" => "Add tags",
// "More Like This" => "More Like This",
// "List everything tagged" => "List everything tagged",
// "\$type" => "\$type",
// "Last `\$module_rows` Modified Comments" => "Last `\$module_rows` Modified Comments",
// "Last Modified Comments" => "Last Modified Comments",
// "No avatar" => "No avatar",
// "Login through Shibboleth" => "Login through Shibboleth",
// "CapsLock is on" => "CapsLock is on",
// "OpenID Login" => "OpenID Login",
// "RSS Feeds" => "RSS Feeds",
// "A leading plus sign indicates that this word must be present in every object returned" => "A leading plus sign indicates that this word must be present in every object returned",
// "A leading minus sign indicates that this word must not be present in any row returned" => "A leading minus sign indicates that this word must not be present in any row returned",
// "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher" => "By default (when neither plus nor minus is specified) the word is optional, but the object that contain it will be rated higher",
// "These two operators are used to change a word's contribution to the relevance value that is assigned to a row" => "These two operators are used to change a word's contribution to the relevance value that is assigned to a row",
// "Parentheses are used to group words into subexpressions" => "Parentheses are used to group words into subexpressions",
// "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator" => "A leading tilde acts as a negation operator, causing the word's contribution to the object relevance to be negative. It's useful for marking noise words. An object that contains such a word will be rated lower than others, but will not be excluded altogether, as it would be with the - operator",
// "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended" => "An asterisk is the truncation operator. Unlike the other operators, it should be appended to the word, not prepended",
// "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed" => "The phrase, that is enclosed in double quotes &quot;, matches only objects that contain this phrase literally, as it was typed",
// "Advanced search" => "Advanced search",
// "Advanced Search Help" => "Advanced Search Help",
// "Page Relations" => "Page Relations",
// "Are you sure you want to delete this shout" => "Are you sure you want to delete this shout",
// "Delete this shout" => "Delete this shout",
// "Edit this shout" => "Edit this shout",
// "`\$module_params.prefix`" => "`\$module_params.prefix`",
// "Top `\$module_rows` Objects" => "Top `\$module_rows` Objects",
// "Up-to-date-ness" => "Up-to-date-ness",
// "Upcoming `\$module_rows` events" => "Upcoming `\$module_rows` events",
// "Tiki Action Calendar" => "Tiki Action Calendar",
// "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones" => "Select <a href=\"tiki-list_banners.php\" title=\"Banners\">Admin &gt; Banners</a> from the menu to create and edit banner zones",
// "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users" => "<strong>Activate</strong> will display content for Admin only. Select <strong>Publish</strong> to display for all users",
// "Editing and Plugins" => "Editing and Plugins",
// "Text area" => "Text area",
// "Meta Tags" => "Meta Tags",
// "Intertiki" => "Intertiki",
// "Sef URL" => "Sef URL",
// "Blogs Listing" => "Blogs Listing",
// "Create a blog" => "Create a blog",
// "Spell checking" => "Spell checking",
// "Requires a separate download" => "Requires a separate download",
// "Custom blog headings" => "Custom blog headings",
// "Blog-level" => "Blog-level",
// "Post-level" => "Post-level",
// "Default number per page" => "Default number per page",
// "Default ordering" => "Default ordering",
// "Blogs Listings" => "Blogs Listings",
// "Select which items to display when listing blogs" => "Select which items to display when listing blogs",
// "General settings" => "General settings",
// "Default calendars to display" => "Default calendars to display",
// "All calendars" => "All calendars",
// "A subset of available calendars" => "A subset of available calendars",
// "Create calendar" => "Create calendar",
// "View list begins" => "View list begins",
// "Focus Date" => "Focus Date",
// "Period beginning" => "Period beginning",
// "Manual selection of time/date" => "Manual selection of time/date",
// "JS calendar" => "JS calendar",
// "Year selection is valid when the JS Calendar <strong>is not</strong> enabled" => "Year selection is valid when the JS Calendar <strong>is not</strong> enabled",
// "First year in the dropdown" => "First year in the dropdown",
// "Enter a year or use +/- N to specify a year relative to the current\n\tyear" => "Enter a year or use +/- N to specify a year relative to the current\n\tyear",
// "Last year in the dropdown" => "Last year in the dropdown",
// "Group calendars" => "Group calendars",
// "Sticky popup" => "Sticky popup",
// "Item view tab" => "Item view tab",
// "Administer categories" => "Administer categories",
// "Category path" => "Category path",
// "Exclude these categories" => "Exclude these categories",
// "Separate category IDs with a comma (,)" => "Separate category IDs with a comma (,)",
// "Show category objects" => "Show category objects",
// "Use PHPLayers for category browser" => "Use PHPLayers for category browser",
// "PHPLayers is disabled" => "PHPLayers is disabled",
// "Categories used in templates (TPL)" => "Categories used in templates (TPL)",
// "Will improve performance, but may show forbidden results" => "Will improve performance, but may show forbidden results",
// "Permission to all (not just any) of an object's categories is required for access" => "Permission to all (not just any) of an object's categories is required for access",
// "Character set for mail" => "Character set for mail",
// "Detect user timezone if browser allows, otherwise site default" => "Detect user timezone if browser allows, otherwise site default",
// "License page" => "License page",
// "Enable copyright management for" => "Enable copyright management for",
// "Question and Answer prefix on Answers" => "Question and Answer prefix on Answers",
// "Programmer" => "Programmer",
// "Copyright System" => "Copyright System",
// "Copyright system" => "Copyright system",
// "Minichat" => "Minichat",
// "Comments Moderation" => "Comments Moderation",
// "Comments Locking" => "Comments Locking",
// "JavaScript popup date selector" => "JavaScript popup date selector",
// "Css Menus (suckerfish)" => "Css Menus (suckerfish)",
// "Mootools or JQuery" => "Mootools or JQuery",
// "Floating help aka the Big Blue Help Icon" => "Floating help aka the Big Blue Help Icon",
// "Seem ok" => "Seem ok",
// "Features that may change or might be re-worked in the future" => "Features that may change or might be re-worked in the future",
// "HTML Purifier" => "HTML Purifier",
// "HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)" => "HTML Purifier (Content is cleaned to XHTML 1.1 Strict on each save)",
// "JQuery: JavaScript UI effects" => "JQuery: JavaScript UI effects",
// "Need polish" => "Need polish",
// "Features that need admin help and user patience to work well" => "Features that need admin help and user patience to work well",
// "Mindmap" => "Mindmap",
// "Print Indexed" => "Print Indexed",
// "SEFURL" => "SEFURL",
// "Ajax auto-save" => "Ajax auto-save",
// "Malfunctioning" => "Malfunctioning",
// "These features have critical faults - not recommended" => "These features have critical faults - not recommended",
// "Neglected" => "Neglected",
// "Action Calendar" => "Action Calendar",
// "Tiki action calendar" => "Tiki action calendar",
// "Display 'MyTiki' in the application menu" => "Display 'MyTiki' in the application menu",
// "Group Watches" => "Group Watches",
// "User Levels" => "User Levels",
// "Group Alert" => "Group Alert",
// "Programmer Features" => "Programmer Features",
// "TikiTests" => "TikiTests",
// "Use Minified Scripts" => "Use Minified Scripts",
// "To create or remove file galleries, select" => "To create or remove file galleries, select",
// "from the application menu" => "from the application menu",
// "Gallery Listing" => "Gallery Listing",
// "Search Indexing" => "Search Indexing",
// "Create a Gallery" => "Create a Gallery",
// "Store in database" => "Store in database",
// "Store in directory" => "Store in directory",
// "Podcast directory" => "Podcast directory",
// "Required for podcasts" => "Required for podcasts",
// "Default Ordering" => "Default Ordering",
// "Batch uploading" => "Batch uploading",
// "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols" => "If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload files in that dir, either by scp, ftp, or other protocols",
// "Require file author's name for anonymous uploads" => "Require file author's name for anonymous uploads",
// "Upload Regex" => "Upload Regex",
// "Must match" => "Must match",
// "Cannot match" => "Cannot match",
// "Gallery Listings" => "Gallery Listings",
// "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries" => "Changing these settings will <em>not</em> affect existing file galleries. These changes will apply <em>only</em> to new file galleries",
// "Select which items to display when listing galleries: " => "Select which items to display when listing galleries: ",
// "Automatically index files on upload or change" => "Automatically index files on upload or change",
// "Handlers" => "Handlers",
// "Add custom handlers to make your files &quot;searchable&quot; content" => "Add custom handlers to make your files &quot;searchable&quot; content",
// "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command" => "Use <strong>%1</strong> as the internal file name. For example, use <strong>strings %1</strong> to convert the document to text, using the Unix <strong>strings</strong> command",
// "To delete a handler, leave the <strong>System Command</strong> field blank" => "To delete a handler, leave the <strong>System Command</strong> field blank",
// "System Command" => "System Command",
// "Forums Listing" => "Forums Listing",
// "Create a forum" => "Create a forum",
// "Topic archiving" => "Topic archiving",
// "Quick jumps" => "Quick jumps",
// "Replies are empty" => "Replies are empty",
// "If disabled, replies will quote the original post" => "If disabled, replies will quote the original post",
// "First post of a thread can have an empty body" => "First post of a thread can have an empty body",
// "Will be a thread title" => "Will be a thread title",
// "Threads" => "Threads",
// "Manage thread defaults per-forum" => "Manage thread defaults per-forum",
// "Display thread configuration bar" => "Display thread configuration bar",
// "Allows users to override the defaults" => "Allows users to override the defaults",
// "Keep settings for all forums during the user session" => "Keep settings for all forums during the user session",
// "Default style" => "Default style",
// "Default sort mode" => "Default sort mode",
// "Forum name search" => "Forum name search",
// "When listing forums" => "When listing forums",
// "Forum content search" => "Forum content search",
// "Topic content search" => "Topic content search",
// "Search is disabled" => "Search is disabled",
// "Use Tiki (database-independent) search" => "Use Tiki (database-independent) search",
// "Use database (full-text) search" => "Use database (full-text) search",
// "Select which items to display when listing forums" => "Select which items to display when listing forums",
// "Description length" => "Description length",
// "3D Tag Browser" => "3D Tag Browser",
// "Show tag cloud" => "Show tag cloud",
// "Maximum number of tags in cloud" => "Maximum number of tags in cloud",
// "Show freetags in middle column" => "Show freetags in middle column",
// "Preload freetag random tag" => "Preload freetag random tag",
// "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>" => "When arriving on <a href=\"tiki-browse_freetags.php\">freetag search page</a>",
// "Random tag cloud colors" => "Random tag cloud colors",
// "Separate colors with a comma (,)" => "Separate colors with a comma (,)",
// "Alphanumeric ASCII characters only" => "Alphanumeric ASCII characters only",
// "No accents or special characters" => "No accents or special characters",
// "Accept all charactrs" => "Accept all charactrs",
// "Lowercase tags only" => "Lowercase tags only",
// "Multilingual freetags" => "Multilingual freetags",
// "Multiligual disabled" => "Multiligual disabled",
// "&quot;More Like This&quot; algorithm" => "&quot;More Like This&quot; algorithm",
// "weighted" => "weighted",
// "Minimum amount of tags in common" => "Minimum amount of tags in common",
// "Tag Management" => "Tag Management",
// "Morcego 3D browser disabled" => "Morcego 3D browser disabled",
// "Enable freetags 3D browser" => "Enable freetags 3D browser",
// "Graph appearance" => "Graph appearance",
// "Node size" => "Node size",
// "Spring (connection) size" => "Spring (connection) size",
// "Node color" => "Node color",
// "Camera settinsg" => "Camera settinsg",
// "Camera distance adjusted relative to nearest node" => "Camera distance adjusted relative to nearest node",
// "Physics engine" => "Physics engine",
// "Friction constant" => "Friction constant",
// "Elastic constant" => "Elastic constant",
// "Eletrostatic constant" => "Eletrostatic constant",
// "Node mass" => "Node mass",
// "Node charge" => "Node charge",
// "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below" => "Note: if you change this directory, you have to move the contents to the new directory. You can also use the 'Mover' below",
// "Force and limit categorization to within subtree of" => "Force and limit categorization to within subtree of",
// "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)" => "Use default max rows, images per row, thumbnails size and scale size for all galleries (set values below)",
// "Pixels Default" => "Pixels Default",
// "Default scale size" => "Default scale size",
// "Mover" => "Mover",
// "Admin Password" => "Admin Password",
// "Release Check" => "Release Check",
// "Reset or upgrade your database" => "Reset or upgrade your database",
// "Check for updates automatically" => "Check for updates automatically",
// "TikiWiki will check for updates when you access the main Administration page" => "TikiWiki will check for updates when you access the main Administration page",
// "Check for updates now" => "Check for updates now",
// "Sender email" => "Sender email",
// "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences" => "Go to <a href=\"tiki-admin.php?page=look\" title=\"\"><strong>Look &amp; Feel</strong></a> section for additional site related customization preferences",
// "Use TikiWiki feature as homepage" => "Use TikiWiki feature as homepage",
// "Use different URL as home page" => "Use different URL as home page",
// "Miscellaneous" => "Miscellaneous",
// "Server OS" => "Server OS",
// "Smarty Security" => "Smarty Security",
// "Do not allow php code in smarty templates" => "Do not allow php code in smarty templates",
// "Use PEAR::Date library" => "Use PEAR::Date library",
// "Default charset for sending mail" => "Default charset for sending mail",
// "Mail end of line" => "Mail end of line",
// "Logging and Reporting" => "Logging and Reporting",
// "Report all PHP errors except strict" => "Report all PHP errors except strict",
// "Visible to Admin only" => "Visible to Admin only",
// "Include Smarty notices" => "Include Smarty notices",
// "Log mail in Tiki logs" => "Log mail in Tiki logs",
// "Log SQL" => "Log SQL",
// "Log queries using more than" => "Log queries using more than",
// "This may impact performance" => "This may impact performance",
// "Add HTML comment at start and end of each Smarty template (TPL)" => "Add HTML comment at start and end of each Smarty template (TPL)",
// "CSRF Security" => "CSRF Security",
// "Use these options to protect against cross-site request forgeries (CSRF)" => "Use these options to protect against cross-site request forgeries (CSRF)",
// "Require confirmation if possible CSRF detected" => "Require confirmation if possible CSRF detected",
// "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings" => "See <a href=\"tiki-admin_security.php\" title=\"Security\"><strong>Admin &gt; Security Admin</strong></a> for additional security settings",
// "Site Access" => "Site Access",
// "Close site (except for those with permission)" => "Close site (except for those with permission)",
// "Message to display" => "Message to display",
// "Close site when server load is above the threshold  (except for those with permission)" => "Close site when server load is above the threshold  (except for those with permission)",
// "Maximum average server load threshold in the last minute" => "Maximum average server load threshold in the last minute",
// "Host" => "Host",
// "On permission denied, display login module (for Anonymous)" => "On permission denied, display login module (for Anonymous)",
// "Send to URL" => "Send to URL",
// "Performance" => "Performance",
// "Cache external pages" => "Cache external pages",
// "Cache external images" => "Cache external images",
// "GZip output" => "GZip output",
// "Output compression is active" => "Output compression is active",
// "Compression is handled by" => "Compression is handled by",
// "Session" => "Session",
// "Advanced configuration warning" => "Advanced configuration warning",
// "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects" => "Note that storing session data in the database is an advanced systems administration option, and is for admins who have comprehensive access and understanding of the database, in order to deal with any unexpected effects",
// "Enabling this feature will immediately log you out when you save this preference" => "Enabling this feature will immediately log you out when you save this preference",
// "Session lifetime" => "Session lifetime",
// "The \"Contact Us\" feature is disabled" => "The \"Contact Us\" feature is disabled",
// "Allow anonymous visitors to use the \"Contact Us\"" => "Allow anonymous visitors to use the \"Contact Us\"",
// "The default help system may not be complete" => "The default help system may not be complete",
// "You can help with the TikiWiki documentation" => "You can help with the TikiWiki documentation",
// "Show user's real name instead of login (when possible)" => "Show user's real name instead of login (when possible)",
// "Highlight group" => "Highlight group",
// "Show user's contribution on the user information page" => "Show user's contribution on the user information page",
// "Display UserTracker information on the user information page" => "Display UserTracker information on the user information page",
// "Use the format: trackerId, fieldId1, fieldId2, .." => "Use the format: trackerId, fieldId1, fieldId2, ..",
// "Separators" => "Separators",
// "Locations (breadcrumbs)" => "Locations (breadcrumbs)",
// "Choices" => "Choices",
// "Default timezone" => "Default timezone",
// "Use site default to show times" => "Use site default to show times",
// "Detect user timezone (if browser allows). Otherwise use site default" => "Detect user timezone (if browser allows). Otherwise use site default",
// "Sample" => "Sample",
// "Change the <strong>Admin</strong> password" => "Change the <strong>Admin</strong> password",
// "Google Map setup" => "Google Map setup",
// "Default x for map center" => "Default x for map center",
// "Default y from map center" => "Default y from map center",
// "Babelfish links" => "Babelfish links",
// "Customized String Translation" => "Customized String Translation",
// "Default language" => "Default language",
// "User preferences are disabled" => "User preferences are disabled",
// "Users can change site language" => "Users can change site language",
// "Available languages" => "Available languages",
// "Use Ctrl+Click to select multiple languages" => "Use Ctrl+Click to select multiple languages",
// "Display available translations" => "Display available translations",
// "Changing page language will also change the site language" => "Changing page language will also change the site language",
// "Translation assistant" => "Translation assistant",
// "Urgent translation notifications" => "Urgent translation notifications",
// "Quantify change size" => "Quantify change size",
// "Multilingual structures" => "Multilingual structures",
// "Structures are disabled" => "Structures are disabled",
// "Multilingual One Page feature" => "Multilingual One Page feature",
// "Syntax error" => "Syntax error",
// "Intertiki exchange feature" => "Intertiki exchange feature",
// "Intertiki client" => "Intertiki client",
// "Tiki Unique key" => "Tiki Unique key",
// "InterTiki Slave mode" => "InterTiki Slave mode",
// "as master" => "as master",
// "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)" => "Limit group import (comma-separated list of imported groups, leave empty to avoid limitation)",
// "Intertiki shared cookie for sliding auth under same domain" => "Intertiki shared cookie for sliding auth under same domain",
// "InterTiki Server" => "InterTiki Server",
// "Intertiki server" => "Intertiki server",
// "Intertiki Server enabled" => "Intertiki Server enabled",
// "Access Log file" => "Access Log file",
// "Errors Log file" => "Errors Log file",
// "Known hosts" => "Known hosts",
// "Look and Feel" => "Look and Feel",
// "Semantic" => "Semantic",
// "Webservices management" => "Webservices management",
// "PAM" => "PAM",
// "CAS" => "CAS",
// "Tiki" => "Tiki",
// "Tiki and OpenID" => "Tiki and OpenID",
// "Validate by email" => "Validate by email",
// "&quot;Standard&quot; uses the client's IP and is more secure. &quot;Simple&quot; uses a unique ID and is more reliable" => "&quot;Standard&quot; uses the client's IP and is more secure. &quot;Simple&quot; uses a unique ID and is more reliable",
// "Cookie name" => "Cookie name",
// "LDAP" => "LDAP",
// "Will override the Host and Port settings" => "Will override the Host and Port settings",
// "Search scope" => "Search scope",
// "Subtree" => "Subtree",
// "One level" => "One level",
// "Base object" => "Base object",
// "LDAP version" => "LDAP version",
// "Realname attribute" => "Realname attribute",
// "Country attribute" => "Country attribute",
// "E-mail attribute" => "E-mail attribute",
// "Base DN" => "Base DN",
// "LDAP User" => "LDAP User",
// "User DN" => "User DN",
// "User attribute" => "User attribute",
// "User OC" => "User OC",
// "LDAP Group" => "LDAP Group",
// "Group DN" => "Group DN",
// "Group attribute" => "Group attribute",
// "Group OC" => "Group OC",
// "LDAP Member" => "LDAP Member",
// "Member attribute" => "Member attribute",
// "Member is DN" => "Member is DN",
// "LDAP Admin" => "LDAP Admin",
// "Admin user" => "Admin user",
// "Admin password" => "Admin password",
// "You must change the Authentication Method to PAM for these changes to take effect" => "You must change the Authentication Method to PAM for these changes to take effect",
// "Shibboleth Authentication " => "Shibboleth Authentication ",
// "You must change the Authentication Method to Shibboleth for these changes to take effect" => "You must change the Authentication Method to Shibboleth for these changes to take effect",
// "Valid affiliations" => "Valid affiliations",
// "Separate multiple affiliations with commas" => "Separate multiple affiliations with commas",
// "Create with default group" => "Create with default group",
// "Default group" => "Default group",
// "You must change the Authentication Method to CAS for these changes to take effect" => "You must change the Authentication Method to CAS for these changes to take effect",
// "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/" => "You also need to upload the <a target=\"_blank\" href=\"http://esup-phpcas.sourceforge.net/\">phpCAS library</a> separately to lib/phpcas/",
// "CAS Server" => "CAS Server",
// "Hostname" => "Hostname",
// "You must enable PHP CAS first" => "You must enable PHP CAS first",
// "UI Effects" => "UI Effects",
// "The \"users can change theme\" feature will override the theme displayed" => "The \"users can change theme\" feature will override the theme displayed",
// "Theme not saved yet - click \"Apply\"" => "Theme not saved yet - click \"Apply\"",
// "Theme options" => "Theme options",
// "Each group can have its theme" => "Each group can have its theme",
// "Use transition style sheet from version" => "Use transition style sheet from version",
// "View Templates" => "View Templates",
// "Enable additional general layout layers for shadows, rounded corners or other decorative styling" => "Enable additional general layout layers for shadows, rounded corners or other decorative styling",
// "Activate will only show content for admin. Check Publish to use content for all users" => "Activate will only show content for admin. Check Publish to use content for all users",
// "Top Bar" => "Top Bar",
// "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  " => "Note: Needs feature PHPLayers on(default), or feature CSS Menu on  ",
// "Menu ID" => "Menu ID",
// "Prefix breadcrumbs with 'Location : '" => "Prefix breadcrumbs with 'Location : '",
// "Site Report Bar" => "Site Report Bar",
// "Webmaster Report" => "Webmaster Report",
// "Webmaster Email" => "Webmaster Email",
// "Custom End of <body> Code" => "Custom End of <body> Code",
// "Bottom bar (RSS)" => "Bottom bar (RSS)",
// "Power by" => "Power by",
// "Display fast move links (by 10 percent of the total number of pages) " => "Display fast move links (by 10 percent of the total number of pages) ",
// "Hide pagination when there is only one page" => "Hide pagination when there is only one page",
// "JQuery plugins and add-ons" => "JQuery plugins and add-ons",
// "Requires jquery feature" => "Requires jquery feature",
// "JQuery Tooltips" => "JQuery Tooltips",
// "JQuery Tooltips: Customisable help tips" => "JQuery Tooltips: Customisable help tips",
// "JQuery Autocomplete" => "JQuery Autocomplete",
// "JQuery Superfish" => "JQuery Superfish",
// "JQuery Superfish (effects on CSS menus)" => "JQuery Superfish (effects on CSS menus)",
// "JQuery Reflection" => "JQuery Reflection",
// "JQuery Reflection (reflection effect on images)" => "JQuery Reflection (reflection effect on images)",
// "JQuery Cycle (slideshow)" => "JQuery Cycle (slideshow)",
// "For future use" => "For future use",
// "JQuery UI" => "JQuery UI",
// "JQuery UI: More JQuery functionality" => "JQuery UI: More JQuery functionality",
// "JQuery Sheet" => "JQuery Sheet",
// "JQuery Spreadsheet" => "JQuery Spreadsheet",
// "JQuery Sortable Tables" => "JQuery Sortable Tables",
// "Standard UI effects" => "Standard UI effects",
// "Effect for modules etc" => "Effect for modules etc",
// "Main JQuery effect" => "Main JQuery effect",
// "Slide" => "Slide",
// "Blind (UI)" => "Blind (UI)",
// "Clip (UI)" => "Clip (UI)",
// "Drop (UI)" => "Drop (UI)",
// "Explode (UI)" => "Explode (UI)",
// "Fold (UI)" => "Fold (UI)",
// "Puff (UI)" => "Puff (UI)",
// "Slide (UI)" => "Slide (UI)",
// "Effect speed" => "Effect speed",
// "Fast" => "Fast",
// "Slow" => "Slow",
// "Effect direction" => "Effect direction",
// "Vertical" => "Vertical",
// "Horizontal" => "Horizontal",
// "Tab UI effects" => "Tab UI effects",
// "Effect for tabs" => "Effect for tabs",
// "JQuery effect for tabs" => "JQuery effect for tabs",
// "Effect speed for tabs" => "Effect speed for tabs",
// "Effect direction for tabs" => "Effect direction for tabs",
// "Correct PNG images alpha transparency in IE6 (experimental)" => "Correct PNG images alpha transparency in IE6 (experimental)",
// "List of CSS selectors to be fixed, each selector separated by comma" => "List of CSS selectors to be fixed, each selector separated by comma",
// "List of HTMLDomElements to be fixed, each element separated by comma" => "List of HTMLDomElements to be fixed, each element separated by comma",
// "Context Menus (only in file galleries so far)" => "Context Menus (only in file galleries so far)",
// "Use context menus for actions (icons)" => "Use context menus for actions (icons)",
// "Use context menus for actions (text)" => "Use context menus for actions (text)",
// "Users can opt-out internal messages" => "Users can opt-out internal messages",
// "Users accept internal messages by default" => "Users accept internal messages by default",
// "Change Preferences" => "Change Preferences",
// "Meta tags" => "Meta tags",
// "Keywords" => "Keywords",
// "Include freetags" => "Include freetags",
// "Use thread title instead" => "Use thread title instead",
// "Use image title instead" => "Use image title instead",
// "Geo URL" => "Geo URL",
// "Meta robots" => "Meta robots",
// "Revisit after" => "Revisit after",
// "&quot;Modules&quot; are the boxes of content in the right &amp; left columns" => "&quot;Modules&quot; are the boxes of content in the right &amp; left columns",
// "Admin &gt; Modules" => "Admin &gt; Modules",
// "from the menu to create and edit modules" => "from the menu to create and edit modules",
// "Show module controls" => "Show module controls",
// "Users can configure modules" => "Users can configure modules",
// "Users can shade modules" => "Users can shade modules",
// "Module decides" => "Module decides",
// "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item" => "It works with the File Gallery, wiki pages (via a plugin), and a new multimedia tracker item",
// "ProgressBarPlay Color" => "ProgressBarPlay Color",
// "ProgressBarLoad Color" => "ProgressBarLoad Color",
// "ProgressBarButton Color" => "ProgressBarButton Color",
// "ProgressBar Color" => "ProgressBar Color",
// "Volume On Color" => "Volume On Color",
// "Volume Off Color" => "Volume Off Color",
// "Volume Button Color" => "Volume Button Color",
// "Button Color" => "Button Color",
// "Button Pressed Color" => "Button Pressed Color",
// "Button Over Color" => "Button Over Color",
// "Button Info Color" => "Button Info Color",
// "Button Info Pressed Color" => "Button Info Pressed Color",
// "Button Info Over Color" => "Button Info Over Color",
// "Button Info Text Color" => "Button Info Text Color",
// "ID3 Tag Color" => "ID3 Tag Color",
// "Play Time Color" => "Play Time Color",
// "Total Time Color" => "Total Time Color",
// "Panel Display Color" => "Panel Display Color",
// "Alert Message Color" => "Alert Message Color",
// "Preload Delay" => "Preload Delay",
// "Max Play time" => "Max Play time",
// "URL Append" => "URL Append",
// "Message after limited time" => "Message after limited time",
// "ID of System File Galleries to upload multimedia files" => "ID of System File Galleries to upload multimedia files",
// "Anonymous voting" => "Anonymous voting",
// "Allow re-voting" => "Allow re-voting",
// "Categories disabled" => "Categories disabled",
// "TikiWiki Profiles" => "TikiWiki Profiles",
// "Profile repository" => "Profile repository",
// "Filter the list of profiles" => "Filter the list of profiles",
// "Repositories" => "Repositories",
// "Repository URLs" => "Repository URLs",
// "Enter multiple repository URLs, one per line" => "Enter multiple repository URLs, one per line",
// "Data Channels" => "Data Channels",
// "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. " => "Data channels create a named pipe to run profiles from user space. One channel per line. Each line is comma delimited and contain <strong>channel name, domain, profile, allowed groups</strong>. ",
// "More information" => "More information",
// "Show Author" => "Show Author",
// "Homepage URL" => "Homepage URL",
// "Feed for directory" => "Feed for directory",
// "Map files" => "Map files",
// "Feed for maps" => "Feed for maps",
// "Image Path" => "Image Path",
// "Caching time" => "Caching time",
// "Use <strong>0</strong> for no caching" => "Use <strong>0</strong> for no caching",
// "can be seen on page" => "can be seen on page",
// "in Admin menu" => "in Admin menu",
// "Search Results" => "Search Results",
// "Search type" => "Search type",
// "Database search" => "Database search",
// "This search uses the MySQL Full-Text feature" => "This search uses the MySQL Full-Text feature",
// "Tiki search" => "Tiki search",
// "This database-independent search is always enabled" => "This database-independent search is always enabled",
// "Specify the Tiki search settings" => "Specify the Tiki search settings",
// "Refresh mode" => "Refresh mode",
// "Use <strong>0</strong> for no refresh" => "Use <strong>0</strong> for no refresh",
// "When the Database search is enabled, you must manually refresh the Tiki search indexes" => "When the Database search is enabled, you must manually refresh the Tiki search indexes",
// "Refresh all search index now" => "Refresh all search index now",
// "Refresh trackers search index now" => "Refresh trackers search index now",
// "Refresh tracker search index now" => "Refresh tracker search index now",
// "Refresh files search index now" => "Refresh files search index now",
// "Parse the results" => "Parse the results",
// "May impact performance" => "May impact performance",
// "Enabling these options will improve performance, but may show forbidden results" => "Enabling these options will improve performance, but may show forbidden results",
// "Select the items to display on the search results page" => "Select the items to display on the search results page",
// "Object filter" => "Object filter",
// "Search box" => "Search box",
// "Select the information to display for each result" => "Select the information to display for each result",
// "Pertinence" => "Pertinence",
// "Last modified date" => "Last modified date",
// "Search engine friendly url Postfilter" => "Search engine friendly url Postfilter",
// "List of Url Parameters that should go in the path" => "List of Url Parameters that should go in the path",
// "Display article title in the sefurl" => "Display article title in the sefurl",
// "Display blog title in the sefurl" => "Display blog title in the sefurl",
// "Known Types" => "Known Types",
// "Token" => "Token",
// "Invert" => "Invert",
// "Show Usage" => "Show Usage",
// "Delete &amp; Unreference" => "Delete &amp; Unreference",
// "Invert Relation" => "Invert Relation",
// "Self" => "Self",
// "New Types" => "New Types",
// "Fix" => "Fix",
// "No occurences found" => "No occurences found",
// "Text area (that apply throughout many features)" => "Text area (that apply throughout many features)",
// "Plugin Aliases" => "Plugin Aliases",
// "Anonymous editors must enter anti-bot code (CAPTCHA)" => "Anonymous editors must enter anti-bot code (CAPTCHA)",
// "Protect email against spam" => "Protect email against spam",
// "External link icon" => "External link icon",
// "External links will be identified with" => "External links will be identified with",
// "Use File Galleries to store pictures " => "Use File Galleries to store pictures ",
// "Wiki paragraph formatting" => "Wiki paragraph formatting",
// "...but still create line breaks within paragraphs" => "...but still create line breaks within paragraphs",
// "&lt;return&gt; for rows" => "&lt;return&gt; for rows",
// "Show quicktags above textareas" => "Show quicktags above textareas",
// "If disabled, quicktags will be shown to the left of textareas" => "If disabled, quicktags will be shown to the left of textareas",
// "Open Hotwords in new window" => "Open Hotwords in new window",
// "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting" => "Use Quote plugin rather than &ldquo;&gt;&rdquo; for quoting",
// "Plugin disabled" => "Plugin disabled",
// "Default size" => "Default size",
// "Comments " => "Comments ",
// "Forum reply" => "Forum reply",
// "About plugins" => "About plugins",
// "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below" => "Tiki plugins add functionality to wiki pages, articles and blogs etc. You can enable and disable them below",
// "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>" => "You can approve plugin use at <a href=\"tiki-plugins.php\">tiki-plugins.php</a>",
// "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below" => "The edit plugin icon is an easy way for users to edit the parameters of each plugin in wiki pages. It can be disabled for individual plugins below",
// "Edit plugin icons" => "Edit plugin icons",
// "Enable edit plugin icons" => "Enable edit plugin icons",
// "(experimental - not comprehensively tested and requires new JQuery feature)" => "(experimental - not comprehensively tested and requires new JQuery feature)",
// "Enable" => "Enable",
// "Disable edit plugin icon (make plugin inline)" => "Disable edit plugin icon (make plugin inline)",
// "About plugin aliases" => "About plugin aliases",
// "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}" => "Tiki plugin aliases allow you to define your own custom configurations of existing plugins.<br />Find out more here: {help url=\"Plugin+Alias\"}",
// "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}" => "This page is designed to work with JQuery {icon _id=\"arrow_right\" href=\"tiki-admin.php?page=features\"}",
// "Available Alias" => "Available Alias",
// "Enable Plugins" => "Enable Plugins",
// "General Information" => "General Information",
// "Plugin Name" => "Plugin Name",
// "Base Plugin" => "Base Plugin",
// "Body Label" => "Body Label",
// "Dependencies" => "Dependencies",
// "Validation" => "Validation",
// "Inline (No Plugin Edit UI)" => "Inline (No Plugin Edit UI)",
// "Simple Plugin Arguments" => "Simple Plugin Arguments",
// "Argument" => "Argument",
// "New Argument" => "New Argument",
// "Plugin Parameter Documentation" => "Plugin Parameter Documentation",
// "Safe" => "Safe",
// "Plugin Body" => "Plugin Body",
// "Ignore User Input" => "Ignore User Input",
// "Default Content" => "Default Content",
// "Encoding" => "Encoding",
// "Argument Source (if different)" => "Argument Source (if different)",
// "Default Value" => "Default Value",
// "Composed Plugin Arguments" => "Composed Plugin Arguments",
// "Pattern" => "Pattern",
// "Tracker attachment preferences" => "Tracker attachment preferences",
// "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely" => "WARNING : Old and New trackers cannot coexist. Trackers created with new library will not work with old library and conversely",
// "Tracker attachments" => "Tracker attachments",
// "Include a flag by each e-mail to quickly flag/un-flag them" => "Include a flag by each e-mail to quickly flag/un-flag them",
// "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used" => "Enter the URL of a web services returning either JSON or YAML. Parameters can be specified by enclosing a name between percentage signs. For example: %name%. %service% and %template% are reserved keywords and cannot be used",
// "Lookup" => "Lookup",
// "Test Input" => "Test Input",
// "Response Information" => "Response Information",
// "OIntegrate Version" => "OIntegrate Version",
// "Not supported" => "Not supported",
// "Schema Version" => "Schema Version",
// "Schema Documentation" => "Schema Documentation",
// "Available" => "Available",
// "Not specified, default used" => "Not specified, default used",
// "Content Type" => "Content Type",
// "Not specified" => "Not specified",
// "Returned Data" => "Returned Data",
// "Proposed Templates" => "Proposed Templates",
// "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters" => "Register this web service. It will be possible to register the templates afterwards. Service name must only contain letters",
// "Register Service" => "Register Service",
// "Registered Templates" => "Registered Templates",
// "Engine" => "Engine",
// "Output" => "Output",
// "Register Template" => "Register Template",
// "Use the 'Quick Edit' module to easily create or edit wiki pages" => "Use the 'Quick Edit' module to easily create or edit wiki pages",
// "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules" => "Select <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">Admin &gt; Modules</a> to add this (or other) modules",
// "Staging &amp; Approval" => "Staging &amp; Approval",
// "Page Listings" => "Page Listings",
// "If the page does not exist, Tiki will create it" => "If the page does not exist, Tiki will create it",
// "Wiki link format" => "Wiki link format",
// "Latin" => "Latin",
// "Select the characters that can be used with Wiki link syntax: ((page name))" => "Select the characters that can be used with Wiki link syntax: ((page name))",
// "Page display" => "Page display",
// "Page ID" => "Page ID",
// "Page version" => "Page version",
// "Page name display stripper" => "Page name display stripper",
// "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>" => "Enter a character to use as the delimiter when displaying page names. All characters after the delimiter will be stripped when displaying the page name.</em>",
// "Allow override per page" => "Allow override per page",
// "Display show/hide icon displayed before headings" => "Display show/hide icon displayed before headings",
// "Wiki action bar" => "Wiki action bar",
// "Buttons: Save, Preview, Cancel, .." => "Buttons: Save, Preview, Cancel, ..",
// "Page navigation bar location" => "Page navigation bar location",
// "When using the ...page... page break wiki syntax" => "When using the ...page... page break wiki syntax",
// "Wiki top line" => "Wiki top line",
// "Neither" => "Neither",
// "Page description, icons, backlinks, .." => "Page description, icons, backlinks, ..",
// "Wiki buttons" => "Wiki buttons",
// "Buttons: Edit, Source, Remove, .." => "Buttons: Edit, Source, Remove, ..",
// "Save draft" => "Save draft",
// "Requires AJAX" => "Requires AJAX",
// "experimental" => "experimental",
// "Edit section" => "Edit section",
// "Edit section level" => "Edit section level",
// "Allow minor edits" => "Allow minor edits",
// "Minor edits do not flag new content for translation and do not send watch notifications" => "Minor edits do not flag new content for translation and do not send watch notifications",
// "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled" => "Only user groups granted the tiki_p_minor permission (and admins) will be able to save minor edits when this is enabled",
// "Regex search and replace" => "Regex search and replace",
// "Log bytes changes (+/-) in action logs" => "Log bytes changes (+/-) in action logs",
// "Display by default" => "Display by default",
// "Tag for current wiki" => "Tag for current wiki",
// "Restore wiki to tag" => "Restore wiki to tag",
// "Restore" => "Restore",
// "WikiWords" => "WikiWords",
// "Maximum number of versions" => "Maximum number of versions",
// "Never delete versions younger than" => "Never delete versions younger than",
// "Display IP address" => "Display IP address",
// "Default diff style" => "Default diff style",
// "HTML diff" => "HTML diff",
// "Side-by-side diff by characters" => "Side-by-side diff by characters",
// "Inline diff" => "Inline diff",
// "Inline diff by characters" => "Inline diff by characters",
// "Full side-by-side diff by characters" => "Full side-by-side diff by characters",
// "Full inline diff" => "Full inline diff",
// "Full inline diff by characters" => "Full inline diff by characters",
// "History includes only page data, description, and change comment" => "History includes only page data, description, and change comment",
// "Forum for discussion" => "Forum for discussion",
// "Polls are disabled" => "Polls are disabled",
// "like pages" => "like pages",
// "Make structure from page" => "Make structure from page",
// "Categorize structure pages together" => "Categorize structure pages together",
// "Create webhelp from structure" => "Create webhelp from structure",
// "Import pages" => "Import pages",
// "Slideshows" => "Slideshows",
// "User's page" => "User's page",
// "Users can lock pages" => "Users can lock pages",
// "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page" => "When viewing a page, if it doesn't exist automatically redirect to a similarly  named page",
// "(mandatory for feature to work)" => "(mandatory for feature to work)",
// "Replace freetags with that of staging pages, on approval" => "Replace freetags with that of staging pages, on approval",
// "Add new freetags of approved copy (into tags field) when editing staging pages" => "Add new freetags of approved copy (into tags field) when editing staging pages",
// "Orphan page" => "Orphan page",
// "Select which items to display when listing pages" => "Select which items to display when listing pages",
// "Name length" => "Name length",
// "Edit comments" => "Edit comments",
// "Edit Comments length" => "Edit Comments length",
// "Categories path" => "Categories path",
// "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>" => "Wysiwyg means What You See Is What You Get, and is handled in Tikiwiki by <a href=\"http://fckeditor.net\">FCKeditor</a>",
// "Wysiwyg Editor Features" => "Wysiwyg Editor Features",
// "Wysiwyg Editor is optional" => "Wysiwyg Editor is optional",
// "... and is displayed by default" => "... and is displayed by default",
// "Reopen with the same editor" => "Reopen with the same editor",
// "Content is parsed like wiki page" => "Content is parsed like wiki page",
// "Content is partially parsed" => "Content is partially parsed",
// "Toolbar skin" => "Toolbar skin",
// "Toolbar content" => "Toolbar content",
// "information" => "information",
// "preference" => "preference",
// "preference name" => "preference name",
// "TikiCache/System" => "TikiCache/System",
// "SysLogs" => "SysLogs",
// "Mods" => "Mods",
// "Stats &amp; banners" => "Stats &amp; banners",
// "kb" => "kb",
// "Graph Contributions" => "Graph Contributions",
// "Group Bar Plot" => "Group Bar Plot",
// "Accumulated Bar Plot" => "Accumulated Bar Plot",
// "Legend background color" => "Legend background color",
// "Save graphs to image gallery" => "Save graphs to image gallery",
// "contribution" => "contribution",
// "contributor" => "contributor",
// "Volumes are equally distributed on each contributors/author" => "Volumes are equally distributed on each contributors/author",
// "connection time" => "connection time",
// "connection seconds" => "connection seconds",
// "mns" => "mns",
// "Volumn per category" => "Volumn per category",
// "Volumn per category and per user" => "Volumn per category and per user",
// "Number of actions per user" => "Number of actions per user",
// "Number of actions per object" => "Number of actions per object",
// "Number of actions per category" => "Number of actions per category",
// "Number of actions per category and per user" => "Number of actions per category and per user",
// "Volumn per the users'group and per contribution" => "Volumn per the users'group and per contribution",
// "Volumn per group and per contribution" => "Volumn per group and per contribution",
// "Volumn per user and per contribution" => "Volumn per user and per contribution",
// "Volumn per users'contribution and time" => "Volumn per users'contribution and time",
// "Volumn per contribution and time" => "Volumn per contribution and time",
// "Wiki page actions except viewed will always be recorded but can be not reported" => "Wiki page actions except viewed will always be recorded but can be not reported",
// "Configure" => "Configure",
// "Create Calendar" => "Create Calendar",
// "View Calendars" => "View Calendars",
// "Perso" => "Perso",
// "View Calendar" => "View Calendar",
// "Create/Edit Calendars" => "Create/Edit Calendars",
// "Custom URL" => "Custom URL",
// "Standard Colors" => "Standard Colors",
// "Green" => "Green",
// "Blue" => "Blue",
// "Purple" => "Purple",
// "Orange" => "Orange",
// "Yellow" => "Yellow",
// "Let me select my own colors" => "Let me select my own colors",
// "Custom foreground color" => "Custom foreground color",
// "Ex" => "Ex",
// "Custom background color" => "Custom background color",
// "Default event status" => "Default event status",
// "Show in calendar view" => "Show in calendar view",
// "Group of users alerted when calendar event is modified" => "Group of users alerted when calendar event is modified",
// "Delete events older than" => "Delete events older than",
// "Browse the category system" => "Browse the category system",
// "Current Category ID" => "Current Category ID",
// "Admin charts" => "Admin charts",
// "Use in" => "Use in",
// "Visible in no sections" => "Visible in no sections",
// "Remove section" => "Remove section",
// "Edit the contribution" => "Edit the contribution",
// "Contributions are mandatory in wiki pages" => "Contributions are mandatory in wiki pages",
// "Contributions are mandatory in forums" => "Contributions are mandatory in forums",
// "Contributions are mandatory in comments" => "Contributions are mandatory in comments",
// "Contributions are mandatory in blogs" => "Contributions are mandatory in blogs",
// "Contributions are displayed in the comment/post" => "Contributions are displayed in the comment/post",
// "Create a new contribution" => "Create a new contribution",
// "List of contributions" => "List of contributions",
// "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}" => "To use cookie in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{cookie}{/literal}",
// "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link" => "To create a drawing in a Wiki page, use {literal}{draw name=foo}{/literal}, where foo is the name of the drawing. After saving, click on the drawing link",
// "Use Admin DSN to define the database to be used by the SQL plugin" => "Use Admin DSN to define the database to be used by the SQL plugin",
// "Admin External Wikis" => "Admin External Wikis",
// "Enable Features" => "Enable Features",
// "Append a reply link to outbound mails" => "Append a reply link to outbound mails",
// "Set thread preferences" => "Set thread preferences",
// "Show threads preferences" => "Show threads preferences",
// "hide threads preferences" => "hide threads preferences",
// "Default style for threads" => "Default style for threads",
// "Duplicate Forum" => "Duplicate Forum",
// "Duplicate" => "Duplicate",
// "Admin HTML Page Dynamic Zones" => "Admin HTML Page Dynamic Zones",
// "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones" => "Use {literal}{ed id=name}{/literal} or {literal}{ted id=name}{/literal} to insert dynamic zones",
// "Refresh rate (if dynamic)" => "Refresh rate (if dynamic)",
// "Admin dynamic zones" => "Admin dynamic zones",
// "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature" => "An easier way to integrate content from another site into Tiki is via iframed links using Tiki's <a class=\"rbox-link\" href=\"tiki-admin_links.php\">featured links</a> feature",
// "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>" => "To use these links, you must assign the featured_links <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a>",
// "article-put" => "article-put",
// "Discard to the end from" => "Discard to the end from",
// "mn" => "mn",
// "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple sections with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR" => "Separate multiple permissions with a comma ( , ) for an AND or a vertical bar ( | ) for an OR",
// "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each" => "Selecting 2 groups means that the option will be seen if the user belongs to the 2 groups. If you want the 2 groups to see the option, create 2 options with one group each",
// "switch with previous option" => "switch with previous option",
// "switch with next option" => "switch with next option",
// "To customize the menu's CSS id (#)" => "To customize the menu's CSS id (#)",
// "Folder Icon" => "Folder Icon",
// "Path and filename of closed folder icon" => "Path and filename of closed folder icon",
// "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder" => "To use custom folder icons in menus, enter the path to the icon for the <strong>closed</strong> folder",
// "In the same directory, include an icon for the opened folder" => "In the same directory, include an icon for the opened folder",
// "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>" => "The \"opened folder\" icon name must be identical to the \"closed folder\" icon name, prefixed with the letter <strong>o</strong>",
// "For example, the default icon is: pics/icons/folder.png" => "For example, the default icon is: pics/icons/folder.png",
// "The name of the \"open folder\" icon is: pics/icons/ofolder.png" => "The name of the \"open folder\" icon is: pics/icons/ofolder.png",
// "Assign/Edit modules" => "Assign/Edit modules",
// "Move Up" => "Move Up",
// "Move Down" => "Move Down",
// "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y" => "Params: specific params to the module and/or general params ('lang', 'flip', 'title', 'decorations', 'section', 'overflow', 'page', 'nobox', 'bgcolor', 'color', 'theme', 'notitle', 'nopage'). Separator between params:'&amp;'. E.g. maxlen=15&amp;nonums=y",
// "The" => "The",
// "setting will override your selection of specific groups" => "setting will override your selection of specific groups",
// "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either" => "Because <a class=\"rbox-link\" href=\"tiki-admin.php?page=module\">Users can Configure Modules</a>, select either",
// "to make sure users will notice any newly assigned modules" => "to make sure users will notice any newly assigned modules",
// "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site" => "Create your new custom module below. Make sure to preview first and make sure all is OK before <a href=\"#assign\">assigning it</a>. Using html, you will be fine. However, if you improperly use wiki syntax or Smarty code, you could lock yourself out of the site",
// "Use Wiki Structure" => "Use Wiki Structure",
// "Export Subscriber Emails" => "Export Subscriber Emails",
// "Included group, group users and emails will be refreshed at each newsletter sending" => "Included group, group users and emails will be refreshed at each newsletter sending",
// "Add subscribers of another newsletter" => "Add subscribers of another newsletter",
// "Allow customized text message to be sent with the html version" => "Allow customized text message to be sent with the html version",
// "Mail notifications" => "Mail notifications",
// "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications" => "You need to set <a href=\"tiki-admin.php?page=general\">Sender Email</a> before creating email notifications",
// "Alert" => "Alert",
// "A user edits an article" => "A user edits an article",
// "A user deletes an article" => "A user deletes an article",
// "A comment in a wiki page is posted or edited" => "A comment in a wiki page is posted or edited",
// "Preload Admin Account" => "Preload Admin Account",
// "User / Group" => "User / Group",
// "Multiple" => "Multiple",
// "Trackers Outbound Emails" => "Trackers Outbound Emails",
// "Forums Outbound Emails" => "Forums Outbound Emails",
// "Add poll option" => "Add poll option",
// "Edit poll option" => "Edit poll option",
// "Create poll" => "Create poll",
// "Edit poll" => "Edit poll",
// "Toggle Quick Options" => "Toggle Quick Options",
// "Add Option" => "Add Option",
// "Leave box empty for deleting an option" => "Leave box empty for deleting an option",
// "Votes older than these days are no more considered" => "Votes older than these days are no more considered",
// "Span" => "Span",
// "Add poll to pages" => "Add poll to pages",
// "Quicktags category filter" => "Quicktags category filter",
// "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed" => "To use RSS feeds in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{rss id=x}{/literal}, where x is the ID of the RSS feed",
// "Edit this RSS Module" => "Edit this RSS Module",
// "Create new RSS Module" => "Create new RSS Module",
// "RSS channels" => "RSS channels",
// "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>" => "To <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://security.tikiwiki.org/tiki-contact.php\">report any security issues</a>",
// "TikiWiki settings" => "TikiWiki settings",
// "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors" => "About WikiPlugins and security: Make sure to only grant the \"tiki_p_plugin_approve\" permission to trusted editors",
// "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)" => "You can deactivate risky plugins at (<a href=\"tiki-admin.php?page=textarea\">tiki-admin.php?page=textarea</a>)",
// "Security checks" => "Security checks",
// "See end of table for detailed explanations" => "See end of table for detailed explanations",
// "owner" => "owner",
// "special" => "special",
// "uid" => "uid",
// "gid" => "gid",
// "suid" => "suid",
// "sgid" => "sgid",
// "r" => "r",
// "w" => "w",
// "Set User ID (suid) files" => "Set User ID (suid) files",
// "World writable files or directories" => "World writable files or directories",
// "Files or directories the Webserver can write to" => "Files or directories the Webserver can write to",
// "Strange Inodes (not file, not link, not directory)" => "Strange Inodes (not file, not link, not directory)",
// "Executable files" => "Executable files",
// "What to do with these check results" => "What to do with these check results",
// "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"" => "Suid files are not part of tiki and there is no need for suid files in a webspace. Sometimes intruders that gain elevated privileges leave suid files to \"keep the door open\"",
// "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content" => "In some environments where you cannot get root or have no other possibilities, it is unavoidable to let your webserver write to some tiki directories like \"templates_c\" or \"temp\". In any other case this is not needed. A bug in a script or other users could easily put malicious scripts on your webspace or upload illegal content",
// "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information" => "The risk is almost the same in shared hosting environments without proper privilege separation (suexec wrappers). The webserver has to be able to write to some directories like \"templates_c\" or \"temp\". Review the tiki install guide for further information",
// "Inodes that are not files or directories are not part of tiki. Review these Inodes" => "Inodes that are not files or directories are not part of tiki. Review these Inodes",
// "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod" => "Setting the executable bit can be dangerous if the webserver is configured to execute cgi scripts from that directories. If you use the usual php module (for apache) then php scripts and other files in tiki do not need to have the executable bit. You can safely remove the executable bit with chmod",
// "The structure" => "The structure",
// "has just been created" => "has just been created",
// "You will remove structure" => "You will remove structure",
// "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict" => "Note that the following pages are also part of another structure. Make sure that access permissions (if any) do not conflict",
// "The following pages have automatically been categorized with the same categories as the structure" => "The following pages have automatically been categorized with the same categories as the structure",
// "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent" => "The following pages have categories but the structure has none. You may wish to uncategorize them to be consistent",
// "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent" => "The following pages are in categories that the structure is not in. You may wish to recategorize them in order to be consistent",
// "View structure" => "View structure",
// "Xml Zip" => "Xml Zip",
// "Add a New Question" => "Add a New Question",
// "This survey stats" => "This survey stats",
// "Edit Survey Question" => "Edit Survey Question",
// "Add a New Question to this survey" => "Add a New Question to this survey",
// "Multiple choices of thumbnails from a file gallery" => "Multiple choices of thumbnails from a file gallery",
// "Wiki textarea" => "Wiki textarea",
// "Answer is mandatory" => "Answer is mandatory",
// "Number of required answers (for multiple choices)" => "Number of required answers (for multiple choices)",
// "Min" => "Min",
// "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots" => "For a multiple answer question put the answers into the following field, separated by a comma. Example: one,two,many,lots",
// "For a rate, you can give the maximum value" => "For a rate, you can give the maximum value",
// "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4" => "For the 'multiple choices of thumbnail from a file gallery' type, options are: Gallery ID. Example: 4",
// "Tiki Cache/System Admin" => "Tiki Cache/System Admin",
// "Directory to exterminate" => "Directory to exterminate",
// "Clear all Tiki caches" => "Clear all Tiki caches",
// "All user prefs sessions" => "All user prefs sessions",
// "Directories to save" => "Directories to save",
// "Full Path to the Zip File" => "Full Path to the Zip File",
// "Generate a zip of those directories" => "Generate a zip of those directories",
// "A zip has been written to {\$zipPath}" => "A zip has been written to {\$zipPath}",
// "Directory is not writeable" => "Directory is not writeable",
// "Inactive - Click to Activate" => "Inactive - Click to Activate",
// "Active - Click to Deactivate" => "Active - Click to Deactivate",
// "New tracker field" => "New tracker field",
// "Select list items that will be displayed" => "Select list items that will be displayed",
// "Multilingual content" => "Multilingual content",
// "Field is public? (viewed in trackerlist plugin)" => "Field is public? (viewed in trackerlist plugin)",
// "visible by creator &amp; admin only" => "visible by creator &amp; admin only",
// "The option creator needs a field of type user selector and option 1" => "The option creator needs a field of type user selector and option 1",
// "Visible by" => "Visible by",
// "Editable by" => "Editable by",
// "Description text is wiki-parsed" => "Description text is wiki-parsed",
// "Export fieldId also" => "Export fieldId also",
// "Check the box to re-import in this tracker and change the fields" => "Check the box to re-import in this tracker and change the fields",
// "Uncheck the box to import in another database" => "Uncheck the box to import in another database",
// "Edit This Tracker's Fields" => "Edit This Tracker's Fields",
// "Create Tracker" => "Create Tracker",
// "Duplicate Tracker" => "Duplicate Tracker",
// "Create/Edit Tracker" => "Create/Edit Tracker",
// "Auto create corresponding categories" => "Auto create corresponding categories",
// "Create a group for each item" => "Create a group for each item",
// "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL" => "tracker name must be unique, field names must be unique\nfor a tracker and they must be valid in SQL",
// "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender" => "The tracker will use the text field named Subject if any as subject and will use the user email or for anonymous the email field if any as sender",
// "Only one item per user or IP" => "Only one item per user or IP",
// "The tracker needs a user or IP field with the option 1" => "The tracker needs a user or IP field with the option 1",
// "Format if not the default short one" => "Format if not the default short one",
// "Show creation date when viewing tracker item" => "Show creation date when viewing tracker item",
// "Show lastModif date when viewing tracker item" => "Show lastModif date when viewing tracker item",
// "ItemId" => "ItemId",
// "and display last comment user/date" => "and display last comment user/date",
// "Items can be created only during a certain time" => "Items can be created only during a certain time",
// "Show these fields (ID comma separated) in a popup on item link when listing tracker items" => "Show these fields (ID comma separated) in a popup on item link when listing tracker items",
// "Group of users alerted when tracker is modified" => "Group of users alerted when tracker is modified",
// "timestamp" => "timestamp",
// "Charset encoding" => "Charset encoding",
// "User Choice" => "User Choice",
// "Only directly included" => "Only directly included",
// "will have all the permissions of the included groups" => "will have all the permissions of the included groups",
// "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)" => "For other Tiki features, use relative links (such as <em>http:tiki-forums.php</em>)",
// "Default category assigned to uncategorized objects edited by a user with this default group" => "Default category assigned to uncategorized objects edited by a user with this default group",
// "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)" => "Users Information Tracker Fields Asked at Registration Time<br />(fieldIds separated with :)",
// "User can assign to the group himself" => "User can assign to the group himself",
// "Create Item" => "Create Item",
// "Choose a field .." => "Choose a field ..",
// "Add to group" => "Add to group",
// "Download CSV export" => "Download CSV export",
// "Assign users to group" => "Assign users to group",
// "Each user in the file must already exist" => "Each user in the file must already exist",
// "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>" => "To create users or/and assign them to groups, got to <a href=\"tiki-adminusers.php\">admin->users</a>",
// "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login" => "Since this tiki site is in slave mode and import groups, the master groups will be automatically reimported at each login",
// "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login" => "Since this tiki site is in slave mode and import preferences, the master user preferences will be automatically reimported at each login",
// "Updated users" => "Updated users",
// "More Criteria" => "More Criteria",
// "Group (direct)" => "Group (direct)",
// "ago" => "ago",
// "Assign to group" => "Assign to group",
// "Edit Group" => "Edit Group",
// "Validate user" => "Validate user",
// "Template wiki page" => "Template wiki page",
// "Assign user to Groups" => "Assign user to Groups",
// "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)" => "Warning: changing the username could require the user to change his password (for user registered with an old tikiwiki&lt;=1.8)",
// "Warning: it will mess with slave intertiki sites that use this one as master" => "Warning: it will mess with slave intertiki sites that use this one as master",
// "No password is required" => "No password is required",
// "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth" => "Tikiwiki is configured to delegate the password managment to LDAP through PEAR Auth",
// "Repeat Password" => "Repeat Password",
// "User must change password at first login" => "User must change password at first login",
// "Send an email to the user in order to allow him to validate his account" => "Send an email to the user in order to allow him to validate his account",
// "Last Login" => "Last Login",
// "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>" => "You can export users of a group in <a href=\"tiki-admingroups.php\">admin->groups->a_group</a>",
// "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences" => "More languages are available. To view them, update languages you can read from <a href=\"tiki-user_preferences.php\">user preferences</a> or your browser's preferences",
// "Approve page changes in staging" => "Approve page changes in staging",
// "Page has been approved" => "Page has been approved",
// "Changes from the following versions under staging have been merged into the approved version" => "Changes from the following versions under staging have been merged into the approved version",
// "Show Help" => "Show Help",
// "Article type" => "Article type",
// "Actions on this article type" => "Actions on this article type",
// "inherited from" => "inherited from",
// "inherited" => "inherited",
// "Level configuration" => "Level configuration",
// "Assign User {\$assign_user} to Groups" => "Assign User {\$assign_user} to Groups",
// "Assign User to Group" => "Assign User to Group",
// "Convert the last sub directory to a sub gallery" => "Convert the last sub directory to a sub gallery",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a gallery named \"screenshots\" will be created",
// "Use the last sub directory name as description" => "Use the last sub directory name as description",
// "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created" => "eg. from \"misc/screenshots/digicam0001.jpg\" a description \"screenshots\" will be created",
// "Please do not use this feature to upload data into the database" => "Please do not use this feature to upload data into the database",
// "Process files" => "Process files",
// "Use Wysiwyg Editor" => "Use Wysiwyg Editor",
// "Use Normal Editor" => "Use Normal Editor",
// "Report to Webmaster" => "Report to Webmaster",
// "The TikiWiki Community" => "The TikiWiki Community",
// "database queries used in " => "database queries used in ",
// "Watch Only This Category" => "Watch Only This Category",
// "Watch This Category and Their Descendants" => "Watch This Category and Their Descendants",
// "Stop Watching Only This Category" => "Stop Watching Only This Category",
// "Stop Watching This Category and Their Descendants" => "Stop Watching This Category and Their Descendants",
// "in the current category - and its subcategories: " => "in the current category - and its subcategories: ",
// "With all selected tags" => "With all selected tags",
// "With one selected tag" => "With one selected tag",
// "With last selected tag" => "With last selected tag",
// "Alphabetically" => "Alphabetically",
// "By Size" => "By Size",
// "Cloud" => "Cloud",
// "\$feature_label" => "\$feature_label",
// "Hit" => "Hit",
// "You can view this gallery's configured image (first, random, etc.) in your browser using" => "You can view this gallery's configured image (first, random, etc.) in your browser using",
// "You can include the gallery's image in an HTML page using one of these lines" => "You can include the gallery's image in an HTML page using one of these lines",
// "Cyclic" => "Cyclic",
// "Admin Calendar" => "Admin Calendar",
// "Export Calendars" => "Export Calendars",
// "Click to export calendars" => "Click to export calendars",
// "Click to select visible calendars" => "Click to select visible calendars",
// "Export calendars" => "Export calendars",
// "advanced parameters" => "advanced parameters",
// "Delete event" => "Delete event",
// "All-Day" => "All-Day",
// "Website" => "Website",
// "View this Week" => "View this Week",
// "View this Day" => "View this Day",
// "o" => "o",
// "Recurrence" => "Recurrence",
// "This event depends on a recurrence rule" => "This event depends on a recurrence rule",
// "This event is not recurrent" => "This event is not recurrent",
// "On a weekly basis" => "On a weekly basis",
// "Each" => "Each",
// "of the week" => "of the week",
// "On a monthly basis" => "On a monthly basis",
// "of the month" => "of the month",
// "On a yearly basis" => "On a yearly basis",
// "There's no such date as" => "There's no such date as",
// "Starting on" => "Starting on",
// "ending by" => "ending by",
// "ending after" => "ending after",
// "events" => "events",
// "Start period" => "Start period",
// "End after" => "End after",
// "occurrences" => "occurrences",
// "End before" => "End before",
// "Event is repeated" => "Event is repeated",
// "every" => "every",
// "of every month" => "of every month",
// "on each" => "on each",
// "Date and time of end" => "Date and time of end",
// "Events cannot end before they start" => "Events cannot end before they start",
// "or new" => "or new",
// "Choose users to alert" => "Choose users to alert",
// "chair" => "chair",
// "default role" => "default role",
// "required participant" => "required participant",
// "optional participant" => "optional participant",
// "non participant" => "non participant",
// "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in" => "Give participant list separated by commas. Roles have to be given in a prefix separated by a column like in",
// "role:login_or_email,login_or_email" => "role:login_or_email,login_or_email",
// "If no role is provided, default role will be \"Chair participant\"" => "If no role is provided, default role will be \"Chair participant\"",
// "Update this event only" => "Update this event only",
// "Update every unchanged events of this recurrence rule" => "Update every unchanged events of this recurrence rule",
// "Update every events of this recurrence rule" => "Update every events of this recurrence rule",
// "Delete Recurrent events" => "Delete Recurrent events",
// "Avanced parameters for iCal export" => "Avanced parameters for iCal export",
// "Calendars to be exported" => "Calendars to be exported",
// "Categories checking is not done in the database search" => "Categories checking is not done in the database search",
// "Perform action with checked" => "Perform action with checked",
// "Your account has been validated" => "Your account has been validated",
// "You have to choose a password to use this account" => "You have to choose a password to use this account",
// "Send another message" => "Send another message",
// "Group View" => "Group View",
// "Publish this contact to groups" => "Publish this contact to groups",
// "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>" => "<a href=\"tiki-directory_admin_categories.php\">Add a category now</a>",
// "The following site was added, but may require validation by the admin before appearing on the lists" => "The following site was added, but may require validation by the admin before appearing on the lists",
// "Edit a site" => "Edit a site",
// "Add a site" => "Add a site",
// "Perform action with selected" => "Perform action with selected",
// "Emails to be notified (separated with commas)" => "Emails to be notified (separated with commas)",
// "Max clicks" => "Max clicks",
// "A category is mandatory" => "A category is mandatory",
// "The file will be saved in" => "The file will be saved in",
// "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor" => "For more information, please see <a href=\"{\$prefs.helpurl}Wiki+Page+Editor\" target=\"tikihelp\" class=\"tikihelp\" title=\"{tr}Wiki Page Editor",
// "More help on editing wiki pages" => "More help on editing wiki pages",
// "The syntax system used for creating pages in TikiWiki" => "The syntax system used for creating pages in TikiWiki",
// "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background" => "Will display using the indicated HTML color or color name. Color name can contain two colors separated by a comma. In this case, the first color would be the foreground and the second one the background",
// "Deleted text" => "Deleted text",
// "2 dashes" => "2 dashes",
// "Autonumbered Headings" => "Autonumbered Headings",
// "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)" => "{literal}{toc}{/literal}, {literal}{maketoc}{/literal} prints out a table of contents for the current page based on structures (toc) or ! headings (maketoc)",
// "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)" => "use square brackets for an external link: [URL], [URL|link_description],[URL|link_description|relation] or [URL|description|relation|nocache] (that last prevents the local Wiki from caching the linked page; relation can be used to insert rel attribute for the link - useful e.g. for shadowbox)",
// "page|#anchor" => "page|#anchor",
// "page|#anchor|desc" => "page|#anchor|desc",
// "for wiki heading/anchor references" => "for wiki heading/anchor references",
// "Indentation" => "Indentation",
// "Creates an indentation for each plus(useful in list to continue at the same level)" => "Creates an indentation for each plus(useful in list to continue at the same level)",
// "Monospace font" => "Monospace font",
// "Code sample" => "Code sample",
// "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text" => "~pp~ data ~/pp~ Displays preformated text/code; no Wiki processing is done inside these sections (as with np), and the spacing is fixed (no word wrapping is done).  ~pre~ data ~/pre~ also displayes preformatted text with fixed spacing, but wiki processing still occurs on the text",
// "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar" => "~tc~ Tiki Comment ~/tc~ makes a Tiki comment.  It will be completely removed from the display, but saved in the file for future reference.  ~hc~ HTML Comment ~/hc~ makes an HTML comment.  It will be inserted as a comment in the output HTML; these are not normally displayed in browsers, but can be seen using \"View Source\" or similar",
// "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that" => "Indent text with any number of spaces to turn it into a monospaced block that still follows other Wiki formatting instructions. It will be indended with the same number of spaces that you used.  Note that this mode does not preserve exact spacing and line breaks; use ~pp~...~/pp~ for that",
// "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew" => "Insert resp. right-to-left and left-to-right text direction DIV (up to end of text) and markers for langages as arabic or hebrew",
// "Special characters" => "Special characters",
// "hard space" => "hard space",
// "numeric between ~ for html numeric characters entity" => "numeric between ~ for html numeric characters entity",
// "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines" => "Because the Wiki paragraph formatting feature is on, all groups of non-blank lines are collected into paragraphs.  Lines can be of any length, and will be wrapped together with the next line.  Paragraphs are separated by blank lines",
// "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line" => "Because the Wiki paragraph formatting feature is off, each line will be presented as you write it.  This means that if you want paragraphs to be wrapped properly, a paragraph should be all together on one line",
// "Wiki plugins extend the function of wiki syntax with more specialized commands" => "Wiki plugins extend the function of wiki syntax with more specialized commands",
// "text, bold" => "text, bold",
// "text, italic" => "text, italic",
// "text, underline" => "text, underline",
// "horizontal rule" => "horizontal rule",
// "Add image from File Gallery" => "Add image from File Gallery",
// "quote" => "quote",
// "flash" => "flash",
// "{\$label}" => "{\$label}",
// "Add Image from File Gallery" => "Add Image from File Gallery",
// "Im-Export Languages" => "Im-Export Languages",
// "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character" => "Instructions: Type, or paste, your multiple choice questions below.  One line for the question, then start answer choices on subsequent lines.  Separate additional questions with a blank line.  Indicate correct answers by starting them with a \"*\" (without the quotes) character",
// "Edit quiz results" => "Edit quiz results",
// "and its subpages from the structure" => "and its subpages from the structure",
// "The page already exists. The page that has been added to the structure is the existing one" => "The page already exists. The page that has been added to the structure is the existing one",
// "The following pages added have automatically been categorized with the same categories as the structure" => "The following pages added have automatically been categorized with the same categories as the structure",
// "Monitor the Sub-Structure" => "Monitor the Sub-Structure",
// "Stop Monitoring the Sub-Structure" => "Stop Monitoring the Sub-Structure",
// "Move in this structure" => "Move in this structure",
// "Move to another structure" => "Move to another structure",
// "Categorize all pages in structure together" => "Categorize all pages in structure together",
// "Remove existing categories from ALL pages before recategorizing" => "Remove existing categories from ALL pages before recategorizing",
// "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering" => "If you go to edit this (or any other TPL file) file via the Tiki built-in TPL editor below, all the javascript can be sanitized or completely stripped out by Tiki security filtering",
// "This would cause you problems (e.g. menus can stop collapsing/expanding)" => "This would cause you problems (e.g. menus can stop collapsing/expanding)",
// "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)" => "You should only modify default header.tpl and other important files via text code editor, through console, or SSH, or FTP edit commands. And only if you know what you are doing ! ;-)",
// "Maybe You just want to modify the top of your Tiki site" => "Maybe You just want to modify the top of your Tiki site",
// "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface" => "Please consider using the Look &amp; Feel preferences custom code areas or modify tiki-top_bar.tpl which you can do safely via the web-based interface",
// "Add Notification Email" => "Add Notification Email",
// "Admin notifications" => "Admin notifications",
// "View Page" => "View Page",
// "View Article" => "View Article",
// "Language of newly translated page" => "Language of newly translated page",
// "Unspecified" => "Unspecified",
// "Name of newly translated page" => "Name of newly translated page",
// "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"" => "\"You forgot to specify the language of the translation. Please choose a language in the picklist.\"",
// "Select from available options.." => "Select from available options..",
// "Update '{\$page}'" => "Update '{\$page}'",
// "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval" => "You are editing the staging copy of the approved version of this page. Changes will be merged in after approval",
// "This is a new staging page that has not been approved before" => "This is a new staging page that has not been approved before",
// "The current staging copy may contain changes that have yet to be approved" => "The current staging copy may contain changes that have yet to be approved",
// "View changes since last approval" => "View changes since last approval",
// "You are editing the approved copy of this page" => "You are editing the approved copy of this page",
// "There are currently changes in the staging copy that have yet to be approved" => "There are currently changes in the staging copy that have yet to be approved",
// "Are you sure you do not want to edit" => "Are you sure you do not want to edit",
// "the staging copy" => "the staging copy",
// "instead" => "instead",
// "Change the style used to display differences to be translated" => "Change the style used to display differences to be translated",
// "Change diff styles" => "Change diff styles",
// "Switch to WYSIWYG editor" => "Switch to WYSIWYG editor",
// "Switch to normal (wiki) editor" => "Switch to normal (wiki) editor",
// "Categories will be inherited from the structure top page" => "Categories will be inherited from the structure top page",
// "Disable" => "Disable",
// "AutoSave" => "AutoSave",
// "If you want the saved version instead of the autosaved one" => "If you want the saved version instead of the autosaved one",
// "Regex search " => "Regex search ",
// "Case Insensitivity" => "Case Insensitivity",
// "Edit Comment" => "Edit Comment",
// "Monitor this page" => "Monitor this page",
// "List Sheets" => "List Sheets",
// "Graph" => "Graph",
// "Format" => "Format",
// "Autodetect" => "Autodetect",
// "Export Tracker Items" => "Export Tracker Items",
// "Delimitors" => "Delimitors",
// "Carriage Return inside Field Value" => "Carriage Return inside Field Value",
// "Parse as Wiki Text" => "Parse as Wiki Text",
// "Fields visible in items list" => "Fields visible in items list",
// "Fields searchable or visible in items list" => "Fields searchable or visible in items list",
// "Fields visible in an item view" => "Fields visible in an item view",
// "These fields" => "These fields",
// "Use Ctrl+Click to select multiple fields" => "Use Ctrl+Click to select multiple fields",
// "File Archive" => "File Archive",
// "Be careful to set the right permissions on the files you link to" => "Be careful to set the right permissions on the files you link to",
// "Forum Importer" => "Forum Importer",
// "Import from a Local SQL File" => "Import from a Local SQL File",
// "Forum Type" => "Forum Type",
// "DB Prefix" => "DB Prefix",
// "Local SQL Filename on Server (path will be stripped)" => "Local SQL Filename on Server (path will be stripped)",
// "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up" => "Must be in tikiroot/{\$tmpdir} or tikiroot/img/wiki_up",
// "Verification" => "Verification",
// "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>" => "File must be an SQL file and exist in either <i>\$tikiroot/temp</i> or <i>\$tikiroot/img/wiki_up</i>",
// "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred" => "File was not specified, or could not be found in either location.  Please put the file in either directory and Go Back.  If the file exists in both locations, the \$tikiroot/{\$filecheck} location will be preferred",
// "Select a Forum You Wish to Move (ONE at a time!)" => "Select a Forum You Wish to Move (ONE at a time!)",
// "Which Forum Do You Wish to Import this Into" => "Which Forum Do You Wish to Import this Into",
// "Message queue for forum" => "Message queue for forum",
// "Back to forum" => "Back to forum",
// "Reported messages for forum" => "Reported messages for forum",
// "Perfom action with checked" => "Perfom action with checked",
// "Un-report" => "Un-report",
// "Tag translation" => "Tag translation",
// "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag" => "Note that tags that were created on pages with no language set will remain\n\tuniversal (i.e. is the same tag in all languages) until a language has been set for the tag",
// "Until then, they cannot be translated" => "Until then, they cannot be translated",
// "Show checkboxes to clear language information on tags" => "Show checkboxes to clear language information on tags",
// "There are no tags on this page in your preferred languages" => "There are no tags on this page in your preferred languages",
// "Universal" => "Universal",
// "Show the following languages" => "Show the following languages",
// "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>" => "To learn more about the <a class=\"rbox-link\" target=\"tikihelp\" href=\"http://workflow.tikiwiki.org\">Galaxia workflow engine</a>",
// "Process Graph" => "Process Graph",
// "Galaxia Admin Graph" => "Galaxia Admin Graph",
// "Galaxia Admin Graph tpl" => "Galaxia Admin Graph tpl",
// "Process Graph for" => "Process Graph for",
// "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed" => "No process graph is available. Either the process still contains errors, the graph is not generated yet, or <a href=\"http://www.research.att.com/sw/tools/graphviz/\">GraphViz</a> is not properly installed",
// "Pop-up" => "Pop-up",
// "Galaxia Admin Processes tpl" => "Galaxia Admin Processes tpl",
// "Galaxia Monitor Activities tpl" => "Galaxia Monitor Activities tpl",
// "Galaxia Monitor Instances tpl" => "Galaxia Monitor Instances tpl",
// "Galaxia Monitor Processes tpl" => "Galaxia Monitor Processes tpl",
// "Instance Id" => "Instance Id",
// "Instance Name" => "Instance Name",
// "Instance Status" => "Instance Status",
// "Elapsed time" => "Elapsed time",
// "Galaxia User Activities tpl" => "Galaxia User Activities tpl",
// "No processes defined or activated yet" => "No processes defined or activated yet",
// "Galaxia User Instances tpl" => "Galaxia User Instances tpl",
// "Galaxia User Processes tpl" => "Galaxia User Processes tpl",
// "Global default" => "Global default",
// "Bounding box" => "Bounding box",
// "Google Map Locator" => "Google Map Locator",
// "Save clicked point" => "Save clicked point",
// "Reset view to default" => "Reset view to default",
// "Save current view as default" => "Save current view as default",
// "Center map to saved point" => "Center map to saved point",
// "Reset view to site default" => "Reset view to site default",
// "Users Map" => "Users Map",
// "Pie Chart" => "Pie Chart",
// "Multibar" => "Multibar",
// "Bar Stack" => "Bar Stack",
// "Wiki plug-in" => "Wiki plug-in",
// "Ical import / Export" => "Ical import / Export",
// "Select The calendar to export" => "Select The calendar to export",
// "ICal File" => "ICal File",
// "Modify String in Source Language" => "Modify String in Source Language",
// "Original String" => "Original String",
// "New String" => "New String",
// "XML Zip" => "XML Zip",
// "Welcome to the Tiki installation and upgrade script" => "Welcome to the Tiki installation and upgrade script",
// "Use this script to install a new Tiki database or upgrade your existing database to release" => "Use this script to install a new Tiki database or upgrade your existing database to release",
// "For more information about Tiki, please visit" => "For more information about Tiki, please visit",
// "Tiki is software distributed under the LGPL license" => "Tiki is software distributed under the LGPL license",
// " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>" => " <a href=\"http://creativecommons.org/licenses/LGPL/2.1/\" target=\"_blank\">Here is a human-readable summary of the license below, including many translations.</a>",
// "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements" => "Before installing Tiki, <a href=\"http://doc.tikiwiki.org/tiki-index.php?page=Requirements+and+Setup&bl=y\" target=\"_blank\">review the documentation</a> and confirm that your system meets the minimum requirements",
// "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution" => "Tiki requires <strong>at least</strong> 32MB of PHP memory for script execution",
// "Allocating too little memory will cause Tiki to display blank pages" => "Allocating too little memory will cause Tiki to display blank pages",
// "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages" => "Tiki uses the PHP <strong>mail</strong> function to send email notifications and messages",
// "To test your system configuration, Tiki will attempt to send a test message to you" => "To test your system configuration, Tiki will attempt to send a test message to you",
// "Test email" => "Test email",
// "Email address to send test to" => "Email address to send test to",
// "Copy test mail to " => "Copy test mail to ",
// "Tiki was able to send a test message to" => "Tiki was able to send a test message to",
// "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support" => "Tiki uses the GD library to process images for the Image Gallery and CAPTCHA support",
// "Tiki requires an active database connection" => "Tiki requires an active database connection",
// "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>" => "Use this page to create a new database connection, or use the <a href=\"http://doc.tikiwiki.org/Manual+Installation\" target=\"_blank\" title=\"manual installation\">manual installation process</a>",
// "Enter your TNS Name here and leave Host empty" => "Enter your TNS Name here and leave Host empty",
// "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field" => "Override tnsnames.ora and put your SID here and enter your hostname:port in the Host field",
// "Install &amp; Update Profile" => "Install &amp; Update Profile",
// "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page" => "Failed to set max_execution_time to 0 for PHP. You may experience problems when creating/upgrading the database on a slow system. This will manitest itself by a blank page",
// "Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database" => "Select the installation (or upgrade) profile to use. This profile will populate (or upgrade) the database",
// "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>" => "If you want to upgrade from a previous Tiki release, ensure that you have read and understood the <a href=\"http://doc.tikiwiki.org/Upgrade\" target=\"_blank\">Upgrade instructions</a>",
// "Select the installation profile to use. This profile will populate the database" => "Select the installation profile to use. This profile will populate the database",
// "Bare-bones default install" => "Bare-bones default install",
// "Personal Blog and Profile" => "Personal Blog and Profile",
// "Small Organization Web Presence" => "Small Organization Web Presence",
// "Company Intranet" => "Company Intranet",
// "Collaborative community" => "Collaborative community",
// "See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles" => "See the documentation for <a target=\"_blank\" href=\"http://profiles.tikiwiki.org/Profiles_in_30_installer\" class=\"link\" title=\"Description of available profiles.\">descriptions of the available profiles",
// "The installer could not connect to the Profiles repository" => "The installer could not connect to the Profiles repository",
// "Automatically upgrade your existing database to v" => "Automatically upgrade your existing database to v",
// "Your database has been configured and Tiki is ready to run" => "Your database has been configured and Tiki is ready to run",
// "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application" => "You can now log in into Tiki as user <strong>admin</strong> and start configuring the application",
// "Upgrade operations executed successfully" => "Upgrade operations executed successfully",
// "Installation operations executed successfully" => "Installation operations executed successfully",
// "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages" => "During an upgrade, it is normal to have SQL failures resulting with <strong>Table already exists</strong> messages",
// ".htaccess File" => ".htaccess File",
// "We recommend enabling the <strong>.htaccess</strong> file for your Tiki" => "We recommend enabling the <strong>.htaccess</strong> file for your Tiki",
// "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security" => "This will enable you to use SEFURLs (search engine friendly URLs) and help improve site security",
// "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>" => "To enable this file, simply rename the <strong>_htaccess</strong> file (located in the main directory of your Tiki installation) to <strong>.htaccess</strong>",
// "Complete these fields to configure common, general settings for your site" => "Complete these fields to configure common, general settings for your site",
// "The information you enter here can be changed later" => "The information you enter here can be changed later",
// "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings" => "Refer to the <a href=\"http://doc.tikiwiki.org/Admin+Panels\" target=\"_blank\">documentation</a> for complete information on these, and other, settings",
// "This will appear in the browser title bar" => "This will appear in the browser title bar",
// "Email sent by your site will use this address" => "Email sent by your site will use this address",
// "Secure Login" => "Secure Login",
// "HTTPS login" => "HTTPS login",
// "Enter Your Tiki" => "Enter Your Tiki",
// "Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>" => "Tiki is an opensource project, <em>you</em> can <a href='http://info.tikiwiki.org/Join+the+Community' target='_blank'>join the community</a> and help <a href='http://info.tikiwiki.org/tiki-index.php?page=Develop+Tiki' target='_blank'>develop Tiki</a>",
// "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation" => "If this is a first time installation, go to <strong>tiki-admin.php</strong> after login to start configuring your new Tiki installation",
// "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu" => "If this is an upgrade, clean the Tiki caches manually (the <strong>templates_c</strong> directory) or by using the <strong>Admin &gt; System</strong> option from the Admin menu",
// "Enter Tiki and Lock Installer" => "Enter Tiki and Lock Installer",
// "Enter Tiki Without Locking Installer" => "Enter Tiki Without Locking Installer",
// "MultiTiki Setup" => "MultiTiki Setup",
// "Default Installation" => "Default Installation",
// "DB OK" => "DB OK",
// "No DB" => "No DB",
// "Adding a new host" => "Adding a new host",
// "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter" => "To add a new virtual host run the setup.sh with the domain name of the new host as a last parameter",
// "Are you upgrading an existing Tiki site" => "Are you upgrading an existing Tiki site",
// "Go directly to the <strong>Install/Upgrade</strong> step" => "Go directly to the <strong>Install/Upgrade</strong> step",
// "Install/Upgrade" => "Install/Upgrade",
// "Reset the Database Connection" => "Reset the Database Connection",
// "Tiki Icon" => "Tiki Icon",
// "TikiWiki Project Web Site" => "TikiWiki Project Web Site",
// "TikiWiki CMS/Groupware Project" => "TikiWiki CMS/Groupware Project",
// "Powered by TikiWiki" => "Powered by TikiWiki",
// "Clicking 'Close this window' will reload the main window from where it was opened" => "Clicking 'Close this window' will reload the main window from where it was opened",
// "Last 2 days" => "Last 2 days",
// "Last 3 days" => "Last 3 days",
// "Last 5 days" => "Last 5 days",
// "Last week" => "Last week",
// "Last 2 weeks" => "Last 2 weeks",
// "Last month" => "Last month",
// "v" => "v",
// "Max Clicks" => "Max Clicks",
// "The cache is used by" => "The cache is used by",
// "Approval" => "Approval",
// "Rejected" => "Rejected",
// "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block" => "To use content blocks in a text area (Wiki page, etc), a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{content id=x}{/literal}, where x is the ID of the content block",
// "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block" => "You can also use {literal}{content label=x}{/literal}, where x is the label of the content block",
// "Edit content block" => "Edit content block",
// "Create content block" => "Create content block",
// "Current Value" => "Current Value",
// "SlideShow" => "SlideShow",
// "Keep gallery window open" => "Keep gallery window open",
// "Property <b>{\$fgp_name}</b> Changed" => "Property <b>{\$fgp_name}</b> Changed",
// "/" => "/",
// "Flash binary (.swf or .dcr)" => "Flash binary (.swf or .dcr)",
// "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on" => "Those movies are very good tutorials of tikiwiki use. They have been generated by siridhar with camtasia studio for public use ! Thanks to him. The up-to-date list of movies is on",
// "Links to other items in page" => "Links to other items in page",
// "Links to this page in other pages" => "Links to this page in other pages",
// "Backl" => "Backl",
// " {if \$find ne ''}and {/if}starting with" => " {if \$find ne ''}and {/if}starting with",
// "offline" => "offline",
// "Back to admin" => "Back to admin",
// "For security purposes we must periodically validate your email address to allow continued access to this site" => "For security purposes we must periodically validate your email address to allow continued access to this site",
// "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site" => "A validation email has been sent to you. Please open that email and follow the instructions to once again gain access to the site",
// "This is an experimental feature" => "This is an experimental feature",
// "Requires" => "Requires",
// "Not Enabled" => "Not Enabled",
// "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/" => "Missing dependency. Obtain <a href=\"http://tikiwiki.org/tiki-download_file.php?fileId=50\">visorFreemind.swf</a> and upload it in files/",
// "Tikiwiki Mods" => "Tikiwiki Mods",
// "Mods Configuration" => "Mods Configuration",
// "Update remote index" => "Update remote index",
// "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>" => "Tiki \"mods\" are additional features not included in the public release. Learn more at <a target=\"tikihelp\" href=\"http://mods.tikiwiki.org\">mods.tikiwiki.org</a>",
// "Tiki \"mods\" are undergoing refurbishment" => "Tiki \"mods\" are undergoing refurbishment",
// "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification" => "You will probably some find mods shown as being compatible with older versions of Tiki will work with later versions with little or no modification",
// "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more" => "Your help is needed! Please visit <a href=\"http://dev.tikiwiki.org/tiki-index.php?page=Mods\">dev.tikiwiki.org</a> to find out more",
// "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)" => "Apache has the right to write in your file tree, which enables the installation, removal or upgrade of packages. When you are done with those operations, think to fix those permissions back to a safe state (by using \"sh setup.sh\" for example)",
// "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")" => "To install, remove or upgrade packages you need to give the apache user the right to write files in your web tree (you can use \"sh setup.sh open\" to set it up). After installation you need to remove that permission (using \"sh setup.sh\")",
// "for version" => "for version",
// "all versions" => "all versions",
// "or later" => "or later",
// "No mods found" => "No mods found",
// "licence" => "licence",
// "Tikiwiki Mods Configuration" => "Tikiwiki Mods Configuration",
// "Mods Install/uninstall" => "Mods Install/uninstall",
// "Enable Mods providing" => "Enable Mods providing",
// "Mods local directory" => "Mods local directory",
// "Mods remote server" => "Mods remote server",
// "My Articles" => "My Articles",
// "User Articles" => "User Articles",
// "My User Items" => "My User Items",
// "User Items" => "User Items",
// "User forum topics" => "User forum topics",
// "Forum topics" => "Forum topics",
// "Date of post" => "Date of post",
// "User forum replies" => "User forum replies",
// "Forum replies" => "Forum replies",
// "To display the objects you participate" => "To display the objects you participate",
// "My Infos" => "My Infos",
// "Contacts Preferences" => "Contacts Preferences",
// "My Contacts" => "My Contacts",
// "My Wiki Pages" => "My Wiki Pages",
// "My Galleries" => "My Galleries",
// "My Tracker Items" => "My Tracker Items",
// "My Messages" => "My Messages",
// "My Tasks" => "My Tasks",
// "Sent Edition" => "Sent Edition",
// "HTML version" => "HTML version",
// "Text version" => "Text version",
// "Delete errors" => "Delete errors",
// "Not sent" => "Not sent",
// "Removal of your email address failed" => "Removal of your email address failed",
// "Subscription failed" => "Subscription failed",
// "Subscribe to Newsletter" => "Subscribe to Newsletter",
// "Subscribe to this Newsletter" => "Subscribe to this Newsletter",
// "Add a news server" => "Add a news server",
// "Edit news server" => "Edit news server",
// "Object Watches" => "Object Watches",
// "Watching Groups" => "Watching Groups",
// "These permissions do not apply. Special permissions apply" => "These permissions do not apply. Special permissions apply",
// "No category permissions; special permissions apply" => "No category permissions; special permissions apply",
// "and also to all pages of the sub-structure" => "and also to all pages of the sub-structure",
// "Perms Help" => "Perms Help",
// "Your OpenID identity is valid" => "Your OpenID identity is valid",
// "However, no account is associated to the OpenID identifier" => "However, no account is associated to the OpenID identifier",
// "Create a new Tikiwiki account from OpenID" => "Create a new Tikiwiki account from OpenID",
// "Associate OpenID with an existing Tikiwiki account" => "Associate OpenID with an existing Tikiwiki account",
// "Your identity gives you access to multiple user accounts" => "Your identity gives you access to multiple user accounts",
// "Select account" => "Select account",
// "{\$atts|@count} files attached" => "{\$atts|@count} files attached",
// "Updated from" => "Updated from",
// "Used to update" => "Used to update",
// "File (only .gif, .jpg and .png images approximately 45px × 45px)" => "File (only .gif, .jpg and .png images approximately 45px × 45px)",
// "Plugin execution was denied" => "Plugin execution was denied",
// "Plugin execution pending approval" => "Plugin execution pending approval",
// "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected" => "After argument validation by an editor, the execution of this plugin was denied. This plugin will eventually be removed or corrected",
// "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible" => "This plugin was recently added or modified. Until an editor of the site validates the parameters, execution will not be possible",
// "You are allowed to" => "You are allowed to",
// "View arguments" => "View arguments",
// "Execute the plugin in preview mode (may be dangerous)" => "Execute the plugin in preview mode (may be dangerous)",
// "Approve the plugin for public execution" => "Approve the plugin for public execution",
// "This plugin does not contain any arguments" => "This plugin does not contain any arguments",
// "This plugin's body is empty" => "This plugin's body is empty",
// "Any" => "Any",
// "Items found" => "Items found",
// "Sum" => "Sum",
// "Plugin Approval" => "Plugin Approval",
// "Plugins pending validation are added to this list the first time they are encountered. Only their <em>signature</em> is preserved. Some of the plugins listed here may no longer be in use in the page originally using them. In this case, it's safe to clear them from this list. They will be added back next time they are encountered. Plugins can be approved or rejected from the page containing them" => "Plugins pending validation are added to this list the first time they are encountered. Only their <em>signature</em> is preserved. Some of the plugins listed here may no longer be in use in the page originally using them. In this case, it's safe to clear them from this list. They will be added back next time they are encountered. Plugins can be approved or rejected from the page containing them",
// "Last seen in wiki page <a href=\"%0\">%1</a>" => "Last seen in wiki page <a href=\"%0\">%1</a>",
// "Seen in unknown object" => "Seen in unknown object",
// "Clear checked items" => "Clear checked items",
// "No plugin pending approval" => "No plugin pending approval",
// "Poll Results" => "Poll Results",
// "Top Voted Polls" => "Top Voted Polls",
// "Edit Poll" => "Edit Poll",
// "Find the poll" => "Find the poll",
// "Number of top voted polls to show" => "Number of top voted polls to show",
// "Vote range displayed" => "Vote range displayed",
// "All votes with no span consideration" => "All votes with no span consideration",
// "All votes with span consideration" => "All votes with span consideration",
// "All votes" => "All votes",
// "List Votes" => "List Votes",
// "Permission denied. You do not have permission to read complete articles" => "Permission denied. You do not have permission to read complete articles",
// "Selected Structures" => "Selected Structures",
// "Add Structure" => "Add Structure",
// "No structures" => "No structures",
// "Add Pages" => "Add Pages",
// "No pages" => "No pages",
// "Use Ctrl+Click to select multiple pages" => "Use Ctrl+Click to select multiple pages",
// "Add Pages from Structures" => "Add Pages from Structures",
// "Add Structure Pages" => "Add Structure Pages",
// "Selected Pages" => "Selected Pages",
// "No pages selected" => "No pages selected",
// "P/F" => "P/F",
// "Passed" => "Passed",
// "Rank" => "Rank",
// "star" => "star",
// "half star" => "half star",
// "Edit Received Page" => "Edit Received Page",
// "The highlight pages already exist" => "The highlight pages already exist",
// "Please, change the name if you want the page to be uploaded" => "Please, change the name if you want the page to be uploaded",
// "Received Structures" => "Received Structures",
// "Prefix the checked" => "Prefix the checked",
// "Postfix the checked" => "Postfix the checked",
// "Use your email as login" => "Use your email as login",
// "Minimum {\$prefs.min_username_length} characters long" => "Minimum {\$prefs.min_username_length} characters long",
// "Passcode to register" => "Passcode to register",
// "Not your password" => "Not your password",
// "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}" => "To request a passcode, {if \$prefs.feature_contact eq 'y'}<a href=\"tiki-contact.php\">{/if}\n\tcontact the sytem administrator{if \$prefs.feature_contact eq 'y'}</a>{/if}",
// "Generate a\tpassword" => "Generate a\tpassword",
// "Enter your username or email" => "Enter your username or email",
// "Enter your email" => "Enter your email",
// "Request Password Reset" => "Request Password Reset",
// "Back to page" => "Back to page",
// "to version" => "to version",
// "\$name" => "\$name",
// "Faqs" => "Faqs",
// "Blogs Post" => "Blogs Post",
// "Date Search" => "Date Search",
// "All dates" => "All dates",
// "Calendar Items" => "Calendar Items",
// "Please Confirm" => "Please Confirm",
// "octets" => "octets",
// "Data HTML" => "Data HTML",
// "Data Txt" => "Data Txt",
// "Attached Files" => "Attached Files",
// "To add a file, click here" => "To add a file, click here",
// "Save as Draft" => "Save as Draft",
// "Send a structure" => "Send a structure",
// "Ex: http://tikiwiki.org or localhost" => "Ex: http://tikiwiki.org or localhost",
// "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need" => "Use /commxmlrpc.php if your tikiwiki site is installed at the root, otherwise adapt /tiki to your need",
// "This is the staging copy of" => "This is the staging copy of",
// "the approved version of this page" => "the approved version of this page",
// "Viewing of changes since last approval is possible only after first approval" => "Viewing of changes since last approval is possible only after first approval",
// "Approve changes" => "Approve changes",
// "Latest changes will be synchronized after approval" => "Latest changes will be synchronized after approval",
// "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time" => "This is a new staging page that has not been approved before. Edit and manually move it to the category for approved pages to approve it for the first time",
// "Content may be out of date" => "Content may be out of date",
// "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages" => "An urgent request for translation has been sent. Until this page is updated, you can see a corrected version in the following pages",
// "TOC" => "TOC",
// "page: %0/%1" => "page: %0/%1",
// "Page last modified on %0 by %1" => "Page last modified on %0 by %1",
// "Created by %0" => "Created by %0",
// "Last Modification: %0 by %1" => "Last Modification: %0 by %1",
// "You will not see the latest queries" => "You will not see the latest queries",
// "Clean" => "Clean",
// "Params" => "Params",
// "Total replies" => "Total replies",
// "Average number of replies per topic" => "Average number of replies per topic",
// "FAQ Stats" => "FAQ Stats",
// "Tiki Logs" => "Tiki Logs",
// "Clean logs older than" => "Clean logs older than",
// "months" => "months",
// "TikiTests Edit" => "TikiTests Edit",
// "Summary mode" => "Summary mode",
// "Show Page Differences" => "Show Page Differences",
// "Show Tidy Errors and Warnings" => "Show Tidy Errors and Warnings",
// "Show POST Data" => "Show POST Data",
// "Use Current Session/Logout" => "Use Current Session/Logout",
// "Recorded Links" => "Recorded Links",
// "Request" => "Request",
// "Element to compare (Xpath expression)" => "Element to compare (Xpath expression)",
// "Test Xpath Expression" => "Test Xpath Expression",
// "Post Variables" => "Post Variables",
// "Tidy Results" => "Tidy Results",
// "TikiTests List" => "TikiTests List",
// "Config" => "Config",
// "Replay" => "Replay",
// "Tidy extension not present" => "Tidy extension not present",
// "PECL HTTP extension present" => "PECL HTTP extension present",
// "cURL extension present" => "cURL extension present",
// "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible" => "PECL HTTP and cURL extension not present. Replay of the TikiTest will not be possible",
// "List TikiTests" => "List TikiTests",
// "Create a TikiTest" => "Create a TikiTest",
// "Replay the TikiTest" => "Replay the TikiTest",
// "Edit the TikiTest" => "Edit the TikiTest",
// "TikiTests Record Configuration" => "TikiTests Record Configuration",
// "Start Recording Test" => "Start Recording Test",
// "TikiTests Replay Configuration" => "TikiTests Replay Configuration",
// "Failure" => "Failure",
// "Reference" => "Reference",
// "The pages are different" => "The pages are different",
// "The pages are identical" => "The pages are identical",
// "Recording to pause press the pause button" => "Recording to pause press the pause button",
// "Pause the recording" => "Pause the recording",
// "Paused to resume press the play button" => "Paused to resume press the play button",
// "Resume the recording" => "Resume the recording",
// "Stop the recording" => "Stop the recording",
// "Theme Control Center: Categories" => "Theme Control Center: Categories",
// "Theme Control Center: Sections" => "Theme Control Center: Sections",
// "The following files have been successfully uploaded" => "The following files have been successfully uploaded",
// "You locked the file" => "You locked the file",
// "The file is locked by {\$fileInfo.lockedby}" => "The file is locked by {\$fileInfo.lockedby}",
// "Unzip zip files" => "Unzip zip files",
// "Author if not the file creator" => "Author if not the file creator",
// "Maximum amount of downloads" => "Maximum amount of downloads",
// "Add File" => "Add File",
// "Maximum file size is limited to" => "Maximum file size is limited to",
// "Uploading file.." => "Uploading file..",
// "No File to Upload.." => "No File to Upload..",
// "The column is disabled" => "The column is disabled",
// "a folder" => "a folder",
// "a URL" => "a URL",
// "User Contacts Preferences" => "User Contacts Preferences",
// "Manage Fields" => "Manage Fields",
// "(non public)" => "(non public)",
// "The user requested friendship with you" => "The user requested friendship with you",
// "Accept friendship from this user" => "Accept friendship from this user",
// "Refuse friendship from this user" => "Refuse friendship from this user",
// "Currently waiting for user approval" => "Currently waiting for user approval",
// "Cancel friendship request towards this user" => "Cancel friendship request towards this user",
// "Forum comments" => "Forum comments",
// "Toggle" => "Toggle",
// "Male" => "Male",
// "Female" => "Female",
// "Use Google Map locator" => "Use Google Map locator",
// "Your preferred language" => "Your preferred language",
// "Can you read more languages" => "Can you read more languages",
// "Other languages you can read (select on the left to add to the list on the right)" => "Other languages you can read (select on the left to add to the list on the right)",
// "Displays users' info tooltip on mouseover for every user who allows his information to be public" => "Displays users' info tooltip on mouseover for every user who allows his information to be public",
// "My user items" => "My user items",
// "My level" => "My level",
// "Use \"watches\" to monitor wiki pages or other objects" => "Use \"watches\" to monitor wiki pages or other objects",
// "Watch new items by clicking the {icon _id=eye} button on specific pages" => "Watch new items by clicking the {icon _id=eye} button on specific pages",
// "Select event type" => "Select event type",
// "All watched events" => "All watched events",
// "A user edited an article" => "A user edited an article",
// "A user deleted an article" => "A user deleted an article",
// "A user created a wiki page in a language" => "A user created a wiki page in a language",
// "Used space" => "Used space",
// "up to" => "up to",
// "no limit for admin" => "no limit for admin",
// "No articles yet" => "No articles yet",
// "Add an article" => "Add an article",
// "There are no questions in this FAQ" => "There are no questions in this FAQ",
// "Manage Reported Messages" => "Manage Reported Messages",
// "Monitor Topics of this Forum" => "Monitor Topics of this Forum",
// "Stop Monitoring Topics of this Forum" => "Stop Monitoring Topics of this Forum",
// "Monitor Topics and Threads of this Forum" => "Monitor Topics and Threads of this Forum",
// "Stop Monitoring Topics and Threads of this Forum" => "Stop Monitoring Topics and Threads of this Forum",
// "Group Monitor Topics of this Forum" => "Group Monitor Topics of this Forum",
// "Group Monitor Topics and Threads of this Forum" => "Group Monitor Topics and Threads of this Forum",
// "Watch for replies" => "Watch for replies",
// "Forum Lock" => "Forum Lock",
// "Unarchive" => "Unarchive",
// "posts in this forum" => "posts in this forum",
// "Filter Posts" => "Filter Posts",
// "Posts Filtering" => "Posts Filtering",
// "Last post date" => "Last post date",
// "Show archived posts" => "Show archived posts",
// "Containing posts by" => "Containing posts by",
// "Me" => "Me",
// "Posts with no replies" => "Posts with no replies",
// "Archived" => "Archived",
// "Topic List" => "Topic List",
// "Stop Monitor" => "Stop Monitor",
// "Pending" => "Pending",
// "There was an error connecting to your e-mail account" => "There was an error connecting to your e-mail account",
// "Add a new" => "Add a new",
// "Edit this" => "Edit this",
// " mail account" => " mail account",
// "Group (shared mail inbox) or private" => "Group (shared mail inbox) or private",
// "This will be a group mail account" => "This will be a group mail account",
// "This will be a personal mail account" => "This will be a personal mail account",
// "Auto-refresh page time" => "Auto-refresh page time",
// "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission" => "You do not have the correct permissions to Add or Edit a webmail account. <BR />Please contact your administrator and ask for \"admin_personal_webmail\" or \"admin_group_webmail\" permission",
// "Personal e-mail accounts" => "Personal e-mail accounts",
// "Click to activate" => "Click to activate",
// "This is the active account" => "This is the active account",
// "Group e-mail accounts" => "Group e-mail accounts",
// "Show Unread" => "Show Unread",
// "Show Flagged" => "Show Flagged",
// "Refresh now" => "Refresh now",
// "Group messages" => "Group messages",
// "unFlagged" => "unFlagged",
// "Group Monitor on Structure" => "Group Monitor on Structure",
// "Jump to Content" => "Jump to Content",
// "Latitude" => "Latitude",
// "Longitude" => "Longitude",
// "Word Limit Exceeded" => "Word Limit Exceeded",
// "Word Count" => "Word Count",
// "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator" => "Format: x,y,zoom where x is the longitude, and y is the latitude. Zoom is between 0(view Earth) and 19. You can use <a href=\"tiki-gmap_locator.php?for=item&amp;itemId={\$item.itemId}&amp;trackerId={\$item.trackerId}&amp;fieldId={\$field_value.fieldId}\">{tr}Google Map Locator",
// "Your vote" => "Your vote",
// "Click to vote for this value" => "Click to vote for this value",
// "You have ever subscribed" => "You have ever subscribed",
// "You have not yet subscribed" => "You have not yet subscribed",
// "Unsubscribe" => "Unsubscribe",
// "Google Maps is not enabled" => "Google Maps is not enabled",
// "The main text of this page is available in the following languages" => "The main text of this page is available in the following languages",
// "Missing or incorrect trackerId parameter for the plugin" => "Missing or incorrect trackerId parameter for the plugin",
// "list" => "list",
// "Reinstall" => "Reinstall",
// "Undecided" => "Undecided",
// "Subscribe to a group" => "Subscribe to a group",
// "Toggle display" => "Toggle display",
// "Separate multiple usernames with a comma (&nbsp;,&nbsp;)" => "Separate multiple usernames with a comma (&nbsp;,&nbsp;)",
// "Permission denied you cannot view the Tiki calendar" => "Permission denied you cannot view the Tiki calendar",
// "%s set" => "%s set",
// "%s unset" => "%s unset",
// "Help on Configuration Sections" => "Help on Configuration Sections",
// "Intertiki settings" => "Intertiki settings",
// "Freetags settings" => "Freetags settings",
// "Look & Feel" => "Look & Feel",
// "Configure Site Ads and Banners" => "Configure Site Ads and Banners",
// "Current version is up to date : <b>%s</b>" => "Current version is up to date : <b>%s</b>",
// "A new %s  major release branch is available" => "A new %s  major release branch is available",
// "Must specify actionId" => "Must specify actionId",
// "Users Contributions: Addition" => "Users Contributions: Addition",
// "%s Contributions: Addition" => "%s Contributions: Addition",
// "Users Contributions: Suppression" => "Users Contributions: Suppression",
// "%s Contributions: Suppression" => "%s Contributions: Suppression",
// "Total Contributions Addition per Day" => "Total Contributions Addition per Day",
// "Total Contributions Addition per Week" => "Total Contributions Addition per Week",
// "Total Contributions Suppression per Day" => "Total Contributions Suppression per Day",
// "Total Contributions Suppression per Week" => "Total Contributions Suppression per Week",
// "Total Contributions: Addition" => "Total Contributions: Addition",
// "Total Contributions: Suppression" => "Total Contributions: Suppression",
// "Groups Contributions: Addition" => "Groups Contributions: Addition",
// "Groups Contributions: Suppression" => "Groups Contributions: Suppression",
// "ivory" => "ivory",
// "whitesmoke" => "whitesmoke",
// "beige" => "beige",
// "You can not create a category with a name already existing at this level" => "You can not create a category with a name already existing at this level",
// "The file does not have the required header" => "The file does not have the required header",
// "moved %d images, %d errors occured" => "moved %d images, %d errors occured",
// "a timeout occured. Hit the reload button to move the rest" => "a timeout occured. Hit the reload button to move the rest",
// "Test Image" => "Test Image",
// "Path to mapfiles is invalid" => "Path to mapfiles is invalid",
// "If you use apache, you need a .htaccess file to have this feature working" => "If you use apache, you need a .htaccess file to have this feature working",
// "Error opening uploaded file" => "Error opening uploaded file",
// "You need to provide a username or an email" => "You need to provide a username or an email",
// "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them" => "setting the xbithack option is unsafe. Depending on the file handling of your webserver and your tiki settings, it may be possible that a attacker can upload scripts to file gallery and execute them",
// "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html" => "The \"Snarf Wikiplugin\" is activated. It can be used by wiki editors to include pages from the local network and via regex replacement create any html",
// "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement" => "The \"Regex Wikiplugin\" is activated. It can be used by wiki editors to create any html via regex replacement",
// "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory" => "The \"Lsdir Wikiplugin\" is activated. It can be used by wiki editors to view the contents of any directory",
// "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts" => "The \"Bloglist Wikiplugin\" is activated. It can be used by wiki editors to disclose private blog posts",
// "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"iframe Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"js Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc" => "The \"JQ Wikiplugin\" is activated. It can be used by wiki editors to use Javascript, which can be used to do all kind of nasty things like cross site scripting attacks, etc",
// "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks" => "The \"Redirect Wikiplugin\" is activated. It can be used by wiki editors for cross site scripting attacks",
// "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)" => "The \"Module Wikiplugin\" is activated. It can be used by wiki editors to add modules which permit to access information (see module list)",
// "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users" => "The \"Userlist Wikiplugin\" is activated. It can be used by wiki editors to display the list of users",
// "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users" => "The \"Usercount Wikiplugin\" is activated. It can be used by wiki editors to display a count of the number of users",
// "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands" => "The \"SQL Wikiplugin\" is activated. It can be used by wiki editors to execute SQL commands",
// "Path disclosure" => "Path disclosure",
// "Path disclosure through error message" => "Path disclosure through error message",
// "Are you sure you want to remove this topic" => "Are you sure you want to remove this topic",
// "Are you sure you want to remove this topic AND all the articles related" => "Are you sure you want to remove this topic AND all the articles related",
// "Tracker does not allow attachments" => "Tracker does not allow attachments",
// "Remove permission: %s on %s" => "Remove permission: %s on %s",
// "The description is mandatory as it is used as mail subject" => "The description is mandatory as it is used as mail subject",
// "User login or email is required" => "User login or email is required",
// "User does not exist on master" => "User does not exist on master",
// "User login contains invalid characters" => "User login contains invalid characters",
// "Deleted account %s" => "Deleted account %s",
// "Login contains invalid characters" => "Login contains invalid characters",
// "approved by " => "approved by ",
// "This function is only for staging pages" => "This function is only for staging pages",
// "Permission denied you cannot approve staging pages" => "Permission denied you cannot approve staging pages",
// "Approved page was last saved after most recent staging edit" => "Approved page was last saved after most recent staging edit",
// "Unassign perm %s from group %s" => "Unassign perm %s from group %s",
// "File Galleries Admin Panel" => "File Galleries Admin Panel",
// "Could not read file %s" => "Could not read file %s",
// "Could not write to file %s" => "Could not write to file %s",
// "File %s upload failed" => "File %s upload failed",
// "Upload was successful" => "Upload was successful",
// "File %s removed from Batch directory" => "File %s removed from Batch directory",
// "Impossible to remove file %s from Batch directory" => "Impossible to remove file %s from Batch directory",
// "Incorrect directory chosen for batch upload of files" => "Incorrect directory chosen for batch upload of files",
// "Tiki RSS feed for blog: " => "Tiki RSS feed for blog: ",
// "Last modifications to the blog" => "Last modifications to the blog",
// "Nothing tagged yet" => "Nothing tagged yet",
// "You must clear your browser cache" => "You must clear your browser cache",
// "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>" => "You need to <a href=\"tiki-admin_calendars.php\">create a calendar</a>",
// "Permission denied you can not view this page" => "Permission denied you can not view this page",
// "Tiki RSS feed for calendars" => "Tiki RSS feed for calendars",
// "Invalid old password or unknown user" => "Invalid old password or unknown user",
// "Invalid request. Expecting channels array" => "Invalid request. Expecting channels array",
// "Missing channel name" => "Missing channel name",
// "Authentication required" => "Authentication required",
// "One of the requested channels cannot be requested. It does not exist or permission is denied" => "One of the requested channels cannot be requested. It does not exist or permission is denied",
// "One of the install profiles could not be obtained" => "One of the install profiles could not be obtained",
// "Problem. Try to log in again to receive new confirmation instructions" => "Problem. Try to log in again to receive new confirmation instructions",
// "You cannot download this file right now. Your score is low or file limit was reached" => "You cannot download this file right now. Your score is low or file limit was reached",
// "Error : The file %s doesn't exist" => "Error : The file %s doesn't exist",
// "Translation in progress" => "Translation in progress",
// "Page is a staging copy. Translation must begin from the approved copy" => "Page is a staging copy. Translation must begin from the approved copy",
// "Not enable for this type of object" => "Not enable for this type of object",
// "Can't parse HTML data - no grammar file" => "Can't parse HTML data - no grammar file",
// "The translation set already contains a page in this language" => "The translation set already contains a page in this language",
// "Remove archive: " => "Remove archive: ",
// "Remove file gallery: " => "Remove file gallery: ",
// "Form error - no import method selected for some reason" => "Form error - no import method selected for some reason",
// "Form error - no server-side filename entered for selected import method" => "Form error - no server-side filename entered for selected import method",
// "Last replied forum topics" => "Last replied forum topics",
// "Not supported yet" => "Not supported yet",
// "Canceled friendship request with %s" => "Canceled friendship request with %s",
// "I have refused your friendship request" => "I have refused your friendship request",
// "I have canceled my friendship request" => "I have canceled my friendship request",
// "Role name cannot be empty" => "Role name cannot be empty",
// "Activity name cannot be empty" => "Activity name cannot be empty",
// "Invalid source path" => "Invalid source path",
// "A start activity requires a name for the instance" => "A start activity requires a name for the instance",
// "Back to item" => "Back to item",
// "No valid renderer found. GD or PDFLib required" => "No valid renderer found. GD or PDFLib required",
// "Only the administrator can upload language files" => "Only the administrator can upload language files",
// "Operations executed successfully" => "Operations executed successfully",
// "Page saved (version %d)" => "Page saved (version %d)",
// "Error writing in the databse: \$query" => "Error writing in the databse: \$query",
// "Delete comments" => "Delete comments",
// "Approved Status" => "Approved Status",
// "Queued" => "Queued",
// "The file is already locked by %s" => "The file is already locked by %s",
// "Remove file: " => "Remove file: ",
// "Warning: Empty file" => "Warning: Empty file",
// "Please re-upload your file" => "Please re-upload your file",
// "Permission denied you can edit this file" => "Permission denied you can edit this file",
// "Cannot read the file" => "Cannot read the file",
// "Upload was not successful. Duplicate file content" => "Upload was not successful. Duplicate file content",
// "Unable to contact remote server" => "Unable to contact remote server",
// "More than %d unsuccessful login attempts have been made" => "More than %d unsuccessful login attempts have been made",
// "An email has been sent to you with the instructions to follow" => "An email has been sent to you with the instructions to follow",
// "Your default nickname is already in use. A new one has to be selected" => "Your default nickname is already in use. A new one has to be selected",
// "The selected account is not associated with your identity" => "The selected account is not associated with your identity",
// "unknown action" => "unknown action",
// "Authentication method is not OpenID" => "Authentication method is not OpenID",
// "Invalid password" => "Invalid password",
// "Account disabled" => "Account disabled",
// "You must use the right case for your user name" => "You must use the right case for your user name",
// "Feature Ajax Disabled. Please ask your site administrator to enable" => "Feature Ajax Disabled. Please ask your site administrator to enable",
// "You must first setup MapServer" => "You must first setup MapServer",
// "invalid mapfile name" => "invalid mapfile name",
// "An error as occured with the mapfile" => "An error as occured with the mapfile",
// "Please create a directory named '.\$prefs['map_path'].' to hold your map files" => "Please create a directory named '.\$prefs['map_path'].' to hold your map files",
// "map edit" => "map edit",
// "No page provided" => "No page provided",
// "Page \"%0\" does not exist" => "Page \"%0\" does not exist",
// "Are you sure you want to delete this note" => "Are you sure you want to delete this note",
// "Permission denied you cannot assign permissions for this object" => "Permission denied you cannot assign permissions for this object",
// "Permission denied you cannot view the source of this page" => "Permission denied you cannot view the source of this page",
// "Missing object list type argument" => "Missing object list type argument",
// "Index" => "Index",
// "Index (' . \$code . " => "Index (' . \$code . ",
// "Please enter a valid %s.  No spaces, more than %d characters and contain %s" => "Please enter a valid %s.  No spaces, more than %d characters and contain %s",
// "This is not a valid mail adress" => "This is not a valid mail adress",
// "mail adress" => "mail adress",
// "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password" => "Please contact the Administrator if you do not get the email, or if there is an issue with resetting the password",
// "You cannot rename staging pages. Please rename the approved page instead" => "You cannot rename staging pages. Please rename the approved page instead",
// "Cannot rename page because maybe new staging page name already exists" => "Cannot rename page because maybe new staging page name already exists",
// "invalid email" => "invalid email",
// "Notice: this variable may not be empty" => "Notice: this variable may not be empty",
// "Notice: invalid variable value" => "Notice: invalid variable value",
// "Permission denied you cannot remove this sheet" => "Permission denied you cannot remove this sheet",
// "You do not have permission to edit messages \$owner" => "You do not have permission to edit messages \$owner",
// "Clean the sql logs" => "Clean the sql logs",
// "Report to the webmaster" => "Report to the webmaster",
// "Batch file processed" => "Batch file processed",
// "A new page is created in a language" => "A new page is created in a language",
// "Language watch" => "Language watch",
// "Permission denied: you cannot view this blog post while it is marked private" => "Permission denied: you cannot view this blog post while it is marked private",
// "You must suggest a question; please try again" => "You must suggest a question; please try again",
// "Incorrect thread" => "Incorrect thread",
// "The connection was OK" => "The connection was OK",
// "Tidy Extension not present" => "Tidy Extension not present",
// "The TikiTests Replay File is Empty" => "The TikiTests Replay File is Empty",
// "The TikiTests Replay File has an error" => "The TikiTests Replay File has an error",
// "TikiTest List" => "TikiTest List",
// "TikiTest Record" => "TikiTest Record",
// "You need one of the extension pecl HTTP or Curl to replay the TikiTest" => "You need one of the extension pecl HTTP or Curl to replay the TikiTest",
// "The TikiTest Replay File is Empty" => "The TikiTest Replay File is Empty",
// "TikiTest Replay" => "TikiTest Replay",
// ### end of untranslated words
// ###

// ###
// ### start of possibly untranslated words
// ###

"Re:" => "Re:",
"ID" => "ID",
"Albania" => "Albania",
"Algeria" => "Algeria",
"Angola" => "Angola",
"Antigua" => "Antigua",
"Argentina" => "Argentina",
"Bahamas" => "Bahamas",
"Bangladesh" => "Bangladesh",
"Barbados" => "Barbados",
"Bermuda" => "Bermuda",
"Brunei" => "Brunei",
"Chile" => "Chile",
"China" => "China",
"Costa Rica" => "Costa Rica",
"Cuba" => "Cuba",
"El Salvador" => "El Salvador",
"Fiji" => "Fiji",
"Guam" => "Guam",
"Guatemala" => "Guatemala",
"Haiti" => "Haiti",
"Honduras" => "Honduras",
"Iraq" => "Iraq",
"Ireland" => "Ireland",
"Israel" => "Israel",
"Jamaica" => "Jamaica",
"Kuwait" => "Kuwait",
"Malta" => "Malta",
"Nepal" => "Nepal",
"Panama" => "Panama",
"Portugal" => "Portugal",
"Quatar" => "Quatar",
"Russia" => "Russia",
"Samoa" => "Samoa",
"Slovakia" => "Slovakia",
"Slovenia" => "Slovenia",
"Sri Lanka" => "Sri Lanka",
"Taiwan" => "Taiwan",
"Togo" => "Togo",
"Tonga" => "Tonga",
"Venezuela" => "Venezuela",
"Zambia" => "Zambia",
"Português" => "Português",
"Wiki" => "Wiki",
"Blogs" => "Blogs",
"FAQs" => "FAQs",
"blog" => "blog",
"faq" => "faq",
"WikiDiff::apply: line count mismatch: %s != %s" => "WikiDiff::apply: line count mismatch: %s != %s",
"WikiDiff::_check: failed" => "WikiDiff::_check: failed",
"WikiDiff::_check: edit sequence is non-optimal" => "WikiDiff::_check: edit sequence is non-optimal",
"WikiDiff Okay: LCS = %s" => "WikiDiff Okay: LCS = %s",
"Link" => "Link",
"Blog" => "Blog",
"Downloads" => "Downloads",
"Login" => "Login",
"FAQ" => "FAQ",
"min" => "min",
"wiki" => "wiki",
"faqs" => "faqs",
"blogs" => "blogs",
"index" => "index",
"Item" => "Item",
"jscalendar" => "jscalendar",
"~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~" => "~np~{ARTICLE(Field=>[,Id=>])}{ARTICLE}~/np~",
"Cookie" => "Cookie",
"Copyright" => "Copyright",
"Desc" => "Desc",
"Img" => "Img",
"Id" => "Id",
"Original" => "Original",
"id" => "id",
"desc" => "desc",
"Download" => "Download",
"Total" => "Total",
"RSS Wiki" => "RSS Wiki",
"RSS Blogs" => "RSS Blogs",
"Ip" => "Ip",
"Normal" => "Normal",
"CC" => "CC",
"BCC" => "BCC",
"1" => "1",
"2" => "2",
"3" => "3",
"4" => "4",
"5" => "5",
"Cache" => "Cache",
"Links" => "Links",
"Menus" => "Menus",
"QuickTags" => "QuickTags",
"Chat" => "Chat",
"Banners" => "Banners",
"Cookies" => "Cookies",
"Mail-in" => "Mail-in",
"phpinfo" => "phpinfo",
"login" => "login",
"Sites" => "Sites",
"Menu" => "Menu",
"Wiki RSS" => "Wiki RSS",
"Blogs RSS" => "Blogs RSS",
"Del" => "Del",
"[-]" => "[-]",
"Trackback pings" => "Trackback pings",
"URI" => "URI",
"RSS" => "RSS",
"Webmail" => "Webmail",
"InterTiki" => "InterTiki",
"Rankings" => "Rankings",
"Requires user's information to be public" => "Requires user's information to be public",
"E-mail" => "E-mail",
"Experimental" => "Experimental",
"PHPLayers" => "PHPLayers",
"Shadowbox" => "Shadowbox",
"Mootools" => "Mootools",
"Ajax" => "Ajax",
"Workflow" => "Workflow",
"pixels" => "pixels",
"Unix" => "Unix",
"Windows" => "Windows",
"IP" => "IP",
"Wysiwyg" => "Wysiwyg",
"PEAR::Auth" => "PEAR::Auth",
"Editor" => "Editor",
"Webmaster" => "Webmaster",
"LRU list purging rate" => "LRU list purging rate",
"Plugins" => "Plugins",
"AutoLinks" => "AutoLinks",
"dls" => "dls",
"Similar" => "Similar",
"which apply to more than one section" => "which apply to more than one section",
"DSN" => "DSN",
"bytes" => "bytes",
"x" => "x",
"Loc" => "Loc",
"Cat" => "Cat",
"Lang" => "Lang",
"Prio" => "Prio",
"h" => "h",
"Ranks" => "Ranks",
"CMS" => "CMS",
"cookie" => "cookie",
"Ver" => "Ver",
"Coms" => "Coms",
"..." => "...",
"Regex" => "Regex",
"wiki-get" => "wiki-get",
"wiki-put" => "wiki-put",
"wiki-append" => "wiki-append",
"phpLayersMenus" => "phpLayersMenus",
"PDF" => "PDF",
"UTF-8" => "UTF-8",
"ISO-8859-1" => "ISO-8859-1",
"bcc" => "bcc",
"powered by" => "powered by",
"TikiWiki CMS/Groupware" => "TikiWiki CMS/Groupware",
"popup" => "popup",
"+" => "+",
"URL:" => "URL:",
"editor" => "editor",
"tagline" => "tagline",
"%" => "%",
"normal" => "normal",
"Int" => "Int",
"Manual" => "Manual",
"#" => "#",
"inter" => "inter",
"val" => "val",
"If:SetNextact" => "If:SetNextact",
"Proc" => "Proc",
"auto" => "auto",
"int" => "int",
"MultiTiki" => "MultiTiki",
"msgs" => "msgs",
"Prefs" => "Prefs",
"Newsgroup" => "Newsgroup",
"Slides" => "Slides",
"Site" => "Site",
"tikiwiki.org" => "tikiwiki.org",
"auto-link urls" => "auto-link urls",
"eek" => "eek",
"pvs" => "pvs",
"Mb" => "Mb",
"Weblogs" => "Weblogs",
"Pos" => "Pos",
"Dif" => "Dif",
"Emot" => "Emot",
"pts" => "pts",
"TOP" => "TOP",
"%H:%M %Z" => "%H:%M %Z",
"tiki-mobile.php" => "tiki-mobile.php",
"unicode" => "unicode",
// ###
// ### end of possibly untranslated words
// ###

"This feature is disabled" => "Este recurso está desabilitado",
"Permission denied you cannot view pages" => "Permissão negada: você não pode ver páginas",
"Cookies must be allowed to vote" => "Você precisa habilitar cookies no seu navegador para poder votar",
"This forum is flat and doesn't allow replies to other replies" => "Esse fórum não permite respostas às respostas",
"This script cannot be called directly" => "Este script não pode ser chamado diretamente",
"The copyright management feature is not enabled." => "O recurso de gerenciamento de direitos autorais está desabilitado.",
"Copyright management" => "Gereciamento de copyright",
"No page indicated" => "Nenhuma página indicada",
"You must supply all the information, including title and year." => "Você precisa fornecer toda a informação, incluindo título e ano.",
"You do not have permission to use this feature" => "Você não tem permissão para usar esta funcionalidade",
"This feature is for admins only" => "Este recurso é apenas para administradores",
"Type" => "Tipo",
"Name" => "Nome",
"Description" => "Descrição",
"Size" => "Tamanho",
"Created" => "Criado em",
"Uploaded" => "Enviado",
"Last Modified" => "Última Modificação",
"Creator" => "Criador",
"Author" => "Autor",
"Last editor" => "Último editor",
"Comment" => "Comentário",
"Files" => "Arquivos",
"Hits" => "Visitas",
"Locked by" => "Travado por",
"Path" => "Caminho",
"Default View" => "Visualização Padrão",
"Afghanistan" => "Afeganistão",
"American Samoa" => "Samoa  Americana",
"Armenia" => "Arménia",
"Australia" => "Austrália",
"Austria" => "Áustria",
"Bahrain" => "Barém",
"Belarus" => "Bielorrúsia",
"Belgium" => "Bélgica",
"Bolivia" => "Bolívia",
"Brazil" => "Brasil",
"Cameroon" => "Camarões",
"Canada" => "Canadá",
"Cayman Islands" => "Ilhas  Cayman",
"Colombia" => "Colômbia",
"Cook Islands" => "Ilhas Cook",
"Croatia" => "Croácia",
"Cyprus" => "Chipre",
"Czech Republic" => "República Tcheca",
"Denmark" => "Dinamarca",
"Dominican Republic" => "Republica Dominicana",
"Ecuador" => "Equador",
"Egypt" => "Egito",
"Estonia" => "Estónia",
"Ethiopia" => "Etiópia",
"Europe" => "Europa",
"Federated States of Micronesia" => "Estados Federados da Micronésia",
"Finland" => "Finlândia",
"France" => "França",
"French Guiana" => "Guiana Francesa",
"French Polynesia" => "Polinésia Francesa",
"Germany" => "Alemanha",
"Greece" => "Grécia",
"Guinea Bissau" => "Guiné Bissao",
"Guyana" => "Guiana",
"Hungary" => "Hungria",
"Iceland" => "Islândia",
"India" => "Índia",
"Indonesia" => "Indonésia",
"Iran" => "Irã",
"Italy" => "Italia",
"Ivory Coast" => "Costa do Marfim",
"Japan" => "Japão",
"Jordan" => "Jordânia",
"Kazakstan" => "Cazaquistão",
"Kenya" => "Quênia",
"Latvia" => "Letônia",
"Lebanon" => "Líbano",
"Lithuania" => "Lituânia",
"Luxemburg" => "Luxemburgo",
"Macedonia" => "Macedônia",
"Malaysia" => "Malásia",
"Marshall Islands" => "Ilhas Marshall",
"Mauritius" => "Mauricius",
"Mexico" => "México",
"Monaco" => "Mônaco",
"Mongolia" => "Mongólia",
"Morocco" => "Marrócos",
"Mozambique" => "Moçambique",
"Netherlands" => "Holanda",
"New Caledonia" => "Nova Caledonia",
"New Zealand" => "Nova Zelândia",
"Nicaragua" => "Nicarágua",
"Niger" => "Níger",
"Nigeria" => "Nigéria",
"None" => "Nenhum",
"North Korea" => "Coréia do Norte",
"Norway" => "Noruéga",
"Other" => "Outro",
"Pakistan" => "Paquistão",
"Palestine" => "Palestina",
"Papua New Guinea" => "Papua Nova Guiné",
"Paraguay" => "Paraguai",
"Peru" => "Perú",
"Poland" => "Polonia",
"Puerto Rico" => "Porto Rico",
"Romania" => "Romênia",
"Saudi Arabia" => "Arábia Saudita",
"Singapore" => "Singapura",
"Solomon Islands" => "Ilhas Salomão",
"Somalia" => "Somália",
"South Africa" => "África do Sul",
"South Korea" => "Coréia do Sul",
"Spain" => "Espanha",
"St Vincent Grenadines" => "São Vicente e Granadinas",
"Sudan" => "Sudão",
"Surinam" => "Suriname",
"Sweden" => "Suécia",
"Switzerland" => "Suíça",
"Thailand" => "Tailândia",
"Timor-Leste" => "Timor Leste",
"Trinidad Tobago" => "Trinidá e Tobago",
"Tunisia" => "Tunísia",
"Turkey" => "Turquía",
"Ukraine" => "Ucrânia",
"United Arab Emirates" => "Emirados Árabes Unidos",
"United Kingdom" => "Reino Unido",
"United States" => "Estados Unidos",
"Uruguay" => "Uruguai",
"Vatican" => "Vaticano",
"Wales" => "País de Gales",
"World" => "Mundo",
"Yugoslavia" => "Iugoslávia",
"Zimbabwe" => "Zimbábue",
"Text_Wiki libraries need to be installed. Please see http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter" => "Bibliotecas \"Text_Wiki\" precisam ser instaladas. Por favor, veja http://dev.tikiwiki.org/MediaWiki+to+TikiWiki+converter",
"MySQL classic (mysql)" => "MySQL clássico (mysql)",
"Email address not valid, test mail not sent" => "Endereço de e-mail inválido, o e-mail de teste não foi enviado",
"Email address empty and \"copy\" checkbox not set, test mail not sent" => "O endereço de e-mail está vazio e o checkbox \"cópia\" não está marcado, o e-mail de teste não foi enviado",
"Test mail from Tiki installer " => "Teste de e-mail do instalador do Tiki ",
"Congratulations!\n\nYour server can send emails.\n\n" => "Parabéns!\n\nSeu servidor pode enviar e-mails.\n\n",
"Arabic" => "Arábico",
"Catalan" => "Catalão",
"Simplified Chinese" => "Chinês Simplificado",
"Chinese" => "Chinês",
"Czech" => "Theco",
"Danish" => "Holandês",
"German" => "Alemão",
"English" => "Inglês",
"English British" => "Inglês Britânico",
"Spanish" => "Espanhol",
"Greek" => "Grego",
"French" => "Francês",
"Hebrew" => "Hebreu",
"Croatian" => "Croata",
"Italian" => "Italiano",
"Japanese" => "Japonês",
"Korean" => "Coreano",
"Hungarian" => "Hungaro",
"Dutch" => "Dinamarquês",
"Norwegian" => "Norueguês",
"Polish" => "Polonês",
"Brazilian Portuguese" => "Português do Brasil",
"Russian" => "Russo",
"Pijin Solomon" => "Salomão de Pijin",
"Slovak" => "Eslovaco",
"Serbian" => "Sérvio",
"Serbian Latin" => "Latim Sérvio",
"Swedish" => "Sueco",
"Tuvaluan" => "Tuvaluano",
"Traditional Chinese" => "Chinês Tradicional",
"Ukrainian" => "Ucraniano",
"This instance of activity is already complete" => "Essa instância já foi completada",
"Fatal error: cannot execute automatic activity \$activityId" => "Erro fatal: não é possível executar a atividade automática \$activityId",
"Fatal error: setting next activity to an unexisting activity" => "Erro fatal: configurando a próxima atividade para uma atividade inexistente",
"Fatal error: nextActivity does not match any candidate in autorouting switch activity" => "Erro fatal: PróximaAtividade não combina com qualquer chave de atividade candidata",
"Fatal error: non-deterministic decision for autorouting activity" => "Erro fatal: nenhuma determinação para decisão de atividade de auto-rotação",
"Fatal error: trying to send an instance to an activity but no transition found" => "Erro fatal: tentando enviar uma instância para uma atividade mas nenhuma transição foi encontrada",
"Cannot add transition only split activities can have more than one outbound transition" => "Não é possível adicionar transição. Somente divisão de atividades podem ter mais que uma transição de saída",
"Circular reference found some activity has a transition leading to itself" => "Referência circular encontrou alguma transição chegando para si mesma",
"Process does not have a start activity" => "Processo não possui uma atividade inicial",
"Process does not have exactly one end activity" => "Processo não possui exatamente um fim de atividade",
"End activity is not reachable from start activity" => "Fim da atividade não é alcançável pelo início da atividade",
"Activity" => "Atividade",
"is interactive but has no role assigned" => "é interativo mas não possui parte designada",
"is non-interactive and non-autorouted but has no role assigned" => "é não-interativo e não roteado mas não possui parte designada",
"is standalone but has transitions" => "é standalone mas tem transições",
"Role" => "Perfil",
"is not mapped" => "não está mapeado",
"Activity '.\$res['name'].' is standalone and is using the \$instance object" => "Atividade '.\$res['name'].' é standalone e está usando o objeto \$instance",
"Activity '.\$res['name'].' is interactive so it must use the \$instance->complete() method" => "Atividade '.\$res['name'].' é interativa então deve usar o método \$instance->complete()",
"Activity '.\$res['name'].' is non-interactive so it must not use the \$instance->complete() method" => "Atividade '.\$res['name'].' é não-interativa então deve usar o método \$instance->complete()",
"Activity '.\$res['name'].' is switch so it must use \$instance->setNextActivity(\$actname) method" => "Atividade '.\$res['name'].' é chaveada então deve usar o método \$instance->setNextActivity(\$actname)",
"Process %d has been activated" => "Processo %d foi ativado",
"Process %d has been deactivated" => "Processo %d foi desativado",
"Process %s %s imported" => "Processo %s %s importado",
"Process %s removed" => "Processo %s removido",
"Process %s has been updated" => "Processo %s foi atualizado",
"Process %s has been created" => "Processo %s foi criado",
"points" => "pontos",
"newest" => "mais novo",
"oldest" => "mais antigo",
"on left side" => "no lado esquerdo",
"on center" => "no centro",
"on right side" => "no lado direito",
"Disabled" => "Desabilitado",
"Plain text" => "Texto não formatado",
"Link to user information" => "Link para informações do usuário",
"User avatar" => "Fotografia do usuário",
"Creation date (desc)" => "Data de criação (desc)",
"Last modification date (desc)" => "última data de modificação (desc)",
"Blog title (asc)" => "Título do Blog (asc)",
"Number of posts (desc)" => "Número de mensagens (desc)",
"Visits (desc)" => "Visitas (desc)",
"Activity (desc)" => "Atividade (desc)",
"Top bar" => "Barra superior",
"Bottom bar" => "Barra inferior",
"no cache" => "sem cache",
"minute" => "minuto",
"minutes" => "minutos",
"hour" => "hora",
"hours" => "horas",
"as Creator &amp; Last Editor" => "como criador &amp; Último editor",
"Business style" => "Estilo de negócios",
"Collaborative style" => "Estilo colaborativo",
"Page last modified on" => "Última modificação em",
"no (disabled)" => "não (disabilitado)",
"|| for rows" => "|| para linhas",
"<return> for rows" => "\n para linhas",
"Only with last version" => "Apenas com a última versão",
"Any 2 versions" => "2 versões quaisquer",
"complete" => "completo",
"latin" => "latim",
"english" => "inglês",
"Day" => "Dia",
"Week" => "Semana",
"Month" => "Mês",
"Quarter" => "Bimestre",
"Semester" => "Semestre",
"Year" => "Ano",
"Saturday" => "Sábado",
"Sunday" => "Domingo",
"Monday" => "Segunda-feira",
"Depends user language" => "Depende do idioma do usuário",
"No error reporting" => "Não reportar erros",
"Report all PHP errors" => "Reportar todos os erros de PHP",
"Report all errors except notices" => "Reportar todos os erros, com exceção das notícias",
"Creation Date (asc)" => "Data de criação (crescente)",
"Creation Date (desc)" => "Data de criação (desc)",
"Topics (desc)" => "Assuntos (desc)",
"Threads (desc)" => "Seqüências (desc)",
"Last post (desc)" => "Última mensagem (desc)",
"Name (desc)" => "Nome (desc)",
"Name (asc)" => "Nome (asc)",
"Score ascending" => "Pontuação crescente",
"Score descending" => "Pontuação decrescente",
"Name ascending" => "Nome crescente",
"Name descending" => "Nome decrescente",
"Login ascending" => "Login crescente",
"Login descending" => "Login decrescente",
"replace current window" => "substituir a janela atual",
"new window" => "nova janela",
"inline frame" => "frame interno",
"Each day" => "Cada dia",
"Each week" => "Cada semana",
"Each month" => "Cada mês",
"5 minutes" => "Após 5 minutos",
"15 minutes" => "15 minuto",
"30 minutes" => "30 minuto",
"1 hour" => "1 hora",
"2 hours" => "2 horas",
"10 hours" => "10 horas",
"20 hours" => "20 horas",
"1 day" => "Após 1 dia",
"1 week" => "Após 1 semana",
"1 month" => "Após 1 mês",
"1 year" => "1 ano",
"Allow secure (https) login" => "Permitir login seguro (https)",
"Consider we are always in HTTPS, but do not check" => "Considerar que estamos sempre em HTTPS, mas não verifique",
"Require secure (https) login" => "Exigir login seguro (https)",
"Just Tiki" => "Apenas autenticação do Tiki",
"Web Server" => "Servidor Web",
"Tiki and PEAR::Auth" => "Tiki e PEAR::Auth",
"Tiki and PAM" => "Tiki e PAM",
"CAS (Central Authentication Service)" => "CAS (Sistema de Autenticação Central)",
"choose a group ..." => "escolher um grupo ...",
"Registered" => "Registrado",
"Anonymous" => "Anônimo",
"Admins" => "Administradores",
"Never use transition css" => "Nunca usar css de transição",
"Use @version:x.x specified in theme css or none if not specified" => "Usar @version:x.x especificada no tema css ou nenhuma se não for especificada",
"Use @version:x.x specified in theme css or 1.9 if not specified" => "Usar @version:x.x especificada no tema css ou versão 1.9 se não for especificada",
"Use @version:x.x specified in theme css or 2.0 if not specified" => "Usar @version:x.x especificada no tema css ou versão 2.0 se não for especificada",
"LastModif" => "Última modificação",
"Use database to store files" => "Utilizar o banco de dados para armazenar arquivos",
"Use a directory to store files" => "Utilizar um diretório para armazenar arquivos",
"Ascending" => "Crescente",
"Descending" => "Decrescente",
"No forums" => "Nenhum fórum",
"%s enabled" => "%s habilitado",
"\$feature is turned on" => "recurso \$feature está ativado",
"%s disabled" => "%s desabilitado",
"\$feature is turned off" => "recurso \$feature está desativado",
"\$feature set to nothing" => "\$feature definido como nada",
"Permission denied" => "Permissão negada",
"Template %s not registered" => "O Modelo %s não está registrado",
"The file is not a CSV file or has not a correct syntax" => "O arquivo não é um arquivo CSV ou não possui o formato correto",
"Error line: %d" => "Linha do erro: %d",
"locked" => "travada",
"locked by" => "travado por",
"Administration:" => "Administração:",
"All Day" => "O dia inteiro",
"in" => "em",
"continued" => "continuação",
"New Image Uploaded by" => "Nova imagem carregada por",
"New Subscriptions" => "Nova assinatura",
"New Item in Tracker" => "Novo item no acompanhamento",
"tracker" => "acompanhamento",
"by" => "por",
"Image Gallery" => "Imagem da galeria",
"Articles" => "Artigos",
"Forums" => "Fóruns",
"Directory" => "Diretórios",
"File Gallery" => "Galeria de arquivos",
"Quizzes" => "Testes",
"Trackers" => "Acompanhamentos",
"Survey" => "Pesquisa",
"Newsletter" => "Comunicado",
"Charts" => "Gráficos",
"article" => "artigo",
"directory" => "diretório",
"file gallery" => "galeria de arquivos",
"forum" => "fórum",
"image gallery" => "galeria de imagens",
"newsletter" => "comunicado",
"poll" => "enquete",
"quiz" => "teste",
"survey" => "pesquisa",
"wiki page" => "página wiki",
"image" => "imagem",
"calendar" => "calendário",
"Invalid filename (using filters for filenames)" => "Nome inválido de arquivo (usando filtros para nomes de arquivos)",
"Cannot upload this file maximum upload size exceeded" => "Impossível carregar este arquivo: tamanho máximo para arquivo atingido",
"(not registered)" => "(não registrado)",
"You have mistyped the anti-bot verification code; please try again." => "Você digitou errado o código de verificação; por favor tente de novo.",
"Please wait %d secondes between posts" => "Por favor, espere %d segundos entre um post e outro",
"Wrong password. Cannot post comment" => "Senha incorreta. Impossível enviar comentário",
"A contribution is mandatory" => "Uma contribuição é obrigatória",
"You have to enter a title and text" => "Você precisa digitar um título e um texto",
"Invalid Email" => "E-mail inválido",
"Your message has been queued for approval, the message will be posted after a moderator approves it." => "Sua mensagem está aguardando aprovação. A mensagem será postada após aprovação por um moderador.",
"This forum is locked" => "Esse fórum esta bloqueado",
"This thread is locked" => "Essa conversa está bloqueada",
"Those comments are locked" => "Aqueles comentários estão bloqueados",
"text" => "texto",
"Line:" => "Linha:",
"Lines:" => "Linhas:",
"Newsletter subscription information at" => "Informação para inscrição no Boletim em",
"Tiki Link - Insert internal link" => "Tiki Link - Insira um link interno",
"Find" => "Buscar",
"find" => "buscar",
"prev" => "ant",
"Page" => "Página",
"next" => "próx",
"Page name" => "Nome da página",
"Cannot open this file:" => "Não foi possível abrir este arquivo:",
"This is the value of your server's PHP '%s' setting" => "Esse é o valor da configuração '%s' do seu servidor PHP",
"You can check the modifications at : " => "Você pode verificar as modificações em : ",
"Wiki Home" => "Página Inicial Wiki",
"Home" => "Página inicial",
"previous page" => "página anterior",
"next page" => "página posterior",
"posted on" => "enviado em",
"Continue" => "Continuar",
"By:" => "Por:",
"Read" => "Lida",
"List articles" => "Listar artigos",
"Last post" => "Última mensagem",
"Invalid imagename (using filters for filenames)" => "Nome inválido de imagem (usando filtros para nomes de arquivos)",
"Errors detected" => "Erros detectados",
"Upload was not successful" => "Carga interrompida com falha",
"No image yet, sorry." => "Sinto muito, sem nenhuma imagem ainda.",
"Contributions" => "Contribuições",
"No valid ogr2ogr executable" => "Executável ogr2ogr não é válido",
"Could not create \$tdo.mif in data directory" => "Não foi possível criar \$tdo.mif no diretório data",
"Could not create \$tdo.mid in data directory" => "Não foi possível criar \$tdo.mid no diretório data",
"unknown" => "desconhecido",
"User Map Generated in:" => "Mapa do usuário Gerado em:",
"Image Map Generated in:" => "Mapa da imagem Gerado em:",
"NONE" => "NENHUM",
"File %s not found" => "Arquivos %s não encontrados",
"File %s is not a valid archive" => "Arquivo %s não é um arquivo válido",
"Impossible to open %s : %s" => "Impossível abrir %s : %s",
"This poll is closed." => "Esta enquete está fechada.",
"Wiki top pages" => "Páginas Wiki mais populares",
"Most relevant pages" => "Páginas mais relevantes",
"Relevance" => "Relevância",
"Wiki last pages" => "Páginas Wiki recentes",
"Modified" => "Modificado",
"Forums last topics" => "Tópicos recentes nos fóruns",
"Topic date" => "Data do tópico",
"Forums last posts" => "Últimas inserções nos fóruns",
"Forums most read topics" => "Tópicos mais lidos nos fóruns",
"Reads" => "Leituras",
"Forums best topics" => "Melhores tópicos nos fóruns",
"Score" => "Pontuação",
"Forums most visited forums" => "Fóruns mais visitados",
"Visits" => "Visitas",
"Forums with most posts" => "Fóruns com mais mensagens",
"Posts" => "Mensagens",
"Wiki top galleries" => "Galerias Wiki mais populares",
"Wiki top file galleries" => "Galerias de arquivos mais populares",
"Wiki top images" => "Imagens mais populares",
"Wiki top files" => "Arquivos mais populares",
"Wiki last images" => "Imagens mais recentes",
"Upload date" => "Data de carga",
"Wiki last files" => "Arquivos recentes",
"Wiki top articles" => "Artigos mais populares",
"Most visited blogs" => "Blogs mais visitados",
"Most active blogs" => "Blogs mais ativos",
"Blogs last posts" => "Últimas mensagens em blogs",
"Post date" => "Data de envio",
"Wiki top authors" => "Autores de Wiki mais produtivos",
"Pages" => "Páginas",
"Top article authors" => "Autores de artigos mais produtivos",
"The passwords do not match" => "O valor dos campos senha e confirmação de senha devem ser iguais",
"User already exists" => "O usuário já existe",
"Wrong registration code" => "Código de registro incorreto",
"Invalid username" => "Usuário inválido",
"Username is too long" => "Identificador de usuário muito longo",
"Username cannot contain whitespace" => "Identificador de usuário não pode conter espaços",
"Wrong passcode you need to know the passcode to register in this site" => "Código de registro incorreto; você precisa fornecer um código válido para registrar-se neste site",
"Invalid email address. You must enter a valid email address" => "Endereço de email inválido. Você precisa fornecer um endereço de email válido",
"The registration mail can't be sent. Contact the administrator" => "O e-mail para registro não pode ser enviado. Contate o administrador",
"See other user's profile" => "Veja outro perfil de usuário",
"Have your profile seen" => "Mostre o seu perfil para outros",
"Make friends" => "Fazer amigos",
"Receive message" => "Receber mensagem",
"Send message" => "Enviar mensagem",
"Read an article" => "Ler um artigo",
"Publish an article" => "Publicar um artigo",
"Have your article read" => "Mostre seus artigos para outros",
"Create new file gallery" => "Criar nova galeria de arquivos",
"Upload new file to gallery" => "Subir novo arquivo para a galeria",
"Download other user's file" => "Baixar outro arquivo do usuário",
"Have your file downloaded" => "Permita que outros baixem seus arquivos",
"Create a new image gallery" => "Criar nova galeria de imagem",
"Upload new image to gallery" => "Subir um novo arquivo para a galeria",
"See other user's gallery" => "Veja outra galeria do usuário",
"See other user's image" => "Veja outra imagem do usuário",
"Have your gallery seen by other user" => "Mostre sua galeria para outros usuários",
"Have your image seen" => "Mostre sua imagem para outros",
"Create new blog" => "Criar novo blog",
"Post in a blog" => "Postar no blog",
"Read other user's blog" => "Ler o blog de outro usuário",
"Have your blog read" => "Mostre seu blog para outros",
"Create a new wiki page" => "Criar nova página wiki",
"Edit an existing page" => "Editar uma página existente",
"Attach file" => "Anexar um arquivo",
"Tracker" => "Acompanhamento",
"Unknown" => "Desconhecido",
"Trackeritem" => "Item de acompanhamento",
"Image" => "Imagem",
"Article" => "Artigo",
"Directory category" => "Categoria de diretório",
"Forum" => "Fórum",
"Wiki Comment" => "Comentário Wiki",
"Calendar item" => "Item de Calendário",
"Gallery" => "Galeria",
"Blog post" => "Mensagem de blog",
"Tracker item" => "Item do acompanhamento",
"Simple" => "Simples",
"Advanced" => "Advançado",
"Prev" => "Ant",
"Next" => "Próx",
"First {\$params['itemname']}" => "Primeiro {\$params['itemname']}",
"Last {\$params['itemname']}" => "Último {\$params['itemname']}",
"Next {\$params['itemname']}" => "Próximo {\$params['itemname']}",
"Prev {\$params['itemname']}" => "Anterior {\$params['itemname']}",
"Help page:" => "Página de ajuda:",
"Edit Template" => "Editar modelo",
"Admin Feature" => "Administrar Recurso",
"Hide" => "Esconder",
"help" => "auxílio",
"All" => "Todos",
"The text is" => "O texto é",
"character(s) too long - please edit it." => "caracter(es) muito grandes - por favor edite-os.",
"Date Selector" => "Seletor de Data",
"phplayers are not available on this site" => "o recurso phplayers não está disponível neste site",
"Select All" => "Selecionar todos",
"days" => "dias",
"day" => "dia",
"mins" => "min",
"secs" => "s",
"done" => "pronto",
"Text cut here" => "Corte o texto aqui",
"Task" => "Tarefa",
"from" => "de",
"for" => "para",
"Priority" => "Prioridade",
"Start date:" => "Data inicial:",
"End date:" => "Data final:",
"User information - Click for more info" => "Informação do usuário - Clique para saber mais",
"Friend" => "Amigo",
"Last seen on" => "Visto pela última vez em",
"(idle for %s seconds)" => "(inativo por %s segundos)",
"More info about \$other_user" => "Mais informação sobre \$other_user",
"(idle for \$idletime seconds)" => "(inativo por \$idletime segundos)",
"Yes" => "Sim",
"No" => "Não",
"Use this tree to copy the structure" => "Use esta árvore para copiar a estrutura",
"created from structure" => "criar da estrutura",
"Table of contents" => "Tabela de conteúdo",
"You have to make %d choice(s) for the question" => "Você precisa fazer %d escolha(s) para a questão",
"You have to make at least %d choice(s) for the question" => "Você precisa fazer ao menos %d escolha(s) para a questão",
"You have to make less than %d choice(s) for the question" => "Você precisa fazer menos de %d escolha(s) para a questão",
"You have to choose at least %d choice(s) for the question" => "Você precisa escolher ao menos %d escolha(s) para a questão",
"unknown error" => "erro desconhecido",
"You are not logged in" => "Você não está logado(a)",
"Page cannot be found" => "A página não foi encontrada",
"Page '%0' cannot be found" => "A página '%0' não pôde ser encontrada",
"Permission denied you cannot view this section" => "Permissão negada: você não pode ver esta seção",
"For the security of your password direct access to the feed is only available via https" => "Para segurança de sua senha, o acesse direto para o feed é disponível apenas via https",
"An error occured in a database query!" => "Ocorreu um erro em uma <i>query</i> ao banco de dados!",
"Help link" => "Link de Ajuda",
"Help" => "Ajuda",
"You are banned from" => "Você foi banido(a) de",
"quizzes" => "testes",
"forums" => "fóruns",
"games" => "jogos",
"Edit Plugin" => "Editar Plugin",
"Click to edit dynamic variable" => "Clique para editar a variável dinâmica",
"Update variables" => "Atualizar variáveis",
"Edit Section" => "Editar Seção",
"Show" => "Mostrar",
"You are not allowed to upload this type of file." => "Você não tem permissão para subir esse tipo de arquivo.",
"You must select a file." => "Você precisa selecionar um arquivo.",
"Altering database table failed" => "Alterando tabela do banco de dados falhou",
"%d points" => "%d pontos",
"Removed" => "Removido",
"__WARNING__: No such module \$plugin!" => "__ADVERTÊNCIA__: Não existe o módulo \$plugin!",
"at" => "em",
"new" => "novo",
"Create page:" => "Criar página:",
"Unknown language" => "Idioma desconhecido",
"Click here to confirm your action" => "Clique aqui para confirmar sua ação",
"Sea Surfing (CSRF) detected. Operation blocked." => "Detectado um Sea Surfing (CSRF). Operação bloqueada.",
"Rating" => "Nota",
"Item Modification" => "Modificação de Item",
"Item creation" => "Criação de Item",
"Subject" => "Assunto",
"Tracker was modified at " => "Acompanhamento foi modificado em ",
"View the tracker item at:" => "Visualizar item do acompanhamento em:",
"Field is not numeric" => "Campo não é numérico",
"Field is not a link to mp3 in the gallery" => "Campo não é um link para mp3 na galeria",
"Field is not a link to FLV in the gallery" => "Campo não é um link para FLV na galeria",
"Field is not a link to FLV or MP3 in the gallery" => "Campo não é um link para FLV ou MP3 na galeria",
"text field" => "campo texto",
"half column" => "metade da coluna",
"size" => "tamanho",
"prepend" => "acrescentar ao começo",
"append" => "agregar",
"max" => "máximo",
"<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a one-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>samerow,size,prepend,append,max</strong>\n\t\t\t\t<dt>Example: 0,80,\$,,80\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field or checkbox in the same row if a 1 is specified;\n\t\t\t\t<dd><strong>[size]</strong> is the visible length of the field in characters;\n\t\t\t\t<dd><strong>[prepend]</strong> is text that will be displayed before the field;\n\t\t\t\t<dd><strong>[append]</strong> is text that will be displayed just after the field;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Função: Permitir entrada de texto alfanumérico em um campo de uma linha de tamanho arbitrário.\n\t\t\t\t<dt>Uso: <strong>mesma_linha,tamanho,pre_texto,pos_texto,maximo</strong>\n\t\t\t\t<dt>Exemplo: 0,80,\$,,80\n\t\t\t\t<dt>Descrição:\n\t\t\t\t<dd><strong>[mesma_linha]</strong> Vai exibir o próximo campo ou checbox na mesma linha se for definido como 1;\n\t\t\t\t<dd><strong>[tamanho]</strong> é o tamanho de caractéres do campo exibido;\n\t\t\t\t<dd><strong>[pre_texto]</strong> é o texto que será exibido antes do campo;\n\t\t\t\t<dd><strong>[pos_texto]</strong> é o texto que será exibido após o campo;\n\t\t\t\t<dd><strong>[maximo]</strong> é o número máximo de caracteres que podem ser salvos;\n\t\t\t\t<dd>as opções devem aparecer na ordem especificada, separado por virgulas.\n\t\t\t\t</dl>",
"textarea" => "área de texto",
"<dl>\n\t\t\t\t<dt>Function: Allows alphanumeric text input in a multi-line field of arbitrary size.\n\t\t\t\t<dt>Usage: <strong>quicktags,width,height,max,listmax,wordmax</strong>\n\t\t\t\t<dt>Example: 0,80,5,30,200\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[quicktags]</strong> enables quicktags if a 1 is specified;\n\t\t\t\t<dd><strong>[width]</strong> is the width of the box, in chars;\n\t\t\t\t<dd><strong>[height]</strong> is the number of visible lines in the box;\n\t\t\t\t<dd><strong>[max]</strong> is the maximum number of characters that can be saved;\n\t\t\t\t<dd><strong>[listmax]</strong> is the maximum number of characters that are displayed in list mode;\n\t\t\t\t<dd><strong>[wordmax]</strong> will alert if word count exceeded with a positive number (1+) or display a word count with a negative number (-1);\n\t\t\t\t<dd>multiple options must appear in the order specified, separated by commas.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Função: Permitir a entrada de texto alfanumérico em campos multi-linha de tamanho arbitrário.\n\t\t\t\t<dt>Uso: <strong>etiquetas,largura,altura,maximo,maximo_lista,maximo_palavra</strong>\n\t\t\t\t<dt>Exemplo: 0,80,5,30,200\n\t\t\t\t<dt>Descrição:\n\t\t\t\t<dd><strong>[etiquetas]</strong> habilita etiquetas se for definido como 1;\n\t\t\t\t<dd><strong>[largura]</strong> é a largura da caixa em caracteres;\n\t\t\t\t<dd><strong>[altura]</strong> é o número de linhas visíveis na caixa de texto;\n\t\t\t\t<dd><strong>[maximo]</strong> é o número máximo de caracteres que podem ser salvos;\n\t\t\t\t<dd><strong>[maximo_lista]</strong> é o número máximo de caracteres que são exibidos no modo lista;\n\t\t\t\t<dd><strong>[maximo_palavra]</strong> alertará se o número de palavras exceder com um número positivo (1+) ou exibe uma contagem de palavras com um número negativo (-1);\n\t\t\t\t<dd>as opções devem aparecer na ordem especificada, separado por virgulas.\n\t\t\t\t</dl>",
"checkbox" => "caixa de marcação",
"<dl>\n\t\t\t\t<dt>Function: Provides a checkbox field for yes/no, on/off input.\n\t\t\t\t<dt>Usage: <strong>samerow</strong>\n\t\t\t\t<dt>Example: 1\n\t\t\t\t<dt>Description:\n\t\t\t\t<dd><strong>[samerow]</strong> will display the next field on the same row if a 1 is specified.\n\t\t\t\t</dl>" => "<dl>\n\t\t\t\t<dt>Função: Dispoem um campo checkbox para entradas de sim/não, ou ligado/desligado.\n\t\t\t\t<dt>Uso: <strong>mesma_linha</strong>\n\t\t\t\t<dt>Exemplo: 1\n\t\t\t\t<dt>Descrição:\n\t\t\t\t<dd><strong>[mesma_linha]</strong> irá exibir o próximo campo na mesma linha se for definido como 1.\n\t\t\t\t</dl>",
"numeric field" => "campo numérico",
"drop down" => "caixa de seleção",
"radio buttons" => "botões  circulares <i>(radio buttons)</i>",
"user selector" => "selecionador de usuário",
"group selector" => "selecionador de grupo",
"country selector" => "selecionador de país",
"date and time" => "data e hora",
"action" => "ação",
"header" => "cabeçalho",
"category" => "categoria",
"item link" => "item do link",
"items list" => "lista de itens",
"email" => "e-mail",
"multimedia" => "multimídia",
"system" => "sistema",
"attachment" => "anexo",
"open" => "aberto",
"pending" => "pendente",
"closed" => "fechado",
"Message" => "Mensagem",
"No extra information for that attached file. " => "Sem informações extras para o arquivo anexado. ",
"child categories" => "categorias-filhas",
"objects in category" => "objetos nesta categoria",
"(AT)" => "(ARROBA)",
"(DOT)" => "(PONTO)",
"The administrator has not yet validated your account. Please wait." => "O administrador ainda não validou sua conta. Por favor aguarde.",
"You must validate your account first. An email has been sent to you" => "Primeiro você precisa validar sua conta. Um e-mail foi enviado para o endereço fornecido",
"Password should be at least" => "A senha deveria ter no mínimo",
"characters long" => "caracteres",
"Password must contain both letters and numbers" => "A senha deve ser composta de letras e algarismos",
"The registration mail can't be sent because there is no server email address set, and this feature is disabled" => "O e-mail de registro não pode ser enviado porque não há um de endereço de e-mail do servidor defindo, e este recurso está desabilitado",
"The user email confirmation can't be sent. Contact the administrator" => "O e-mail de confirmação do usuário não pode ser enviado. Por favor entre em contato com o administrador.",
"Personal Phone" => "Telefone residencial",
"Personal Mobile" => "Celular (pessoal)",
"Personal Fax" => "Fax",
"Work Phone" => "Telefone do trabalho",
"Work Mobile" => "Celular (trabalho)",
"Work Fax" => "Fax (trabalho)",
"Company" => "Empresa",
"Organization" => "Organização",
"Department" => "Departamento",
"Division" => "Divisão",
"Job Title" => "Cargo",
"Street Address" => "Endereço",
"City" => "Cidade",
"State" => "Estado",
"Zip Code" => "CEP",
"Country" => "País",
"User-Agent Info" => "Informação do Usuário-Agente",
"Info" => "Informações",
"Info required - IP|SVRSW|BROWSER" => "Informaçãoe exigida - IP|SERVIDOR|NAVEGADOR",
"Displays browser client info" => "Mostra as informações do navegador do cliente",
"Anchor Link" => "Link para âncora",
"Puts a link to an anchor in a wiki page. Use in conjunction with the ANAME plugin, which sets the location and name of the anchor" => "Cria um link para uma posição numa página wiki. Use junto com o plugin ANAME, que permite definir a localização e o nome de uma posição",
"linktext" => "texto de link",
"Anchor Name" => "Nome da âncora",
"Puts an anchor into a wiki page. Use in conjunction with the ALINK plugin, which makes links to the anchor" => "Cria uma posição numa página wiki. Use junto com o plugin ALINK, que cria links para posições",
"Image Annotation" => "Anotação de Imagem",
"Location" => "Local",
"Width" => "Largura",
"Height" => "Altura",
"Alignment" => "Alinhamento",
"Save changes to annotations" => "Salvar mudanças nas anotações",
"Field" => "Campo",
"Article ID" => "ID do Artigo",
"Includes an article" => "Exibe um artigo",
"Id is optional. If not given, last article is used. Default field is heading." => "O campo Id é opcional. Se não fornecido, o último artigo publicado será exibido. O campo padrão a ser exibido é o cabeçalho, isso pode ser alterado com o parâmetro Field.",
"Article List" => "Lista de Artigos",
"Articles displayed" => "Artigos exibidos",
"Topics expression" => "Assuntos",
"Topic ID expression" => "ID do Assunto",
"Type expression" => "Tipo",
"Category ID" => "ID do Assunto",
"Language" => "Idioma",
"Sort order" => "Ordenar",
"Quiet" => "Silencioso",
"Title only" => "Somente Título",
"Includes articles listing into a wiki page" => "Inclui uma listagem de artigos numa página wiki",
"~np~{ARTICLES(max=>3, topic=>topicName, topicId=>id, type=>type, categId=>Category parent ID, lang=>en, sort=>columnName_asc|columnName_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~" => "~np~{ARTICLES(max=>3, topic=>Assunto, topicId=>IDdoAssunto, type=>tipo, categId=>IDdaCategoria, lang=>pt-br, sort=>nomeDaColuna_asc|nomeDaColuna_desc), quiet=>y|n, titleonly=>y|n}{ARTICLES}~/np~",
"Attachment" => "Anexo",
"File" => "Arquivo",
"Show description" => "Exibir descrição",
"Bullets" => "Lista de Tópicos",
"Inline" => "Na mesma linha",
"Number" => "Número",
"Show icon" => "Mostrar ícone",
"No such attachment on this page" => "Nenhum anexo nessa página",
"Displays an attachment or a list of them" => "Mostra um anexo ou uma lista deles",
"Gives the name of the attached file to link to" => "Forneça o nome do arquivo anexado para linkar com",
"Avatar" => "Fotografia",
"Displays the user Avatar" => "Exibe a fotografia do usuário",
"username" => "usuário",
"Back" => "Voltar",
"Backlinks" => "Referências",
"List all pages which link to specific pages" => "Listar todas as páginas que possuem links para as páginas especificadas",
"No pages links to" => "Nenhuma página com link para",
"One page links to" => "Uma página com link para",
"pages link to" => "páginas com links para",
"Zone" => "Zona",
"Items" => "Itens",
"Insert theme styled box on wiki page" => "Inserir caixa com estilo do tema na página wiki",
"Category" => "Categoria",
"Insert list of items for the current/given category into wiki page" => "Inserir uma lista de itens para a categoria atual/fornecida na página wiki",
"Categories are disabled" => "Categorias estão desabilitadas",
"Display Tiki objects that have not been categorized" => "Exibir objetos Tiki que não foram categorizados",
"Objects" => "Objetos",
"Insert the full category path for each category that this wiki page belongs to" => "Inserir o caminho completo para cada categoria a que esta página wiki pertence",
"Center" => "Centralizar",
"Centers the plugin content in the wiki page" => "Centraliza o conteúdo de plugin na página wiki",
"Chart" => "Gráfico",
"title" => "título",
"Code" => "Código",
"Displays a snippet of code" => "Mostrar um pedaço de código",
"code" => "código",
"note: colors and ln are exclusive" => "nota: cores e ln são exclusivos",
"Dynamic Content" => "Conteúdo dinâmico",
"Insert copyright notices" => "Inserir informações de copyright",
"Example" => "Exemplo",
"and" => "e",
"seconds" => "segundos",
"Insert a division block on wiki page" => "Insira um bloco de divisão na página wiki",
"Creates a definition list" => "Criar uma lista de definição",
"term" => "termo",
"definition" => "definição",
"one definition per line" => "uma definição por linha",
"drawing not found" => "desenho não encontrado",
"Events" => "Eventos",
"Upcoming events" => "Próximos eventos",
"Label" => "Rótulo",
"Displays the data using the Tikiwiki odd/even table style" => "Exibe os dados usando o estilo de tabelas par/ímpar do Tikiwiki",
"cells" => "células",
"heads and cells separated by ~|~" => "cabeçalhos e células separadas por ~|~",
"Title" => "Título",
"sort" => "ordenar",
"Displays a SWF on the wiki page" => "Mostra um SWF na página wiki",
"Movie URL" => "URL do arquivo",
"Missing parameter movie to the plugin flash" => "O parâmetro movie é obrigatório para o plugin flash",
"missing parameters" => "faltando os parâmetros",
"Incorrect param" => "Parâmetro incorreto",
"failed" => "falhou",
"description" => "descrição",
"Value" => "Valor",
"Displays a graphical GAUGE" => "Exibe um medidor gráfico",
"Missing parameter" => "Faltando parâmetro",
"type" => "tipo",
"Group" => "Grupo",
"Display wiki text if user is in one of listed groups" => "Mostra o texto wiki se o usuário pertencer a um dos grupos listados",
"HTML code" => "Código HTML",
"URL" => "Endereço",
"name" => "nome",
"Image ID" => "ID da Imagem",
"Image size" => "Tamanho da imagem",
"Image height" => "Altura da imagem",
"Image width" => "Largura da imagem",
"Include" => "Incluir",
"Start" => "Início",
"Stop" => "Parar",
"Include a page" => "Incluir uma página",
"Runs a Java applet to access a local Jabber service" => "Executa um applet Java para acessar um serviço local Jabber",
"Displays the text only if the language matchs" => "Mostrar o texto somente se o idioma combina",
"Last Modification" => "última modificação em",
"List Pages" => "Listar páginas",
"List wiki pages." => "Listar páginas wiki.",
"Sort" => "Ordenar",
"or" => "ou",
"Lists files in a directory" => "Lista de arquivos em um diretório",
"Filter" => "Filtrar",
"could not be opened because it doesn't exist or permission was denied" => "não pode ser aberto porque não existe ou porque as permissões foram insuficientes",
"Map" => "Associar",
"Displays a map" => "Mostra mapa",
"Feature disabled" => "Recurso desabilitado",
"Style" => "Estilo",
"Module Name" => "Nome do Módulo",
"Please choose a module" => "Por favor, selecione um módulo",
"to be used as argument" => "para ser utilizado como argumento",
"Displays a module inlined in page" => "Exibe um módulo embutido na página",
"Sorry no such module" => "Sinto muito, módulo inexistente",
"Font" => "Fonte",
"Displays the data using a monospace font" => "Exibe os dados usando uma fonte monoespaçada",
"Text" => "Texto",
"Sticky" => "Persistente",
"data" => "dados",
"Object" => "Objeto",
"Days" => "Dias",
"Displays object hit info by object and days" => "Mostra informações de acesso do objeto por objeto e dias",
"Picture" => "Imagens",
"picture not found" => "imagem não encontrada",
"Information" => "Informação",
"Provides a list of plugins on this wiki." => "Provê uma lista de plug-ins neste wiki.",
"No version indicated" => "Nenhuma versão indicada",
"No arguments indicated" => "Nenhum argumento indicado",
"Displays the output of a poll, fields are indicated with numeric ids." => "Mostrar a saída de uma enquete, os campos são indicados por números.",
"missing poll ID for plugin POLL" => "faltando ID da enquete para o plugin POLL",
"wrote:" => " escreveu:",
"Quote:" => "Cita:",
"Quote text by surrounding the text with a box, like the [QUOTE] BBCode" => "Cita o texto cercado por um boz, como o [QUOTE] do BBCode",
"one data per line" => "um dado por linha",
"Search" => "Busca",
"Takes regex expressions and parses the content between the REGEX tags and replaces the text." => "Pega expressões regex e cruza o conteúdo com as tags REGEX e substitui o texto.",
"Icon" => "Ícone",
"Date" => "Data",
"You need to specify a RSS Id" => "Você precisa especificar um Id RSS",
"RSS Id incorrect:" => "Id RSS incorreto:",
"Automatically creates a link to the appropriate SourceForge object" => "Criar automaticamente um link para o objeto apropriado no SourceForge",
"Sheet Heading" => "Cabeçalho da planilha",
"TikiSheet" => "Planilha Tiki",
"Edit Sheet" => "Editar planilha",
"List wiki pages" => "Listar páginas wiki",
"Display" => "Mostrar",
"Last modified by" => "Última modificação por",
"Action" => "Ação",
"This data is put in a CODE caption." => "Esse dados são postos como uma legenda CODE.",
"Missing url parameter for SNARF plugin." => "Faltando endereço url como parâmetro para o plugin SNARF.",
"Sorts the plugin content in the wiki page" => "Ordena o conteúdo do plugin na página wiki",
"Order" => "Ordem",
"Split a page into rows and columns" => "Dividir uma página em linhas e colunas",
"First" => "Primeiro",
"Edit" => "Editar",
"row1col1" => "linha1col1",
"row1col2" => "linha1col2",
"row2col1" => "linha2col1",
"row2col2" => "linha2col2",
"Run a sql query" => "Executar uma consulta SQL",
"sql query" => "Consulta SQL",
"Missing db param" => "Parâmetro de banco de dados ausente",
"Displays text in subscript." => "Mostra o texto no modo subscrito.",
"Subscribe" => "Inscrever-se",
"Groups" => "Grupos",
"Tag Name" => "Nome do rótulo",
"Displays text between an html tag" => "Mostrar texto entre tag HTML",
"Thumbnail" => "Miniatura",
"Displays the thumbnail for an image" => "Mostrar miniatura para uma imagem",
"Search the titles of all pages in this wiki" => "Buscar os títulos de todas as páginas deste wiki",
"No pages found for title search" => "Nenhuma página encontrada para a busca de título",
"One page found for title search" => "Uma página encontrada para a busca de título",
"pages found for title search" => "páginas encontradas para a busca de título",
"Structure ID" => "ID de Estrutura",
"Public" => "Público",
"List top scoring users" => "Listar usuários com maior pontuação",
"Translate" => "Traduzir",
"Translate a string" => "Traduzir uma frase",
"Fields" => "Campos",
"Preview" => "Pré-visualização",
"preview" => "pré-visualização",
"View" => "Ver",
"Error" => "Erro",
"Following mandatory fields are missing" => "Os seguintes campos obrigatórios não foram preenchidos",
"Following fields are incorrect" => "Os seguintes campos estão incorretos",
"Displays an input form for tracker submit" => "Mostra um formulário para inserção de um acompanhamento",
"You do not have permission to insert an item" => "Você não tem permissão para inserir um item",
"You do not have permission to modify an item" => "Você não tem permissão para modificar um item",
"Fields marked with a * are mandatory." => "Os campos marcados com * são obrigatórios",
"Filters" => "Filtros",
"Example:" => "Exemplo:",
"Filters the items of a tracker, fields are indicated with numeric ids." => "Filtre os ítens de um acompanhamento, os campos são indicados com ids numéricos.",
"Status" => "Estado",
"Displays the output of a tracker content, fields are indicated with numeric ids." => "Mostrar a saída de conteúdo de uma acompanhamento, campos são indicados com números.",
"More" => "Mais",
"Template" => "Padrão",
"Mode" => "Modo",
"Error in tracker ID" => "Erro no ID do acompanhamento",
"No field indicated" => "Sem campo indicado",
"Links to a translated content" => "Links para um conteúdo traduzido",
"Flag" => "Marca",
"Displays the number of registered users" => "Mostrar o número de usuários registrados",
"Group name" => "Nome do grupo",
"User List" => "Lista de usuários",
"Displays a list of registered users" => "Mostra a lista de usuários registrados",
"users" => "usuários",
"Preferences" => "Preferências",
"User Information" => "Informações do Usuário",
"Versions" => "Versões",
"Split the text in parts visible only under some conditions" => "Dividir o texto em partes visíveis apenas em algumas situações",
"Vote" => "Votar",
"Table" => "Tabela",
"Lists ''wanted'' Wiki pages: " => "Lista páginas wiki ''desejadas'': ",
"^Parameters: key=>value,...\n" => "^Parâmetros: chave=>valor,...\n",
"__key__ | __default__ | __comments__\n" => "__chave__ | __padrão__ | __comentários__\n",
"empty string" => "string vazia",
"possible values: " => "valores possíveis: ",
"ignored" => "ignorado",
"External Wiki" => "Wiki Externo",
"valid" => "válida",
"End of debug output." => "Final da saída de debug.",
"Wanted Page" => "Página desejada",
"Display youtube video in a wiki page" => "Mostra um vídeo do Youtube numa página wiki",
"Missing parameter movie to the youtube plugin" => "O parâmetro movie é obrigatório para o plugin do Youtube",
"Removed version \$version" => "Versão removida \$version",
"rollback version " => "reverter para versão ",
"Changed actual version to \$version" => "Versão atual alterada para versão \$version",
"Top" => "Topo",
"Page locked" => "Página travada",
"Page unlocked" => "Página destravada",
"Removed last version" => "Última versão removida",
"ERROR: Either the subject or body must be non-empty" => "ERRO: Ou o assunto ou o corpo tem que ser preenchido",
"ERROR: No valid users to send the message" => "ERRO: Nenhum destinatário válido para a mensagem",
"Invalid user" => "Usuário inválido",
"Message sent to" => "Mensagem enviada para",
"Sent box is full. Archive or delete some sent messages first if you want to send more messages." => "A caixa de saída esta cheia. Arquive ou delete algumas mensagens antes de enviar novas mensagens.",
"You have to be able to receive messages in order to send them. Goto your user preferences and enable 'Allow messages from other users'" => "Para poder enviar mensagens, você primeiro precisa habilitar a opção para recebe-las. Nas preferências de usuário habilite 'Permitir mensagens de outros usuários'.",
"User %s can not receive messages, mailbox is full" => "Os usuários %s não podem receber mensagens pois a caixa de entrada deles esta cheia",
"User %s can not receive messages" => "Os usuários %s não podem receber mensagens",
"Invalid user: %s" => "Usuário inválido: %s",
"Message will be sent to: " => "A mensagem foi enviada para: ",
"Archive is full. Delete some messages from archive first." => "O arquivo esta cheio. Delete algumas mensagens antes de arquivar novas.",
"No more messages" => "Nenhuma outra mensagem",
"Tiki Calendar" => "Calendário Tiki",
"list topics with links to the articles" => "listar tópicos com links para os artigos",
"Article Topics" => "Tópicos dos artigos",
"Calendar" => "Calendário",
"Please provide an Id" => "Forneça um Id por favor",
"no object here yet" => "Nenhum objeto aqui",
"Create/Edit" => "Criar/editar",
"Quick Edit a Wiki Page" => "Edição rápida de página Wiki",
"Post" => "Enviar",
"Changes since" => "Mudanças desde",
"new comments" => "novos comentários",
"new posts" => "novas mensagens",
"wiki pages changed" => "páginas Wiki alteradas",
"new articles" => "Novos Artigos",
"new FAQs" => "novos FAQs",
"new blogs" => "novos blogs",
"new blog posts" => "Novos postagens nos blogs",
"new image galleries" => "Nova galeria de imagens",
"new images" => "novas imagens",
"new file galleries" => "Novas galeria de arquivos",
"new files" => "novos arquivos",
"new polls" => "nova enquete",
"new users" => "novos usuários",
"new tracker items" => "novos itens de acompanhamento",
"The task title must have at least 3 characters" => "O título da tarefa deve conter pelo menos 3 caracteres",
"Invalid username or password" => "Usuário ou senha inválidos",
"Auto approve forum posts" => "Aprovar automaticamente mensagens no fórum",
"change password" => "alterar senha",
"smarty notice reporting" => "reportar notícias do smarty",
"country" => "país",
"Anti-Bot verification code" => "Código de verificação anti-robô",
"Random Image" => "Imagem Aleatória",
"Enter the code you see above" => "Digite o código que está acima",
"List of attached files" => "Lista de arquivos anexados",
"uploaded" => "carregado",
"Delete" => "Apagar",
"Remove" => "Remover",
"Upload file" => "Carregar arquivo",
"Attach" => "Anexar",
"Attach a file to this item" => "Anexar um arquivo a este item",
"Version" => "Versão",
"Attachments" => "Arquivos anexados",
"more info" => "mais informações",
"No attachments for this item" => "Sem arquivos anexados a este item",
"debug" => "depuração",
"Fatal error" => "Erro crítico",
"Created by" => "Criada por",
"on" => "em",
"RSS feed" => "Fonte RSS",
"Edit blog" => "Editar blog",
"Monitor this Blog" => "Monitorar este blog",
"Stop Monitoring this Blog" => "Não monitorar mais este blog",
"Activity=" => "Atividade=",
"Actions" => "Ações",
"Properties" => "Propriedades",
"No records found" => "Nenhum registro encontrado",
"Categorize" => "Categorização",
"Admin Categories" => "Administrar categorias",
"No categories defined" => "Nenhuma categoria definida",
"Browse Category" => "Navegar na categoria",
"posts:" => "mensagens:",
"stars" => "estrelas",
"User Level" => "Nível de usuário",
"private message" => "mensagem particular",
"Send eMail to User" => "Enviar email ao usuário",
"user online" => "usuário on-line",
"user offline" => "usuário offline",
"top of page" => "topo da página",
"Reply" => "Responder",
"Approve" => "Aprovar",
"Reject" => "Rejeitar",
"Report this post" => "Solicitar que um moderador revise essa mensagem",
"Save to notepad" => "Salvar no bloco de notas",
"Monitor this Topic" => "Monitorar este tópico",
"Stop Monitoring this Topic" => "Não monitorar mais este tópico",
"Errors" => "Erro",
"Moderator actions" => "Ações de moderador",
"reported:" => "enviadas:",
"queued:" => "pendentes:",
"Move to topic:" => "Mover para o tópico:",
"Move" => "Mover",
"Delete Selected" => "Apagar selecionados",
"Unlock" => "Destravar",
"Lock" => "Travar",
"Messages" => "Mensagens",
"Plain" => "Plano",
"Headers Only" => "Cabeçalho apenas",
"Newest first" => "Mais novos em primeiro",
"Oldest first" => "Mais antigos em primeiro",
"Title (desc)" => "Título (desc)",
"Title (asc)" => "Título (asc)",
"Threshold" => "Limite",
"Set" => "Definir",
"Replies" => "Respostas",
"Note" => "Nota",
"New Reply" => "Nova resposta",
"Editing reply" => "Editar resposta",
"Reply to the selected post" => "Responder a mensagem selecionada",
"Post new message" => "Enviar nova mensagem",
"Editing comment" => "Editando comentário",
"Comment on the selected post" => "Comentar mensagem selecionada",
"Post new comment" => "Enviar novo comentário",
"required" => "obrigatório",
"Smileys" => "Emoticons",
"Quicktags" => "Tags rápidos",
"Enter your name" => "Digite seu nome",
"Reply to parent post" => "Responder para a mensagem principal",
"Post new reply" => "Enviar nova resposta",
"Post as Anonymous" => "Enviar como anônimo",
"Cancel" => "Cancelar",
"Posting replies" => "Enviar respostas",
"Posting comments" => "Dicas para a edição",
"Use" => "Usar",
"for links" => "para links",
"HTML tags are not allowed inside posts" => "Tags HTML não são permitidos dentro de mensagens",
"Add Comment" => "Comentário",
"1 comment" => "1 comentário",
"Comments" => "Comentários",
"Go back" => "Retornar",
"Return to home page" => "Retornar à página inicial",
"Type of contribution:" => "Tipo de contribuição:",
"Copyrights" => "Direitos Autorais",
"Authors" => "Autores",
"Add" => "Adicionar",
"Syntax" => "Formato",
"Page generation debugging log" => "Log de depuração de geração de página",
"Features state" => "Estado de recursos",
"features matched" => "recursos selecionados",
"Watchlist" => "Lista de Notificações",
"Duplicate File Gallery" => "Duplicar galeria de arquivos",
"duplicate" => "duplicar",
"There are individual permissions set for this file gallery" => "Existem permissões individuais definidas para esta galeria de arquivos",
"Save" => "Salvar",
"View inserted gallery" => "Ver galeria criada",
"Display Properties" => "Configurar visualização",
"required field for podcasts" => "campo obrigatório para podcast",
"any file" => "qualquer arquivo",
"podcast (audio)" => "podcast (áudio)",
"podcast (video)" => "podcast (vídeo)",
"Gallery is visible to non-admin users?" => "Galeria visível para usuários não administradores?",
"This Gallery is Public" => "Essa galeria é pública",
"unlimited" => "ilimitado",
"none" => "nenhum",
"Parent gallery" => "Galeria pai",
"Owner of the gallery" => "Dono da galeria",
"Default sort order" => "Ordem de listagem padrão",
"descending" => "decrescente",
"ascending" => "crescente",
"Max description display size" => "Tamanho máximo para descrição",
"Max Rows per page" => "Máximo de linhas por página",
"Listing configuration" => "Configuração de listagem",
"Please login" => "Faça o login",
"Perhaps you were looking for:" => "Talvez você esteja procurando por:",
"There are no wiki pages similar to '{\$page}'" => "Não há nenhuma página wiki similar a '{\$page}'",
"You are not logged in." => "Você não está logado.",
"Go to Login Page" => "Ir para a página de login",
"Create this page" => "Criar esta página",
"(page will be orphaned)" => "(a página será órfã)",
"Close Window" => "Fechar janela",
"Go to" => "Ir para",
"Private Gallery" => "Galeria privada",
"Active Perms" => "Permissões ativas",
"Perms" => "Permissões",
"Archives" => "Arquivos",
"Replace" => "Trocar",
"List" => "Lista",
"Browse" => "Navegar",
"Name-filename" => "Nome-nome de arquivo",
"Filename only" => "Apenas nome de arquivo",
"Show as a column" => "Mostrar em uma coluna",
"Show in popup box" => "Mostrar numa janela popup",
"Close" => "Fechar",
"Exact&nbsp;match" => "Correspondência&nbsp;exata",
"any type" => "qualquer tipo",
"all topic" => "todos os tópicos",
"any language" => "qualquer idioma",
"any category" => "qualquer categoria",
"Number of displayed rows" => "Número de linhas exibidas",
"Go" => "Ir",
"in:" => "em:",
"Show php error messages" => "Mostrar mensagens de erro do PHP",
"Folksonomy Tags" => "Tags",
"Put tags separated by spaces. For tags with more than one word, use no spaces and put words together." => "Insira as palavras-chave separadas por espaço. Para palavras-chave com mais de uma palavra, não use espaços, coloque as palavras juntas..",
"Tags" => "Palavras-chave",
"Images Galleries" => "Galerias de imagem",
"Edit this page!" => "Editar esta página!",
"RSS Articles" => "RSS Artigos",
"RSS Image Galleries" => "RSS Galeria de imagens",
"RSS File Galleries" => "RSS Galeria de arquivos",
"RSS Forums" => "RSS Fóruns",
"RSS Maps" => "RSS Mapas",
"RSS Directories" => "RSS Diretórios",
"RSS Calendars" => "RSS Calendário",
"Loading" => "Carregando",
"Perform action with checked:" => "Ação com o que foi selecionado:",
"Move Selected Files" => "Mover os arquivos selecionados",
"Are you sure you want to delete the selected files?" => "Você tem certeza que deseja remover os arquivos selecionados?",
"Assign Permissions" => "Designar Permissões",
"Move to" => "Mover para",
"Assign" => "Atribuir",
"Filename" => "Nome do arquivo",
"No information" => "Nenhuma informação",
"Hi {\$mail_user} has sent you this link:" => "Olá! O usuário {\$mail_user} enviou este link para você:",
"Blog post:" => "Mensagem de blog:",
"at:" => "em:",
"Somebody or you tried to subscribe this email address at our site:" => "Alguém (possivelmente você) tentou registrar este endereço de email no nosso site:",
"To the newsletter:" => "Para o comunicado:",
"Description:" => "Descrição:",
"In order to confirm your subscription you must access the following URL:" => "Para confirmar esta assinatura, acesse o seguinte endereço:",
"To validate your account and login to the site, please click on the following link:" => "Para validar sua conta e logar no site, por favor clique no seguinte link:",
"The administrator approved your account." => "O administrador ativou a sua conta.",
"Confirm your email at %s" => "Confirme seu e-mail em %s",
"Author:" => "Autor:",
"A new message was posted to forum" => "Uma nova mensagem foi enviada ao fórum",
"New topic:" => "Novo tópico:",
"Topic:" => "Tópico:",
"You sent a request with the subject:" => "Você mandou uma requisição com o assunto:",
"Use the subject to indicate the operation to apply:" => "Use o assunto para indicar a operação para aplicar:",
"Tiki mail-in instructions" => "Instruções para mail-in Tiki",
"Page not found:" => "Página não encontrada:",
"Hi," => "Olá,",
"A new message was posted to you at {\$mail_machine}" => "Uma nova mensagem foi enviada para você a partir de {\$mail_machine}",
"From" => "De",
"New message arrived from %s" => "Nova mensagem chegou de %s",
"Hi" => "Olá",
"Your Tiki account registration request for {\$mail_site} was validated by the site admin and your account is active now." => "Seu pedido de registro de conta no Tiki para {\$mail_site} foi validade pelo administrados e sua conta está ativa agora.",
"To login with your username and password, please follow this link:" => "Para entrar usando seu usuário e senha, por favar acesse esse link:",
"Enjoy the site!" => "Esperamos que você aprecie o site!",
"Tiki User Account Activated" => "Conta Tiki do usuário ativada",
"has requested an account on" => "solicitou uma conta em",
"Group:" => "Grupo:",
"To validate that account, please follow the link:" => "Para validar essa conta, por favor siga o link:",
"best regards" => "de nossa maior consideração",
"your Tikiwiki" => "seu Tikiwiki",
"Tiki User Registration Request" => "Solicitação de registro de usuário tiki",
"Go to your friendship network to accept or refuse this request" => "Vá para a sua rede de amigos para aceitar ou rejeitar esse pedido",
"You're invited to join my network of friends!" => "Convite para entrar na minha rede de amigos!",
"The user" => "O usuário",
"registered at your site" => "registrou-se no seu site",
"New user registration" => "Cadastramento de novo usuário",
"Bye bye!" => "Até logo!",
"This email address has been removed to the list of subscriptors of:" => "Este endereço de email foi removido da lista de assinantes de:",
"Newsletter:" => "Comunicado:",
"Bye bye from %s at %s" => "Removido da lista %s em %s",
"You can unsubscribe from this newsletter following this link" => "Você pode cancelar a assinatura deste comunicado clicando abaixo:",
"Welcome to our newsletter!" => "Bem-vindo(a) ao nosso comunicado!",
"This email address has been added to the list of subscriptors of:" => "Este endereço de email foi adicionado à lista de assinantes de:",
"You can always cancel your subscription using:" => "Você pode cancelar sua assinatura a qualquer momento usando:",
"Welcome to %s at %s" => "Bem vindo a %s em %s",
"Tiki email notification" => "Notificação de email Tiki",
"Someone coming from IP Address" => "Alguém acessando do endereço IP",
"requested a reminder of the password for your account" => "solicitou um lembrete de senha da sua conta",
"requested password reset for your account" => "solicitou que a senha para sua conta fosse recriada",
"Since this is your registered email address we inform that the password for this account is" => "Sendo esse o seu endereço eletrônico a sua senha é",
"Important: Username & password are CaSe SenSitiVe" => "Importante: Usuário e senha são sensíveis a caixa ALTA/baixa",
"Important: The old password remains active if you don't click the link above." => "Importante: a senha velha permanecerá ativa se você não clicar no link acima.",
"Your Tiki account information for %s" => "A sua informação da conta Tiki para %s",
"A new article was submitted by {\$mail_user} to {\$mail_site} at {\$mail_date|tiki_short_datetime}" => "Um novo artigo foi enviado por \$mail_user} para {\$mail_site} em {\$mail_date|tiki_short_datetime}",
"You can edit the submission following this link:" => "Você pode editar este artigo editando este link:",
"Title:" => "Título:",
"Heading:" => "Cabeçalho:",
"Body:" => "Corpo:",
"New article submitted at %s" => "Novo artigo enviado em %s",
"Look at this link:" => "Veja esse link:",
"A friend sends you a link from: " => "Um amigo lhe enviou um link de: ",
"Tracker was modified at" => "Acompanhamento modificado as",
"You or someone registered this email address at" => "alguém (possivelmente você) registrou este endereço de email em",
"If you want to be a registered user in this site you will have to use the following link to login for the first time:" => "Se você deseja ser um usuário registrado neste site, utilize o seguinte link para logar-se pela primeira vez:",
"Your registration confirmation" => "Instruções para cadastramento no Tiki",
"You will receive an email with information to login for the first time into this site" => "Você receberá um email com instruções sobre como logar-se pela primeira vez neste site",
"Your account request has been stored and will be activated by the admin as soon as possible." => "Seu pedido de conta foi registrado e será ativado pelo administrador o mais rápido possível.",
"You'll receive email notification once your account is activated." => "Você receberá um e-mail avisando quando a sua conta estiver ativa.",
"Please do not attempt to login until you receive the email notification." => "Por favor não tente se logar enquanto não receber o e-mail de ativação.",
"View the article at:" => "Vejo o artigo em:",
"If you don't want to receive these notifications follow this link:" => "Se você não deseja receber estas notificações siga este link:",
"New blog post: {\$mail_title}, \"{\$mail_post_title}\", by {\$mail_user|username} at {\$mail_date|tiki_short_datetime}" => "Nova mensagem de blog: {\$mail_title}, \"{\$mail_post_title}\", por {\$mail_user|username} em {\$mail_date|tiki_short_datetime}",
"View the blog at:" => "Veja o blog em:",
"New blog post at %s" => "Novo post no blog em %s",
"Modified calendar item" => "Item do calendário modificado",
"New calendar item" => "Novo item no calendário",
"changed" => "alterada",
"created" => "criação",
"Removed by" => "Removido por",
"removed" => "removido",
"New" => "Novo",
"File Gallery %s changed" => "Galeria de arquivos %s alterada",
"A file was removed from the file gallery" => "Um arquivo foi removido da galeria de imagens",
"File Name" => "Nome do arquivo",
"A new file was posted to file gallery" => "Novo arquivo na galeria de arquivos",
"Posted by" => "Enviado por",
"File Description" => "Descrição do Arquivo",
"Image Gallery {\$galleryName} changed" => "Galeria de imagem {\$galleryName} modificada",
"A new file was posted to image gallery" => "Um novo arquivo foi enviado para a galeria de imagem",
"The map {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "O mapa {\$mail_page} foi alterado por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"You can view the updated map following this link:" => "Você pode ver o mapa atualizado pelo link:",
"You can edit the map following this link:" => "Você pode editar o mapa pelo seguinte link:",
"Structure modified" => "Estrutura modificada",
"A new file have been attached to page" => "Um novo arquivo foi anexado à página",
"File name" => "Nome do arquivo",
"New attachment on %s, page" => "Novos anexos em %s, página",
"The page {\$mail_page} was created by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi criada por {\$mail_user} as {\$mail_date|tiki_short_datetime}",
"The page {\$mail_page} was changed by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi alterada por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"Comment:" => "Comentário:",
"You can view the page by following this link:" => "Você pode acessar a página através desse link:",
"You can view a diff back to the previous version by following this link:" => "Você pode visualizar uma comparação de uma versão anterior através desse link:",
"The changes in this version follow below, followed after by the current full page text." => "As mudanças nessa versão seguem abaixo, em seguida é mostrado a versão atual da página.",
"-Lines: {\$oldd} changed to +Lines: {\$newd}" => "-Linhas: {\$oldd} mudou para +Linhas: {\$newd}",
"The new page content follows below." => "O conteúdo da nova página está abaixo.",
"The page {\$mail_page} was commented by {\$mail_user} at {\$mail_date|tiki_short_datetime}" => "A página {\$mail_page} foi comentada por {\$mail_user} em {\$mail_date|tiki_short_datetime}",
"an anonymous user" => "um usuário anônimo",
"Wiki page renamed" => "Página wiki renomeada",
"Old name" => "Nome antigo",
"New name" => "Novo nome",
"Thank you for your registration. You may log in now." => "Obrigado por se registrar. Você já pode ser logar no site.",
"click on the map to zoom or pan, do not drag" => "clique no mapa para um zoom, não para arrastar",
"Scale" => "Escala",
"Zoom out" => "Menos zoom",
"Query" => "Consulta",
"Pan" => "Panorâmica",
"Zoom in" => "Mais zoom",
"Redraw" => "Redesenhar",
"select zoom/pan/query and image size" => "selecione zoom/pan/consulta e tamanho da imagem",
"View the Map Only" => "Veja apenas o mapa",
"Reset Map" => "Reiniciar mapa",
"Click on the map or click redraw" => "Clique no mapa ou clique em redesenhar",
"Last modification date" => "Data da última modificação",
"Overview" => "Visão geral",
"Legend" => "Legenda",
"Layer Manager" => "Gerenciador de Camadas",
"Layer" => "Camada",
"On" => "Ligado",
"Download Layer" => "Download Camada",
"This layer has been set by the maps administrator to not be downloadable" => "Essa camada foi definida para como impossível de ser baixada pelo administrador dos mapas",
"you have requested to download the layer:" => "você requisitou o download da camada:",
"Here are the files to download, do not forget to rename them:" => "Aqui estão os arquivos para o download, não esqueça de renomeá-los:",
"Mapfiles" => "Arquivos de Mapas",
"Mapfile" => "Arquivo de Mapa",
"Available mapfiles" => "Arquivos de Mapas disponíveis",
"hits last 7 days" => "cliques nos últimos 7 dias",
"monitor this map" => "monitorar este mapa",
"Stop Monitoring this Map" => "Parar de monitorar este mapa",
"Create a new mapfile" => "Criar um novo arquivo de mapa",
"Create" => "Criar",
"Mapfile listing" => "Listagem de mapas de arquivos",
"Reload" => "Recarregar",
"History" => "Histórico",
"You can view this map in your browser using" => "Você pode ver este mapa em seu browser usando",
"Zoom out x2" => "Menos zoom x2",
"Zoom in x2" => "Mais zoom x2",
"Mapfile History" => "Histórico dos arquivos de mapa",
"of" => "de",
"Compare" => "Comparar",
"Comparing version {\$old.version} with version {\$new.version}" => "Comparando versão {\$old.version} com a versão {\$new.version}",
"Version:" => "Versão:",
"Current" => "Atual",
"Versions are identical" => "As versões são idênticas",
"Legend:" => "Legenda:",
"v=view" => "v=visualizar",
"c=compare" => "c=comparar",
"d=diff" => "d=visualizar diferentes versões",
"Full side-by-side diff" => "Comparar diferentes versões lado-a-lado completo",
"Unified diff" => "Comparar diferentes versões unificado",
"Side-by-side view" => "Visualizar lado a lado",
"User" => "Usuário",
"Diff" => "Difer",
"Older Version" => "Versão antiga",
"Directories" => "Diretórios",
"back to" => "voltar para",
"Upload From Disk:" => "Carregar Do Disco:",
"Upload Files" => "Carregar Arquivos",
"Bytes maximum" => "Máximo de bytes",
"Create Directory:" => "Criar Diretório:",
"index file (.shp):" => "arquivo índice (.shp):",
"files to index (regexp):" => "arquivos para índice (regexp):",
"Message Archive" => "Arquivo de mensagens",
"messages" => "mensagens",
"Archive is full!" => "Arquivo está cheio!",
"Unread" => "Não lida",
"Flagged" => "Selecionada",
"Unflagged" => "Não selecionada",
"Containing" => "Conteúdo",
"Sender" => "remetente",
"No messages to display" => "Nenhuma mensagem a exibir",
"Broadcast message" => "Enviar mensagem global",
"OK" => "Ok",
"All users" => "Todos os usuários",
"Lowest" => "Mínima",
"Low" => "Baixa",
"High" => "Alta",
"Very High" => "Máxima",
"Send" => "Enviar",
"Compose message" => "Escreva mensagem",
"If you want people to be able to reply to you, enable <a href='tiki-user_preferences.php'>Allow messages from other users</a> in your preferences." => "Se você quer receber respostas, habilite <a href='tiki-user_preferences.php'>Permitir mensagens de outros usuários</a> em suas preferencias.",
"ERROR" => "ERRO",
"Invalid" => "Inválido",
"To" => "Para",
"No messages to download" => "Nenhuma mensagem para baixar",
"Mailbox is full! Delete or archive some messages if you want to receive more messages." => "A caixa de entrada esta cheia! Delete ou arquive algumas mensagens para pode receber novas mensagens.",
"Find replied message" => "encontrar mensagens respondidas",
"Archive" => "Arquivo",
"Mark as read" => "Marcar como lida",
"Mark as unread" => "Marcar como não lida",
"Mark as flagged" => "Marcar como selecionada",
"Mark as unflagged" => "Marcar como não selecionada",
"Mark" => "marca",
"Mailbox" => "Caixa de entrada",
"Compose" => "Escrever",
"Broadcast" => "Enviar para todos",
"Sent" => "Enviado",
"Auto-archive age for read messages:" => "Arquivar automaticamente mensagens lidas depois de certo tempo:",
"Read message" => "Ler mensagem",
"Return to mailbox" => "Voltar para a Caixa de Entrada",
"replyall" => "responder a todos",
"Unflag" => "Desmarcar",
"Flag this message" => "Marcar esta mensagem",
"Cc" => "CC",
"Return to archive" => "Retornar para o arquivo",
"Return to outbox" => "Retornar para a caixa de saída",
"Sent Messages" => "Mensagens enviadas",
"Replied" => "Respondido",
"Not replied" => "Não respondido",
"move to archive" => "mover para o arquivo",
"receiver" => "destinatário",
"'name' parameter for tikimodule missed" => "parâmetro 'nome' para tikimodule está perdido",
"Move module up" => "Mover módulo para cima",
"Up" => "Para cima",
"Move module down" => "Mover módulo para baixo",
"Down" => "Para baixo",
"Move module to opposite side" => "Mover módulo para o lado oposto",
"opp side" => "lado oposto",
"Unassign this module" => "Desabilitar este módulo",
"Are you sure you want to unassign this module?" => "Você tem certeza que deseja desabilitar este módulo?",
"Admin Menu" => "Administrar Menu",
"Live Support" => "Suporte on-line",
"Banning" => "Banimento",
"Users" => "Usuários",
"Modules" => "Módulos",
"Hotwords" => "Palavras-chaves",
"RSS Modules" => "Módulos RSS",
"Polls" => "Enquetes",
"Mail Notifications" => "Notificações por e-mail",
"Search Stats" => "Estatísticas de busca",
"Categories" => "Categorias",
"Edit Templates" => "Editar padrões",
"Content Templates" => "Padrões de Conteúdo",
"HTML Pages" => "Páginas HTML",
"Shoutbox" => "Mural",
"Shoutbox Words" => "Palavras do quadro negro",
"Referer Stats" => "Estatísticas de Referências",
"Import PHPWiki Dump" => "Importar PHPWiki",
"Admin dsn" => "Administrar DSN",
"Security Admin" => "Administrar segurança",
"Display type unknown, you have to enter the banner type" => "Tipo desconhecido, você precisa especificar o tipo do banner",
"You forgot your Google ad_client number !" => "Você esqueceu o seu número ad_client do Google!",
"More..." => "Mais...",
"Tikiwiki Assistant" => "Assistente do Tikiwiki",
"Thank you for installing Tikiwiki" => "Obrigado por instalar o Tikiwiki",
"To configure your Tiki" => "Para configurar o seu Tiki",
"Select" => "Selecionar",
"Admin Home" => "Administrar Página Inicial (Home)",
"Admin" => "Administrar",
"from the menu" => "pelo menu",
"Read the <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">configuration documentation</a>" => "Ler a <a class=\"link\" href=\"http://doc.tikiwiki.org/Configuration\" title=\"Tikiwiki Documentation\" target=\"_blank\">documentação de configuração</a>",
"Watch the <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">demo movies" => "Assista aos <a class=\"link\" href=\"http://tikiwiki.org/TikiMovies\" title=\"Demos\" target=\"_blank\">vídeos de demonstração",
"To remove this module" => "Para remover este módulo",
"Admin Modules" => "Administrar Módulos",
"and remove the assistant module" => "e para remover o módulo de ajuda",
"You can also add other modules" => "Você também pode adicionar outros módulos",
"To customize the menu" => "Para customizar o menu",
"Admin Menus" => "Administrar Menus",
"and edit menu ID 42" => "e edite o menu de Id 42",
"Or, create your own menu and add it to a module" => "Ou crie o seu próprio menu e adicione-o a um módulo",
"To begin configuring Tiki, please" => "Para começar a configurar o Tiki, por favor",
"as the Admin" => "como administrador",
"The Tikiwiki Community" => "A Comunidade Tikiwiki",
"Tikiwiki Documentation" => "Documentação do Tikiwiki",
"For help, visit <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>" => "Para obter ajuda, visite <a href=\"http://doc.tikiwiki.org\" title=\"Tikiwiki Documentation\" target=\"_blank\">http://doc.tikiwiki.org</a>",
"Last `\$module_rows` blog comments" => "Últimos `\$module_rows` comentários nos blogs",
"Last blog comments" => "Últimos comentários nos blogs",
"Recently visited pages" => "Páginas recentemente visitadas",
"January" => "Janeiro",
"February" => "Fevereiro",
"March" => "Março",
"April" => "Abril",
"May" => "Maio",
"June" => "Junho",
"July" => "Julho",
"August" => "Agosto",
"September" => "Setembro",
"October" => "Outubro",
"November" => "Novembro",
"December" => "Dezembro",
"Tuesday" => "Terça-feira",
"Wednesday" => "Quarta-feira",
"Thursday" => "Quinta-feira",
"Friday" => "Sexta-feira",
"Today" => "Hoje",
"Received objects" => "Objetos recebidos",
"Pages:" => "Páginas:",
"Last `\$module_rows` Sites" => "Últimos `\$module_rows` Sites",
"Last Sites" => "Últimos Sites",
"Directory Stats" => "Estatísticas dos links",
"Sites to validate" => "Sites a validar",
"Searches" => "Buscar",
"Visited links" => "Links visitados",
"Top \$module_rows Sites" => "Melhores \$module_rows Sites",
"Top Sites" => "Sites mais visitados",
"Current events" => "Eventos atuais",
"Featured links" => "Links oferecidos",
"Top `\$module_rows` topics" => "Melhores `\$module_rows` tópicos",
"Top topics" => "Tópicos mais discutidos",
"Last `\$module_rows` forum posts" => "Últimas `\$module_rows` mensagens no fórum",
"Last forum posts" => "Últimas mensagens no fórum",
"Last `\$module_rows` forum topics" => "Últimos `\$module_rows` tópicos em fóruns",
"Last forum topics" => "Últimos tópicos de fóruns",
"Most commented forums" => "Fóruns mais comentados",
"Most read topics" => "Tópicos mais lidos",
"Most visited forums" => "Fóruns mais visitados",
"Most popular tags" => "Palavras-chave mais populares",
"My prefered tags" => "Minhas palavras-chave preferidas",
"Google Search" => "Busca Google",
"Last `\$module_rows` actions" => "Últimas `\$module_rows` ações",
"Last actions" => "Últimas ações",
"Last `\$module_rows` articles" => "Últimos `\$module_rows` artigos",
"Last articles" => "Últimos artigos",
"Last `\$module_rows` blog posts" => "Últimas `\$module_rows` postagens em blogs",
"Last blog posts" => "Últimas mensagens para blogs",
"Last" => "Última",
"Last `\$module_rows` Created blogs" => "Últimos `\$module_rows` Blogs criados",
"Last Created blogs" => "Últimos Blogs Criados",
"Last `\$module_rows` Created FAQs" => "Últimas `\$module_rows` FAQs Criadas",
"Last Created FAQs" => "Últimos FAQs Criados",
"Last `\$module_rows` Created Quizzes" => "Últimos `\$module_rows` Testes Criados",
"Last Created Quizzes" => "Últimos Testes Criados",
"Last `\$module_rows` modified file galleries" => "Últimas `\$module_rows` galerias de arquivos modificadas",
"Last modified file galleries" => "Últimas galerias de arquivos modificadas",
"Last `\$module_rows` Files" => "Últimos `\$module_rows` arquivos",
"Last Files" => "Arquivos Recentes",
"Last `\$module_rows` galleries" => "Últimas `\$module_rows` galerias",
"Last galleries" => "Últimas galerias",
"Last `\$module_rows` Images" => "Últimas `\$module_rows` imagens",
"Last Images" => "Últimas imagens",
"insert original" => "inserir original",
"insert thumbnail" => "inserir miniatura",
"Last `\$module_rows` modified events" => "Últimos `\$module_rows` eventos modificados",
"Last modifed events" => "Últimos eventos modificados",
"Last `\$module_rows` changes" => "Últimas `\$module_rows` alterações",
"Last changes" => "Últimas alterações",
"more" => "mais",
"Last `\$module_rows` Modified Items" => "Últimos `\$module_rows` itens modificados",
"Last Modified Items" => "Últimos itens modificados",
"Last `\$module_rows` Modified blogs" => "Últimos `\$module_rows` blogs modificados",
"Last Modified blogs" => "Últimos blogs modificados",
"Last `\$module_rows` submissions" => "Últimas `\$module_rows` submissões",
"Last submissions" => "Últimos artigos enviados",
"Last `\$module_rows` Items" => "Últimos `\$module_rows` itens",
"Last Items" => "Últimos itens",
"Last `\$module_rows` visitors" => "Últimos `\$module_rows` visitantes",
"Last Visitors" => "Últimos visitantes",
"Register" => "Registrar-se",
"You" => "Você",
"Live support" => "Suporte On-line",
"Open operator console" => "Abrir o console de operador",
"Online users" => "Usuários on-line",
"We have" => "Existem",
"online users" => "usuários on-line",
"Logged in as" => "Usuário:",
"Logout" => "Finalizar a sessão",
"Switch User" => "Trocar de usuário",
"Switch" => "Alternar",
"Switch user" => "Trocar de usuário",
"Login through CAS" => "Entrar com CAS",
"Login as admin" => "Logar como administrador",
"Login as" => "Entrar como",
"Email" => "E-mail",
"eMail" => "E-mail",
"Password" => "Senha",
"Remember me" => "Lembre-se de mim",
"week" => "semana",
"month" => "mês",
"year" => "ano",
"Click here to register" => "Clique aqui para registrar",
"Click here if you've forgotten your password" => "Clique aqui se você esqueceu sua senha",
"I forgot my password" => "Esqueci minha senha",
"Click here to login using the default security protocol" => "Clique aqui para autenticar o protocolo padrão",
"Standard" => "Padrão",
"Click here to login using a secure protocol" => "Clique aqui para se autenticar usando um protocolo seguro",
"Secure" => "Seguro",
"Stay in ssl Mode" => "Permanecer no modo seguro",
"local account" => "conta local",
"What is OpenID?" => "O que é OpenID?",
"Tiki Logo" => "Logotipo Tiki",
"You have" => "Você possui",
"New Messages" => "Mensagens novas",
"New Message" => "Mensagem nova",
"You have 0 new messages" => "Você possui 0 mensagens novas",
"Waiting Submissions" => "Artigos Pendentes",
"submissions waiting to be examined" => "Artigos com aprovação pendente",
"Old articles" => "Artigos antigos",
"Send a message to" => "Enviar uma mensagem para",
"Send a message" => "Enviar mensagem",
"Random Images" => "Imagens aleatórias",
"Random Pages" => "Páginas aleatórias",
"Register as a new user" => "Registrar-se como novo usuário",
"Your email could not be validated; make sure you email is correct and click register below." => "Seu endereço de email não pôde ser validado; certifique-se de que está correto e clique em registrar-se abaixo.",
"Your registration code:" => "Seu código de registro:",
"Username" => "Usuário",
"Passcode to register (not your user password)" => "Código para registro (não é sua senha pessoal)",
"Registration code" => "Código de registro",
"Repeat password" => "Confirmação de senha",
"Generate a password" => "Gerar uma senha",
"Articles RSS" => "Artigos RSS",
"Image Galleries RSS" => "Galeria de imagens RSS",
"Image Galleries" => "Galerias de imagens",
"File Galleries RSS" => "Galeria de arquivos RSS",
"File Galleries" => "Galerias de Arquivos",
"Forums RSS" => "Fóruns RSS",
"Maps RSS" => "Mapas RSS",
"Maps" => "Mapas",
"Calendars" => "Calendários",
"Entire Site" => "Todo o Site",
"Wiki Pages" => "Páginas Wiki",
"Image Gals" => "Galeria de imagens",
"Images" => "Imagens",
"Blog Posts" => "Mensagens de Blogs",
"Search Wiki PageName" => "Buscar Nome de Página Wiki",
"Read More" => "Ler Mais",
"Since your last visit" => "Desde sua última visita",
"Since your last visit on" => "Desde sua última visita em",
"New Images" => "Novas imagens",
"Wiki Pages Changed" => "Páginas Wiki alteradas",
"New Files" => "Novos arquivos",
"New Comments" => "Novos comentários",
"New Tracker Items" => "Novos itens de acompanhamento",
"New Calendar Events" => "Novos eventos no calendário",
"New Users" => "Novos usuários",
"click to edit" => "clique para editar",
"Nothing has changed" => "Nenhuma alteração",
"Site Language:" => "Idioma do site:",
"Theme" => "Tema",
"Site default" => "Padrão do site",
"TikiTests Menu" => "Menu do TikiTestes",
"List Tests" => "Listar Testes",
"Create Test" => "Criar Teste",
"Most Active blogs" => "Blogs mais ativos",
"Top `\$module_rows` articles" => "`\$module_rows` melhores artigos",
"Top articles" => "Artigos mais lidos",
"Top `\$module_rows` File Galleries" => "`\$module_rows` Melhores Galerias de Arquivos",
"Top File Galleries" => "Galerias de Arquivos mais visitadas",
"Top `\$module_rows` files" => "Melhores `\$module_rows` arquivos",
"Top files" => "Melhores arquivos",
"Top `\$module_rows` Forum Posters" => "Os mais `\$module_rows` ativos no fórum",
"Top Forum Posters" => "Usuários mais ativos no fórum",
"Top `\$module_rows` games" => "Melhores `\$module_rows` jogos",
"Top games" => "Jogos mais populares",
"Top `\$module_rows` galleries" => "`\$module_rows` melhores galerias",
"Top galleries" => "Galerias mais visitadas",
"Top `\$module_rows` Images" => "`\$module_rows` melhores imagens",
"Top Images" => "Imagens mais populares",
"Top Objects" => "Objetos mais vistos",
"Top `\$module_rows` Pages" => "Melhores `\$module_rows` Páginas",
"Top Pages" => "Páginas mais visitadas",
"Top `\$module_rows` Quizzes" => "Melhores `\$module_rows` Testes",
"Top Quizzes" => "Testes mais visitados",
"Most `\$module_rows` visited blogs" => "`\$module_rows` Blogs mais visitados",
"Top `\$module_rows` Visited FAQs" => "`\$module_rows` FAQs mais visitadas",
"Top Visited FAQs" => "FAQs mais visitados",
"Page translation" => "Tradução da página",
"There are no translations of this page." => "Não há traduções desta página.",
"Better translations" => "Melhores traduções",
"update from it" => "atualizar deste",
"view" => "ver",
"None match your" => "Nenhum casa com o seu",
"preferred languages" => "idiomas preferenciais",
"Equivalent translations" => "Traduções equivalentes",
"Translations that need improvement" => "Traduções que precisam ser melhoradas",
"update it" => "atualizar",
"The Next Event" => "O Próximo Evento",
"No Upcoming Events" => "Sem Eventos Futuros",
"click to view" => "clique para ver",
"My blogs" => "Meus Blogs",
"Bookmarks" => "Favoritos",
"My galleries" => "Minhas galerias",
"My Pages" => "Minhas Páginas",
"User tasks" => "Tarefas do usuário",
"Done" => "pronto",
"Public tasks" => "Tarefas públicas",
"select" => "selecionar",
"User informations" => "Informações do usuário",
"Group informations" => "Informações do grupo",
"You need to activate user and/or group trackers" => "Você precisa ativar o acompanhamento para usuário e/ou grupo",
"Top users" => "Usuários mais ativos",
"Whats related" => "O que está relacionado",
"online user" => "usuário on-line",
"on host" => "no servidor",
"Last `\$module_rows` wiki comments" => "Últimos `\$module_rows` comentários no wiki",
"Last wiki comments" => "Últimos comentários no wiki",
"on page" => "na página",
"Videos on YouTube" => "Vídeos no YouTube",
"More Videos" => "Mais vídeos",
"Real Name" => "Nome completo",
"vote" => "votar",
"Send Newsletter" => "Enviar newsletter",
"Insert/Edit an internal wiki link" => "Inserir/Editar um link wiki interno",
"Wiki Link insert" => "Inserir link wiki",
"Please make a selection of text in order to create a link" => "Por favor, selecione um texto para poder criar um link",
"Insert an image" => "Insira uma imagem",
"Tiki Image - Insert an image" => "Imagem Tiki - Insira uma imagem",
"Structures:" => "Estruturas:",
"show structures" => "mostrar estruturas",
"hide structures" => "esconder estruturas",
"Manage structures" => "Administrar estruturas",
"By" => "Por",
"Location : " => "Localização : ",
"Find:" => "Localizar:",
"Read more" => "Leia mais",
"pages" => "páginas",
"To edit the copyright notices" => "Para editar as mensagens de diretos autorais",
"Click Here" => "Clique aqui",
"The content on this page is licensed under the terms of the" => "O conteúdo desta página é licenciado sob os termos do",
"Print" => "Imprimir",
"Email This Post" => "enviar por email",
"Permalink" => "Link permanente",
"comment" => "comentário",
"comments" => "comentários",
"First page" => "Primeira página",
"Previous page" => "Página anterior",
"page" => "página",
"Next page" => "Próxima página",
"Last page" => "Última página",
"referenced by" => "referenciado por",
"references" => "referências",
"View Comments" => "Ver comentários",
"Blog name" => "Nome do blog",
"Enlarge area height" => "Ampliar a altura de área",
"Reduce area height" => "Reduzir a altura de área",
"Do not group by item" => "Não agrupar por item",
"Group by item" => "Agrupar por item",
"Calendar View" => "Ver em forma de calendário",
"List View" => "Ver em forma de lista",
"Tools Calendars" => "Calendários de Ferramentas",
"Check / Uncheck All" => "Marcar / desmarcar todos",
"Refresh" => "Atualizar",
"Tip" => "Dica",
"Cancel Edit" => "Cancelar edição",
"Change preferences" => "Alterar preferências",
"Site Ads and Banners" => "Publicidade e banners do site",
"Content" => "Conteúdo",
"Activate" => "Ativar",
"Publish" => "publicação",
"General" => "Geral",
"Features" => "Recursos",
"Profiles" => "Perfis",
"Customize look and feel of your Tiki" => "Personalize a aparência do seu site",
"Look &amp; Feel" => "Aparência",
"i18n" => "Idioma",
"Module" => "Módulo",
"Community" => "Comunidade",
"Freetags" => "Palavras-chave",
"Multimedia" => "Multimídia",
"User files" => "Arquivos do usuário",
"Wysiwyg editor" => "Editor Wysiwyg",
"Semantic wiki links" => "Links wiki semânticos",
"Semantic links" => "Links semânticos",
"Webservices" => "Serviços Web",
"To add/remove blogs, go to \"Create/Edit Blog\" under \"Blogs\" on the application menu, or" => "Para adicionar/remover blogs, va para \"Create/Edit Blog\" em \"Blogs\" no menu de aplicações, ou",
"General Settings" => "Configurações Gerais",
"Home Blog (main blog)" => "Blog Inicial (Blog principal)",
"Not Installed" => "Não Instalado",
"Points" => "Pontos",
"Title length" => "Tamanho do título",
"Creation date" => "Data de criação",
"Last modified" => "Última modificação em",
"To add/remove calendars, look for \"Calendar\" under \"Admin\" on the application menu, or" => "Para adicionar/remover calendários, vá em \"Calendário\" em \"Administrar\" no menu principal, ou",
"Change settings" => "Alterar configurações",
"Default view mode" => "Visualização padrão",
"First day of the week" => "Primeiro dia da semana",
"Split hours in periods of" => "Dividir horas em períodos de",
"1 minute" => "1 minuto",
"10 minutes" => "10 minuto",
"Browse categories" => "Navegar nas categorias",
"Enable now" => "Habilite agora",
"Permissions" => "permissões",
"Ignore category viewing restrictions" => "Ignorar restrições para visualizar categorias",
"Look under \"Articles\" on the application menu for links to" => "Procure em \"Articles\" no menu de aplicações por links para",
"Admin topics" => "Administrar topicos",
"Admin types" => "Administrar tipos",
"Articles Listing" => "Lista de Artigos",
"Title of articles home page" => "Título da página inicial de arquivos",
"Topic" => "Assunto",
"Maximum number of articles on articles home page" => "Número máximo de artigos na página inicial de artigos",
"Submissions" => "Artigos submetidos",
"Specify notification emails when creating articles" => "Especificar e-mails de notificação quando criar artigos",
"Import CSV file" => "Importar arquivo CSV",
"Batch upload (CSV file)" => "Carga em lote (arquivo CSV)",
"File format: title,authorName,heading,body,lang,user" => "Formato de arquivo: título, autor, cabeçalho, corpo, idioma, usuário",
"Import" => "Importar",
"Select which items to display when listing articles" => "Selecione que arquivos mostrar quando listando artigos",
"Publication date" => "Data de publicação",
"Expiration date" => "Data de expiração",
"Visible" => "Visível",
"Users Listing" => "Lista de usuários",
"Users can choose to show their gender" => "Usuários podem escolher mostrar seu sexo",
"Requires User Preferences feature" => "Requer o recurso Preferências do Usuário",
"Show user's information on mouseover" => "Mostrar informações do usuário ao passar o mouse sobre",
"Real name" => "Nome real",
"Gender" => "Sexo",
"avatar" => "fotografia",
"Number of friends" => "Número de amigos",
"Feature is disabled" => "Recurso não habilitado",
"Last login" => "Último login",
"Distance" => "Distância",
"Default user preferences" => "Preferências do usuário padrão",
"Users Default Preferences" => "Preferências padrão do usuário",
"default" => "padrão",
"Number of visited pages to remember" => "Número de páginas visitadas a lembrar",
"Displayed time zone" => "Fuso horário exibido",
"User information" => "Informação do Usuário",
"Private" => "Privada",
"public" => "pública",
"Use double-click to edit pages" => "Clique-duplo para editar páginas",
"Show user's info on mouseover" => "Mouseover mostra informações do usuário",
"Tasks per page" => "Tarefas por página",
"User messages" => "Mensagens de usuário",
"Messages per page" => "Mensagens por página",
"Allow messages from other users" => "Permitir mensagens de outros usuários",
"Notify sender when reading mail" => "Notificar remetente quando o e-mail for lido",
"Send me an email for messages with priority equal or greater than" => "Envie-me um email para mensagens com prioridade igual ou maior que",
"Auto-archive read messages after x days" => "Arquivar automaticamente mensagens lidas depois de x dias",
"never" => "nunca",
"My Tiki" => "Meu Tiki",
"My pages" => "Minhas páginas",
"My messages" => "Minhas mensagens",
"My tasks" => "Minhas tarefas",
"My forum topics" => "Meus tópicos nos fóruns",
"My forum replies" => "Minhas respostas nos fóruns",
"My items" => "Meus itens",
"My workflow" => "Minha workflow",
"Select which items to display when listing users" => "Selecione quais itens mostrar quando listar usuários",
"Copyright allows to determine a copyright for all the objects of tikiwiki" => "Copyright permite determinar um copyright para todos os objetos do TikiWiki",
"Submit notice" => "Enviar notícia",
"Feature" => "Recurso",
"To configure your directory, find \"Admin Directory\" under \"Directory\" on the application menu, or" => "Para configurar o seu diretório, procure \"Admin Directory\" em \"Directory\" no menu de aplicações, ou",
"Number of columns per page when listing categories" => "Número de colunas por página quando listar categorias",
"Links per page" => "Links por página",
"Validate URLs" => "Validar Endereços",
"enable cool sites" => "habilitar sites legais",
"Show Country Flag" => "Mostrar bandeira do país",
"Method to open directory links" => "Abrindo links do diretório",
"New Window" => "Nova janela",
"To add/remove FAQs, look for \"Admin FAQs\" under \"FAQs\" on the application menu, or" => "Para adicionar/remover FAQs, procure por \"Admin FAQs\" em \"FAQs\" no menu de aplicações, ou",
"Default number of comments per page" => "Número padrão de comentários por página",
"Comments default ordering" => "Ordenação padrão para comentários",
"No tabs" => "Nenhuma aba",
"Apply" => "Aplicar",
"Reset" => "Reiniciar",
"Main" => "Principal",
"Global Features" => "Recursos globais",
"More Functionality" => "Outras funcionalidades",
"UI Enhancements" => "Melhorias de interface",
"Main Features" => "Recursos principais",
"Newsletters" => "Comunicados",
"Site Global Features" => "Recursos globais",
"Action Log" => "Log de atividades",
"Action log setting" => "Configurar log de atividades",
"Internationalization" => "Internacionalização",
"Multilingual" => "Multilíngüe",
"Additional Features" => "Recursos adicionais",
"Surveys" => "Pesquisas",
"Featured Help" => "Auxílio oferecido",
"Live support system" => "Sistema de auxílio on-line",
"Tell a Friend" => "Envie para um amigo",
"HTML pages" => "páginas HTML",
"Contact Us" => "Entre em Contato",
"User interface enhancement features" => "Recursos de interface",
"JsCalendar" => "Calendário Java Script",
"PhpLayers Dynamic menus" => "Menus dinâmicos PhpLayers",
"Fullscreen" => "Modo tela cheia",
"Allow users to activate fullscreen mode" => "Permitir que usuários ativem o modo tela cheia",
"Experimental Features" => "Recursos experimentais",
"Mobile" => "Dispositivos móveis",
"Morcego 3D browser" => "Navegador Morcego 3D",
"Search engine friendly url" => "URL amigável",
"Spreadsheet" => "Planilha",
"Tiki Sheet" => "Planilha Tiki",
"Magic Admin Panel" => "Painel de Administração Mágico",
"Old features no longer maintained" => "Recursos antigos sem manutenção",
"Drawings" => "Desenhos",
"Friendship" => "Amizade",
"Friendship Network" => "Rede de amigos",
"Games" => "Jogos",
"SWFObject" => "Objeto SWF",
"SwfObject" => "Objeto Swf",
"Administration Features" => "Recursos de administração",
"Banning System" => "Sistema de Banimento",
"Banning system" => "Sistema de banimento",
"Stats" => "Estatísticas",
"Redirect On Error" => "Redirecionar em caso de erro",
"Communications (send/receive objects)" => "Comunicação (enviar/receber objetos)",
"Custom Home" => "Página Inicial Personalizada",
"User Features" => "Recursos do Usuário",
"Mini Calendar" => "Mini-Calendário",
"User Preferences Screen" => "Tela de Preferências do Usuário",
"User Notepad" => "Bloco de notas do usuário",
"User Bookmarks" => "Favoritos",
"User Contacts" => "Contatos do usuário",
"User Watches" => "Notificações do usuário",
"User Watches Translations" => "Usuários acompanham as traduções",
"User Menu" => "Menu do Usuário",
"User Tasks" => "Tarefas do usuário",
"User Messages" => "Mensagens do usuário",
"User Files" => "Arquivos do usuário",
"Newsreader" => "Notícias",
"Integrator" => "Integrador",
"XMLRPC API" => "API de XMLRPC",
"Debugger Console" => "Console de depuração",
"requires PHP5 or more" => "requer PHP5 ou uma versão mais atual",
"Workflow engine" => "Gerenciador de Workflow",
"If you decide to store files in a directory you must ensure that the user cannot access directly to the directory." => "Se você decidir guardar arquivos em um diretório precisa ter certeza de que os usuários não conseguem acessam diretamente o diretório escolhido.",
"You have two options to accomplish this:<br /><ul><li>Use a directory outside your document root, make sure your php script can read and write to that directory</li><li>Use a directory inside the document root and use .htaccess to prevent the user from listing the directory contents</li></ul>" => "Você tem duas opções:<br /><ul><li>Usar um diretório fora do documento root, para isso verifique se o seu script php pode ler e escrever nesse diretório</li><li>Usar um diretório dentro do documento root e usar .htaccess para prevenir que os usuários possam listar o conteúdo do diretório</li></ul>",
"To configure the directory path use UNIX like paths for example files/ or c:/foo/files or /www/files/" => "Para configurar o diretório do patch use patchs do UNIX, por exemplo files/ ou c:/foo/files ou /www/files/",
"Home Gallery (main gallery)" => "Galeria Inicial (galeria principal)",
"The server must be able to read/write the directory." => "O servidor precisa ter permissão de leitura e escrita no diretório.",
"The directory can be outside the web space." => "O diretório pode ser fora do espaço web.",
"Allow download limit per file" => "Permitir limite de download por arquivo",
"Prevent download if score becomes negative" => "Não permite download se a pontuação for negativa",
"Score is disabled" => "Pontuação não está habilitada",
"Allow same file to be uploaded more than once" => "Permitir que o mesmo arquivo seja enviado mais de uma vez",
"Never" => "Nunca",
"Yes, even in the same gallery" => "Sim, inclusive na mesma galeria",
"Only in different galleries" => "Apenas em galerias diferentes",
"The server must be able to read the directory." => "O servidor precisa ter acesso de leitura ao diretório.",
"MIME Type" => "Tipo MIME",
"Reindex all files for search" => "Reindexar todos os arquivos para busca",
"To add/remove forums, look for \"Admin forums\" under \"Forums\" on the application menu, or" => "Para adicionar/remover forums, procure por \"Admin forums\" em \"Forums\" no menu de aplicações, ou",
"Home Forum (main forum)" => "Fórum Inicial (fórum principal)",
"Accept wiki syntax" => "Aceitar sintaxe Wiki",
"Do not prefix messages titles by 'Re: '" => "Não adicione prefixo em mensagens com titulo 'Re: '",
"Topics" => "Assuntos",
"Posts per day" => "Mensagens por dia",
"Number of Tags to show in Tag Suggestions" => "Número de tags para mostrar na sugestão de tags",
"Valid characters pattern" => "Padrão de caracteres válidos",
"basic" => "básico",
"Cleanup unused tags" => "Deletar tags não utilizadas",
"Browser width" => "Largura da janela do navegador",
"Browser height" => "Altura da janela do navegador",
"Navigation depth" => "Profundidade da navegação",
"Text size" => "Tamanho do texto",
"Camera distance" => "Distância da câmera",
"Field of view" => "Campo de vista",
"Feed animation interval (milisecs)" => "Intervalo de popup dos páginas (milisegundos)",
"To add/remove image galleries, go to \"Image Galleries\" on the application menu, or" => "Para adicionar/remover galerias, vá para \"Acervo de imagens\" no menu de aplicações, ou",
"You can upload images of a size of " => "Você pode fazer upload de imagens nesse tamanho ",
"Alter the php.ini variables file_uploads, upload_max_filesize, post_max_size and database variables (max_allowed_packet for mysql) to change this value" => "Altere as variáveis file_uploads, upload_max_filesize, post_max_size e database variables (max_allowed_packet no mysql) para mudar os valores no arquivo php.ini",
"Home Gallery" => "Página inicial das Galerias",
"Galleries features" => "Recursos das Galerias",
"Uses Slideshow" => "Usar Slideshow",
"Use database to store images" => "Utilizar banco de dados para armazenar imagens",
"Use a directory to store images" => "Utilizar um diretório para armazenar imagens",
"Directory path" => "Caminho do diretório",
"Library to use for processing images" => "Biblioteca para processamento de imagens",
"Uploaded image names must match regex" => "Imagens carregadas devem seguir a expressão regular",
"Uploaded image names cannot match regex" => "Imagens carregadas não podem seguir a expressão regular",
"Directory Batch Loading" => "Carregar diretórios em lote",
"If you enable Directory Batch Loading, you need to setup a web-readable directory (outside of your web space is better). Then setup a way to upload images in that dir, either by scp, ftp, or other protocols" => "Se você ativar a opção para carregar diretórios em lote, é necessário configurar um diretório onde seu servidor web possa ler (de preferência fora do seu espaço web). Também é necessário configurar uma forma para fazer o upload de imagens para aquele diretório, isso pode ser por scp, ftp, ou de outras formas",
"Enable directory batch loading" => "Habilitar a função de carregar diretórios em lote",
"Batch loading directory" => "Diretório carregado em lote",
"Display image informations in a mouseover box" => "Mostrar informações da imagem no mouseover",
"yes, and don't display those informations under the image" => "sim, e também mostrar as informações abaixo da imagem",
"Default:" => "Padrão:",
"Images per row" => "Imagens por linha",
"Thumbnails size X" => "Largura das miniaturas",
"Thumbnails size Y" => "Altura das miniaturas",
"Set features" => "Definir recursos",
"Exterminator" => "Exterminador",
"Remove images in the system gallery not being used in Wiki pages, articles or blog posts" => "Remover da galeria do sistema imagens que não estão sendo usados ou páginas Wiki, artigos ou mensagens de Blog",
"Move images from database storage to filesystem storage" => "Mover imagens da base dados para um diretório no sistema de arquivos",
"Move images from filesystem storage to database storage" => "Mover imagens de um diretório no sistema de arquivos para a banco de dados",
"All galleries" => "Todas as galerias",
"System Gallery" => "Galeria do sistema",
"Move images from old filesystem store to new directory" => "Mover imagens de um diretório antigo para um novo diretório no sistema de arquivos",
"Moved" => "Movido",
"Gallery listing configuration" => "Configuração da listagem de galeria",
"Parent" => "Pai",
"Change configuration" => "Alterar configuração",
"Image galleries comments settings" => "Configurações de comentários para galerias de imagens",
"General Preferences" => "Preferências gerais",
"Date and Time Formats" => "Formatos de data e hora",
"Tiki version" => "Versão do Tiki",
"Check frequency" => "Checar frequência",
"Site Identity" => "Identidade do site",
"Browser title" => "Título no navegador",
"Home Page" => "Página Principal",
"Use group homepages" => "Página inicial por grupo",
"Go to group homepage only if login from default homepage" => "Ir para a página inicial do grupo apenas se o login for feito a partir da página inicial padrão",
"Custom home" => "Página inicial personalizada",
"Unknown/Other" => "Desconhecido/Outro",
"(standard)" => "(padrão)",
"(some Unix MTA)" => "(alguns Unix MTA)",
"PHP error reporting level:" => "Mensagens de erro do PHP:",
"Protect against CSRF with a ticket" => "Proteger contar CSRF com um ticket",
"Use proxy" => "Usar proxy",
"Port" => "Porta",
"Tikiwiki.org help" => "Ajuda Tikiwiki.org",
"Store session data in database" => "Armazenar sessões no banco de dados",
"Contact" => "Contato",
"Contact user" => "Usuário para contato",
"Count admin pageviews" => "Contar visitas do admin",
"Temporary directory" => "Diretório temporário",
"Help System" => "Sistema de Ajuda",
"Help URL" => "URL de ajuda",
"Examples" => "Exemplos",
"Long date format" => "Formato longo para datas",
"Short date format" => "Formato curto para datas",
"Long time format" => "Formato longo para horas",
"Short time format" => "Formato curto para horas",
"Fields display order" => "Ordem de exibição dos campos",
"Date and Time Format Help" => "Auxílio para formatos de data e hora",
"Change admin password" => "Alterar a senha de admin",
"New password" => "Nova senha",
"Minimum {\$prefs.min_pass_length} characters long" => "mínimo de {\$prefs.min_pass_length} caracteres",
"Change password" => "Alterar senha",
"You need to request a Google Maps Key for this web site. You can easily generate a key for your domain at :" => "Você precisa soliticar uma chave do Google Maps para esse site. Isso pode ser feito no endereço:",
"Google Map Key" => "Chave do Google Maps",
"Default zoom level" => "Nível de zoom padrão",
"whole earth" => "toda terra",
"country size" => "tamanho do país",
"city size" => "tamanho da cidade",
"max zoom" => "zoom máximo",
"Detect browser language" => "Detectar idioma do navegador",
"Show pages in user's preferred language" => "Mostrar páginas no idioma padrão do usuário",
"Restrict supported languages" => "Restringir idiomas disponíveis",
"Use database for translation" => "Usar banco de dados para tradução",
"Edit or ex/import Languages" => "Editar ou importar/exportar Línguas",
"Record untranslated" => "Gravar sem tradução",
"Warning: overrides manually registered local users" => "Alerta: sobrescreve usuários locais criados manualmente",
"Import user preferences" => "Importar preferências do usuários",
"Import user groups" => "Importar grupos de usuários",
"host" => "servidor",
"port" => "porta",
"Add new server" => "Adicionar novos servidores",
"Key" => "Chave",
"Enable/disable Tiki features in " => "Habilitar/desabilitar recursos do Tiki em ",
", but configure them elsewhere" => ", mas configure em outro lugar",
"Text Area" => "Área de texto",
"Admin Groups" => "Administrar grupos",
"Admin Users" => "Administrar usuários",
"Authentication method" => "Método de autenticação",
"Tiki and HTTP Auth" => "Tiki e autenticação HTTP",
"Registration" => "Inscrição",
"Users can register" => "Usuários podem se cadastrar",
"You need to set <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Sender Email</a>" => "Você precisa configurar o <a href=\"tiki-admin.php?page=general&amp;cookietab=2\">Remetente do E-mail</a>",
"Validate user's email server" => "Validar servidor de e-mail do usuário",
"Require validation by Admin" => "Exigir validação pelo Administrador",
"Require passcode to register" => "Exigir código secreto para registrar",
"Passcode" => "Código Secreto",
"Users must enter this code to register" => "Usuários devem entrar com esse código para registrar",
"Use CAPTCHA to prevent automatic/robot registrations" => "Prevenir registro automático de robos",
"Requires PHP GD library" => "Requer biblioteca PHP GD",
"Include &quot;Generate Password&quot; option on registration form" => "Incluier opção &quot;Gerar Senha&quot; no formulário de registro",
"Use tracker to collect more user information" => "Usar acompanhamento (tracker) para colertar mais informações do usuário",
"Use the <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Admin: Groups</a></strong> page to select which tracker and fields to display" => "Usar a página <strong><a href=\"tiki-admingroups.php\" title=\"Admin Groups\">Administrar: Grupos</a></strong> para selecionar qual acompanhamento (tracker) e quais campos exibir",
"Use tracker to collect more group information" => "Usar acompanhamento (tracker) para coletar mais informações do grupo",
"Users can select a group to join at registration" => "Usuários podem escolher em que grupo entrar ao se registrar",
"By default, new users automatically join the Registered group" => "Por padrão, novos usuários são automaticamente adicionados ou grupo Registrados",
"Re-validate user by email after" => "Re-validar usuário por e-mail depois",
"Use <strong>-1</strong> for never" => "Use <strong>-1</strong> para nunca",
"unsuccessful login attempts" => "falha no login exibe",
"Create a new group for each user" => "Criar uma novo grupo para cada usuário",
"The group will be named identical to the user's username" => "O grupo será nomeado igual ao nome de usuário",
"Disable browser's autocomplete feature for username and password fields" => "Desabilitar recurso Auto-completar dos navegadores para nome de usuário e senha",
"Use challenge/response authentication" => "Utilizar autenticação desafio/resposta",
"Confirm that the Admin account has a valid email address or you will not be permitted to login" => "Confirmar se a conta do Administrador tem um e-mail válido ou você não poderá logar-se",
"Use HTTPS login" => "Usar login HTTPS",
"Users can choose to stay in SSL mode after an HTTPS login" => "Usuários podem escolher ficar no modo SSL depois de efetuar login HTTPS",
"Users can switch between secured or standard mode at login" => "Usuários podem escolher entre modo de login padrão e seguro",
"HTTP port" => "Porta HTTP",
"HTTPS port" => "Porta HTTPS",
"User's choice" => "Escolhar do usuário",
"Always" => "Sempre",
"Method" => "Método",
"Duration" => "Duração",
"Use email as username" => "Usar email como nome de usuário",
"Minimum length" => "Tamanho mínimo",
"Maximum length" => "Tamanho máximo",
"Force lowercase" => "Forçar letras minúsculas",
"Username pattern" => "Padrão para nome de usuário",
"Store password as plain text" => "Armazenar senha como texto simples",
"Remind/forgot password" => "Lembrar Senha",
"If passwords </em>are stored<em> as plain text, the password will be emailed to the user" => "Se a senha </em>estiver armazenada<em> como texto simples, ela será enviada por e-mail ao usuário",
"If passwords </em>are not<em> plain text, reset instructions will be emailed to the user" => "Se a senha </em>NÃO estiver<em> armazenada como texto simples, instruções para resetá-la serão enviadas ao usuaŕio",
"Encryption method" => "Método de criptografia",
"Users can change their password" => "Usuários podem modificar suas senhas",
"Require characters and numerals" => "Exigir letras e números",
"Password expires after" => "Senha expira depois de",
"You must change the Authentication Method to PEAR::Auth for these changes to take effect" => "Você deve mudar o Método de Autenticação para PEAR::Auth para essas mudanças terem efeito",
"Create user if not in Tiki" => "Criar usuário se não estiver no Tiki",
"Create user if not in Auth" => "Criar usuário se não estiver no Auth",
"Use Tiki authentication for Admin login" => "Use autenticação do Tiki para login do Administrador",
"PAM service" => "Serviço PAM",
"Currently unused" => "Atualmente sem uso",
"CAS server version" => "Versão do servidor CAS",
"Version 1.0" => "Versão 1.0",
"Version 2.0" => "Versão 2.0",
"General Layout" => "Layout do site",
"Reg users can change theme" => "Usuários comuns podem alterar tema",
"Restrict available themes" => "Restringir temas disponíveis",
"Available styles:" => "Estilos disponíveis:",
"Slideshows theme" => "Tema para slides",
"Edit CSS" => "Editar CSS",
"Theme Control" => "Controle de temas",
"Template Viewing" => "Visualizar templates",
"Tiki Template Viewing" => "Visualização de Modelos Tiki",
"General Layout options" => "Opções gerais de layout",
"Custom Site Header" => "Cabeçalho personalizado",
"logged as" => "logado como",
"Site Logo and Title" => "Logotipo e Título do Site",
"Site logo source (image path)" => "Caminho para a imagem de logotipo",
"Site logo background color" => "Cor de fundo do logo do site",
"Site logo background style" => "Estildo do plano de fundo do logo",
"Site logo alignment" => "Alinhamento do logo do site",
"Site logo title (on mouse over)" => "Título do logo do site (aparece quando o mouse passa por cima)",
"Alt. description (e.g. for text browsers)" => "Descrição alternativa (ex: para navegadores modo texto",
"Site title" => "Título do Site",
"Site subtitle" => "Sub-título do Site",
"Site Search Bar" => "Barra de busca no site",
"Site Login Bar" => "Barra de login",
"Site menu bar" => "Barra do menu do site",
"Current Version" => "Versão atual",
"Custom code" => "Código personalizado",
"Users can Flip Columns" => "Usuários podem mudam colunas",
"Left column" => "Coluna da esquerda",
"always" => "sempre",
"user decides" => "usuário decide",
"Site Breadcrumbs" => "Rastro de navegação",
"Site location bar" => "Barra de localização do site",
"at top of page" => "no topo da página",
"at top of center column" => "no topo da coluna central",
"Larger font for" => "Maior fonte para",
"entire location" => "localização completa",
"page name" => "nome da página",
"Use page description:" => "Descrição do uso da página:",
"Right column" => "Coluna da direita",
"Left blank to use the default sender email" => "Deixe em branco para usar o e-mail padrão",
"Email this page" => "Enviar para um amigo",
"Custom Site Footer" => "Rodapé personalizado",
"Bottom bar icons" => "Ícones da barra inferior",
"Bottom bar debug" => "Informações de <i>debug</i> na barra inferior",
"Pagination links" => "Paginação",
"Maximum number of records in listings" => "Número máximo de registros em listagens",
"Use relative (next / previous) pagination links" => "Usar links de paginação relativos (próximo / anterior)",
"Use direct pagination links" => "Links de paginação direta",
"Max. number of links around the current item:" => "Número máximo de links em torno da página atual:",
"Max. number of links after the first or before the last item:" => "Número máximo de links depois da primeira ou antes da última página:",
"Display 'First' and 'Last' links" => "Exibir links 'Primeiro' e 'Último'",
"Use Icons" => "Usar ícones",
"Warning" => "Aviso",
"Left" => "Esquerda",
"Right" => "Direita",
"Other options" => "Outras opções",
"Use Tabs" => "Usar Tabs",
"Display menus as folders" => "Exibir menus como pastas",
"Layout per section" => "Layout por sessão",
"Admin layout per section" => "Administrar layout por sessão",
"Favicon icon file name:" => "Nome do arquivo do favicon:",
"Favicon icon MIME type:" => "Tipo MINE do Favicon:",
"image/png" => "imagem/png",
"image/bmp" => "imagem/bmp",
"image/x-icon" => "imagem/x-icon",
"full path to mapfiles" => "caminho completo para os arquivos de mapas",
"default mapfile" => "arquivo de mapa padrão",
"Wiki Page for Help" => "Página Wiki para Ajuda",
"Wiki Page for Comments" => "Página Wiki para Comentários",
"Full path to gdaltindex" => "Caminho completo para o gdaltindex",
"Full path to ogr2ogr" => "Path completo para ogr2ogr",
"Map Zone" => "Zona do mapa",
"Generate User Map" => "Gerar mapa do usuário",
"Maximum mailbox size (messages, 0=unlimited)" => "Tamanho máximo da caixa de entrada (mensagens, 0=ilimitado)",
"Maximum mail archive size (messages, 0=unlimited)" => "Tamanho máximo do arquivo de e-mail (mensagens, 0=ilimitado)",
"Maximum sent box size (messages, 0=unlimited)" => "Tamanho máximo da caixa de saída (mensagens, 0=ilimitado)",
"geo.position" => "geo.posição",
"geo.region" => "geo.região",
"geo.placename" => "geo.nome_do_local",
"Robots" => "Robôs",
"Display modules to all groups always" => "Módulos acessíveis por todos grupos",
"Hide anonymous-only modules from registered users" => "Esconder módulos exclusivos dos usuários anônimos de usuários registrados",
"Flash Length" => "Largura do flash",
"Flash Heigth" => "Altura do flash",
"Video Length" => "Largura do vídeo",
"Video Heigth" => "Altura do vídeo",
"To add/remove polls, look for \"Polls\" under \"Admin\" on the application menu, or" => "Para adicionar/remover enquetes, procure por \"Polls\" em \"Admin\" no menu de aplicações, ou",
"Show categories" => "Mostrar categorias",
"Show objects" => "Mostrar objetos",
"Last update" => "Última atualização",
"Profile" => "Perfil",
"Repository" => "Repositório",
"installed" => "instalado",
"Use this page to configure the RSS feeds generated by Tiki. To syndicate RSS feeds from other sites, use the <strong>Admin</strong> &gt; <strong>RSS Modules</strong> menu option, or" => "Use essa página para configurar os feeds RSS gerados pelo Tiki. Para agregar feeds RSS de outros sites veja a opção <strong>Admin</strong> &gt; <strong>Módulos RSS</strong> do menu, ou",
"Feed for articles" => "Feed para artigos",
"Feature is disabled." => "Recurso desabilitado.",
"Maximum number of items to display" => "Número máximo de itens a serem exibidos",
"Feed for blogs" => "Feed para os blogs",
"Individual blogs" => "Para cada blog",
"Image galleries" => "Galerias de imagens",
"Feed for image galleries" => "Feed para as galerias de imagens",
"Individual image galleries" => "Para cada galeria de imagem",
"Feed for file galleries" => "Feed para as galerias de arquivos",
"Individual file galleries" => "Para cada galeria de arquivo",
"Feed for wiki" => "Feed para páginas wiki",
"Feed for forums" => "Fonte para fóruns",
"Individual forums" => "Para cada fórum",
"Individual trackers items" => "Para cada item dos acompanhamentos",
"Calendar events" => "Eventos do calendário",
"Defaults" => "Padrões",
"Default RDF version" => "Versão RDF padrão",
"Specification" => "Especificação",
"Documentation" => "Documentação",
"Enabling caching will override existing permissions - all content will be public. Enable this option <strong>only</strong> if your syndicated content should be public." => "Ao habilitar o cache você sobrescreve todas as permissões existentes - todo o conteúdo do site será público. Habilite essa opção <strong>apenas</strong> se deseja que o conteúdo do site seja público.",
"You can see users rank by score in the module users_rank, for that go to" => "Você pode ver o ranking dos usuários no módulo users_rank, para isso procure por",
"Admin modules" => "Administrar módulos",
"Expiration" => "Expiração",
"Search stats" => "Estatísticas de busca",
"random" => "aleatório",
"Refresh rate" => "Taxa de atualização",
"Minimum length of search word" => "Tamanho mínimo da palavra de busca",
"Max. number of words containing a syllable" => "Número máximo de palavras contendo uma sílaba",
"Max. age in hours of syllable search cache" => "Tempo máximo em horas de buscas de sílabas armazenadas",
"LRU list length" => "Tamanho da lista LRU",
"Refresh wiki search index now" => "Atualizar índice de busca no wiki agora",
"Referer Search Highlighting" => "Destacar busca",
"Ignore individual object permissions" => "Ignorar permissões individuais para objeto",
"hits" => "visitas",
"Open external links in new window" => "Links externos em nova janela",
"Dynamic Content System" => "Sistema de Conteúdo Dinâmico",
"Allow to post comments as Anonymous" => "Permitir que anônimos enviem comentários",
"Automonospaced text" => "Texto auto-monoespaçado",
"Tables syntax" => "Sintaxe de tabelas",
"rows" => "linhas",
"Required" => "Obrigatório",
"Parameters" => "Parâmetros",
"To configure your trackers, look for \"Admin trackers\" under \"Trackers\" on the application menu, or" => "Para configurar seus acompanhamentos, procure por \"Admin trackers\" em \"Trackers\" no menu de aplicações, ou",
"Trackers with mirror tables" => "Acompanhamentos com tabelas espelho",
"Use trackers with mirror tables" => "Usar acompanhamentos com tabelas espelho",
"Values are stored in a dedicated table for each tracker, then you can easily manipulate them outside Tikiwiki" => "Dados são armazenados em uma tabela dedicada para cada acompanhamento, então você pode facilmente manipulá-los fora do Tikiwiki",
"Validate choice" => "Validar escolha",
"Storage" => "Armazenar",
"Change" => "Mudar",
"No records" => "Nenhum registro",
"Change all to db" => "Mudar tudo para a banco de dados",
"Change all to file" => "Mudar tudo para arquivo",
"Quota (Mb)" => "Cota (Mb)",
"Use database to store userfiles" => "Utilizar o banco de dados para armazenar arquivos dos usuários",
"Use a directory to store userfiles" => "Utilizar um diretório para armazenar arquivos dos usuários",
"Allow viewing HTML mails?" => "Permitir visualização de mensagens HTML?",
"Maximum size for each attachment" => "Tamanho máximo para cada arquivo anexado",
"Unlimited" => "Ilimitado",
"Create New" => "Criar nova",
"Home page" => "Página inicial",
"Complete" => "Completo",
"Individual cache" => "Armazenamento individual",
"Content templates" => "Padrões de conteúdo",
"Warn on edit conflict" => "Avisar quando houver conflito de edição",
"Undo" => "Desfazer",
"Footnotes" => "Notas de rodapé",
"Permission" => "Permissão",
"Allow HTML" => "Permitir HTML",
"Sandbox" => "Bancada de testes",
"Manage attachments" => "Administrar Manage attachments",
"Dumps" => "Exportações",
"Remove a tag" => "Remover um rótulo",
"Generate dump" => "Gerar exportação",
"Download last dump" => "Download última exportação",
"Pictures" => "Imagens",
"Remove unused pictures" => "Remover imagens não utilizadas",
"Export" => "Exportar",
"Export Wiki Pages" => "Exportar páginas Wiki",
"Accept dashes and underscores in WikiWords" => "Aceitar hífen e travessão em PalavrasWiki",
"Link plural WikiWords to their singular forms" => "Conectar plurais de PalavrasWiki para suas formas singulares",
"Side-by-side diff" => "Comparar diferentes versões lado-a-lado",
"Discuss pages on forums" => "Discutir páginas nos fóruns",
"Forums are disabled." => "O recurso fórum está disabilitado.",
"View source" => "Ver fonte",
"Structures" => "Estruturas",
"Open page as structure" => "Abrir página como estrutura",
"Import HTML" => "Importar HTML",
"UserPage prefix:" => "Prefixo da página do usuário:",
"Page creators are admin of their pages" => "Autores são admins de suas páginas",
"MultiPrint" => "MultiImpressão",
"Wiki watch" => "Acompanhamento Wiki",
"Create watch for author on page creation" => "Criar notificações para autor na criação da página",
"Enable watch events when I am the editor" => "Habilitar notificações de eventos quando eu for o editor",
"Enable watches on comments" => "Habilitar notificações em comentários",
"Watch minor edits" => "Acompanhar edições menores (minor edits)",
"Use wiki page staging and approval" => "Usar teste/aprovação das páginas wiki",
"Force bounce of editing of approved pages to staging" => "Forçar páginas aprovadas editadas ao estado de regime de teste",
"Delete staging pages at approval" => "Deletar páginas em regime de teste ao aprovar",
"Hide page name prefix" => "Esconder prefixo do nome da página",
"Staging" => "Regime de teste",
"Approved" => "Aprovada",
"Out-of-sync" => "Fora de sincronia",
"Categorize approved pages with categories of staging copy on approval" => "Categorizar páginas aprovadas com as categorias da cópia em regime de estágio aprovada",
"List pages" => "Listar páginas",
"Configuration" => "Configuração",
"Wiki attachments" => "Arquivos anexados Wiki",
"Restore defaults" => "Restaurar padrões",
"Database Version Problem" => "Problema com a Versão do Banco de Dados",
"disabled" => "desabilitado",
"enabled" => "habilitado",
"Crosslinks to other features and settings" => "Outros recursos e configurações relacionados",
"Other sections" => "Outras sessões",
"Contact us" => "Entre em contato",
"Administration features" => "Recursos Administrativos",
"Security" => "Segurança",
"Edit Languages" => "Editar Idiomas",
"Transversal features" => "Recursos Transversais",
"Navigation features" => "Recursos de Navegação",
"Look &amp; feel" => "Aparência",
"themes" => "temas",
"Text area features" => "Recursos de Texto",
"features you can use in all text areas, like wiki pages, blogs, articles, forums, etc" => "Recursos que você pode usar em todas as áreas de inserção de texto, como páginas wiki, blogs, artigos, fóruns, etc...",
"Report" => "Reportar",
"Setting" => "Configurar",
"User:" => "Usuário:",
"Category:" => "Categoria:",
"Background color:" => "Cor de fundo:",
"Edit Action" => "Editar ação",
"Save Action" => "Salvar ação",
"Statistics" => "Estatísticas",
"Total number of users" => "Número total de usuários",
"Total number of objects" => "Número total de objetos",
"Weeks" => "Semanas",
"recorded" => "gravado",
"viewed" => "visualizada",
"Add or edit a rule" => "Adicionar ou editar uma regra",
"Rule title" => "Título da regra",
"Username regex matching" => "Identificador de usuário por expressão regular",
"IP regex matching" => "IP por expressão regular",
"Banned from sections" => "Banido(a) das seções",
"Rule activated by dates" => "Regra ativada por datas",
"Rule active from" => "Regra ativa de",
"Rule active until" => "Regra ativa até",
"Custom message to the user" => "Mensagem personalizada para o usuário",
"Rules" => "Regras",
"User/IP" => "Usuário/IP",
"Sections" => "Seções",
"Admin Calendars" => "Administrar Calendários",
"List of Calendars" => "Lista de Calendários",
"Edit Calendar" => "Editar calendário",
"Participants" => "Participantes",
"Url" => "Endereço",
"Subscription" => "Inscrições",
"Add Event" => "Adicionar evento",
"Custom Locations" => "Locais Personalizados",
"Custom Participants" => "Personalizar participantes",
"Custom Categories" => "Categorias Personalizadas",
"Custom Languages" => "Idiomas Personalizados",
"Custom Subscription List" => "Personalizar lista de inscrições",
"Custom Priorities" => "Prioridades Personalizadas",
"Personal Calendar" => "Calendário pessoal",
"Start of day" => "Início do dia",
"End of day" => "Fim do dia",
"Red" => "Vermelho",
"Current category" => "Categoria atual",
"Child categories" => "Categorias-filhas",
"Edit permissions for this category" => "Editar permissões para essa categoria",
"Edit this category:" => "Editar esta categoria:",
"Add new category" => "Adicionar uma nova categoria",
"Perms inherited from closest parent if possible or from global perms" => "Permissões inerentes ao parentesco mais próximo se possível ou a permissões globais",
"Assign permissions automatically" => "Associar permissão automaticamente",
"recommended for best performance" => "recomendado para melhorar o desempenho",
"Batch upload (CSV file):" => "Upload em lote (arquivo CSV):",
"Objects in category" => "Objetos na categoria",
"Remove from this Category" => "Remover dessa categoria",
"No records found." => "Nenhum registro encontrado.",
"Add objects to category" => "Adicionar objetos à categoria",
"image gal" => "gal. imagem",
"file gal" => "gal. arquivo",
"Admin chart items" => "Administrar itens de gráficos",
"Edit Chart" => "Editar gráfico",
"Add or edit an item" => "Adicionar ou editar um item",
"Update" => "Atualizar",
"Chart items" => "Itens de gráficos",
"No items defined yet" => "Nenhum item foi definido ainda",
"Add or edit a chart" => "Adicionar ou editar um gráfico",
"Active" => "Ativo",
"Users can vote for only one item from this chart per period" => "Usuários podem votar em um único item por período",
"Prevent users from voting for the same item more than once" => "Previne que usuários votem no mesmo item mais de uma vez",
"Users can suggest new items" => "Usuários podem sugerir itens",
"Auto validate user suggestions" => "Validades automaticamente sugestões de usuários",
"Ranking shows" => "Ranking exibe",
"All items" => "Todos os itens",
"Top 10 items" => "10 itens superiores",
"Top 20 items" => "20 itens superiores",
"Top 40 items" => "40 itens superiores",
"Top 50 items" => "50 itens superiores",
"Top 100 items" => "100 itens superiores",
"Top 250 items" => "250 itens superiores",
"Voting system" => "Sistema de votação",
"Vote items" => "Itens de voto",
"Rank 1..5" => "Nota 1..5",
"Rank 1..10" => "Nota 1..10",
"Ranking frequency" => "Freqüência de votação",
"Realtime" => "Tempo real",
"Each 5 minutes" => "A cada 5 minutos",
"Daily" => "Diariamente",
"Weekly" => "Semanalmente",
"Monthly" => "Mensalmente",
"Show Average" => "Exibir a Média",
"Show Votes" => "Exibir Votos",
"Use Cookies for unregistered users" => "Utilizar cookies para usuários não registrados",
"Users can vote again after" => "Usuários podem votar novamente",
"Anytime" => "A qualquer hora",
"No charts defined yet" => "Nenhum gráfico ainda definido",
"Admin templates" => "Administrar padrões",
"Edit this template:" => "Editar este padrão:",
"Create new template" => "Criar um novo padrão",
"Use wysiwyg editor" => "Usar editor WYSIWYG",
"Use normal editor" => "Usar editor normal",
"No features are configured to use templates." => "Não há recursos configurados para usar templates.",
"Templates" => "Padrões",
"Admin Contributions" => "Contribuições do Administrador",
"Settings" => "Configurações",
"Admin cookies" => "Administrar cookies",
"Create/edit cookies" => "Criar/editar cookies",
"Upload Cookies from textfile" => "Carregar Cookies a partir de arquivo texto",
"Upload from disk:" => "Carregar do disco:",
"Upload" => "Carregar",
"Remove all cookies" => "Remover todos cookies",
"Admin drawings" => "Administrar desenhos",
"Available drawings" => "Desenhos disponíveis",
"Create/edit dsn" => "Criar/editar dsn",
"Admin external wikis" => "Administrar Wikis externos",
"View template" => "Visualizar template",
"tiki admin external wikis template" => "tiki administra templates de wikis externos",
"Edit template" => "Editar modelo",
"Create/Edit External Wiki" => "Criar/editar Wiki Externo",
"URL (use \$page to be replaced by the page name in the URL example: http://www.example.com/tiki-index.php?page=\$page)" => "Endereço (use \$page para substituir pelo nome da página na URl. Exemplo: http://www.exemplo.com.br/tiki-index.php?page=\$page)",
"ExtWiki" => "Wikiext",
"Admin Forums" => "Administrar Fóruns",
"Create new forum" => "Criar novo fórum",
"Duplicate forum" => "Duplicar fórum",
"View this forum" => "Ver esse fórum",
"Import forums" => "Importar fórum",
"List forums" => "Listar fóruns",
"Edit this Forum:" => "Editar este Fórum:",
"Create New Forum" => "Criar um Novo Fórum",
"There are individual permissions set for this forum" => "Existem permissões individuais definidas para este fórum",
"Prevent flooding" => "Prevenir-se contra sobrecarga",
"Minimum time between posts" => "Tempo mínimo entre mensagens",
"Section" => "Seção",
"Create new" => "Criar nova",
"Moderator user" => "Usuário moderador",
"Moderator group" => "Grupo moderador",
"Password protected" => "Protegido por senha",
"Topics only" => "Apenas os assuntos",
"All posts" => "Todas as mensagens",
"Forum password" => "Senha do fórum",
"Only allow replies to the first message (flat forum)" => "Apenas permitir respostas a primeira mensagem",
"Send this forums posts to this email" => "Enviar as mensagens deste fórum para o seguinte e-mail",
"Prune unreplied messages after" => "Mensagens não respondidas expiram após",
"Prune old messages after" => "Mensagens antigas expiram após",
"Topic list configuration" => "Configuração da lista de assuntos",
"Posts can be rated" => "Mensagens podem receber notas",
"Display last post titles" => "Mostrar os títulos das últimas postagens",
"no display" => "não mostrar",
"Forward messages to this forum to this e-mail address, in a format that can be used for sending back to the inbound forum e-mail address" => "Direcionar mensagens deste fórum para este endereço de e-mail, em um formato que possa ser usado para enviar mensagens de volta",
"Send mails even when the post is generated by inbound mail" => "Enviar e-mails mesmo quando a mensagem for gerada por lixo eletrônico",
"Originating e-mail address for mails from this forum" => "Originar endereços de e-mail para mensagens deste fórum",
"Add messages from this email to the forum" => "Adicionar mensagens do seguinte e-mail para este fórum",
"POP3 server" => "Servidor POP3",
"Use topic smileys" => "Usar emoticons nos assuntos",
"Show topic summary" => "Exibir sumário dos assuntos",
"User information display" => "Exibição de informações dos usuários",
"Online" => "On-line",
"Approval type" => "Tipo de aprovação",
"All posted" => "Todas as mensagens enviadas",
"Queue anonymous posts" => "Enfileirar mensagens anônimas",
"Queue all posts" => "Enfileirar todas as mensagens",
"No attachments" => "Sem arquivos anexados",
"Everybody can attach" => "Todos podem anexar",
"Only users with attach permission" => "Apenas usuários com permissão de anexar",
"Moderators and admin can attach" => "Moderadores e admin podem anexar",
"Store attachments in:" => "Armazenar arquivos anexados em:",
"Database" => "Banco de dados",
"Max attachment size (bytes)" => "Tamanho máximo para arquivo anexado (bytes)",
"Set topics preferences" => "Definir preferências dos tópicos",
"Show topics preferences" => "Mostrar preferências dos tópicos",
"hide topics preferences" => "Esconder preferências dos tópicos",
"Default ordering for topics" => "Ordenação padrão para os assuntos",
"Date (desc)" => "Data (desc)",
"Date (asc)" => "Data (asc)",
"Score (desc)" => "Pontuação (desc)",
"Replies (desc)" => "Respostas (desc)",
"Reads (desc)" => "Leituras (desc)",
"Topics per page" => "Assuntos por página",
"Default ordering for threads" => "Ordenação padrão para as seqüências",
"List Forums" => "Listagem dos fóruns",
"Age" => "Idade",
"PPD" => "Ppd",
"Admin Hotwords" => "Administrar Palavras-Chaves",
"Add Hotword" => "Adicionar Palavra-chave",
"Word" => "Palavra",
"Admin HTML pages" => "Administrar páginas HTML",
"Edit this page" => "Editar esta página",
"View page" => "Ver página",
"Edit zone" => "Editar zona",
"Dynamic zones" => "Zonas dinâmicas",
"zone" => "zona",
"content" => "conteúdo",
"Mass update" => "Atualização em massa",
"Create new HTML page" => "Criar nova página HTML",
"Edit this HTML page:" => "Editar esta página HTML:",
"Apply template" => "Aplicar um padrão",
"Dynamic" => "Dinâmica",
"Static" => "Estática",
"Last Modif" => "última modificação",
"Edit Repository:" => "Editar Repositório:",
"Create New Repository" => "Criar Novo Repositório",
"List Repositories" => "Listar repositórios",
"New Repository" => "Novo repositório",
"View Repository" => "Ver repositório",
"Human readable repository name" => "Nome de repositório humanamente legível",
"Path to repository (local filesystem: relative/absolute web root, remote: prefixed with 'http://')" => "Caminho do repositório (sistema de arquivos local: relativo/absoluto, remoto: prefixado com 'http://')",
"File name of start page" => "Nome do arquivo da página de início",
"Start page" => "Página de início",
"CSS file to load when browse this repository" => "Carregar arquivo CSS quando navegar este repositório",
"CSS file" => "Arquivo CSS",
"Is repository visible to users" => "repositório visível para usuários",
"Can files from repository be cached" => "Arquivos do repositório podem ser armazenados",
"Cacheable" => "Armazenáveis",
"Are files from repository can be cached" => "Arquivos do repositório podem ser armazenados",
"Clear all cached pages of this repository" => "Limpar todas as páginas armazenadas deste repositório",
"Clear cache" => "Limpar cache",
"Seconds count 'till cached page will be expired" => "Segundos não podem ser contados até o armazenamento de páginas expirar",
"Cache expiration" => "Expiração do cache",
"Human readable text description of repository" => "Descrição humanamente legível do repositório",
"Available Repositories" => "Repositórios Disponíveis",
"CSS File" => "Arquivo CSS",
"Edit rules" => "Edit regras",
"Edit Rules for Repository:" => "Editar Regras para o Repositório:",
"Configure Repositories" => "Configurar repositórios",
"Configure this Repository" => "Configurar este repositório",
"View this Repository" => "Ver este repositório",
"New Rule" => "Nova regra",
"Copy Rules" => "Copiar regras",
"view/hide copy rules dialog" => "ver/esconder copiar diálogo de regras",
"Source repository" => "Repositório de origem",
"Copy" => "Copiar",
"According this order rules will be applied ('0' or empty = auto)" => "De acordo com esta ordem de regras pode ser aplicada ('0' ou vazio = auto)",
"Rule order" => "Ordenação de regra",
"Text to search for" => "Buscar por texto",
"Text to replace" => "Texto para trocar",
"Is this regular expression or simple search/replacer" => "É uma expressão regular ou busca simples/alteração",
"Is case sensitive (for simple replacer)" => "É sensível a maiúsculas e minúsculas (para troca simples)",
"Case sensitive" => "Sensível a caixa",
"subset of chars: imsxeADSXUu, which is regex modifiers" => "subconjunto de caracteres: imsxeADSXUu, os quais a expressão regular modifica",
"Regex modifiers" => "Modificadores de Regex",
"Human readable text description of rule" => "Texto humanamente legível de descrição de regra",
"Check to enable this rule" => "Selecione para habilitar esta regra",
"Enabled" => "Habilitado",
"Preview options" => "Pré-visualizar opções",
"Apply all rules or just this to generate preview" => "Aplicar todas as regras ou somente esta para gerar a pré-visualização",
"Apply all rules" => "Aplicar todas as regras",
"View source code after rules applied" => "Ver o código-fonte depois que as regras foram aplicadas",
"Code preview" => "Pré-visualização de código",
"Generate HTML preview" => "Gerar pré-visualização HTML",
"HTML preview" => "Pré-visualização HTML",
"Test file from repository to generate preview for (empty = configured start page)" => "Testar arquivo do repositório para gerar pré-visualização para (vazio = página de início configurada)",
"Preview Results" => "Resultados de Pré-visualização",
"Rules List" => "Lista de Regras",
"Case" => "Caixa",
"Configure/Options" => "Configurar/Opções",
"Admin layout" => "Administrar layout",
"Theme control" => "Controle de temas",
"layout options" => "opções de layout",
"Generate positions by hits" => "Gerar posições por número de acessos",
"List of featured links" => "Lista de links oferecidos",
"Position" => "Posição",
"Add Featured Link" => "Adicionar Link Oferecido",
"Edit this Featured Link:" => "Editar este Link Oferecido:",
"Create new Featured Link" => "Criar um novo Link Oferecido",
"disables the link" => "desabilita este link",
"Link type" => "Tipo de link",
"replace current page" => "substituir a página atual",
"framed" => "em frame",
"open new window" => "abrir em nova janela",
"Mail-in accounts" => "Contas de Mail-in",
"Account" => "Conta",
"Add new Mail-in account" => "Adicionar nova conta de Mail-in",
"Edit Mail-in account" => "Editar conta de Mail-in",
"Account name" => "Nome da conta",
"POP server" => "Servidor POP",
"SMTP server" => "Servidor SMTP",
"SMTP requires authentication" => "Servidor SMTP requer autenticação",
"Article Topic" => "Tópico de artigo",
"Admin Topics" => "Administrar Assuntos",
"Article Type" => "Tipo de artigo",
"Admin Types" => "Administrar tipos de artigos",
"Allow anonymous acces" => "Permitir acesso anônimo",
"Allow attachments" => "Permitir anexos",
"Check Mail-in accounts" => "Verificar contas de Mail-in",
"Check automatically" => "Verificar automaticamente",
"Frequency" => "Freqüência",
"List menus" => "Listar menus",
"Edit this menu" => "Editar este menu",
"Edit menu options" => "Editar opções do menu",
"Show Quick Urls" => "Mostrar Quick Urls",
"Some useful URLs" => "Alguns endereços úteis",
"Hide Quick Urls" => "Esconder Quick Urls",
"For wiki page, use ((PageName))." => "Para uma página wiki utilize ((NomeDaPagina)).",
"Use Ctrl+Click to select multiple groups." => "Use Ctrl+Clique para selecionar mais de um grupo.",
"option" => "opções",
"section level 0" => "seção (nível 0)",
"section level 1" => "seção (nível 1)",
"section level 2" => "seção (nível 2)",
"section level 3" => "seção (nível 3)",
"sorted section level 0" => "seção ordenada (nível 0)",
"separator" => "separador",
"Choose" => "Escolha",
"Home Blog" => "Blog Principal",
"Home Image Gal" => "Gal. Imgs Principal",
"Home Image Gallery" => "Galeria de Imagens Principal",
"Home File Gal" => "Gal. Arqs Principal",
"Home File Gallery" => "Galeria de Arquivos Principal",
"User preferences" => "Preferências do usuário",
"User prefs" => "Preferências",
"List galleries" => "Listar galerias",
"List image galleries" => "Listar galerias de imagens",
"Upload image" => "Carregar imagem",
"Gallery Rankings" => "Rankings de Galerias",
"Browse a gallery" => "Navegar por uma galeria",
"Articles home" => "Página de artigos",
"All articles" => "Todos artigos",
"Submit" => "Submeter",
"List Blogs" => "Listar Blogs",
"Create blog" => "Criar blog",
"File galleries" => "Galerias de Arquivos",
"View a forum" => "Exibir um fórum",
"View a thread" => "Exibir uma seqüência",
"View a FAQ" => "Exibir um FAQ",
"Take a quiz" => "Fazer um teste",
"Quiz stats" => "Estats. Teste",
"Stats for a Quiz" => "Estatísticas de um teste",
"Preview menu" => "Pré-visualização do menu",
"Menu options" => "Opções de menus",
"Export CSV data" => "Exportar para arquivo CSV",
"Import CSV data" => "Importar de arquivo CSV",
"To add new options to the menu set the optionId field to 0. To remove an option set the remove field to 'y'." => "Para adicionar novas opções ao menu defina o campo optionId igual a 0. Para remover uma opção defina o campo remove igual a 'y'.",
"To use menus in a <a href=\"tiki-admin_modules.php\">module</a>, <a href=\"tiki-admin.php?page=siteid\">Site identity</a> or a template, use {literal}{menu id=x}{/literal}, where x is the ID of the menu." => "Para usar menus em um<a href=\"tiki-admin_modules.php\">módulo</a>, <a href=\"tiki-admin.php?page=siteid\">Identidade do Site</a> ou um modelo, use {literal}{menu id=x}{/literal}, onde x é o ID do menu.",
"To use <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a>, you can use one of the three following syntaxes:" => "Para usar <a target=\"tikihelp\" href=\"http://phplayersmenu.sourceforge.net/\">phplayersmenu</a> (Menu em Camadas PHP), você pode usar uma das três sintaxes a seguir:",
"This will work well (or not!) depending on your theme. To learn more about <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">themes</a>" => "Isso funcionará bem (ou não!) dependendo do seu tema. Para aprender mais sobre <a target=\"tikihelp\" href=\"http://themes.tikiwiki.org\">temas</a>",
"Edit this Menu:" => "Editar este Menu:",
"Create new Menu" => "Criar um novo Menu",
"dynamic collapsed" => "contraído dinamicamente",
"dynamic extended" => "expandido dinamicamente",
"fixed" => "fixo",
"Options" => "Opções",
"Active Permissions" => "Ativar permissões",
"Clear Cache" => "Limpar o cache",
"User Modules" => "Módulos de Usuário",
"Assigned Modules" => "Módulos Atribuídos",
"Left Modules" => "Módulos da Esquerda",
"Rows" => "Linhas",
"Move to Right Column" => "Mover para a coluna direita",
"Unassign" => "Não atribuir mais",
"Right Modules" => "Módulos da Direita",
"Move to Left Column" => "Mover para a coluna esquerda",
"Assign new module" => "Atribuir novo módulo",
"Edit this assigned module:" => "Editar este módulo atribuído:",
"Cache Time" => "Tempo de Cache",
"Display Modules to All Groups" => "Exibir módulos para todos os grupos",
"Visibility" => "Visibilidade",
"Displayed now for all eligible users even with personal assigned modules" => "Mostrando agora para todos os usuários elegíveis com módulos pessoais designados",
"Displayed for the eligible users with no personal assigned modules" => "Mostrado para os usuários elegíveis sem módulos pessoais designados",
"Displayed now, can't be unassigned" => "Mostrando agora, pode não estar designado",
"Not displayed until a user chooses it" => "Não mostrar até um usuário escolher isto",
"Create new user module" => "Criar um novo módulo de usuário",
"Edit this user module:" => "Editar este módulo de usuário:",
"Must be wiki parsed" => "Interpretar código wiki (selecione se usou um código wiki)",
"Objects that can be included" => "Objetos que podem ser incluídos",
"Available polls" => "Enquetes disponíveis",
"Random active poll" => "Enquete ativa aleatórea",
"Random current poll" => "Enquete atual aleatórea",
"Use Poll" => "Usar a enquete",
"Random image from" => "Imagem aleatória a partir de",
"Use Gallery" => "Usar a galeria",
"Dynamic content blocks" => "Blocos de conteúdo dinâmico",
"Use Dynamic Content" => "Usar conteúdo dinâmico",
"Use RSS Module" => "Utilizar módulo rss",
"Use Menu" => "Utilizar o menu",
"Use phplayermenu" => "Usar phplayermenu",
"Banner zones" => "Zonas de Banner",
"Use Banner Zone" => "Utilizar zona de banner",
"Data" => "Dados",
"Admin newsletter subscriptions" => "Administrar assinaturas de comunicados",
"List Newsletters" => "Listar comunicados",
"Admin Newsletters" => "Administrar comunicados",
"Send Newsletters" => "Enviar Comunicados",
"Add a subscription newsletters" => "Adicionar uma assinatura ao comunicado",
"You can add several email addresses by separating them with commas." => "É possível adicionar vários endereços de e-mail separando eles com vírgula.",
"Add email:" => "Adicionar email:",
"Add user:" => "Adicionar usuário:",
"Group users" => "Grupo de usuários",
"Group subscription also subscribes included groups" => "Inscrição do grupo também inscrive grupos incluídos",
"Don't send confirmation mail" => "Não enviar e-mail de confirmação",
"The user email will be refreshed at each newsletter sending" => "O usuário de e-mail vai ser atualizado a cada newsletter que for enviada",
"Batch e-mail subscribe" => "Inscrever e-mails em lote",
"txt file, one e-mail per line" => "arquivo de texto, um e-mail por linha",
"Subscribe group" => "Inscrever grupo",
"Subscriptions" => "Assinaturas",
"Valid" => "Válido",
"Subscribed" => "inscrita",
"Admin newsletters" => "Administrar comunicados",
"Create/Edit Newsletters" => "Criar/editar comunicados",
"There are individual permissions set for this newsletter" => "Existem permissões individuais definidos para este comunicado",
"Users can subscribe/unsubscribe to this list" => "Usuários podem inscrever/desinscrever nesta lista",
"Users can subscribe any email address" => "Usuários podem inscrever quaisquer endereços de e-mail",
"Add unsubscribe instructions to each newsletter" => "Adicionar instruções de desinscrição em cada newsletter",
"Validate email addresses" => "Validar endereços de e-mail",
"Editions" => "Edições",
"Drafts" => "Rascunhos",
"Last Sent" => "última enviada",
"Add notification" => "Adicionar notificação",
"Event" => "Evento",
"A user registers" => "Um usuário se registrou",
"A user submits an article" => "Um usuário submeteu um artigo",
"Any wiki page is changed" => "Qualquer página wiki é alterada",
"Any wiki page is changed, even minor changes" => "Qualquer página wiki é alterada, mesmo com pequenas mudanças",
"PHP error" => "Erro de PHP",
"Email:" => "E-mail:",
"List polls" => "Listar enquetes",
"Edit this poll" => "Editar esta enquete",
"Preview poll" => "Pre-visualização da enquete",
"Option" => "Opções",
"Poll options" => "Opções de enquetes",
"Votes" => "Votos",
"Admin Polls" => "Administrar Enquetes",
"Set last poll as current" => "Definir a última enquete como atual",
"Close all polls but last" => "Fechar todas as enquetes menos a última",
"Activate all polls" => "Ativar todas as enquetes",
"active" => "ativo",
"current" => "atual",
"template" => "padrão",
"object" => "objeto",
"PublishDate" => "Data de Publicação",
"0 for no limit" => "0 para ilimitado",
"Results" => "Resultados",
"Wiki pages" => "Páginas wiki",
"Use Ctrl+Click to select multiple pages." => "Use Ctrl+Clique para selecionar mais de uma página.",
"Lock the pages" => "Travar as páginas",
"Admin Quicktags" => "Admininstrar Quicktags",
"Create/Edit QuickTags" => "Criar/Editar QuickTags",
"Insert (use 'text' for figuring the selection)" => "Inserir (usar 'text' para figurar a seleção)",
"Path to the tag icon" => "Caminho para o ícone de tag",
"Admin RSS Modules" => "Administrar módulos RSS",
"Tips" => "Dicas",
"This page is to configure settings of RSS feeds read/imported by Tiki. To generate/export RSS feeds, look for \"RSS feeds\" on the admin panel, or" => "Essa página está configurada com fontes RSS geradas/importadas pelo tiki. Para gerar/exportar fontes RSS, procure por \"RSS feeds\" no painel de administração, ou",
"Content for the feed" => "Conteúdo para a fonte",
"show feed title" => "mostrar campo de título",
"show publish date" => "mostrar data de publicação",
"Show Title?" => "Mostrar título?",
"Show Date?" => "Mostrar data?",
"View feed" => "Ver feed",
"PHP settings" => "Configurar PHP",
"PHP variable" => "Variáveis do PHP",
"Risk Factor" => "Fator de risco",
"Explanation" => "Explicação",
"Tiki variable" => "Variável Tiki",
"Check all tiki files" => "Checar todos os arquivos tiki",
"Note, that this can take a very long time. You should check your max_execution_time setting in php.ini." => "Nota: isso pode demorar muito tempo. Cheque o item max_execution_time no arquivo php.ini.",
"Note: You have to import security data via installation process (<a href=\"tiki-install.php\">tiki-install.php</a>). Import the *secdb* update files in your database." => "Nota: voc tem que importar os dados das configurações de segurança através do processo de instalção (<a href=\"tiki-install.php\">tiki-install.php</a>). Importe o *secdb* enviado para a sua banco de dados.",
"File checks" => "Checar arquivo",
"Check file permissions" => "Verificar as permissões do arquivo",
"This check tries to find files with problematic file permissions. Some file permissions that are shown here as problematic may be unproblematic or unavoidable in some environments." => "Essa checagem tenta encontrar arquivos com permissões problemáticas. Algumas permissões de arquivos marcadas como problemáticas podem não ser ou então podem ser inevitáveis em alguns sistemas.",
"user" => "usuário",
"group" => "grupo",
"other" => "outro",
"sticky" => "persistente",
"Admin Shoutbox Words" => "Administrar palavras do quadro negro",
"Add Banned Word" => "Adicinionar palavras banidas",
"Are you sure you want to delete this word?" => "Você tem certeza que deseja deletar essa palavra?",
"Destroy the structure leaving the wiki pages" => "Destruir a estrutura mantendo as páginas Wiki",
"Destroy the structure and remove the pages" => "Destruir a estrutura e remover as páginas",
"Edit structure" => "Editar estrutura",
"Export Pages" => "Exportar páginas",
"Dump Tree" => "Exportar árvore",
"Create WebHelp" => "Criar WebHelp",
"View WebHelp" => "Ver webhelp",
"Create new structure" => "Criar uma nova estrutura",
"Alias" => "Apelido",
"Tree" => "árvore",
"Use single spaces to indent structure levels" => "Usar espaços simples para indentar níveis da estrutura",
"Create New Structure" => "Criar nova estrutura",
"List surveys" => "Listar pesquisas",
"Survey Stats" => "Estatísticas das pesquisas",
"Edit this Survey" => "Editar esta pesquisa",
"Admin Surveys" => "Administrar pesquisas",
"Question" => "Pergunta",
"One choice" => "Uma opção",
"Multiple choices" => "Múltipla escolha",
"Short text" => "Texto curto",
"Rate (1..5)" => "Nota (1..5)",
"Rate (1..10)" => "Nota (1..10)",
"Rate" => "Classificação",
"Options (if apply)" => "Opções (se for o caso)",
"Questions" => "Perguntas",
"Admin surveys" => "Administrar pesquisas",
"List Surveys" => "Listar Pesquisas",
"Edit this Survey:" => "Editar esta Pesquisa:",
"Create New Survey" => "Criar nova pesquisa",
"There are individual permissions set for this survey" => "Existem permissões individuais definidas para esta pesquisa",
"Open" => "Aberto",
"If your Tiki is acting weird, first thing to try is to clear your cache below. Also very important is to clear your cache after an upgrade (by FTP/SSH when needed)." => "Se o Tiki apresenta alguma comportamento estranho limpar o cache pode resolver o problema. É sempre importante limpar o cache depois de atualizar a versão do sistema.",
"Exterminator of cached content" => "Exterminador de cache",
"Empty" => "Esvaziar",
"Templates compiler" => "Compilador de modelos",
"Compile" => "Compilar",
"Advanced feature" => "recurso avançado",
"Fix UTF-8 Errors in Tables" => "Consertar erros de codificação UTF-8 nas tabelas",
"Warning: Make a backup of your Database before using this function!" => "Cuidado: faça um backup da sua banco de dados antes de utilizar essa função!",
"Warning: If you try to convert large tables, raise the maximum execution time in your php.ini!" => "Cuidado: se você for converter grandes tabelas, aumente o tempo máximo de execução no php.ini!",
"This function converts ISO-8859-1 encoded strings in your tables to UTF-8" => "Essa função converte linhas codificadas em ISO-8859-1 para UTF-8",
"This may be necessary if you created content with tiki &lt; 1.8.4 and Default Charset settings in apache set to ISO-8859-1" => "Isso pode ser necessário se você criou conteúdo com o tiki &lt; 1.8.4 e com a codificação padrão do apache definida como ISO-8859-1",
"UTF-8 Errors fixed" => "Erros de codificação UTF-8 corrigidos",
"Investigate" => "Investigar",
"Fix it" => "Corrigir",
"Create a new topic" => "Criar um novo assunto",
"Topic Name" => "Nome do Assunto",
"Upload Image" => "Carregar uma Imagem",
"List of topics" => "Lista de assuntos",
"Articles (subs)" => "Artigos (assinaturas)",
"topic image" => "imagem do assunto",
"Deactivate" => "Desativar",
"Remove with articles" => "Remover com artigos",
"List Trackers" => "Listar",
"Admin Trackers" => "Administrar",
"Edit This Tracker" => "Editar",
"View This Tracker's Items" => "Ver itens",
"Edit tracker field" => "Editar campos",
"Is column visible when listing tracker items?" => "Visível durante listagem de itens do acompanhamento?",
"Column links to edit/view item?" => "Clique na coluna para editar/visualizar o item?",
"Column is searchable?" => "Coluna localizável no mecanismo de busca?",
"Field is hidden?" => "Campo oculto?",
"not hidden" => "não oculto",
"visible to admin only" => "visível apenas aos administradores",
"editable by admin only" => "editável apenas para o administrador",
"Field is mandatory?" => "Campo obrigatório?",
"Error message:" => "Mensagem de erro:",
"Tracker fields" => "Campos do acompanhamento",
"isMain" => "Clique",
"Tbl vis" => "Tab visiv",
"Searchable" => "Aparece no mecanismo de busca",
"Hidden" => "Secreto",
"Mandatory" => "Obrigatório",
"Import/Export Trackers Fields" => "Importar/exportar campos dos acompanhamentos",
"Edit Tracker" => "Editar acompanhamento",
"Import/Export" => "Importar/Exportar",
"Found" => "Encontrado",
"trackers" => "acompanhamentos",
"with" => "com",
"There are individual permissions set for this tracker" => "Estas são as permissões individuais para este acompanhamento",
"No individual permissions. Global permissions apply." => "Nenhuma permissão individual, permissões globais em efeito",
"Use \"explicit\" names in the mirror table" => "Usar nomes \"explícitos\" nas tabelas espelho",
"Show status" => "Mostrar status",
"Default status displayed in list mode" => "Status padrão aparente no modo de lista",
"Show status to tracker admin only" => "Mostrar status do acompanhamento para o administrador apenas",
"Send copies of all activity in this tracker to this e-mail address" => "Enviar cópias de toda a atividade nesse acompanhamento para esse endereço de e-mail",
"Use simplified e-mail format" => "Usar formato de e-mail simplificado",
"New items are created with status" => "Novos itens são criados com o status",
"Authoritative status for modified items" => "Estado obrigatório para itens modificados",
"No change" => "Nenhuma mudança",
"Item creator can modify his items?" => "O criador pode modificar os seus itens?",
"The tracker needs a user field with the option 1" => "O acompanhamento precisa de um campo para o usuário com a opção 1",
"Member of the default group of creator can modify items?" => "Membro do grupo padrão do criador pode modificar itens?",
"The tracker needs a group field with the option 1" => "O acompanhamento precisa de um campo para o grupo com a opção 1",
"Show creation date when listing tracker items?" => "Exibir data de criação na lista de itens de acompanhamento?",
"Show lastModif date when listing tracker items?" => "Exibir data da última alteração na lista de itens de acompanhamento?",
"What field is used for default sort?" => "Qual campo usado para a listagem por padrão?",
"What is default sort order in list?" => "Qual a ordem padrão para a listagem?",
"Tracker items allow ratings?" => "Itens dos acompanhamentos podem ter classificação?",
"with values" => "quais valores",
"and display rating results in listing?" => "e mostra o resultado da classificação na listagem?",
"Tracker items allow comments?" => "itens de acompanhamento podem ser comentados?",
"and display comments in listing?" => "e mostra comentários na listagem?",
"Tracker items allow attachments?" => "itens de acompanhamento permitem arquivos anexados?",
"and display attachments in listing?" => "e mostra anexos na listagem?",
"Attachment display options (Use numbers to order items, 0 will not be displayed, and negative values display in popups)" => "Opções para mostrar os anexos (Use números para ordenar os itens, 0 não será mostrado e valores negativos para aparecer em popups)",
"Filesize" => "Tamanho",
"Filetype" => "Tipo do arquivo",
"LongDesc" => "Descrição longa",
"After:" => "Depois:",
"Before:" => "Antes:",
"Do not show empty fields in item view?" => "Não mostrar campos vazios na visualização de um item?",
"Import/export trackers" => "Importar/Exportar acompanhamentos",
"Date Format" => "Formato da data",
"Admin groups" => "Administrar grupos",
"Admin users" => "Administrar usuários",
"Add new group" => "Adicionar novo grupo",
"Edit group" => "Editar grupos",
"Members" => "Membros",
"Add a New Group" => "Adicionar novo grupo",
"List of existing groups" => "Lista de grupos existentes",
"Includes" => "Inclusões",
"Group Homepage" => "Página principal do grupo",
"Use wiki page name or full URL" => "Usar nome da página wiki ou URL",
"Group Theme" => "Tema do grupo",
"Use site default" => "Usar padrão do site",
"Group Information Tracker" => "Informação do grupo de acompanhamentos",
"choose a group tracker ..." => "escolher um grupo de acompanhamentos ...",
"choose a field ..." => "escolha um campo ...",
"Users Information Tracker" => "Informações dos usuários de acompanhamentos",
"choose a users tracker ..." => "escolher usuários de acompanhamentos ...",
"Group tracker item : {\$groupitemid}" => "Item do grupo de acompanhamento : {\$groupitemid}",
"Edit Item" => "Editar item",
"Group tracker item not found" => "Item do grupo de acompanhamento não encontrado",
"Members List" => "Lista de membros",
"Remove from Group" => "Remover do grupo",
"users in group" => "usuários no grupo",
"CSV File" => "Arquivo CSV",
"Add a New User" => "Adicionar um novo usuário",
"Rejected users" => "Usuários rejeitados",
"Reason" => "Motivo",
"Edit user" => "Editar usuário",
"Edit Account Settings" => "Editar configurações da conta",
"Need to validate email" => "Precisa validar o e-mail",
"to groups" => "aos grupos",
"Edit Included Group" => "Editar grupo incluído",
"Change user preferences" => "Alterar preferências do usuário",
"Remove Users and their Userpages" => "Remover usuários e suas páginas de usuário",
"Manage Group Assignments" => "Alterar associações do grupo",
"Set Default Groups" => "Definir grupos padrão",
"Assign selected to" => "Associar selecionados para",
"Remove selected from" => "Remover selecionados de",
"the following groups:" => "os seguintes grupos:",
"Tip: Hold down CTRL to select multiple" => "Dica: segure a tecla CTRL para selecionar vários",
"Set the default group of the selected users to" => "Definir o grupo padrão dos usuários selecionados para",
"Use the email as username" => "Usar o e-mail como nome do usuário",
"Lowercase only" => "apenas minúsculas",
"User tracker item : {\$usersitemid}" => "Item do acompanhamento do usuário : {\$usersitemid}",
"Overwrite" => "Sobrescrever",
"Overwrite but keep the previous login if the login exists in another case" => "Sobrescrever mas manter o usuário antigo se ele existir em outro caso",
"Don't overwrite" => "Não sobrescrever",
"Overwrite groups:" => "Sobrescrever grupos:",
"Loading..." => "Carregando...",
"New attachments" => "Novos anexos",
"Old attachments" => "Anexos antigos",
"Source" => "Fonte",
"Admin Article Types" => "Administrar Tipos de Artigos",
"List of types" => "Lista de tipos",
"Shows up in the drop down list of article types" => "Mostra no drop down uma lista de tipos de artigos",
"Allow ratings by the author" => "Permitir classificações pelo autor",
"Show before publish date" => "Mostrar antes da data de publicação",
"non-admins can view before the publish date" => "não-administradores podem visualizar antes da data de publicação",
"Show after expire date" => "Mostrar depois da data de expiração",
"non-admins can view after the expire date" => "não-administradores podem visualizar mesmo depois da data final",
"Heading only" => "Somente cabeçalho",
"No article body, heading only" => "Sem corpo de artigo, apenas cabeçalho",
"Allow comments for this type" => "Permitir comentários para esse tipo",
"Comment Can Rate Article" => "Comentário pode classificar artigo",
"Allow comments to include a rating value" => "Permitir que os comentários adicionem valores para a classificação",
"Show image" => "Mostrar imagem",
"Show topic or own image" => "Mostrar tópico ou a própria imagem",
"Show avatar" => "Mostrar fotografia",
"Show author's avatar" => "Mostrar a fotografia do autor",
"Show author" => "Mostrar autor",
"Show author name" => "Mostrar o nome do autor",
"Show publish date" => "Mostrar data de publicação",
"Show expire date" => "Mostrar data de expiração",
"Show reads" => "Mostrar lidas",
"Show the number of times the article was read" => "Mostrar o número de vezes que o artigo foi visualizado",
"Show size" => "Mostrar tamanho",
"Show the size of the article" => "Mostrar o tamanho do artigo",
"Show topline" => "Mostrar linha de cima",
"Show a small title over the title" => "Mostrar um pequeno título embaixo do título",
"Show subtitle" => "Mostrar sub-título",
"Show the subtitle" => "Mostrar o sub-título",
"Show source" => "Mostrar fonte",
"Show link to source after article body" => "Mostrar link para a fonte depois do corpo do artigo",
"Show Image Caption" => "Mostrar descrição da imagem",
"Show a legend under the image" => "Mostrar legenda embaixo da imagem",
"Show Language" => "Mostrar idioma",
"Show the language" => "Mostrar o idioma",
"Creator can edit" => "Criador pode editar",
"The person who submits an article of this type can edit it" => "A pessoa que envia um artigo desse tipo pode edita-lo",
"Show lang" => "Mostrar idioma",
"Review" => "Resenha",
"Classified" => "Classificado",
"Create a new type" => "Criar um novo tipo",
"Group Information" => "Informações do Grupo",
"level" => "nível",
"Create level" => "Criar nível",
"all permissions in level" => "todas as permissões no nível",
"Default Group" => "Grupo Padrão",
"Assign Perms to this Group" => "Associar permissões para esse grupo",
"backlinks to" => "refere-se a",
"No backlinks to this page" => "Sem referências para esta página",
"Directory batch upload" => "Diretório para fazer upload em lote",
"Browse Gallery" => "Navegar pela galeria",
"Upload From Disk" => "Carregar do disco",
"available images" => "imagens disponíveis",
"Remove File Extension from Image Name" => "Remover a extensão quando mostrar o nome da imagem",
"eg. from \"digicam0001.jpg\" then name digicam0001 will be used for the name field" => "exemplo: de \"digicam0001.jpg\" será mostrado digicam0001 no campo nome",
"Select a Gallery" => "Selecionar galeria",
"Process" => "Processo",
"Browse File Gallery" => "Navegar na galeria de arquivos",
"available files" => "arquivos disponíveis",
"Select a File Gallery" => "Selecionar uma galeria de arquivos",
"Edit Post" => "Editar Mensagem",
"View Blog" => "Ver o blog",
"If you want to use images please save the post first and you will be able to edit/post images. Use the &lt;img&gt; snippet to include uploaded images in the textarea editor or use the image URL to include images using the WYSIWYG editor. " => "Se você quer usar imagens, salve pela primeira vez e então estará habilitado a editar/enviar imagens. Use o código &lt;img&gt; para incluir imagens que já estão no site ou use o endereço URL da imagem para incluir imagens usando o editor WYSIWYG. ",
"Use ...page... to separate pages in a multi-page post" => "Utilize ...page... para separar as páginas em uma mensagem multi-página",
"Upload image for this post" => "Carregar uma imagem para esta mensagem",
"Trash" => "Lixeira",
"Mark entry as private:" => "Marcar entrada como privada:",
"Spellcheck" => "Verificação ortográfica",
"Save and Exit" => "Salvar e sair",
"Powered by" => "Provido por",
"Made with" => "Criado com",
"Execution time" => "Tempo de execução",
"Memory usage" => "Memória usada",
"Server load" => "Carga do servidor",
"Last update from SVN" => "Última atualização do SVN",
"Admin Category" => "Administrar categoria",
"Admin the Category System" => "Administrar as categorias do sistema",
"Browse in" => "Navegar em",
"Trackers Items" => "Itens dos acompanhamentos",
"Sheets" => "Planilhas",
"Hide subcategories objects" => "Esconder subcategorias dos objetos",
"Show subcategories objects" => "Mostrar subcategorias dos objetos",
"Upper level" => "Nível superior",
"Browse related tags" => "Navegar por tags relacionadas",
"Network of Tags related to" => "Rede de tags relacionadas a",
"Clear" => "Limpar",
"More Popular Tags" => "Tags mais populares",
"results found" => "resultados encontrados",
"List Galleries" => "Listar galerias",
"Edit Gallery" => "Editar galeria",
"Rebuild Thumbnails" => "Recriar miniaturas",
"Directory Batch" => "Diretório em lote",
"List Gallery" => "Listar a galeria",
"All Images" => "Todas as imagens",
"Monitor this Gallery" => "Monitorar essa galeria",
"Stop Monitoring this Gallery" => "Parar de monitorar essa galeria",
"Sort Images by" => "Ordenar imagens por",
"subgallery" => "sub galeria",
"Subgallery" => "Sub-galeria",
"Original Size" => "Tamanho original",
"rotate right" => "girar para a direita",
"rotate" => "girar",
"Details" => "Detalhes",
"You can include the image in a tiki page using one of these lines" => "Você pode incluir imagens numa página tiki usando uma dessas linhas",
"Return to Gallery" => "Retornar à galeria",
"Edit Image" => "Editar Imagem",
"First Image" => "Primeira imagem",
"Prev Image" => "Imagem anterior",
"Smaller" => "Menor",
"Bigger" => "Maior",
"Popup window" => "Janela de popup",
"Next Image" => "Próxima imagem",
"Slideshow Forward" => "Avançar slide",
"Last Image" => "última imagem",
"Direction" => "Direção",
"Click to zoom" => "Clique para dar zoom",
"Image Name" => "Nome da Imagem",
"Image Scale" => "Escaladeimagem",
"Latitude (WGS84/decimal degrees)" => "Latitude (WGS84/decimal graus)",
"Longitude (WGS84/decimal degrees)" => "Longitude (WGS84/decimal graus)",
"Move image" => "Mover a imagem",
"You can view this image in your browser using" => "Você pode visualizar esta imagem em seu navegador usando",
"You can include the image in an HTML page using one of these lines" => "Você pode incluir imagens no código HTML usando uma dessas linhas",
"Stop Monitoring this Page" => "Não monitorar mais esta página",
"Monitor this Page" => "Monitorar esta página",
"Visible Calendars" => "Calendários visíveis",
"Group Calendars" => "Agrupar Calendários",
"Edit event" => "Editar item",
"View event" => "Ver item",
"Organized by" => "Ordenado por",
"Tentative" => "Tentativa",
"Confirmed" => "Confirmada",
"Cancelled" => "Cancelada",
"Change Focus" => "Mudar focochange focus",
"Calendar Item" => "Item do calendário",
"New event" => "Novo item",
"Edit Calendar Item" => "Editar o Item do Calendário",
"New Calendar Item" => "Novo Item no Calendário",
"times" => "vezes",
"End" => "Fim",
"Roles" => "Perfis",
"Calendar import" => "Importar calendário",
"Calendar has been updated" => "Calendário foi atualizado",
"import" => "importar",
"Previous" => "Anterior",
"%m/%d" => "%d/%m",
"Assign permissions to category" => "Associar permissões a uma categoria",
"Current permissions for this category" => "Permissões dessa categoria",
"Remove from this Category Only" => "Remover apenas dessa categoria",
"Remove from this Category &amp; all its Children" => "Remover dessa categoria &amp; todas os seus filhos",
"Assign permissions" => "Designar permissões",
"to group" => "ao grupo",
"this category &amp; all its children" => "essa categoria &amp; todos os seus filhos",
"this category only" => "essa categoria apenas",
"Assigning permissions for <b>all children</b> is recommended for best performance." => "Associar permissões para <b>todos os filhos</b> é recomendado para uma melhor performance.",
"Change password enforced" => "Alteração obrigatória de senha",
"Change your password" => "Alterar sua senha",
"Old password" => "Senha antiga",
"Send a message to us" => "Escreva-nos",
"Contact us by email" => "Entre em contato por email",
"Click here to send us an email" => "Clique aqui para nos enviar um e-mail",
"Contacts" => "Contatos",
"Create/edit contacts" => "Criar/editar contatos",
"First Name" => "Nome",
"Last Name" => "Sobrenome",
"Nickname" => "Apelido",
"You can browse the generated WebHelp here" => "Você pode navegar o WebHelp gerado aqui",
"Structure" => "Estrutura",
"Top page" => "Página de Topo",
"Tiki Debugger Console" => "Console de Depuração Tiki",
"Current URL" => "Endereço atual",
"Command" => "Comando",
"exec" => "executar",
"Type <code>help</code> to get list of available commands" => "Digite <code>ajuda</code> para obter uma lista de comandos",
"Add a new site" => "Adicionar um novo site",
"You cannot add sites until Directory Categories are setup." => "Você não pode adicionar sites porque o diretório das categorias ainda não foi configurado.",
"Please contact the Site Administrator" => "Por favor entre em contato com o administrador do site",
"Site added" => "Site adicionado",
"Categories:" => "Categorias:",
"Use Ctrl+Click to select multiple categories." => "Use Ctrl+Clique para selecionar mais de uma categoria.",
"Directory Administration" => "Administrar links",
"There are" => "Existem",
"invalid sites" => "sites inválidos",
"valid sites" => "sites válidos",
"Users have visited" => "Usuários visitaram",
"sites from the directory" => "sites do diretório",
"Users have searched" => "Usuários buscaram",
"times from the directory" => "vezes a partir do diretório",
"Related" => "Relacionados",
"Validate" => "Validar",
"Admin directory categories" => "Administrar categorias de diretório",
"Parent category" => "Categoria-Pai",
"Add a directory category" => "Adicionar uma nova categoria",
"Edit this directory category" => "Editar esta categoria",
"Children type" => "Tipos de filhos",
"Most visited sub-categories" => "Sub-categorias mais visitadas",
"Category description" => "Descrição da categoria",
"Random sub-categories" => "Sub-categorias aleatórias",
"Maximum number of children to show" => "Número máximo de filhos a exibir",
"Allow sites in this category" => "Permitir sites nesta categoria",
"Show number of sites in this category" => "Exibir número de sites nesta categoria",
"Editor group" => "Grupo do editor",
"Subcategories" => "Sub-categorias",
"cType" => "Tipo",
"allow" => "permitir",
"count" => "contagem",
"relate" => "relacionadas",
"Admin related categories" => "Administrar categorias relacionadas",
"Add a related category" => "Adicionar uma categoria relacionada",
"Mutual" => "Mútuo",
"Related categories" => "Categorias relacionadas",
"Admin sites" => "Administrar sites",
"Is valid" => "É válido",
"New Sites" => "Novos sites",
"Cool Sites" => "Sites legais",
"Add a Site" => "Adicionar um site",
"Add a Category" => "Adicionar categoria",
"any" => "qualquer",
"in entire directory" => "em todas as categorias",
"in current category" => "na categoria atual",
"Sort by" => "Ordenar por",
"name (desc)" => "nome (desc)",
"name (asc)" => "nome (asc)",
"hits (desc)" => "visitas (desc)",
"hits (asc)" => "visitas (asc)",
"creation date (desc)" => "data de criação (desc)",
"creation date (asc)" => "data de criação (asc)",
"last updated (desc)" => "última atualização em (desc)",
"last updated (asc)" => "última atualização em (asc)",
"Added" => "Adicionado em",
"Last updated" => "Última atualização em",
"No records." => "Nenhum registro.",
"Total categories" => "Total de categorias",
"Total links" => "Total de links",
"Links to validate" => "Links a validar",
"Searches performed" => "Buscas realizadas",
"Total links visited" => "Links visitados totais",
"Directory ranking" => "Ranking de links",
"Search results" => "Resultados da busca",
"Validate sites" => "Sites validados",
"Edit article" => "Editar artigo",
"List Articles" => "Listar Artigos",
"View Articles" => "Ver artigos",
"One of the email addresses you typed is invalid" => "Um dos endereços de e-mail digitados não é válido",
"Topline" => "Topo",
"Subtitle" => "Sub-título",
"Author Name" => "Nome do Autor",
"Own Image" => "Imagem própria",
"Article image" => "Imagem do artigo",
"Use own image" => "Usar imagem própria",
"Float text around image" => "Texto flutuante ao redor da imagem",
"Own image size x" => "Largura da imagem própria",
"Own image size y" => "Altura da imagem própria",
"Image caption" => "Legenda",
"Heading" => "Cabeçalho",
"Body" => "Corpo",
"Publish Date" => "Data de Publicação",
"Expiration Date" => "Data de Expiração",
"From:" => "De:",
"Edit or create banners" => "Editar ou criar banners",
"List banners" => "Listar banners",
"URL to link the banner" => "Endereço para ligar ao banner",
"Client" => "Cliente",
"Max impressions" => "Impressões (máx)",
"-1 for unlimited" => "(-1 para ilimitado)",
"Or, create a new zone" => "Ou crie uma nova zona de banners",
"Show the banner only between these dates" => "Exibir o banner apenas entre estas datas",
"From date" => "Do dia",
"To date" => "Ao dia",
"Use dates" => "Utilizar datas",
"Show the banner only in this hours" => "Exibir o banner apenas entre estas horas",
"to" => "a",
"Show the banner only on" => "Exibir o banner apenas às",
"Mon" => "Seg",
"Tue" => "Ter",
"Wed" => "Qua",
"Thu" => "Qui",
"Fri" => "Sex",
"Sat" => "Sáb",
"Sun" => "Dom",
"Select ONE method for the banner" => "Selecione UM método para o banner",
"Use HTML" => "Usar HTML",
"Use image" => "Usar a imagem",
"Image:" => "Imagem:",
"Current Image" => "Imagem atual",
"Use image generated by URL (the image will be requested at the URL for each impression)" => "Usar a imagem gerada pelo endereço (a imagem será requisitada no endereço para cada impressão)",
"Use Flash" => "Usar Flash",
"Movie Size" => "Dimensões do arquivo",
"FlashPlugin min version" => "Versão mínina para o plugin Flash",
"ex" => "exemplo",
"Use text" => "Utilizar texto",
"Save the Banner" => "Salvar o banner",
"Remove Zones (you lose entered info for the banner)" => "Remover Zonas (informações editadas para o banner serão perdidas)",
"Create Blog" => "Criar Blog",
"Current heading" => "Cabeçalho atual",
"There are individual permissions set for this blog" => "Existem permissões individuais definidas para este blog",
"Number of posts to show" => "Número de mensagens a exibir",
"Allow other user to post in this blog" => "Permitir a outros usuários escrever neste blog",
"Use titles in blog posts" => "Utilizar títulos nas mensagens do blog",
"Allow search" => "Permitir busca",
"Allow comments" => "Permitir comentários",
"Show user avatar" => "Mostrar fotografia dos usuários",
"Blog heading" => "Cabeçalho do Blog",
"Edit Style Sheet" => "Editar Style Sheet",
"Style Sheet" => "Folha de Estilo",
"choose a stylesheet" => "escolher um style sheet",
"Try" => "Experimentar",
"Wiki Help" => "Ajuda wiki",
"Wiki Syntax" => "Sintaxe wiki",
"Bold text" => "Texto em negrito",
"Italic text" => "Texto em itálico",
"single quotes" => "aspas simples",
"Underlined text" => "Texto sublinhado",
"Colored text" => "Texto colorido",
"Headings" => "Cabeçalhos",
"Show/Hide" => "Mostrar/esconder",
"show/hide heading section. + (shown) or - (hidden) by default" => "mostrar/esconder sessão do cabeçalho. + (mostra) or - (esconde) por padrão",
"Horizontal rule" => "Linha horizontal",
"Text box" => "Caixa de texto",
"Box content" => "Conteúdo da caixa",
"Centered text" => "Texto centralizado",
"Dynamic variables" => "Variáveis dinâmicas",
"Inserts an editable variable" => "Inserir uma váriavel editável",
"External links" => "Links externos",
"For an external Wiki, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))" => "Para um Wiki externo, use ExternalWikiName:PageName or ((External Wiki Name: Page Name))",
"Square Brackets" => "Colchetes",
"Use [[foo] to show [foo]." => "Usa [[foo] para mostrar [foo].",
"Wiki References" => "Referências Wiki",
"JoinCapitalizedWords or use" => "UnirPalavrasComMaiusculas ou use",
"page|description" => "página|desc",
"for wiki references" => "para referências Wiki",
"SomeName" => "AlgumNome",
"prevents referencing" => "prevenir referência",
"Lists" => "Listas",
"for bullet lists" => "para listas de itens",
"for numbered lists" => "para listas numeradas",
"for definiton lists" => "para listas de definições",
"Tables" => "Tabelas",
"row" => "linha",
"col" => "coluna",
"Title bar" => "Barra de título",
"Line break" => "Quebra de linha",
"(very useful especially in tables)" => "(muito útil especialmente em tabelas)",
"creates the editable drawing foo" => "cria o desenho editável foo",
"Multi-page pages" => "Páginas multi-página",
"to separate pages" => "para separar páginas",
"Non parsed sections" => "Seções não interpretadas",
"Prevents wiki parsing of the enclosed data." => "O conteúdo entre as tags não é interpretado como código wiki.",
"Preformated sections" => "Seções pré-formatadas",
"Block Preformatting" => "Pré-formatar bloca",
"Note that plugin arguments can be enclosed with double quotes (&quot;); this allows them to contain , or = or &gt;" => "Nota: é possível utilizar aspas duplas (&quot;) enter os argumentos de um plugin; isso permite que o argumento contenha , ou = ou &gt;",
"No description available" => "Descrição não disponível",
"table" => "tabela",
"table new" => "nova tabela",
"external link" => "link externo",
"wiki link'" => "link wiki'",
"heading1" => "cabeçalho1",
"title bar" => "barra de título",
"box" => "caixa",
"rss feed" => "fonte rss",
"dynamic content" => "conteúdo dinâmico",
"center text" => "centralizar texto",
"colored text" => "texto colorido",
"dynamic variable" => "variável dinâmica",
"New wms Metadata" => "Nova metadata wms",
"New Class" => "Nova classe",
"New Projection" => "Nova projeção",
"New Query" => "Nova consulta",
"New Scalebar" => "Nova barra de escala",
"New Layer" => "Nova camada",
"New Label" => "Novo rótulo",
"New Reference" => "Nova referência",
"New Legend" => "Nova legenda",
"New Web" => "Nova web",
"New Outputformat" => "Novo formato de saída",
"New Mapfile" => "Novo arquivo de mapa",
"special chars" => "carac especiais",
"special characters" => "caracteres especiais",
"Leave Fullscreen Edit" => "Deixar modo de edição em tela cheia",
"Fullscreen Edit" => "Editar em tela cheia",
"Browse Images" => "Navegar na galeria",
"Edit successful!" => "Edição bem-sucedida!",
"The following image was successfully edited" => "A seguinte imagem foi editada com sucesso",
"Image Description" => "Descrição da Imagem",
"Upload from disk to change the image:" => "Carregue uma nova imagem para alterar a atual:",
"Save and Go Next" => "Salvar e ir para a próxima",
"Edit and create Languages" => "Editar e criar Línguas",
"Toggle interactive translation off" => "Desligar modo de tradução interativa",
"Toggle interactive translation on" => "Ligar modo de tradução interativa",
"Edit and create languages" => "Editar e criar línguas",
"Create Language" => "Criar Língua",
"Shortname" => "Nome Abreviado",
"like" => "como",
"Longname" => "Nome Completo",
"Select the language to edit" => "Selecione uma língua a editar",
"Add a translation" => "Adicionar uma tradução",
"Edit translations" => "Editar traduções",
"Translate recorded" => "Tradução registrada",
"Translation" => "Tradução",
"reset table" => "reinicializar",
"Create New Block" => "Criar um novo bloco",
"Return to block listing" => "Retornar à listagem de blocos",
"Block description: " => "Descrição do bloco: ",
"You are editing block:" => "Você está editando o bloco:",
"Publishing date" => "Data de publicação",
"Publishing Date" => "Data de Publicação",
"Edit question options" => "Editar opções da pergunta",
"List Quizzes" => "Listar Testes",
"Quiz Stats" => "Estatísticas de testes",
"This Quiz Stats" => "Estatísticas deste teste",
"Edit this Quiz" => "Editar este teste",
"Admin Quizzes" => "Administrar testes",
"Create/edit options for question" => "Criar/editar opções para a pergunta",
"Create/edit quizzes" => "Criar/editar testes",
"There are individual permissions set for this quiz" => "Existem permissões individuais para este teste",
"Quiz can be repeated" => "Teste pode ser repetido",
"Store quiz results" => "Armazenar resultados do teste",
"Immediate feedback" => "Retorno imediato",
"Show correct answers" => "Mostrar respostas corretas",
"Shuffle questions" => "Embaralhar questões",
"Shuffle answers" => "Embaralhar respostas",
"Questions per page" => "Perguntas por página",
"Quiz is time limited" => "Tempo-limite para o teste",
"Maximum time" => "Tempo máximo",
"Passing Percentage" => "Percentual decorrido",
"Quiz" => "Teste",
"canRepeat" => "podeRepetir",
"timeLimit" => "tempoLimite",
"Edit quiz questions" => "Editar perguntas do teste",
"Create/edit questions for quiz" => "Criar/editar perguntas do teste",
"Question Type" => "Tipo das questões",
"Import questions from text" => "Importar questões do texto",
"Input" => "Entrada",
"maxScore" => "notaMaxima",
"From Points" => "Pontos Mínimos",
"To Points" => "Pontos Máximos",
"Answer" => "Resposta",
"Modify Structure" => "Modificar Estrutura",
"You will remove" => "Você irá remover",
"and its subpages from the structure, now you have two options:" => "e suas sub-páginas da estrutura, existem duas opções:",
"Remove only from structure" => "Remover apenas da estrutura",
"Remove from structure and remove page too" => "Remover da estrutura e remover também a página",
"Structure Layout" => "Estrutura de Layout",
"Promote" => "Promover",
"Demote" => "Demover",
"Current Node" => "Nó Atual",
"Page alias" => "Apelido da Página",
"at the beginning" => "no começo",
"at the end" => "no fim",
"Add pages to current node" => "Adicionar páginas ao nó atual",
"After page" => "Após a página",
"Create Page" => "Criar página",
"Use pre-existing page" => "Utilizar uma página pré-existente",
"Submit article" => "Enviar artigo",
"List Submissions" => "Listar submissões",
"<b>*</b>=optional" => "<b>*</b>=opcional",
"<b>Topline</b>=small line above Title" => "<b>Linha de cima</b>=pequena linha em cima do título",
"<b>Subtitle</b>=small line below Title" => "<b>Subtítulo</b>=pequena linha embaixo do título",
"<b>Source</b>=URL to article source" => "<b>Fonte</b>=indica a fonte do artigo",
"Submit Article" => "Enviar artigo",
"Auto-Approve Article" => "Aprovar automaticamente um artigo",
"Edit templates" => "Editar padrões",
"Template listing" => "Listagem de padrões",
"Available templates" => "Padrões disponíveis",
"Save Only in the Theme:" => "Salvar apenas no tema:",
"Delete the copy in the theme:" => "Deletar a cópia no tema:",
"Edit a topic" => "Editar um tópico",
"Translate:" => "Traduzir:",
"You must specify the object language" => "Você precisa especificar o objeto do idioma",
"The object doesn't exist" => "O objeto não existe",
"The object doesn't have a language" => "O objeto não possui um idioma",
"The object has already a translation for this language" => "O objeto já tem uma tradução para esse idioma",
"The object is already in the set of translations" => "O objeto já está selecionado para traduções",
"Create translation" => "Criar tradução",
"Or" => "Ou",
"Add existing page as a translation of this page" => "Adicionar uma página como tradução desta página",
"Manage existing translations of this page" => "Administrar traduções desta página",
"detach" => "desanexar",
"Change language for this page" => "Mudar idioma desta página",
"Change Language" => "Mudar idioma",
"No language is assigned to this page." => "Nenhum idioma associado a esta página.",
"Please select a language before performing translation." => "Por favor, selecione um idioma antes de iniciar a tradução.",
"Set Current Page's Language" => "Definir o idioma desta página",
"View object" => "Ver objeto",
"Preview your changes." => "Pré-visualizar suas alterações.",
"Save the page." => "Salvar página.",
"Cancel the edit, you will lose your changes." => "Cancele a edição, você perderá suas alterações.",
"Your edit session will expire in" => "Sua sessão de edição vai expirar em",
"Your edit session will expire in 1 minute. You must PREVIEW or SAVE your work now, to avoid losing your edits." => "Sua sessão de edição vai expirar em 1 minuto. Você deve pré-visualizar ou salvar o trabalho para evitar perder suas alterações.",
"Draft written on" => "Rascunho escrito em",
"Warning: new versions of this page have been made after this draft" => "Atenção: novas versões dessa página foram feitas depois desse rascunho",
"The SandBox is a page where you can practice your editing skills, use the preview feature to preview the appearance of the page, no versions are stored for this page." => "A bancada de testes é uma página onde você pode praticar as técnicas de edição, usar o recurso de pré-visualização. Nenhuma versão da bancada de testes é armazenada.",
"Perhaps you are looking for:" => "Talvez você esteja procurando por:",
"This edit session will expire in {\$edittimeout} minutes" => "Essa sessão de edição irá acabar em {\$edittimeout} minutos",
"<strong>Preview</strong> or <strong>Save</strong> your work to restart the edit session timer." => "<strong>Pré-visualize</strong> ou <strong>salve</strong> seu trabalho para reiniciar o tempo da sessão.",
"Admin Content Templates" => "Administrar padrões de conteúdo",
"Use rating" => "Usar classificação",
"There is no available poll template." => "Não existe um modelo de enquete disponível.",
"You should ask an admin to create them." => "Você deve pedir para o administrador cria-los.",
"or use" => "ou use",
"an existing poll" => "uma enquete existente",
"votes" => "votos",
"Replace to" => "Substituir por",
"My Footnotes" => "Notas de rodapé",
"Translation request" => "Atualizar traducação",
"Send urgent translation request." => "Enviar aviso para atualização das traduções desta página.",
"Year:" => "Ano:",
"Authors:" => "Autores:",
"Try to convert HTML to wiki" => "Tentar converter HTML para wiki",
"Import page" => "Importar página",
"export all versions" => "exportar todas as versões",
"Upload picture" => "Carregar uma imagem",
"Add another image" => "Adicionar outra imagem",
"License" => "Licença",
"Important" => "Importante",
"Lock this page" => "Travar essa página",
"Export to file" => "Exportar arquivo",
"status" => "estado",
"lastModif" => "ultimaModif",
"All fields" => "Todos os campos",
"Admin FAQ" => "Administrar FAQ",
"List FAQs" => "Listar FAQs",
"View FAQ" => "Visualizar FAQ",
"Edit this FAQ" => "Editar este FAQ",
"New Question" => "Nova pergunta",
"Edit FAQ question" => "Editar questão do FAQ",
"Add FAQ question" => "Adicionar questão ao FAQ",
"Use a question from another FAQ" => "Utilizar uma pergunta de outro FAQ",
"FAQ questions" => "Perguntas do FAQ",
"Suggested questions" => "Perguntas sugeridas",
"No suggested questions" => "Sem perguntas sugeridas",
"Upload File" => "Carregar arquivo",
"View tpl" => "Exibir tpl",
"File Galleries tpl" => "Galeria de arquivos tpl",
"Create New File Gallery" => "Criar uma nova galeria de arquivos",
"You can access the file gallery using the following URL" => "Você pode acessar a galeria de arquivos pelo seguinte endereço",
"Size (width x height)" => "Tamanho (largura x altura)",
"Admin forums" => "Administrar fóruns",
"Edit queued message" => "Editar mensagem na fila",
"make this a thread of" => "transformar em uma seqüência de",
"None, this is a thread message" => "Nenhuma, esta é uma mensagem de uma seqüência",
"summary" => "sumário",
"announce" => "anúncio",
"hot" => "quente",
"no feeling" => "insensível",
"frown" => "muxoxo",
"exclaim" => "exclamação",
"idea" => "idéia",
"mad" => "furioso",
"neutral" => "neutro",
"question" => "pergunta",
"sad" => "triste",
"happy" => "feliz",
"wink" => "piscadela",
"Save and Approve" => "Salvar e aprovar",
"convert to topic" => "converter em um assunto",
"List of messages" => "Lista de mensagens",
"New Topic" => "Novo assunto",
"no summary" => "sem sumário",
"No messages queued yet" => "Nenhuma mensagem na fila",
"Search by name" => "Procurar por nome",
"Search in content" => "Procurar no conteúdo",
"Last Post" => "Última mensagem",
"Configure Forum" => "Configurar fórum",
"Reported by" => "Enviada por",
"No records to display" => "Nenhum registro",
"Set language" => "Definir idioma",
"Pending requests" => "Solicitações pendentes",
"Request Time" => "Solicitar tempo",
"Accept" => "Aceitar",
"Refuse" => "Recusar",
"Waiting requests" => "Esperando solicitações",
"Cancel friendship request" => "Cancelar pedido de amizade",
"Your friends" => "Seus amigos",
"break friendship" => "romper amizade",
"Activity completed" => "Atividade completada",
"Admin process activities" => "Administrar atividades do processo",
"Add or edit an activity" => "Adicionar ou editar uma atividade",
"activity" => "atividade",
"split" => "dividir",
"join" => "unir",
"standalone" => "independente",
"interactive" => "interativa",
"auto routed" => "roteado automaticamente",
"Expiration Time" => "Data de expiração",
"Years" => "Anos",
"Months" => "Meses",
"Hours" => "Horas",
"Minutes" => "Minutos",
"Add transitions" => "Adicionar transições",
"Add transition from:" => "Adicionar uma transição de:",
"Add transition to:" => "Adicionar uma transição para:",
"No roles associated to this activity" => "Não há um perfil associado a esta atividade",
"Add Role" => "Adicionar perfil",
"Add New" => "Adicionar novo",
"Process activities" => "Atividades do processo",
"Routing" => "Roteamento",
"Interactive" => "Interativo",
"Automatic" => "Automático",
"Auto routed" => "Roteado automaticamente",
"route" => "rota",
"(no roles)" => "(sem perfil)",
"No activities defined yet" => "Nenhuma atividade definida ainda",
"Process Transitions" => "Transições do Processo",
"List of transitions" => "Lista de transições",
"Origin" => "Origem",
"No transitions defined yet" => "Nenhuma transição definida ainda",
"Add a transition" => "Adicionar uma transição",
"Edit Tpl" => "Editar tpl",
"This process is invalid" => "Este processo é inválido",
"List of processes" => "Lista de processos",
"Inactive" => "Inativo",
"act" => "atv",
"Active Process" => "Processo ativo",
"Invalid Process" => "Processo inválido",
"Valid Process" => "Processo válido",
"Activities" => "Atividades",
"New Minor" => "Novo secundário",
"New Major" => "Novo principal",
"No processes defined yet" => "Nenhum processo definido ainda",
"Admin instance" => "Administrar instância",
"Process:" => "Processo:",
"Instance" => "Instância",
"Workitems" => "Itens de trabalho",
"exception" => "exceção",
"completed" => "completado",
"Aborted" => "Abortado",
"Owner" => "Dono",
"Send all to" => "Enviar todos para",
"Don't move" => "Não mover",
"Started" => "Iniciado",
"Act status" => "Estado da Atvd",
"Ended" => "Terminou",
"Not Defined" => "Não definido",
"Not Interactive" => "Não interativo",
"Not Ended" => "Não terminado",
"Property" => "Propriedade",
"Add property" => "Adicionar propriedade",
"run instance" => "executar instância",
"Executed" => "Executado",
"erase" => "apagar",
"Admin processes" => "Administrar processos",
"Galaxia Admin Processes" => "Administrar Processos do Galaxia",
"Add or edit a process" => "Adicionar ou editar um processo",
"Process Name" => "Nome do Processo",
"ver:" => "versão:",
"is active?" => "Ativo?",
"Or upload a process using this form" => "Ou carregue um processo usando este formulário",
"Admin process roles" => "Administrar perfis de processo",
"Add or edit a role" => "Adicionar ou editar um perfil",
"Process roles" => "Perfis de processo",
"No roles defined yet" => "Nenhum perfil definido ainda",
"Map users to roles" => "Associar usuários a perfis",
"map" => "associar",
"Map groups to roles" => "Associar grupos a perfis",
"Operation" => "Operação",
"No roles are defined yet so no roles can be mapped" => "Nenhuma regra definida, associação impossível",
"List of mappings" => "Lista de associações",
"No mappings defined yet" => "Nenhuma associação definida ainda",
"Admin process sources" => "Administrar fontes de processo",
"select source" => "selecionar a fonte",
"Shared code" => "Código compartilhado",
"Set next user" => "Definir próximo usuário",
"Get property" => "Obter propriedade",
"Set property" => "Definir propriedade",
"Process form" => "Formulário de processamento",
"Set Next act" => "Definir próxima ação",
"Switch construct" => "Alternar diagrama",
"Map process roles" => "Associar perfis do processo",
"Admin Processes" => "Administrar processos",
"Admin Activities" => "Administrar atividades",
"Admin Roles" => "Administrar perfis",
"Edit this Process" => "Editar este processo",
"Monitor Activities" => "Monitorar atividades",
"Galaxia Monitor Activities" => "Monitoramento de Atividades do Galaxia",
"List of activities" => "Lista de atividades",
"routing" => "roteamento",
"Instances" => "Instâncias",
"run" => "executar",
"run activity" => "executar atividade",
"Enter the name of this instance" => "Coloque o nome dessa instância",
"The name is not valid. Please, enter the name again" => "O nome não é válido. Por favor, tente novamente",
"Monitor" => "Monitorar",
"monitor processes" => "monitorar processos",
"monitor activities" => "monitorar atividades",
"monitor instances" => "monitorar instâncias",
"monitor workitems" => "monitorar itens de trabalho",
"Monitor Instances" => "Monitorar instâncias",
"Galaxia Monitor Instances" => "Monitoramento de Instâncias do Galaxia",
"List of instances" => "Lista de instâncias",
"Not ended" => "Não terminado",
"No instances created yet" => "Nenhuma instância criada ainda",
"Monitor Processes" => "Monitorar processos",
"Galaxia Monitor Processes" => "Monitoramento de Processos do Galaxia",
"processes" => "processos",
"being run" => "sendo executados",
"Completed" => "Realizada",
"Exceptions" => "Exceções",
"Monitor workitems" => "Monitorar itens de trabalho",
"List of workitems" => "Lista de itens de trabalho",
"instance" => "instância",
"My activities" => "Minhas atividades",
"Current Activity" => "Atividades atuais",
"Assigned To" => "Associado a",
"exception instance" => "instância-exceção",
"exceptions instance" => "instância-exceções",
"Send Instance" => "Enviar instância",
"abort instance" => "abortar instância",
"grab instance" => "obter instância",
"release instance" => "liberar instância",
"No activities found" => "Nenhuma atividade encontrada",
"My instances" => "Minhas instâncias",
"No instances found" => "Nenhuma instância encontrada",
"User Activities" => "Atividades de Usuário",
"Galaxia User Activities" => "Atividades de Usuário do Galaxia",
"process" => "processo",
"user processes" => "processos de usuários",
"user activities" => "atividades de usuários",
"user instances" => "instâncias de usuários",
"User Instances" => "Instâncias de usuários",
"Galaxia User Instances" => "Instâncias de Usuários do Galaxia",
"Inst Status" => "Estado da inst",
"Not defined" => "Não definido",
"No instances defined yet" => "Nenhuma instância definida ainda",
"User Processes" => "Processos de usuário",
"Galaxia User Processes" => "Processos de Usuário do Galaxia",
"Browsing Workitem" => "Visualizando Item de Trabalho",
"Workitem information" => "Informação do item de trabalho",
"Galleries" => "Galerias",
"Create New Gallery" => "Criar uma nova galeria",
"Create a gallery" => "Criar uma galeria",
"Edit this gallery:" => "Editar esta galeria:",
"There are individual permissions set for this gallery" => "Existem permissões individuais definidas para esta galeria",
"Geographic" => "Geografia",
"Fields to show during browsing the gallery" => "Campos que devem aparecer na navegação da galeria",
"Creation Date" => "Data de criação",
"XY-Size" => "XY-tamanho",
"Gallery Image" => "Galeria de imagens",
"Available scales" => "Escalas disponíveis",
"default scale" => "escalar padrão",
"No scales available" => "Nenhuma escala disponível",
"Original image is default scale" => "A imagem original é a escala padrão",
"Add scaled images with bounding box of square size" => "Adicionar escala para imagem",
"Other users can upload images to this gallery" => "Outros usuários podem carregar imagens nesta galeria",
"You can access the gallery using the following URL" => "Você pode acessar esta galeria pelo seguinte endereço",
"Available Galleries" => "Galerias Disponíveis",
"Choose a filter" => "Escolher filtro",
"Imgs" => "Imagens",
"Make Map" => "Fazer mapa",
"Select Graphic Type" => "Selecionar tipo gráfico",
"Multiline" => "Multi-linha",
"Landscape" => "Paisagem",
"Portrait" => "Retrato",
"Independant Scale" => "Escala independente",
"Horizontal Scale" => "Escala horizontal",
"Bottom" => "Fundo",
"Vertical Scale" => "Escalar vertical",
"Series" => "Séries",
"Calendar Import" => "Importar calendário",
"Im- Export languages" => "Importar/exportar línguas",
"Select the language to Import" => "Selecione a língua para importar",
"Select the language to Export" => "Selecione a língua para exportar",
"Import From File" => "Importar do arquivo",
"Grab Wiki Tables" => "Obter tabelas wiki",
"Import pages from a Structured Text Dump" => "Importar páginas de uma exportação em texto estruturada",
"Name of the dump file (it has to be in dump/)" => "Nome do arquivo de exportação (precisa estar no diretório dump/)",
"Overwrite existing pages if the name is the same" => "Sobrescrever páginas com mesmo nome",
"Previously remove existing page versions" => "Remover versões previamente existentes da página",
"excerpt" => "trecho",
"Result" => "Resultado",
"body" => "corpo",
"Locked" => "Travada",
"Tiki installer" => "Instalador do Tiki",
"Welcome" => "Bem-vindo",
"For the latest information about this release, please read the" => "Para mais informações sobre essa versão leia as",
"Release Notes" => "Notas sobre a versão",
"For complete documentation, please visit" => "Para a documentação completa visite",
"Read the License" => "Leia a licença",
"Review the System Requirements" => "Requisitos do sistema",
"Memory" => "Memoria",
"Success" => "Sucesso",
"Mail" => "E-mail",
"Send Test Message" => "Enviar mensagem de teste",
"Image Processing" => "Processamento de imagens",
"Set the Database Connection" => "Conexão com o banco de dados",
"Use Existing Connection" => "Usar a conexão existente",
"Database information" => "Informações do banco de dados",
"Database user" => "Usuário do banco de dados",
"Install Profile" => "Instalar perfil",
"Install" => "Instalar",
"Reinstall the database" => "Reinstalar a base de dados",
"Upgrade" => "Atualização",
"Review the Upgrade" => "Verificar atualização",
"Review the Installation" => "Verificar a instalação",
"Upgrade complete" => "Atualização completa",
"Installation complete" => "Instalação completa",
"Failed" => "Falhou",
"Configure General Settings" => "Configurações Gerais",
"Administrator" => "Administrador",
"Installation" => "Instalação",
"Recommended" => "Recomendado",
"Database Connection" => "conexão com a base de dados",
"Configure the General Settings" => "Configurações gerais",
"Support Forums" => "Fóruns de suporte",
"Clear cached version and refresh cache" => "Limpar versão em cache e recarregar o cache",
"configure rules" => "configurar regras",
"Edit Repository" => "Editar repositório",
"Interactive translator" => "Tradutor interativo",
"has been updated" => "foi atualizado",
"Close this window" => "Fechar esta janela",
"Go Back" => "Voltar",
"Last Changes" => "Últimas alterações",
"Search by Date" => "Busca por Data",
"LastChanges" => "Ultimas alterações",
"Rollback" => "Restaurar",
"Pages like" => "Páginas semelhantes",
"No pages found" => "Nenhuma página encontrada",
"Edit New Article" => "Editar um novo artigo",
"View Submissions" => "Ver artigos enviados",
"ExpireDate" => "DataDeExpiração",
"AuthorName" => "NomeDoAutor",
"To use a banner in a <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">module</a> or a template, use {literal}{banner zone=ABC}{/literal}, where ABC is the name of the zone." => "Para usar um banner em um <a class=\"rbox-link\" href=\"tiki-admin_modules.php\">módulo</a> ou em um template, use o código {literal}{banner zone=ABC}{/literal}, onde ABC é o nome da zona de banners.",
"Create banner" => "Criar um banner",
"Use Dates?" => "Usar datas?",
"Max Impressions" => "Máx. Exibições",
"Impressions" => "Exibições",
"Clicks" => "Cliques",
"Create New Blog" => "Criar um novo blog",
"Use cache for external pages" => "Cache para páginas externas",
"Dynamic content system" => "Sistema de conteúdo dinâmico",
"Available content blocks" => "Blocos de conteúdo disponíveis",
"Current ver" => "Versão atual",
"Next ver" => "Próxima vers.",
"Future vers" => "Versões futuras",
"Program" => "Programa",
"Edit this FAQ:" => "Editar este FAQ:",
"Create new FAQ" => "Criar um novo FAQ",
"Create New FAQ:" => "Criar um novo FAQ:",
"Users can suggest questions" => "Usuários podem sugerir perguntas",
"Available FAQs" => "FAQs Disponíveis",
"Create a File Gallery" => "Criar uma galeria de arquivos",
"Your comment" => "Comentário",
"optional" => "opcional",
"Modifications" => "Modificações",
"Gallery Images" => "Imagens da Galeria",
"All games are from" => "Todos os jogos são de",
"visit the site for more games and fun" => "visite o site para mais jogos e brincadeiras",
"Upload a game" => "Carregar um jogo",
"Upload a new game" => "Carregar um novo jogo",
"Thumbnail (if the game is foo.swf the thumbnail must be named foo.swf.gif or foo.swf.png or foo.swf.jpg)" => "Miniatura (se o jogo se chamar foo.swf a miniatura deve se chamar foo.swf.gif ou foo.swf.png ou foo.swf.jpg)",
"Edit game" => "Editar o jogo",
"Played" => "Jogado",
"If you can't see the game then you need a flash plugin for your browser" => "Se você não consegue visualizar o jogo então você precisa instalar o plugin Flash no seu navegador",
"Edit Blog" => "Editar Blog",
"Blog Title" => "Título do Blog",
"Edit New Submission" => "Editar nova mensagem",
"Survey stats" => "Estatísticas da pesquisa",
"Take Survey" => "Pegar pesquisa",
"users registered" => "usuários registrados",
"Distance (km)" => "Distância (km)",
"List Movies" => "Listar filmes",
"Choose a movie" => "Escolha um filme",
"Last mod" => "Última alteração",
"Last modification" => "Última alteração",
"Page creator" => "Criador da página",
"Last author" => "Último autor",
"Last version" => "Última versão",
"Status of the page" => "Status da página",
"Page size" => "Tamanho da página",
"unlocked" => "destravada",
"Open client window" => "Abrir a janela de cliente",
"Generate HTML" => "Gerar HTML",
"Transcripts" => "Transcrição",
"Online operators" => "Operadores on-line",
"Operator" => "Operador",
"Accepted requests" => "Aceitar requisições",
"since" => "desde",
"transcripts" => "transcrição",
"Offline operators" => "Operadores offline",
"Add an operator to the system" => "Adicionar um operador ao sistema",
"Operators must be tiki users" => "Operadores devem ser usuários Tiki",
"Set as Operator" => "Definir como operador",
"Chat started" => "Chat iniciado",
"Operator:" => "Operador:",
"Live support:User window" => "Suporte on-line:Janela do usuário",
"Request live support" => "Requisitar suporte on-line",
"Request support" => "Requisitar suporte",
"Open a support ticket instead" => "Obter um bilhete de suporte ao invés disto",
"Your request is being processed" => "Sua requisição está sendo processada",
"cancel request and exit" => "cancelar a requisição e sair",
"cancel request and leave a message" => "cancelar a requisição e deixar uma mensagem",
"Live support:Console" => "Suporte on-line:Console",
"be online" => "ficar on-line",
"be offline" => "ficar offline",
"Support requests" => "Requisições de suporte",
"Requested" => "Requisitou",
"Join" => "Juntar-se",
"Support chat transcripts" => "Transcrições do chat de suporte",
"operator" => "operador",
"started" => "iniciou",
"reason" => "motivo",
"Transcript" => "Transcrição",
"Thank you" => "Obrigado",
"Mail-in feature" => "Recurso mail-in",
"Remove old events" => "Remover eventos antigos",
"duration" => "duração",
"Add event" => "Adicionar evento",
"Mini Calendar: Preferences" => "Mini-Calendário: Preferências",
"Calendar Interval in daily view" => "Intervalo do calendário na visão diária",
"Start hour for days" => "Hora inicial para os dias",
"End hour for days" => "Hora final para os dias",
"Reminders" => "Lembretes",
"no reminders" => "sem lembretes",
"Or enter path or URL" => "Ou entre o caminho ou endereço",
"Add Topic" => "Adicionar assunto",
"Rebuild local list" => "Reconstruir lista localRebuild local list",
"Republish all" => "Republicar todos",
"Publish all" => "Publicar todos",
"Unpublish all" => "Despublicar todos",
"Attention" => "Atenção",
"all types" => "todos os tipos",
"Display only this type" => "Mostrar apenas esse tipo",
"Unpublish" => "Não publicar",
"Republish" => "Publicar novamente",
"Package Config" => "Configurar pacote",
"User Pages" => "Páginas de Usuários",
"y" => "s",
"User Galleries" => "Galerias de Usuário",
"Unread Messages" => "Mensagens não lidas",
"Tasks" => "Tarefas",
"User Blogs" => "Blogs de Usuários",
"MyTiki" => "Área pessoal",
"Notepad" => "Bloco de notas",
"MyFiles" => "Meus Arquivos",
"My Watches" => "Minhas notificações",
"Assigned items" => "Itens atribuídos",
"Sent editions" => "Edições enviadas",
"The newsletter was sent to {\$sent} email addresses" => "O comunicado foi enviado para {\$sent} endereços de email",
"Thanks for your subscription. You will receive an email soon to confirm your subscription. No newsletters will be sent to you until the subscription is confirmed." => "Obrigado por sua assinatura. Você receberá um email em breve para confirmar sua assinatura. Nenhum comunicado será enviado até que sua inscrição seja confirmada.",
"Your email address was removed from the list of subscriptors." => "Seu endereço de email foi removido da lista de assinantes.",
"Subscription confirmed!" => "Assinatura confirmada!",
"Available Newsletters" => "Newsletters disponíveis",
"Select news group" => "Selecionar grupo de news",
"Back to servers" => "Voltar aos servidores",
"Msgs" => "Mens",
"News from" => "Novidades de",
"Back to groups" => "Voltar aos grupos",
"Save position" => "Gravar a posição",
"Reading article from" => "Lendo artigo de",
"Back to list of articles" => "Voltar à lista de artigos",
"Configure news servers" => "Configurar servidores de notícias",
"Configure Newsreader" => "Configurar leitor de notícias",
"configure newsreader server tpl" => "configurar servidor de leitores de notícias tpl",
"Select a news server to browse" => "Selecione um servidor de notícias para visualizar",
"server" => "servidor",
"Read the news" => "Ler notícias",
"News server" => "Servidor de notícias",
"Notes" => "Notas",
"Write a note" => "Escrever uma nota",
"quota" => "cota",
"No notes yet" => "Sem notas ainda",
"Merge selected notes into" => "combinar notas selecionadas em",
"Reading note:" => "Lendo nota:",
"List notes" => "Listar notas",
"Write note" => "Escrever nota",
"Wiki Create" => "Criar wiki",
"Wiki Overwrite" => "Sobrescrever wiki",
"Added:" => "Adicionado:",
"Removed:" => "Removido:",
"Assign permissions to " => "Definir permissões a ",
"View Permissions" => "Ver permissões",
"Edit Permissions" => "Editar permissões",
"These permissions override any global permissions or category permissions affecting this object." => "Essas permissões sobrescrevem qualquer permissão global ou permissões de categorias atribuídas a este objeto.",
"To edit global permissions <a class=\"rbox-link\" href=\"tiki-admingroups.php\">click here</a>." => "Para ver ou editar as permissões globais <a class=\"rbox-link\" href=\"tiki-admingroups.php\">clique aqui</a>.",
"Current permissions for this object" => "Permissões atuais para este objeto",
"No individual permissions, category permissions apply" => "Nenhuma permissão individual, utilizando permissões da categoria",
"Current permissions for categories that this object belongs to" => "Permissões atuais para as categorias que este objeto pertence",
"No category permissions; global permissions apply" => "Sem permissão na categoria, usando permissões globais",
"Assign permissions to this object" => "Definir permissões para este objeto",
"Published" => "Publicado",
"Orphan Pages" => "Páginas Órfãs",
"Browser not supported" => "Navegador não suportado",
"Rename" => "Renomear",
"Make Structure" => "Criar estrutura",
"Discuss" => "Discutir",
"Attach File" => "Anexar",
"1 File Attached" => "1 arquivo anexado",
"Preview of version" => "Visualização prévia da versão",
"(current)" => "(atual)",
"Rollback to this version" => "Restaurar para essa versão",
"Source of version" => "Fonte da versão",
"s=source" => "s=fonte",
"b=rollback" => "b=restaurar",
"Update Translation" => "Atualizar tradução",
"Hide translation history" => "Esconder histórico de tradução",
"Show translation history" => "Mostrar histórico de tradução",
"Pick your avatar" => "Selecione sua fotografia",
"User Preferences" => "Preferências do Usuário",
"Your current avatar" => "Sua fotografia atual",
"no avatar" => "sem fotografia",
"reset" => "reiniciar",
"Pick avatar from the library" => "Selecionar uma fotografia da biblioteca",
"Pick user Avatar" => "Escolher fotografia do usuário",
"Hide all" => "Esconder todos",
"icons" => "ícones",
"Show all" => "Exibir todos",
"Avatar Image" => "Imagem da fotografia",
"Upload your own avatar" => "Carregar sua própria fotografia",
"View Details" => "Ver detalhes",
"Insert" => "Inserir",
"atts" => "atributos",
"List Attachments" => "Listar anexos",
"Average" => "Média",
"View Results" => "Ver Resultados",
"Vote poll" => "Votar na enquete",
"Other Polls" => "Outras enquetes",
"Note: Remember that this is only a preview, and has not yet been saved!" => "Nota: lembre-se que isto é apenas uma visualização, ainda não foi salvo.",
"on:" => "em:",
"Topic image" => "Imagem do assunto",
"Viewing blog post" => "Visualizando mensagem do blog",
"Return to blog" => "Retornar ao blog",
"The original document is available at" => "O documento original pode ser encontrado em",
"Print multiple pages" => "Imprimir múltiplas páginas",
"Add Page" => "Adicionar página",
"Edit quiz" => "Editar quiz",
"General Options" => "Opções gerais",
"Name:" => "Login:",
"Publication Date" => "Data da publicação",
"at " => "às ",
"Use " => "Uso ",
"randomly selected questions." => "selecionar questões aleatoriamente.",
"Test-time Options" => "Opções durante o teste",
"Limit questions displayed per page to " => "Limitar questões mostradas por página ",
"&nbsp question(s)." => "&nbsp questão(s).",
"Impose a time limit of " => "Impor um limite de tempo de ",
"Allow students to store partial results and return to quiz." => "Permitir que estudantes guardem resultados parciais e voltem para o quiz.",
"Allow students to retake this quiz " => "Permitir que estudantes reiniciem esse quiz ",
"Grading and Feedback" => "Classificação e retorno",
"Grading method " => "Método de classificação ",
"Show students their score " => "Mostrar para os estudantes sua pontuação ",
"Show students the correct answers " => "Mostrar para os estudantes a resposta correta ",
"Publish statistics " => "Publicar estatísticas ",
"Extra Options" => "Opções extras",
"Solicit additional questions from students" => "Solicitar questões adicionais dos estudantes",
"Link quiz to forum named: " => "Criar um link do quiz para um fórum chamado: ",
"Prologue:" => "Prólogo:",
"Epilogue:" => "Epílogo:",
"Quiz result stats" => "Estatísticas de resultados do Teste",
"Time" => "Tempo",
"User answers" => "Respostas do usuário",
"Stats for quizzes" => "Estats para testes",
"taken" => "feitos",
"Av score" => "Pontuação méd.",
"Av time" => "Tempo méd.",
"Clear Stats" => "Limpar estatísticas",
"time taken" => "tempo total",
"Stats for this quiz Questions " => "Estatísticas para as perguntas deste teste ",
"Top 10" => "10 Mais",
"Top 20" => "20 Mais",
"Top 50" => "50 Mais",
"Top 100" => "100 Mais",
"Send a link" => "Enviar link",
"Received articles" => "Artigos recebidos",
"Edit received article" => "Editar o artigo recebido",
"Use Image" => "Usar Imagem",
"Image x size" => "Largura da imagem",
"Image y size" => "Altura da imagem",
"Image name" => "Nome da imagem",
"Accept Article" => "Aceitar o Artigo",
"Received Pages" => "Páginas Recebidas",
"Referer stats" => "Estatísticas de referência",
"A valid email is mandatory to register" => "É necessário um e-mail válido para poder se registrar",
"Select your group" => "Selecione seu grupo",
"NOTE: Make sure to whitelist this domain to prevent registration emails being canned by your spam filter!" => "NOTA: Verifique se o domínio desse site não é marcado como spam por seu cliente de e-mail. Se não estiver recebendo e-mails do site verifique se eles não estão na caixa de spam.",
"Tiki site registered" => "Site Tiki registrado",
"The following site was added and validation by admin may be needed before appearing on the lists" => "O site a seguir foi adicionado mas a validação pelo administrador pode ser necessária antes que apareça nas listas",
"You don't have permission to use this feature." => "Você não tem permissão para usar esse recurso.",
"Please register." => "Por favor faça o registro.",
"Register this site at tikiwiki.org" => "Registrar este site no tikiwiki.org",
"Read this first!" => "Leia isto em primeiro!",
"On this page you can make your tiki site known to tikiwiki.org. It will get shown there in a list of known tiki sites." => "Nesta página você pode fazer com que seu site seja conhecido no tikiwiki.org. Ele será mostrado em uma lista de sites tiki conhecidos.",
"Registering is voluntary." => "O registro é voluntário.",
"Registering does not give you any benefits except one more link to your site." => "O registro não dá à você nenhum benefício exceto o link para seu site.",
"You don't get any emails, we don't sell the data about your site." => "Você não pode pegar nenhum e-mail, nós não vendemos os dados sobre seu site.",
"Registering is just for us to get an overview of Tiki's usage." => "O registro é somente para obtermos uma amostragem do uso do Tiki.",
"If your site is private or inside your intranet, you should not register!" => "Se o seu site é privado ou está dentro de sua intranet, você não deve se registrar!",
"Information about your site" => "Informação sobre seu site",
"Send me my Password" => "Envie minha senha",
"Remove page" => "Remover a página",
"Last Version" => "última versão",
"You are about to remove the page" => "Você está prestes a remover a página",
"permanently" => "permanentemente",
"Remove all versions of this page" => "Remover todas as versões desta página",
"Replicate" => "Replicar",
"Slave" => "Escravo",
"Master" => "Principal",
"Operations" => "Operações",
"Operations Log" => "Log das operações",
"Rollback page" => "Restaurar versão da página",
"Searched" => "Buscadas",
"Search in" => "Buscar em",
"Simple search" => "Busca simples",
"No pages matched the search criteria" => "Nenhuma página atendeu aos seus critérios de busca",
"Send blog post" => "Enviar mensagem blog",
"A link to this post was sent to the following addresses:" => "Um link para esta mensagem foi enviada para os seguintes endereços:",
"Send post to this addresses" => "Enviar a mensagem para estes endereços",
"List of email addresses separated by commas" => "Lista de endereços de email separados por vírgulas",
"This newsletter will be sent to {\$subscribers} email addresses." => "Este comunicado será enviado para {\$subscribers} endereços de email.",
"Prepare a newsletter to be sent" => "Preparar um comunicado para envio",
"Apply content template" => "Aplicar conteúdo do template",
"remove" => "remover",
"Send objects" => "Enviar objetos",
"Transmission results" => "Resultados da transmissão",
"Send Wiki Pages" => "Enviar Páginas Wiki",
"Send Articles" => "Enviar Artigos",
"Add Article" => "Adicionar um artigo",
"Send objects to this site" => "Enviar objetos para este site",
"Create a sheet" => "Criar uma planilha",
"Edit this sheet:" => "Editar essa planilha:",
"Create New Sheet" => "Criar nova planilha",
"There are individual permissions set for this sheet" => "Existem permissões individuais definidas para essa planilha",
"Class Name" => "Nome da classe",
"Header Rows" => "Linhas do topo",
"Footer Rows" => "Linhas de baixo",
"Create new Sheet" => "Criar nova planilha",
"You can access the sheet using the following URL" => "Você pode acessar a planilha através do endereço",
"Available Sheets" => "Planilhas disponíveis",
"Tiki Shoutbox" => "Mural",
"Change shoutbox general settings" => "Alterar configurações gerais do quadro negro",
"Post or edit a message" => "Enviar ou editar uma mensagem",
"Parent page" => "Página pai",
"Child" => "Criança",
"Last edited by" => "Último edição por",
"based on work by" => "baseado no trabalho de",
"Contributors to this page" => "Contribuíram para esta página",
"big grin" => "grande sorriso",
"confused" => "confuso",
"cool" => "legal",
"cry" => "chorando",
"evil" => "demônio",
"lol" => "engraçado",
"mr green" => "sr. verde",
"razz" => "insultoso",
"redface" => "cara vermelha",
"rolleyes" => "olhos enrolados",
"smile" => "sorriso",
"surprised" => "surpreso",
"twisted" => "torcido",
"arrow" => "seta",
"santa" => "papai noel",
"Most viewed objects" => "Objetos mais vistos",
"Most viewed objects in the last 7 days" => "Objetos mais vistos nos últimos 7 dias",
"Site Stats" => "Estatísticas do Site",
"Days online" => "Dias on-line",
"Total pageviews" => "Total de visualizações de páginas",
"Average pageviews per day" => "Média de visualizações de páginas diárias",
"Best day" => "Melhor dia",
"Worst day" => "Pior dia",
"Wiki Stats" => "Estatísticas Wiki",
"Size of Wiki Pages" => "Tamanho das Páginas Wiki",
"Average page length" => "Tamanho médio das páginas",
"Average versions per page" => "Média de versões por página",
"Visits to wiki pages" => "Visitas a páginas Wiki",
"Orphan pages" => "Páginas órfãs",
"Average links per page" => "Média de links por página",
"Image galleries Stats" => "Estatísticas de galerias de imagens",
"Average images per gallery" => "Número médio de imagens por galeria",
"Total size of images" => "Tamanho total das imagens",
"Average image size" => "Tamanho médio das imagens",
"Visits to image galleries" => "Visitas as galerias de imagens",
"File galleries Stats" => "Estatísticas das galerias de arquivos",
"Average files per gallery" => "Número médio de arquivos por galeria",
"Total size of files" => "Tamanho total dos arquivos",
"Average file size" => "Tamanho médio dos arquivos",
"Visits to file galleries" => "Visitas as galerias de arquivos",
"CMS Stats" => "Estatísticas de CMS",
"Total reads" => "Total de leituras",
"Average reads per article" => "Média de leituras por artigos",
"Total articles size" => "Tamanho total dos artigos",
"Average article size" => "Tamanho médio dos artigos",
"Forum Stats" => "Estatísticas dos fóruns",
"Total topics" => "Total de assuntos",
"Average topics per forums" => "Média de assuntos por fórum",
"Visits to forums" => "Visitas aos fóruns",
"Blog Stats" => "Estatísticas de Blogs",
"Total posts" => "Total de mensagens",
"Average posts per weblog" => "Média de mensagens por weblog",
"Total size of blog posts" => "Tamanho total das mensagens de blogs",
"Average posts size" => "Tamanho médio das mensagens",
"Visits to weblogs" => "Visitas aos weblogs",
"Poll Stats" => "Estatísticas das enquetes",
"Total votes" => "Total de votos",
"Average votes per poll" => "Média de votos por enquete",
"Total questions" => "Total de perguntas",
"Average questions per FAQ" => "Média de perguntas por FAQ",
"User Stats" => "Estatísticas de usuários",
"User bookmarks" => "Bookmarks de usuários",
"Average bookmarks per user" => "Média de bookmarks por usuário",
"Average questions per quiz" => "Média de perguntas por teste",
"Quizzes taken" => "Testes realizados",
"Average quiz score" => "Nota média nos testes",
"Average time per quiz" => "Tempo médio por teste",
"Usage chart" => "Gráfico de uso",
"Usage chart image" => "Imagem do gráfico de uso",
"Daily Usage" => "Uso diário",
"Stats for surveys" => "Estatísticas de pesquisas",
"Last taken" => "Última realização em",
"Time Left" => "Tempo restante",
"Send Answers" => "Enviar as respostas",
"Thank you for your submission" => "Obrigado por enviar",
"Send a link to a friend" => "Enviar link para um amigo",
"Your email was sent" => "Seu email foi enviado",
"The link was sent to the following addresses:" => "Link enviado para os seguintes endereços:",
"Friend's email" => "Destinatário",
"Separate multiple email addresses with a comma." => "Para enviar para mais de um destinatário separe os endereços com vírgula.",
"Your name" => "Seu nome",
"Your email" => "Seu e-mail",
"I found an interesting page that I thought you would like." => "Encontrei esta página, imagino que seja do seu interesse.",
"Delete this link" => "Deletar este link",
"Theme is selected as follows" => "Um tema é selecionado da seguinte forma",
"If a theme is assigned to the individual object that theme is used." => "Se um tema for atribuído a um objeto individual o tema é utilizado",
"If not then if a theme is assigned to the object's category that theme is used" => "Senão, então se um tema for atribuído à categoria do objeto o tema é utilizado",
"If not then a theme for the section is used" => "Senão, um tema para a seção é utilizado",
"If none of the above was selected the user theme is used" => "Se nenhum dos itens acima for selecionado, o tema do usuário é utilizado",
"Finally if the user didn't select a theme the default theme is used" => "Finalmente, se o usuário não selecionou um tema o tema padrão é utilizado",
"Control by Objects" => "Controlado por objetos",
"Control by Sections" => "Controlar por seções",
"Assign themes to categories" => "Atribuir temas a categorias",
"Assigned categories" => "Categorias atribuídas",
"Theme Control Center: Objects" => "Centro de Controle de Temas: Objetos",
"Control by Categories" => "Controle por Categorias",
"Assign themes to objects" => "Atribuir temas a objetos",
"Assigned objects" => "Objetos atribuídos",
"Assign themes to sections" => "Atribuir temas a seções",
"Assigned sections" => "Seções atribuídas",
"Edit File:" => "Editar arquivo:",
"The following file was successfully uploaded" => "O seguinte arquivo foi carregado com sucesso",
"Additional Info" => "Informações adicionais",
"You can download this file using" => "Você pode baixar este arquivo usando",
"You can link to the file from a Wiki page using" => "Você pode criar um link numa página wiki para o arquivo usando",
"You can display an image in a Wiki page using" => "Você pode exibir uma imagem numa página wiki usando",
"You can link to the file from an HTML page using" => "Você pode criar um link numa página HTML usando",
"No gallery available." => "Nenhuma galeria.",
"You have to create a gallery first!" => "Você precisa criar uma galeria antes de prosseguir!",
"Batch Upload Results" => "Resultado da Carga em Lote",
"Upload successful!" => "Carga bem-sucedida!",
"The following image was successfully uploaded" => "A seguinte imagem foi carregada com sucesso",
"Image ID thumb" => "ID da miniatura da imagem",
"You can include the image in an Wiki page using" => "Você pode incluir a imagem em uma página Wiki usando",
"or use filename" => "ou use o nome do arquivo",
"Now enter the image URL" => "Agora digite o endereço para a imagem",
"or upload a local image from your disk" => "ou carregue uma imagem local do seu disco",
"Batch Upload" => "Carga em lote",
"Thumbnail (optional, overrides automatic thumbnail generation)" => "Miniatura (opcional, sobrescreve a miniatura automaticamente gerada)",
"Note: Maximum image size is limited to" => "Nota: tamanho máximo de uma imagem:",
"User assigned modules" => "Módulos atribuídos pelo usuário",
"Assign module" => "Definir módulo",
"Column" => "Coluna",
"top" => "topo",
"Current folder" => "Pasta atual",
"Folders" => "Pastas",
"Folder in" => "Pasta em",
"Remove Folder" => "Remover pasta",
"Refresh Cache" => "Atualizar cache",
"Admin folders and bookmarks" => "Administrar pastas e favoritos",
"Default view" => "Visão padrão",
"Send me a message" => "Envie-me uma mensagem",
"Assign Group" => "Designar Grupo",
"Homepage" => "Site pessoal ou institucional",
"Users HomePage" => "Página inicial do usuário",
"Personal Wiki Page" => "Página Wiki Pessoal",
"Create page" => "Criar página",
"System" => "Sistema",
"This user is your friend" => "Esse usuário é seu amigo",
"Request friendship from this user" => "Solicitação de amizade desse usuário",
"Toggle options" => "Mudar opções",
"Personal Information" => "Informação pessoal",
"Your personal Wiki Page" => "Sua página Wiki pessoal",
"Your personal tracker information" => "Informações do seu acompanhamento pessoal",
"View extra information" => "Visualizar informação extra",
"Is email public? (uses scrambling to prevent spam)" => "Endereço de email público? (utilizar ofuscação para evitar spam)",
"Unavailable - please set your e-mail below" => "Não disponível - por favor defina seu e-mail abaixo",
"Does your mail reader need a special charset" => "Seu cliente de e-mail precisa de codificação específica",
"Select language..." => "Selecione o idioma...",
"Note author when reading his mail" => "Notificar o autor quando ler o e-mail dele",
"Account Information" => "Conta",
"Leave \"New password\" and \"Confirm new password\" fields blank to keep current password" => "Deixe os campos \"Nova senha\" e \"Confirmar nova senha\" em branco para manter a senha atual",
"Email address" => "E-mail",
"Confirm new password" => "Confirmar nova senha",
"Current password (required)" => "Senha atual (obrigatório)",
"Change administrative info" => "Atualizar",
"New task" => "Nova tarefa",
"Task list" => "Lista de tarefas",
"Admin mode off" => "Administrar modo desligado",
"Admin mode on" => "Administrar modo ligado",
"Task help" => "Ajuda: Tarefas",
"Empty Trash" => "Limpar lixeira",
"Received task" => "Tarefa recebida",
"You received this task, please read and execute it" => "Você recebeu essa tarefa, por favor leia e execute ela",
"Send task" => "Enviar tarefa",
"You send this task to a other user" => "Você enviou essa tarefa para outro usuário",
"Shared task" => "Tarefas compartilhadas",
"This task is public to a special group" => "Essa tarefa é pública para um grupo especial",
"Accepted by Task User and Creator" => "Aceito pelo usuário e criador da tarefa",
"Accepted User and Creator" => "Aceito usuário e criador",
"Task is accepted by user and creator" => "A tarefa foi aceito pelo usuário e pelo criador",
"Not Accepted by One User" => "Não aceito por um usuário",
"Not Accepted User" => "Usuário não aceito",
"Task is rejected by one user" => "Tarefa rejeitada por um usuário",
"Waiting for Me" => "Esperando por mim",
"Task is not accepted by you, read the task and accept or reject it" => "Status da tarefa ainda não definido por você, por favor leia e aceite ou rejeite a tarefa",
"Waiting for Other User" => "Esperando por outro usuário",
"Task is not accepted/rejected by other user" => "Tarefa não foi aceita/rejeitada por outro usuário",
"Admin Mode" => "Modo de administração",
"Edit task" => "Editar tarefa",
"NOT accept" => "Não aceito",
"Remove from Trash" => "Remover da lixeira",
"Move into Trash" => "Mover para a lixeira",
"Task saved" => "Tarefas salvas",
"Edit Task" => "Editar tarefa",
"View Task" => "Visualizar tarefa",
"Open a new task" => "Abrir nova tarefa",
"taskId" => "ID da tarefa",
"Task user" => "Usuário da tarefa",
"Only the creator can delete this task" => "Apenas o proprietário pode deletar a tarefa",
"Use start date and time" => "Data e hora do início",
"Use end date and time" => "Data e hora do término",
"Open / In Process" => "Em andamento",
"Waiting / Not Started" => "Esperando para começar",
"Percentage completed" => "Porcentagem de realização",
"Waiting" => "Esperando",
"Shared for Group" => "Compartilhado para o grupo",
"Accepted by User" => "Aceito pelo usuário",
"No / Rejected" => "Não / rejeitado",
"Accepted by Creator" => "Aceito pelo proprietário",
"This message will be send to users if you are makeing changes of assigned tasks" => "Essa mensagem vai ser enviada para os usuários se você esta fazendo mudanças em tarefas associadas",
"Send message with changes" => "Enviar mensagens com as mudanças",
"Modified by" => "Modificado por",
"Marked as deleted" => "Marcar como deletado",
"Inform task user by email" => "Informar usuário da tarefa por e-mail",
"You can only view this task" => "Você pode apenas visualizar essa tarefa",
"%m/%d/%Y [%H:%M]" => "%m/%d/%A [%H:%M]",
"No tasks entered" => "Nenhuma tarefa cadastrada",
"Select One" => "Selecionar um",
"Undo Trash" => "Limpar lixeira",
"Show:" => "Mostrar:",
"Received" => "Recebido",
"Submitted" => "Enviado",
"Shared" => "Compartilhado",
"All Shared Tasks" => "Todas as tarefas compartilhadas",
"completed (100%)" => "completa (100%)",
"Public for group" => "Público para o grupo",
"Add Watch" => "Adicionar notificação",
"Watches" => "Notificações",
"A user submits a blog post" => "Um usuário enviou uma mensagem no blog",
"A user posts a forum thread" => "Um usuário criou um novo assunto no fórum",
"A user posts a forum topic" => "Um usuário enviou um novo tópico no fórum",
"A user edited a wiki page" => "Um usuário editou uma página wiki",
"May need to refresh twice to see changes" => "Pode ser necessário atualizar duas vezes para ver as alterações",
"Add top level bookmarks to menu" => "Adicionar bookmarks de nível superior ao menu",
"replace window" => "substituir a janela",
"User_versions_for" => "Versões_de_usuário_para",
"This page is being edited by" => "Esta página está sendo validada por",
"Proceed at your own peril" => "Prossiga por conta própria",
"Insert Row" => "Inserir linha",
"Insert Column" => "Inserir coluna",
"Remove Row" => "Remover linha",
"Remove Column" => "Remover coluna",
"Merge Cells" => "Mesclar células",
"Restore Cells" => "Restaurar células",
"Copy Calculation" => "Copiar cálculo",
"Format Cell" => "Formatar célula",
"Before" => "Antes",
"After" => "Depois",
"expires:" => "expira:",
"Banner stats" => "Estatísticas de Banner",
"Create new banner" => "Criar um novo banner",
"Banner Information" => "Informação do Banner",
"Click ratio" => "Taxa de cliques",
"Weekdays" => "Dias da semana",
"mon" => "seg",
"tue" => "ter",
"wed" => "qua",
"thu" => "qui",
"fri" => "sex",
"sat" => "sáb",
"sun" => "dom",
"Banner raw data" => "Dados brutos do Banner",
"Cached" => "Em cache",
"This is a cached version of the page." => "Esta é uma versão em cache da página.",
"Click here to view the Google cache of the page instead." => "Clique aqui para ver, ao invés, o cache do Google.",
"Edit Items" => "Editar itens",
"List Charts" => "Listar gráficos",
"Last Chart" => "último gráfico",
"Previous Chart" => "Gráfico anterior",
"Chart created" => "Gráfico criado",
"Next Chart" => "Próximo gráfico",
"Pre" => "Ant",
"Permanency" => "Permanência",
"chg" => "alt",
"Avg" => "Méd",
"info/vote" => "info/votar",
"Next chart will be generated on" => "Próximo gráfico será gerado em",
"View or vote items not listed in the chart" => "Ver ou votar em itens não listados no gráfico",
"Select something to vote on" => "Selecione uma votação",
"Item information" => "Informação do Item",
"Best Position" => "Melhor Posição",
"Vote this item" => "Votar neste item",
"Highest" => "Maior",
"Answers" => "Repostas",
"Q" => "P",
"A" => "R",
"Add Suggestion" => "Adicionar sugestão",
"Forum List" => "Lista de Fóruns",
"Edit Forum" => "Editar Fórum",
"Manage Message Queue" => "Mensagens pendentes",
"Editing" => "Editando",
"Post New" => "Nova mensagem",
"Summary" => "Sumário",
"Send me an e-mail when someone replies to my topic" => "Envie-me um e-mail quando alguém responder ao meu tópico",
"Don't send me any e-mails" => "Não me envie nenhum e-mail",
"Editing posts" => "Ao editar mensagens",
"Moderator Actions" => "Ações de moderador",
"Move Selected Topics" => "Mover os tópicos selecionados",
"Unlock Selected Topics" => "Destravar os tópicos selecionados",
"Lock Selected Topics" => "Travar os tópicos selecionados",
"Delete Selected Topics" => "Apagar os tópicos selecionados",
"Merge" => "Unir",
"Merge Selected Topics" => "Unir os tópicos selecionados",
"Reported Messages:" => "Mensagens enviadas:",
"Queued Messages:" => "Mensagens pendentes:",
"Merge into topic" => "Unir no tópico",
"Announce" => "Anúncio",
"Hot" => "Quente",
"No topics yet" => "Nenhum tópico criado",
"Jump to forum" => "Ir ao fórum",
"Last hour" => "Última hora",
"Last 24 hours" => "Últimas 24 horas",
"Last 48 hours" => "Últimas 48 horas",
"The post has been reported and will be reviewed by a moderator." => "Um moderador será avisado para revisar a mensagem.",
"prev topic" => "tópico anterior",
"next topic" => "próximo tópico",
"Print this page only" => "Imprimir apenas esta página",
"Print all pages" => "Imprimir todas as páginas",
"Show posts" => "Exibir mensagens",
"Insert New Item" => "Inserir novo item",
"Edit Fields" => "Editar campos",
"Tracker Items" => "itens do acompanhamento",
"View inserted item" => "Visualizar itens inseridos",
"Insert new item" => "Inserir novo item",
"Tracker Item:" => "Item do acompanhamento:",
"Edit/Delete" => "Editar/Deletar",
"View Item" => "Visualizar item",
"Filter Tracker Items" => "Filtrar itens do acompanhamento",
"Add a Comment" => "Adicionar um comentário",
"Items list" => "Lista de itens",
"Special Operations" => "Operações especiais",
"close" => "fechar",
"Show All" => "Mostrar Tudo",
"Clip" => "clip",
"Back To Mailbox" => "retornar à lista de mensagens",
"Full Headers" => "cabeçalhos completos",
"Normal Headers" => "cabeçalhos comuns",
"Reply To All" => "responder a todos",
"Forward" => "remeter",
"Select from address book" => "selecionar da agenda de endereços",
"Use HTML mail" => "Usar email HTML",
"The following addresses are not in your address book" => "Os seguintes endereços não estão na sua agenda de endereços",
"Add Contacts" => "Adicionar contatos",
"Attachment 1" => "Anexo 1",
"Attachment 2" => "Anexo 2",
"Attachment 3" => "Anexo 3",
"Address book" => "Agenda de endereços",
"page id" => "id da página",
"3d browser" => "navegador 3D",
"Cancel Fullscreen" => "Sair do modo tela cheia",
"Show/Hide Left Menus" => "Mostrar/esconder menus do lado esquerdo",
"Show/Hide Right Menus" => "Mostrar/esconder menus do lado direito",
"Remove Image" => "Remover imagem",
"Other:" => "Outro:",
"Number of voices" => "Número de vozes",
"friends" => "amigos",
"Use this thread to discuss the page:" => "Use esse tópico para discutir a página:",
"Start:" => "Início:",
"Close:" => "Fechar:",
"List authors:" => "Listar autores:",
"Save the page as a partial translation." => "Salvar página como tradução parcial.",
"Partial Translation" => "Tradução parcial",
"Save the page as a completed translation." => "Salvar a página como uma tradução completa.",
"Complete Translation" => "Tradução completa",
"Save the page, but do not send notifications and do not count it as new content to be translated." => "Salvar a página, mas não enviar notificações e não contar como novo conteúdo a ser traduzido.",
"Save Minor Edit" => "Menor",
"Save the page as a draft." => "Salvar página como rascunho.",
"Save Draft" => "Salvar rascunho",
"Compose Message" => "Compor mensagem",
"If you want people to be able to reply to you, you have to check <a href='tiki-user_preferences.php'>Allow messages from other users</a>" => "Para que as pessoas possam enviar mensagens para você e responder as mensagens que você enviar é necessário habilitar <a href='tiki-user_preferences.php'>Permitir mensagens de outros usuários</a>",
"Administration" => "Administração",
"Enable/disable Tiki features here, but configure them elsewhere" => "Habilite/desabilite os recursos do tiki aqui, mas a configuração deve ser feita na parte específica de cada recurso",
"General preferences and settings" => "Configurações e preferências gerais",
"User registration, login and authentication" => "Registrar usuário, logar e autenticar",
"Wiki settings" => "Configurações Wiki",
"Wiki Attachments" => "Anexos wiki",
"Article/CMS settings" => "Artigos/Configurações do CMS",
"Poll comments settings" => "Configurações de comentários de enquetes",
"Configuration options for all blogs on your site" => "Opções de configuração para todos os blogs do site",
"Forums settings" => "Configurações de fóruns",
"FAQ comments settings" => "Configurar comentários do FAQ",
"Trackers settings" => "Configurações dos acompanhamentos",
"RSS feeds" => "Fontes RSS",
"RSS settings" => "Configurações do RSS",
"Directory settings" => "Configurar diretório",
"Maps configuration" => "Configurar mapas",
"Meta Tags settings" => "Configurar meta tags",
"Search settings" => "Configurações de busca",
"Score settings" => "Configurar pontuação",
"Community settings" => "Configurações da Comunidade",
"Calendar settings" => "Configurar calendário",
"Help on \$admintitle Config" => "Ajuda sobre configuração em \$admintitle",
"white" => "branco",
"gray" => "cinza",
"silver" => "prata",
"darkgrey" => "cinza escuro",
"Click here to delete the category:" => "Clique aqui para deletar a categoria:",
"Category can`t be parent of itself" => "Categoria não pode ser pai dela mesma",
"No chart indicated" => "Nenhum gráfico indicado",
"Upload failed" => "A carga falhou",
"You have to provide a hotword and a URL" => "Você deve informar uma palavra-chave e uma URL",
"Detected, Version:" => "Versão detectada:",
"Not detected." => "Não detectada.",
"Your admin password has been changed" => "Sua senha de administrador foi alterada",
"You cannot have a blank password" => "Você não pode ter uma senha vazia",
"All Fields except gdaltindex must be filled" => "Todos os campos exceto gdaltindex devem ser preenchidos",
"No valid gdaltindex executable" => "Executável gdaltindex não é válido",
"You cannot mix old and new trackers" => "Você não pode misturar antigos e novos acompanhamentos",
"Tag already exists" => "O tag já existe",
"Tag not found" => "Tag não encontrado",
"Repository name can't be an empty" => "Nome do Repositório não pode ser vazio",
"Requested action is not supported on repository" => "A ação solicitada não é suportada em repositórios",
"No repository" => "Sem repositório",
"Search is mandatory field" => "Busca é um campo mandatório",
"File not found " => "Arquivo não encontrado ",
"Requested action in not supported on repository" => "Ação de requisição não é suportada no repositório",
"Non-existent link" => "Link inexistente",
"Mail-in account %s incorrect" => "Conta %s mail-in incorreta",
"Mail-in account %s saved" => "Conta %s mail-in salva",
"Frequency should be a positive integer!" => "Frequëncia deveria ser um inteiro positivo!",
"Mail-in accounts set to be checked every %s minutes" => "Contas de mail-in configuradas para serem chegas a cada %s minutos",
"Automatic Mail-in accounts checking disabled" => "Checar automaticamente contas de mail-in desabilitado",
"No menu indicated" => "Nenhum menu foi indicado",
"Cannot create or update module: You need to specify a name to the module" => "Não foi possível criar ou atualizar o módulo: você precisa especificar um nome para ele",
"Cannot create or update module: You cannot leave the data field empty" => "Não foi possível criar ou atualizar o módulo: você não pode deixar o campo 'data' em branco",
"No newsletter indicated" => "Nenhum comunicado foi indicado",
"Invalid email" => "E-mail inválido",
"No poll indicated" => "Nenhuma enquete foi indicada",
"unsafe" => "inseguro",
"register_globals should be off by default. See the php manual for details." => "register_globals deve estar desligado por padrão. Veja o manual do php para detalhes.",
"safe" => "seguro",
"session.use_trans_sid should be off by default. See the php manual for details." => "session.use_trans_sid deve estar desligada por padrão. Veja o manual do php para detalhes.",
"upload_tmp_dir is probably within your Tikiwiki directory. There is a risk that someone can upload any file to this directory and access them via web browser" => "upload_tmp_dir provavelmente está no seu diretório do Tikiwiki. Existe um risco de alguém enviar qualquer arquivo para esse diretório e acessá-lo pelo navegador da internet",
"cannot check if the upload_tmp_dir is accessible via web browser. To be sure you should check your webserver config." => "não foi possível checar se o upload_tmp_dir está acessível pelo navegador. Para ter certeza você deve checar a configuração do seu servidor web.",
"risky" => "arriscado",
"allow_url_fopen may potentially be used to upload remote data or scripts. If you dont use the blog feature, you can switch it off." => "allow_url_fopen pode ser utilizado para subir remotamente dados ou scripts. Se você não usa blogs, é melhor deixar essa opção desabilitada.",
"The Path to store files in the filegallery should be outside the tiki root directory" => "O patch para guardar arquivos na galeria de arquivos deve estar fora do diretório principal do tiki",
"The Path to store files in the imagegallery should be outside the tiki root directory" => "O patch para guardar arquivos na galeria de imagens deve estar fora do diretório principal do tiki",
"The feature \"Edit Templates\" is switched on. Do not allow anyone you cannot trust to use this feature. It can easily be used to inject php code." => "O recurso \"Editar templates\" está ativado. Não permita que esse recurso seja utilizado por quem você não pode confiar. Com ele pode-se facilmente injetar código PHP.",
"SQL injection" => "Injeção SQL",
"SQL injection by authenticated user" => "Injeção SQL para usuários autenticados",
"SQL injection by authenticated user with special privileges" => "Injeção SQL apenas para usuários autenticados e com privilégios especiais.",
"SQL injection without authentication" => "Injeção SQL sem autenticação",
"PHP command injection" => "Injeção de comando PHP",
"PHP command injection by authenticated user" => "Injeção de comando PHP para usuário autenticado",
"PHP command injection by authenticated user with special privileges" => "Injeção de comando PHP apenas para usuários autenticados e com privilégios especiais.",
"PHP command injection without authentication" => "Injeção de comando PHP sem autenticação",
"File upload" => "Subir arquivo",
"File is not readable. Unable to check." => "Arquivo não esta disponível para a leitura. Impossível checar.",
"This is not a Tikiwiki file. Check if this file was uploaded and if it is dangerous." => "Esse arquivo não é um arquivo do Tikiwiki. Cheque se ele foi enviado por upload e se ele é perigoso.",
"This is a modified File. Cannot check version. Check if it is dangerous." => "Esse é um arquivo modificado. Não foi possível checar a versão. Verifique se ele pode ser perigoso.",
"This file is from another Tikiwiki version: " => "Esse arquivo é de uma outro versão do Tikiwiki: ",
"You have to provide a word" => "Você precisa especificar uma palavra",
"Permission denied you cannot view this page" => "Permissão negada, você não pode ver esta página",
"Permission denied you cannot edit this page" => "Permissão negada: você não pode editar esta página",
"You must specify a page name, it will be created if it doesn't exist." => "Você deve especificar um nome de página, que pode ser criada se não existir.",
"page not added (Exists)" => "página não adicionada (pré-existente)",
"No survey indicated" => "Nenhuma pesquisa foi indicada",
"You don't have permission to use this feature" => "Você não tem permissão para usar esse recurso",
"No Errors detected" => "Nenhum erro detectado",
"No tracker indicated" => "Nenhum acompanhamento foi indicado",
"Group already exists" => "Grupo já existente",
"Remove group: " => "Remover grupo: ",
"User doesn't exist" => "O usuário não existe",
"Invalid or unknown email" => "E-mail inválido ou desconhecido",
"No records were found. Check the file please!" => "Nenhum registro encontrado. Por favor, verifique o arquivo.",
"User login is required" => "O login do usuário é obrigatório",
"Password is required" => "A senha é obrigatória",
"Email is required" => "O endereço de e-mail é obrigatório",
"User is duplicated" => "Usuário duplicado",
"Created account %s <%s>" => "Criada a conta %s <%s>",
"Assigned %s in group %s" => "Associado %s no grupo %s",
"User %s already exists" => "Usuário %s já existe",
"New %s created with %s %s." => "Novo %s criado com %s %s.",
"Impossible to create new %s with %s %s." => "Impossível criar novo %s com %s %s.",
"%s %s successfully deleted." => "%s %s deletado com sucesso.",
"%s %s removed from %s %s." => "%s %s removido de %s %s.",
"%s <b>%s</b> successfully deleted." => "%s <b>%s</b> deletado com sucesso.",
"%s <b>%s</b> assigned to %s <b>%s</b>." => "%s <b>%s</b> associado a %s <b>%s</b>.",
"%s <b>%s</b> removed from %s <b>%s</b>." => "%s <b>%s</b> removido de %s <b>%s</b>.",
"group <b>%s</b> set as the default group of user <b>%s</b>." => "grupo <b>%s</b> definido como grupo padrão do usuário <b>%s</b>.",
"%s changed from %s to %s" => "%s mudou de %s para %s",
"Impossible to change %s from %s to %s" => "Impossível alterar %s de %s para %s",
"%s modified successfully." => "%s modificado com sucesso.",
"password" => "senha",
"%s modification failed." => "%s modificação falhou.",
"rss feed disabled" => "campo rss desabilitado",
"Tiki RSS feed for articles" => "Fonte RSS para artigos",
"Last articles." => "Últimos Artigos.",
"Unknown group" => "Grupo desconhecido",
"Group doesn't exist" => "O grupo não existe",
"You have to indicate a group" => "Você precisa indicar um grupo",
"This group is invalid" => "Esse grupo não é válido",
"Permission denied you cannot view backlinks for this page" => "Permissão negada: você não pode ver referências a esta página",
"The page cannot be found" => "A página não pôde ser encontrada",
"Image Galleries Admin Panel" => "Painel de administração da galeria de imagens",
"Could not read image %s." => "Não possível possível ler a imagem %s.",
"Image %s upload failed." => "Upload da imagem %s falhou.",
"Image %s uploaded successfully." => "Imagem %s enviada com sucesso.",
"Image %s removed from Batch directory." => "Imagem %s removida do diretório em lote.",
"Impossible to remove image %s from Batch directory." => "Impossível remover imagem %s do diretório em lote.",
"Permission denied you cannot use the batch directory loading" => "Permissão negada, você não pode usar a função para carregar diretórios em lote",
"Incorrect directory chosen for batch upload of images." => "Diretório selecionado incorreto para fazer o upload de imagens em lote.",
"Please setup that dir on " => "Por favor configure aquele diretório ",
"Please contact the website administrator." => "Por favor contate o administrador do site.",
"Invalid directory name" => "Nome de diretório inválido",
"You can't post in any blog maybe you have to create a blog first" => "Você não pode escrever em nenhum blog: talvez você deva criar um blog antes",
"Permission denied you cannot post" => "Permissão negada: você não pode enviar mensagens",
"Permission denied you cannot edit this post" => "Permissão negada: você não pode editar esta mensagem",
"Top visited blogs" => "Blogs mais visitados",
"Last posts" => "Últimas mensagens",
"Top active blogs" => "Blogs mais ativos",
"No blogId specified" => "Nenhum ID de blog especificado",
"Tiki RSS feed for weblogs" => "Fonte RSS do tiki para weblogs",
"Last posts to weblogs." => "Últimas mensagens para weblogs.",
"Permission denied you cannot access this gallery" => "Permissão negada: você não pode acessar esta galeria",
"No gallery indicated" => "Nenhuma galeria foi indicada",
"Permission denied you can not view this section" => "Permissão negada: você não pode ver esta seção",
"Permission denied you cannot remove images from this gallery" => "Permissão negada: você não pode remover imagens desta galeria",
"Permission denied you cannot rebuild thumbnails in this gallery" => "Permissão negada: você não pode recriar miniaturas nesta galeria",
"Permission denied you cannot rotate images in this gallery" => "Permissão negada: você não pode rotacionar imagens nesta galeria",
"No image indicated" => "Nenhuma imagem foi indicada",
"Permission denied you cannot move images from this gallery" => "Permissão negada: você não pode mover imagens desta galeria",
"Permission denied you cannot view the calendar" => "Permissão negada: você não pode visualizar o calendário",
"event without name" => "evento sem nome",
"Access Denied" => "Acesso Proibido",
"First day of week: Sunday (its ID is 0) - translators you need to localize this string!" => "Primeiro dia da semana: Domingo (o ID é 0)",
"Upcoming events." => "Próximos eventos.",
"End:" => "Fim:",
"No category indicated" => "Nenhuma categoria indicada",
"Permission denied; you cannot assign permissions for this category" => "Permissão negada; você não pode associar permissões para essa categoria",
"Invalid username or activation code. Maybe this code has already been used." => "Usuário ou código de ativação inválido. Talvez o código já tenha sido usado.",
"You can not use the same password again" => "Esta senha não pode ser novamente utilizada",
"Top authors" => "Autores mais produtivos",
"ERROR: you must include a subject or a message at least" => "ERRO: você deve incluir um assunto ou, pelo menos, uma mensagem",
"You need to change chmod 'whelp' manually to 777" => "Você deve mudar manualmente o chmod de 'whelp' para 777",
"This feature has been disabled" => "Este recurso foi desabilitado",
"Tiki RSS feed for directory sites" => "Fonte RSS para diretório de sites",
"Last sites." => "Últimos sites.",
"Must enter a name to add a site. " => "Deve digitar um nome para adicionar um site. ",
"Must enter a url to add a site. " => "Deve digitar uma url para adicionar um site. ",
"URL already added to the directory. Duplicate site? " => "URL já foi adicionada ao diretório. Duplicar o site? ",
"URL cannot be accessed wrong URL or site is offline and cannot be added to the directory. " => "A URL não pode ser acessada. URL errada ou o site está fora do ar e não pode ser adicionado ao diretório. ",
"Must select a category. " => "Deve selecionar uma categoria. ",
"Must enter a name to add a site" => "É preciso digitar um nome para o site",
"Must enter a url to add a site" => "É preciso digitar um endereço para o site",
"URL already added to the directory. Duplicate site?" => "URL já presente no diretório. Site duplicado?",
"URL cannot be accessed: wrong URL or site is offline and cannot be added to the directory" => "URL não pode ser acessada: URL errada ou o site está fora do ar e não pode ser adicionado ao diretório",
"Must select a category" => "É preciso selecionar uma categoria",
"No site indicated" => "Nenhum site indicado",
"No parent specified" => "Nenhum parentesco especificado",
"Last sites of directory \".\$rc[\"name\"].\" ." => "Últimos sites do diretório \".\$rc[\"name\"].\" .",
"Article not found" => "Artigo não encontrado",
"Permission denied you cannot edit this article" => "Permissão negada: você não pode editar este artigo",
"The language can't be changed as its set of translations has already this language" => "O idioma não pode ser alterado pois ele já se encontra no espaço de traduções",
"You do not have permissions to edit banners" => "Você não possui permissão de editar banners",
"Banner not found" => "Banner não encontrado",
"You do not have permission to edit this banner" => "Você não possui a permissão para editar este banner",
"Permission denied you cannot create or edit blogs" => "Permissão negada: você não pode criar ou editar blogs",
"Permission denied you cannot edit this blog" => "Permissão negada: você não pode editar este blog",
"You do not have permission to write the style sheet" => "Você não tem permissão para editar a style sheet",
"Invalid request to edit an image" => "Requisição inválida para editar uma imagem",
"Permission denied you cannot edit images" => "Permissão negada: você não pode editar imagens",
"Permission denied you can edit images but not in this gallery" => "Permissão negada: você pode editar imagens, mas não nesta galeria",
"Failed to edit the image" => "Falha ao tentar editar a imagem",
"Permission denied to use this feature" => "Permissão negada para usar este recurso.",
"Shortname must be 2 Characters" => "O nome abreviado deve ter 2 caracteres",
"You must provide a longname" => "Você tem que fornecer um nome completo",
"Language created" => "Língua criada",
"No content id indicated" => "Não foi indicado um id de conteúdo",
"No question indicated" => "Nenhuma questão indicada",
"No quiz indicated" => "Nenhum teste indicado",
"No structure indicated" => "Nenhuma estrutura indicada",
"Invalid structure_id or page_ref_id" => "structure_id inválida ou page_ref_id",
"Permission denied you cannot send submissions" => "Permissão negada: você não pode enviar artigos",
"Permission denied you cannot edit submissions" => "Permissão negada: você não pode editar artigos pendentes",
"You have to create a topic first" => "Você deve criar um tópico antes de prosseguir",
"You do not have permission to do that" => "Você não possui a permissão necessária",
"You do not have permission to write the template:" => "Você não tem permissão para escrever no template:",
"You do not have permission to read the template" => "Você não possui a permissão de ler o padrão",
"No topic id specified" => "Nenhum ID de tópico especificado",
"Invalid topic id specified" => "ID de tópico especificado inválido",
"No object indicated" => "Nenhum objeto indicado",
"No type indicated" => "Nenhum tipo indicado",
"Override lock and carry on with edit" => "Ignorar aviso e editar página",
"Page is currently being edited" => "Outro usuário está editando a página",
"page imported" => "página importada",
"created from import" => "criada a partir de uma importação",
"This page is being edited by " => "Está página está sendo editada por ",
"Please check with the user before editing the page,\n\t\t\totherwise the changes will be stored as two separate versions in the history and\n\t\t\tyou will have to manually merge them later. " => "Por favor entre em contato com o usuário ou então aguarde um momento antes de editar a página.\n\t\t\tSe duas pessoas editarem uma página ao mesmo tempo, duas versões diferentes serão criadas e alguém vai ter que juntá-las depois para que ambas as alterações fiquem visíveis. ",
"Can't import remote HTML page" => "Não posso importar a página HTML remota",
"The SandBox is disabled" => "A Bancada de testes está desabilitada",
"Cannot edit page because it is locked" => "A página não pode ser editada enquanto estiver travada",
"Page already exists. Go back and choose a different name." => "Uma página com esse nome já existe, volte e escolha outro nom/e.",
"No questions group indicated" => "Sem grupo de questões indicado",
"Permission denied you cannot edit this file" => "Permissão negada: você não pode editar este arquivo",
"Permission denied you cannot remove files from this gallery" => "Permissão negada: você não pode remover arquivos desta galeria",
"Top visited file galleries" => "Galerias de arquivo mais visitadas",
"Most downloaded files" => "Arquivos mais baixados",
"Last files" => "Arquivos recentes",
"Tiki RSS feed for file galleries" => "Fonte RSS do tiki para galeria de arquivos",
"Last files uploaded to the file galleries." => "Últimos arquivos enviados para a galeria de arquivos.",
"No galleryId specified" => "Nenhum ID de galeria especificado",
"Tiki RSS feed for the file gallery: " => "Fonte RSS para galeria de arquivos: ",
"No forum indicated" => "Nenhum fórum indicado",
"Forum posts" => "Mensagens do Fórum",
"No forumId specified" => "Nenhum ID de fórum especificado",
"Tiki RSS feed for forum: " => "Fonte RSS para fórum: ",
"Tiki RSS feed for forums" => "Fonte RSS para fóruns",
"Last topics in forums." => "Últimos tópicos nos Fóruns.",
"Accepted friendship request from %s" => "Pedido para entrar na rede de amigos de %s aceito",
"Refused friendship request from %s" => "Pedido para entrar na rede de amigos de %s recusado",
"Broke friendship with %s" => "Romper amizade com %s",
"I have broken our friendship!" => "Eu rompi nossa amizade!",
"You must be logged in to use this feature" => "Você precisa estar logado para usar essa função",
"Friendship request sent to %s" => "Pedido de amizade enviado para %s",
"You're already friend of %s" => "Você já é amigo de %s",
"I have accepted your friendship request!" => "Eu aceitei seu convite para entrar na sua rede de amigos!",
"No process indicated" => "Nenhum processo indicado",
"Activity name already exists" => "Nome repetido para a atividade",
"indicates if the process is active. Invalid processes cant be active" => "indica se o processo está ativo. Processos inválidos não podem ser ativados",
"No instance indicated" => "Nenhuma instância indicada",
"No activity indicated" => "Nenhuma atividade editada",
"The process name already exists" => "Nome repetido para o processo",
"Process already exists" => "Processo já existente",
"You cant execute this activity" => "Você não pode editar esta atividade",
"You couldn't abort a instance" => "Você não pode abortar uma instância",
"You couldn't exception a instance" => "Você não pode fazer uma exceção em uma instância",
"No user indicated" => "Nenhum usuário indicado",
"No title indicated" => "Nenhum título indicado",
"No comment indicated" => "Nenhum comentário indicado",
"No date indicated" => "Nenhuma data indicada",
"No item indicated" => "Nenhum item indicado",
"first uploaded image" => "primeira imagem enviada",
"last uploaded image" => "última imagem enviada",
"first image" => "primeira imagem",
"last image" => "última imagem",
"random image" => "imagem aleatória",
"Permission denied you cannot create galleries and so you cant edit them" => "Permissão negada: você não pode criar galerias ou editá-las",
"Permission denied you cannot edit this gallery" => "Permissão negada: você não pode editar esta galeria",
"Permission denied you cannot remove this gallery" => "Permissão negada: você não pode remover esta galeria",
"Permission denied you cannot make the map of this gallery" => "Permissão negada, você não pode fazer o mapa dessa galeria",
"Top images" => "Imagens mais populares",
"Last images" => "Imagens recentes",
"Back to preferences" => "Voltar para preferências",
"No sheet specified." => "Nenhuma planilha especificada.",
"You must select a renderer." => "Você deve selecionar um renderizador.",
"Invalid Series for current graphic." => "Séries inválidas para o gráfico atual.",
"Tiki RSS feed for image galleries" => "Fonte RSS do tiki para a galeria de imagens",
"Last images uploaded to the image galleries." => "Últimas imagens enviadas para a galeria de imagens.",
"Tiki RSS feed for the image gallery: " => "Fonte RSS para galeria de imagens: ",
"overwriting old page" => "sobrescrevendo página antiga",
"updated from structured text import" => "atualizado a partir de uma exportação em texto estruturada",
"page created" => "página criada",
"created from structured text import" => "criado a partir de uma exportação em texto estruturada",
"No name indicated for wiki page" => "Nome não indicado para a página Wiki",
"No repository given" => "Nenhum repositório conhecido",
"Permission denied you cannot view pages like this page" => "Permissão negada: você não pode ver páginas como esta",
"Permission denied you cannot remove articles" => "Permissão negada: você não pode remover artigos",
"Permission denied you cannot remove banners" => "Permissão negada: você não pode remover banners",
"Permission denied you cannot remove this blog" => "Permissão negada: você não pode remover este blog",
"Non-existent gallery" => "Galeria inexistente",
"Permission denied you can upload files but not to this file gallery" => "Permissão negada: você pode carregar arquivos mas não nesta galeria de arquivos",
"Could not upload the file" => "Não é possível carregar o arquivo",
"Could not find the file requested" => "Não foi possível achar o arquivo requisitado",
"File update was successful" => "Arquivo atualizado com sucesso",
"Permission denied you can't upload files so you can't edit them" => "Permissão negada: você não pode carregar arquivos, de modo que não pode editá-los",
"This gallery does not exist" => "Essa galeria não existe",
"The game file must have .swf or .dcr extension" => "O arquivo do jogo deve ter extensão .swf ou .dcr",
"The thumbnail name must be" => "O nome da miniatura deve ser",
"Please supply both files" => "Por favor suporte ambos os arquivos",
"You cannot admin blogs" => "Você não pode administrar blogs",
"Permission denied you cannot remove submissions" => "Permissão negada: você não pode remover assinaturas",
"Permission denied you cannot approve submissions" => "Permissão negada: você não pode aprovar assinaturas",
"You have to enable cookies to be able to login to this site" => "Você deve habilitar os cookies para se autenticar neste site",
"XMLRPC Error: " => "Erro XMLRPC: ",
"Unable to create login" => "Não foi possível criar o login",
"Account validated successfully." => "Validação da conta confirmada.",
"Sorry, you can't use this feature." => "Desculpe, você não pode usar essa função.",
"edit" => "editar",
"You do not have permissions to view the maps" => "Você não possui permissões para ver os mapas",
"Maps feature is not correctly setup : Maps path is missing." => "Os recursos dos mapas não estão configurados corretamente: Faltando a pasta Mapas.",
"mapfile name incorrect" => "nome do arquivo de mapa incorreto",
"This mapfile already exists" => "Este arquivo de mapa já existen",
"You do not have permission to write to the mapfile" => "Você não tem permissão para escrever no arquivo de mapa",
"You do not have permission to delete the mapfile" => "Você não tem permissão para remover o arquivo de mapa",
"I could not make a copy" => "Não foi possível fazer uma cópia",
"You do not have permission to read the mapfile" => "Você não tem permissão para ler o arquivo de mapa",
"You dont have permission to do that" => "Você não tem permissão para fazer isso",
"Tiki RSS feed for maps" => "Fonte RSS para mapas",
"List of maps available." => "Lista dos mapas disponíveis.",
"You do not have permissions to view the layers" => "Você não tem permissão para ver as camadas",
"You do not have permissions to delete a file" => "Você não tem permissão para remover o arquivo",
"File not found" => "Arquivo não encontrado",
"You do not have permissions to create a directory" => "Você não tem permissão para criar um diretório",
"The Directory is not empty" => "O Diretório não está vazio",
"You do not have permissions to delete a directory" => "Você não tem permissão para remover um diretório",
"You do not have permissions to create an index file" => "Você não tem permissão para criar um arquivo índice",
"Invalid file name" => "Nome de arquivo inválido",
"Invalid files to index" => "Arquivos inválidos para índice",
"I do not know where is gdaltindex. Set correctly the Map feature" => "Eu não sei onde está o gdaltindex. Configure corretamente a funcionalidade de mapa",
"I could not create the index file" => "Eu não posso criar o arquivo de índice",
"Must be logged to use this feature" => "Você deve se logar para usar este recurso",
"Welcome at Hawiki" => "Bem-vindo(a) a Hawiki",
"This Tikiwiki site is prepared for access from a lot of mobile devices, e.g. WAP phones, PDA's, i-mode devices and much more." => "Este site Tikiwiki está preparado para ser acessado de uma gama de dispositivos móveis, como celulares WAP, PDAs, dispositivos i-mode e muitos outros.",
"You can browse this site on your mobile device by directing your device's browser towards the following URL here on this site:" => "Você pode navegar neste site com seu dispositivo móvel apontando o browser dele para o seguinte endereço deste site:",
"About" => "Sobre",
"You need to run setup.sh :<br />./setup.sh \$APACHEUSER all<br />Common Apache users are www-data, apache or nobody" => "Você precisa rodar o script setup.sh :<br />./setup.sh \$APACHEUSER all<br />Usuários comuns no apache são: www-data, apache ou nobody",
"Your PHP installation does not have zlib enabled." => "Sua versão do PHP não tem o zlib habilitado.",
"You must log in to use this feature" => "Você deve se logar para usar este recurso",
"You do not have permission to view other users data" => "Você não possui permissão para ver dados de outros usuários",
"You must be logged in to subscribe to newsletters" => "Você precisa se logar para assinar os comunicados",
"No server indicated" => "Nenhum servidor indicado",
"Cannot connect to" => "Impossível conectar-se a",
"Missing information to read news (server,port,username,password,group) required" => "A informação necessária para ler news (servidor, porta, username, senha, grupo) não foi fornecida",
"Cannot get messages" => "Impossível baixar as mensagens",
"No note indicated" => "Nenhuma nota indicada",
"merged note:" => "nota composta:",
"File is too big" => "O arquivo é grande demais",
"created from notepad" => "criado a partir do Bloco de Notas",
"Page already exists" => "Página já existe",
"Not enough information to display this page" => "Informações insuficientes para exibir esta página",
"Permission denied you cannot browse this page history" => "Permissão negada: você não pode visualizar o histórico desta página",
"No article indicated" => "Nenhum artigo indicado",
"Article is not published yet" => "Artigo ainda não foi publicado",
"No post indicated" => "Nenhuma mensagem indicada",
"Blog not found" => "Blog não encontrado",
"No pages indicated" => "Nenhuma página indicada",
"Pageviews" => "Número de vezes que a página foi visualizada",
"You don't have permission to edit quizzes." => "Você não tem permissão para editar os testes.",
"No result indicated" => "Nenhum resultado indicado",
"You must choose a group" => "Você precisa escolher um grupo",
"The passwords don't match" => "A senha não confere",
"Username cannot contain uppercase letters" => "O nome do usuário não pode conter letras maiúsculas",
"Username must be at least" => "O nome do usuário deve ter no mínimo",
"Username cannot contain more than" => "O nome do usuário não pode conter mais de",
"characters" => "caracteres",
"empty" => "vazio",
"Invalid or unknown username" => "Usuário desconhecido ou inválido",
"Unable to send mail. User has not configured email" => "Não foi possível enviar e-mail. O usuário não configurou um endereço eletrônico",
"The mail can't be sent. Contact the administrator" => "O e-mail não pode ser enviado. Por favor, contate o administrador do site.",
"A password and your IP address reminder email has been sent " => "Uma senha e seu endereço de IP foram enviados para seu endereço eletrônico ",
"An email with a link to reset your password has been sent " => "Um e-mail com um link para alterar sua senha foi enviado",
"to the email" => "para o e-mail",
"to the registered email address for" => "para o endereço de email registrado para",
"last version" => "última versão",
"Permission denied you cannot remove versions from this page" => "Permissão negada: você não pode remover versões desta página",
"Permission denied you cannot rename this page" => "Você não tem permissão para renomear essa página",
"Cannot rename page because the new name begins with reserved prefix" => "Não foi possível renomear a página pois o novo nome começa com um prefixo que está reservado",
"Cannot rename page maybe new page already exists" => "Impossível renomear a página: talvez já exista uma página com este nome",
"changed '%s' from '%s' to '%s'" => "alterado '%s' de '%s' para '%s'",
"Non-existent version" => "Versão inexistente",
"Permission denied you cannot rollback this page" => "Permissão negada: você não pode restaurar esta página",
"Error Message" => "Mensagem de erro",
"Tiki RSS Feed Error Message: \$errmsg" => "Mensagem de erro dos fontes RSS do tiki: \$errmsg",
"Post recommendation at" => "Envie recomendações em",
"No newsletters available." => "Nenhuma newsletters disponível.",
"successfully sent" => "enviada com sucesso",
"not sent" => "não enviada",
"Error: " => "Erro: ",
"Page must be defined inside a structure to use this feature" => "A página tem que ser definida dentro de uma estrutura para o uso deste recurso",
"You cannot take this quiz twice" => "Você não pode fazer este teste mais de uma vez",
"Quiz time limit exceeded quiz cannot be computed" => "Limite de tempo do teste atingido: a nota não será calculada",
"You cannot take this survey twice" => "Você não pode responder a esta pesquisa mais de uma vez",
"Please create a category first" => "Por favor, selecione antes uma categoria",
"Tracker item:" => "Item do acompanhamento:",
"No trackerId specified" => "trackerId não especificado",
"Tiki RSS feed for individual trackers: " => "Fontes RSS do tiki para acompanhamentos individuais: ",
"You must lock the file before editing it" => "Você deve travar o arquivo antes de editá-lo",
"No permission to upload zipped file packages" => "Sem permissão para carregar arquivos zipados",
"Error processing zipped image package" => "Erro tentando processar arquivo zipado de imagem",
"No permission to upload zipped image packages" => "Sem permissão para carregar arquivos zipados de imagem",
"The uploaded file ist not recognized as a image" => "O arquivo enviado não foi reconhecido como imagem",
"Permission denied you cannot upload images" => "Permissão negada: você não pode carregar imagens",
"Permission denied you can upload images but not to this gallery" => "Permissão negada: você pode carregar imagens mas não nesta galeria",
"Cannot get image from URL" => "Impossível obter a imagem a partir do endereço",
"That is not an image (or you have php < 4.0.5)" => "Isto não é uma imagem (ou você tem o PHP < 4.0.5)",
"Usage" => "Uso",
"No url indicated" => "Nenhum endereço indicado",
"Unknown user" => "Usuário desconhecido",
"You are not logged in and no user indicated" => "Você não está logado e nenhum usuário foi indicado",
"The user has chosen to make his information private" => "O usuário preferiu manter sua informação sob sigilo",
"Password has been changed" => "A senha foi alterada",
"Invalid password. Your current password is required to change administrative information" => "Senha inválida. Sua senha é necessária para mudar as informações administrativas",
"Email is set to %s" => "E-mail definido como %s",
"The passwords did not match" => "As senhas não coincidem",
"no" => "não",
"was moved into trash" => "foi movido para a lixeira",
"trashed by" => "deletado por",
"open / in process" => "em andamento",
"Rights by creator" => "Direitos do criador",
"END" => "Fim",
"Percentage" => "Porcentagem",
"Task accepted by creator" => "Tarefa aceita pelo criador",
"Task accepted by task user" => "Tarefa aceita pelo usuário",
"Task NOT accepted by creator" => "Tarefa NÃO aceita pelo criador",
"Task NOT accepted by task user" => "Tarefa NÃO aceita pelo usuário",
"Sorry this task does not exist or you have no rights to view this task" => "Desculpe, essa tarefa não existe ou você não tem permissões para visualiza-la",
"Task entries:" => "Entradas da tarefa:",
"Changes:" => "Mudanças:",
"Info message" => "Mensagem informativa",
"NEW Task" => "Nova tarefa",
"Sorry you are not allowed to send tasks to other users, or the user is not allowed to receive tasks!" => "Desculpe mas você não tem permissão para enviar tarefas para outros usuários ou os usuários não podem receber tarefas!",
"Changes on Task" => "Mudanças na tarefa",
"You received a new task" => "Você recebeu uma nova tarefa",
"The priority is" => "A prioridade é",
"very low" => "muito baixa",
"low" => "baixa",
"high" => "alta",
"very high" => "muito alta",
"You've to start your work at least on" => "Você precisa começar seu trabalho até",
"You've to finish your work on" => "Você precisa terminar seu trabalho em",
"Login and click the link below" => "Login e clique no link abaixo",
"Please read the task and work on it!" => "Por favor leia as tarefas e trabalhe nelas!",
"Sorry, there was an error while trying to write data into the database" => "Desculpe, houve um erro ao tentar escrever na banco de dados",
"Cannot upload this file not enough quota" => "Impossível carregar este arquivo: cota máxima atingida",
"Non-existent user" => "Usuário inexistente",
"No banner indicated" => "Nenhum banner indicado",
"No blog indicated" => "Nenhum blog indicado",
"Permission denied you cannot remove the post" => "Permissão negada: você não pode remover a mensagem",
"No cache information available" => "Informação de cache não disponível",
"No faq indicated" => "Nenhum faq indicado",
"You are not permitted to remove someone else\\'s post!" => "Você não pode remover a mensagem postada por outra pessoa!",
"No thread indicated" => "Nenhuma seqüência indicada",
"A SheetId is required." => "Id da planilha é necessário.",
"That tracker don't use extras." => "Aquele acompanhamento não usa extras.",
"No subject" => "Sem assunto",
"Top pages" => "Páginas mais populares",
"Last pages" => "Páginas recentes",
"Tiki RSS feed for the wiki pages" => "Fonte RSS para páginas wiki",
"Last modifications to the Wiki." => "Últimas modificações no wiki.",
"Error deleting the file" => "Erro ao deletar o arquivo",
"The page is empty" => "A página está vazia",
"###end###"=>"###end###");
?>
